#!/usr/bin/perl
#!C:/Perl/bin/perl.exe

######################################################################################
# LICENSE No: #???????
######################################################################################
#
#
#MySQL(TM) Data Manager v1.70
#
#Copyright  2003 Ioannis Livassov
#
#Licence agreement and limited warranty
#
#MySQL Data Manager (Software) is protected by Copyright Law and
#International Treaty.
#
#You should carefully read the terms and conditions of this agreement
#before purchasing and installing the Software.  
#
#If you do not agree to any of the terms of this License, then do not
#purchase, install, or use this Software.  
#
#One purchased copy of the Software may be only used or installed on
#a single computer used by many people. This is not a concurrent use
#license. If you need another copy of the Software to be installed
#you must purchase another license.
#
#You may access this program through a network by a number of remote
#computers.  
#
#This Software is distributed as it is and with no warranties of any
#kind, whether expressed or implied. Experience dictates that any
#program be thoroughly tested with non-critical data before relying on
#it.  The user must assume the risk of using the program.  This
#disclaimer of warranty constitutes an essential part of this License
#Statement. 
#
#Any liability of the distributor will be limited exclusively to
#refund of purchase price.  In no event shall the distributor, or its
#officers, employees, affiliates, contractors, subsidiaries, or parent
#organizations, be liable for any incidental, consequential, or punitive
#damages whatsoever relating to the use of this Software.
#
#This Agreement is the complete statement of the Agreement between the
#parties on the subject matter, and merges and supersedes all other or
#prior understandings, purchase orders, agreements and arrangements.
#
#You may not sell, rent, lease or redistribute the Software in any form
#without prior written consent. You may create derivative works using its
#code partially providing an appropriate references, assuming the purpose
#of the resulting product will be completely different from that of initial
#program. You may of course modify or improve a reasonably small part of
#the code of this Software in order to fit better to your needs provided
#the Software logo,  its look and feel and the text of this license
#agreement  remain intact.
#
# 
#
#MySQL is a trademark of TcX DataKonsultAB
#
######################################################################################

use strict;
use CGI::Carp qw(fatalsToBrowser carpout);
use File::Copy();
use CGI();
use DBI();
use vars qw($q $host $full_url $WIN32 $delim);

my $VERSION = '1.70';

$q = new CGI;


$host			= $ENV{HTTP_HOST};
$full_url 		= $q->url();
$WIN32 			= 1 if ($^O =~ /win32/i);
$delim			= $WIN32 ? "\\" : '/';
my ($dbh_, $HOME,$SelectRows,$UpdateRows,$DEFAULTHOST,$SOCKET,$MYSQL,$configFile, $HELP,
	$OTHER_MYSQL,$USER_DIR,$MAX_BACKUP_SIZE,$MAX_SCRIPT_SIZE, $MAX_ASCII_SIZE, $CONTACT_EMAIL,
	$COMPRESS,$ALLOW_ZIP,$ALLOW_GZIP,$ZIP,$ZIPLOG,$ERRLOG,$ERROR_LOG, $PRINT_POP_UP,
	$BGCOLOR1,$BGCOLOR2,$STATUSFONTCOLOR,$LOGO,$SLOGAN,$SLOGANCOLOR, $LOGOLINK, $LOGOTARGET, $CHARSET);
	
# NUMBER OF ROWS TO BE SHOWN INITIALLY IN "SELECT" AND "UPDATE" FUNCTIONS
	$SelectRows			= '10';
	$UpdateRows 		= '10';

######################################################################################
# INSTALLATION (Refer to http://www.edatanew.com/about/)
######################################################################################
#
# Path to Configuration File:
# It can be either full or relative path.
# On Linux/Unix systems chmod mdmConfig directory to 777
$configFile = './mdmConfig/mdmConfig.conf';
# To disable interactive setup remark or delete the line above:
# 
# This variable must be unremarked and set if the links and buttons "do not work"
# It must look like: $full_url = "http://www.myhostname.com/cgi-bin/mdm.cgi";
#$full_url 		= "";
#####################################################################################
my $register = "http://www.edatanew.com/order";
my $demomsg = <<EOT
Demo version can not execute this command.
To register this program and download full version visit:
$register

Try fully functional online demo:
http://www.edatanew.com/demo
EOT
;
my $demomsg1 = <<EOT
Demo version can not execute this command on a table with more
than 4 columns.
To register this program and download full version visit:
$register

Try fully functional online demo:
http://www.edatanew.com/demo
EOT
;




if ($configFile and -e $configFile){
	open FH, $configFile or die $!;
	flock (FH,2) unless $WIN32;
	my @config;
	while(<FH>){
		push @config, $_;
	}
	flock (FH,8) unless $WIN32;
	close FH;
	my @default			= ();
	my $config 			= readconfig(\@config);
	push @default, "host=$config->{defaultHost}" if $config->{defaultHost};
	push @default, "port=$config->{defaultPort}" if $config->{defaultPort};
	$DEFAULTHOST		= join (';', @default);
	$HOME				= $config->{homeURL};
	$SOCKET 			= $config->{defaultSocket};
	$MYSQL				= $config->{mysql};
	$OTHER_MYSQL		= $config->{otherMysql};
	$USER_DIR			= $config->{userDirectory};
	$MAX_BACKUP_SIZE	= $config->{backupMax};
	$MAX_SCRIPT_SIZE	= $config->{SQLMax};
	$MAX_ASCII_SIZE		= $config->{asciiMax};
	$CONTACT_EMAIL		= $config->{adminEmail};
	$COMPRESS			= $config->{compressCommand};
	$ALLOW_ZIP			= $config->{allowZIP};
	$ALLOW_GZIP			= $config->{allowGZIP};
	$ZIP				= $config->{zipSyntax};
	$ZIPLOG				= $config->{zipLog};
	$PRINT_POP_UP		= $config->{printPopUp};
	$HELP				= $config->{helpURL};
	$CHARSET			= $config->{charset};
	$BGCOLOR1			= $config->{bgcolor1};		
	$BGCOLOR2			= $config->{bgcolor2};
	$STATUSFONTCOLOR	= $config->{statusfontcolor};
	$LOGO				= $config->{logo};
	$LOGOLINK			= $config->{logolink};
	$LOGOTARGET			= $config->{logotarget};
	$SLOGAN				= $config->{slogan};
	$SLOGANCOLOR		= $config->{slogancolor};
	
	$BGCOLOR1			= $BGCOLOR1 		? '#' . $BGCOLOR1 			: '#336699';
	$BGCOLOR2			= $BGCOLOR2 		? '#' . $BGCOLOR2 			: '#003366';
	$STATUSFONTCOLOR	= $STATUSFONTCOLOR 	? '#' . $STATUSFONTCOLOR 	: '#6699CC';
	$SLOGANCOLOR		= $SLOGANCOLOR 		? '#' . $SLOGANCOLOR 		: '#ffffff';
	$SLOGAN				= "Mysql Data Manager" unless $SLOGAN;
	$CHARSET			= 'ISO-8859-1'		   unless ($CHARSET =~ /\S/); 
	
	
}
else {

#############################################################################################
#				HARDCODED VALUES															#
# Settings of these values are optional. They are used if config file can not be created	# 
#############################################################################################

# HOME PAGE FULL URL
	$HOME				= "http://$host";
#
# COMMON CONNECTION PARAMETERS:
#
# PATH TO SOCKET FILE AND DEFAULT HOST. THE STRINGS ARE USED WHEN THE FIELD 'HOST' (LOGIN PAGE)IS BLANK.
# (CORRECT THIS VALUE AS NEEDED. FOR EXAMPLE UNDER WINDOWS IT MAY BE SOMETHING
# LIKE: 	$DEFAULTHOST	= 'host=localhost:3306';
#			$SOCKET = '';
#
	$DEFAULTHOST		= 'host=localhost:3306';
	$SOCKET 			= '/tmp/mysql.socket';
#
# OTHER PARAMETERS USED TO RUN mysql UTILITY ONLY
#
# PATH TO mysql CLIENT (CORRECT THIS VALUE AS NEEDED. FOR EXAMPLE UNDER WINDOWS 
# IT WILL BE SOMETHING LIKE: 
# $MYSQL = 'c:\mysql\bin\mysql.exe';
	$MYSQL 				= '/usr/local/mysql/bin/mysql';
#
# (SUBSTITUTE THESE VALUES WITH CORRECT ONES):
# FOR EXAMPLE: SET 'SILENT' AND 'COMPRESS': my $OTHER_MYSQL = '-s -C';
# FOR MORE OPTIONS RUN 'mysql -?' IN COMMAND LINE.
	$OTHER_MYSQL 				= '';


# PATH TO USER DIRECTORY (CORRECT THIS VALUE AS NEEDED.)
# CAUTION! If you created some backup files as user 'Username' connected to a location
# 'Location1' and then connect different location 'Location2',
# the program will treat you as different user (even if you use the same user name)
# and created earlier files will be unreachable.
# Each user 'username' connected the location 'locationname' will be provided with his
# own subdirectories:
#  /path/to/user_directory/usename.locationname/sql
#  /path/to/user_directory/usename.locationname/backup  
# or under Windows
# D:\path\to\user_directory\usename.locationname\sql
# D:\path\to\user_directory\usename.locationname\backup 
# It also works if you put something like this (under Windows)
# \path\to\usr - the program treats it as: 
# C:\path\to\usr if the current disk drive is C: (D:\... if the current disk drive is D:, etc.)
# 
# the directories usename.locationname/sql and usename.locationname/backup will be created
# by the program
	$USER_DIR 					= '/home/myrootname/data/usr';

# MAXIMUM TOTAL SIZE OF BAKUP FILES PER USER/HOST (kilobytes). UNLIMITED IF EQUALS ZERO.
	$MAX_BACKUP_SIZE 			= 200;

# MAXIMUM TOTAL SIZE OF USER SCRIPTS
	$MAX_SCRIPT_SIZE 			= 50;

#  MAXIMUM SIZE OF ASCII DELIMITED FILE (FOR IMPORT - EXPORT)
	$MAX_ASCII_SIZE				= 50;
	
# CONTACT EMAIL(TO BE USED IN SOME ERROR MESSAGES
	$CONTACT_EMAIL 				= 'tech@edatanew.com';

# MANUAL COMPRESSING: zip OR gzip ?
	$COMPRESS 					= 'gzip';

# SET ZERO IF ZIP UTILITY IS NOT INSTALLED (to be used for backup file compressing);
	$ALLOW_ZIP 					= 1;

# SET THIS VARIABLE ZERO IF GZIP UTILITY IS NOT INSTALLED. (used for backup file compressing)
	$ALLOW_GZIP 				= 1;

# "zip -qj" - ZIP UTILITY CALL UNDER UNIX/LINUX.
# "Wzzip -Pr" OR "Wzzip" ZIP UTILITY CALL UNDER WINDOWS.
# (WinZip COMMAND LINE UTILITY - SEE http://www.winzip.com).
# USUALLY UNDER UNIX/LINUX THIS UTILITY IS ALREADY INSTALLED.
# IF ANY OTHER ZIP UTILITY IS USED UNDER WINDOWS OR ANOTHER OPERATION SYSTEM,
# CORRECT THE LINE BELOW ACCORDINGLY. (used for backup file compressing)
# IF $ALLOW_ZIP =0 YOU CAN LEAVE IT BLANK: $ZIP = '';

#$ZIP = 'Wzzip -Pr'; 
#$ZIPLOG = "1>NUL"}    #Win32
	$ZIP 						= 'zip -qj';	#UNIX/LINUX 

# UNDER WINDOWS IT CAN LOOK LIKE:
#	 $ZIP = 'Wzzip'; # OR $ZIP = 'Wzzip -Pr'
#	 $ZIPLOG = "1>NUL";
# THE VARIABLE $ZIPLOG IS USED TO REDIRECT THE OUTPUTOF THE UTILITY Wzzip.

# SET THIS VARIABLE EQUALS TO 0 IF YOUR WEB BROWSER DOES NOT SUPPORTS window.print() 
# JAVASCRIPT FUNCTION.
	$PRINT_POP_UP 				= 0 ;

#SET URL OF 'HELP' DIRECTORY:
	$HELP 						= "../help";
#DEFAULT CHARACTER SET:
	$CHARSET			= 'ISO-8859-1'; 
#COLORS:
	$BGCOLOR1			= '#d79f00';	# HEXADECIMAL VALUE	WITH LEADING `#' CHARACTER
	$BGCOLOR2			= '#a46c00';	# HEXADECIMAL VALUE	WITH LEADING `#' CHARACTER
	$STATUSFONTCOLOR	= '#d79f00';	# HEXADECIMAL VALUE	WITH LEADING `#' CHARACTER
	$LOGO				= '';          # URL LIKE http://www.yourdomain.com/images/logo.gif'
	$LOGOLINK			= '';
	$LOGOTARGET			= '';
	$SLOGAN				= "Mysql Data Manager";
	$SLOGANCOLOR		= '#a46c00';	# HEXADECIMAL VALUE	WITH LEADING `#' CHARACTER

#---------------------------------------------------------------------------------------
# END OF MANUAL SETTING
########################################################################################
}
#########################################################################################
#        DO NOT MODIFY ANYTHING BELOW THIS LINE											#
#########################################################################################

my ($query, @ary);
my @selectlike = (
					'select',
					'show',
					'explain',
					'describe',
					'desc'
);

#++++++++++++++++++++++++++++++++++++++

my @typelist = (   	'TINYINT',
					'SMALLINT',
					'INT',
					'MEDIUMINT',
					'BIGINT',
					'FLOAT',
					'DECIMAL',
					'DOUBLE',
					'CHAR',
					'VARCHAR',
					'ENUM',
					'SET',
					'TINYBLOB',
					'TINYTEXT',
					'BLOB',
					'TEXT',
					'MEDIUMBLOB',
					'MEDIUMTEXT',
					'LONGBLOB',
					'LONGTEXT',
					'DATE',
					'TIME',
					'TIMESTAMP',
					'DATETIME',
					'YEAR'
  

);

my %auto_type = (
					TINYINT		  	  =>1,
					SMALLINT		  =>1,
			   		INT	  		  	  =>1,
					MEDIUMINT		  =>1,
					BIGINT			  =>1,
					FLOAT			  =>1,
					NUMERIC			  =>1,
					REAL			  =>1,
					DOUBLE		  	  =>1,
					DECIMAL			  =>1,
					CHAR			  =>1,
					VARCHAR			  =>1,
);
my @textdata = (	'TINYBLOB',
					'BLOB',
					'MEDIUMBLOB',
					'LONGBLOB',
					'TINYTEXT',
					'TEXT',
					'MEDIUMTEXT',
					'LONGTEXT'
);

unless (($CHARSET eq "ISO-8859-1") or ($CHARSET eq "iso-8859-1")){
	local $SIG{__DIE__} = sub{
	print $q->header;
	print "Perl module CGI.pm must be updated"
	};
	$q->charset($CHARSET)
}
my $page 	= $q->param('page');
my $agent;
if ($q->user_agent =~ /(MSIE)|(Opera)/i  ) {$agent = 0}
elsif ($q->user_agent =~ /(\[\w\w\])|(Netscape)/i  ){$agent = 1}

if (($page eq 'logout') or !$page){
	&logout();
	&printparam();
	exit;
}
elsif ($page eq 'setup') {
	&setup();
	&printparam();
	exit;
}

my $NO_HEADER = 1 if (  

			$q->param('downloadBackup') and ($q->param('func') =~ /backup/i) 
			or $q->param('downloadFile') or ($q->param('action') =~ /download/i) 
			
			);

my ($user, $password, $MySQLhost, $usedefault, $database);
$DEFAULTHOST = "mysql_socket=$SOCKET;".$DEFAULTHOST if $SOCKET;
if ($q->param('login')) {
	$user 		= $q->param('user');
	$password	= $q->param('password');
	unless  ($q->param('host')) {
		$MySQLhost			= $DEFAULTHOST;
		$usedefault			= 1;
	}
	else {
		$MySQLhost			= 'host='.$q->param('host');
		$usedefault			= 0;
	}
	if ($q->param('host')	=~ /database=([a-zA-Z0-9_]*)/){$database=$1}
	else {$database 		= $q->param('dbname'); $database =~ s/\s//g;}

	my $cookies = $q->cookie(	
							-name=>'db_manager',
    						-value=>[$user, $password, $MySQLhost, $usedefault],
    						-secure=>0
    						);
	print 	$q->header(-cookie=>$cookies, -expires=>0);
	$page = 'select_db'	if ($database and ($page eq 'connect')); 
		  
} #IF
else {
	($user, $password, $MySQLhost, $usedefault) = $q->cookie('db_manager');
	if (defined $q->param('change_password')){
		$password 	= $q->param('change_password');
    	my $cookies = $q->cookie(	
							-name=>'db_manager',
    						-value=>[$user, $password, $MySQLhost, $usedefault],
    						-secure=>0
    						);
	  	 	print 	$q->header(-cookie=>[$cookies], -expires=>0);
	}
	else {
        if ($q->param('targetconnect')){
			my $targetuser			= $q->param('targetuser');
			my $targetpassword		= $q->param('targetpassword');
			my $targethost			= $q->param('targethost');
			unless ($targethost){$targethost = $DEFAULTHOST}
			my $cookies = $q->cookie(
						-name=>'target_db',
                        -value=>[$targetuser, $targetpassword, $targethost],
						-secure=>0
						);
    		print 	$q->header(-cookie=>[$cookies], -expires=>0);		
		}
		else {	
			print $q->header(-expires=>0) unless $NO_HEADER;
		}
	}
	$MySQLhost	= $DEFAULTHOST if ($usedefault);
	$database 									= $q->param('dbname');
} #ELSE
#++++++++++++++++++++++++++++++++++++++

{
	my ($host_, $port_) = gethost($MySQLhost);
	
	sub myhost {
		unless (defined $_[0]){
			if (wantarray){return($host_, $port_)}
			else {return($host_)}
		}
		else {
			if (wantarray){
				my ($host_, $port_) = gethost($_[0]);
				return($host_, $port_)
			}
			else {
				my $host_ = gethost($_[0]);
				return($host_)
			}
		}
	}
}

my $print = "print" if ($q->param('print'));
&startpage($user, $database) unless $NO_HEADER;
my (%attr) =
(
					PrintError => 0,
					RaiseError => 0,
					#AutoCommit => 0
);

my $dsn					= "DBI:mysql:$database;$MySQLhost";
my $dsn_ 				= $usedefault ? "DBI:mysql:$database:defaulthost" : $dsn;
my $dbh 				= DBI->connect($dsn, $user, $password,\%attr)
	or &bail_out("(DSN, user, password): $dsn, $user, $password");
undef $dsn_; 
if ($database){$dbh->do("USE $database") or bail_out("cannot USE this database: $database", {page => "connect"})}

{
	my ($sth, $res)		= prepare_execute("SELECT VERSION()");
	my $version 		= $sth->fetchrow_array();
	$sth->finish();
	sub check_version {
	#input: version number NN.NN.NNanythyng
	#returns undef if current version is lower then required
	#returns 1 if OK;
		my (@v,@x);
		if ($version =~ /^(\d*)\.(\d*)\.(\d*).*/)	{@v = ($1,$2,$3)}
		if ($_[0] =~ /^(\d*)\.(\d*)\.?(\d*)/)	{@x = ($1,$2,$3)}
		if ($v[0] < $x[0]){return undef} elsif ($v[0] > $x[0]){return 1}
		if ($v[1] < $x[1]){return undef} elsif ($v[1] > $x[1]){return 1}
		if ($v[2] < $x[2]){return undef} else {return 1} ;
	}
	sub get_version{$version}
 
}

if (check_version('3.23.00')){
	push @selectlike, ('optimize','check','analyze','repair');
	undef $auto_type{'VARCHAR'}; undef $auto_type{'CHAR'};
}
my $demomsg2 = "This was generated by unregistered version of MDM";
if ($page eq 'admin'){
    my $back					= {page => "admin"};
	$back->{dbname}	  			= "$database" if $database;
	$back->{selectdbname_}		= $q->param('selectdbname_') if $q->param('selectdbname_');
	my $func = $q->param('func');
	if		($func =~ /flush/i)				{&execFlush($back);&loadAdmin()}
	elsif	($func =~ /analyze/i)			{&execCheckRepair($back, 'ANALYZE')}
	elsif	($func =~ /check/i)				{&execCheckRepair($back, 'CHECK')}
	elsif	($func =~ /repair/i)			{&execCheckRepair($back, 'REPAIR')}	
	elsif	($func =~ /optimize/i)			{&execCheckRepair($back, 'OPTIMIZE')}
	elsif	($func =~ /access/i)			{&loadAccessControl($back)}
	else {&loadAdmin($back)}
}
elsif ($page eq 'select_db') {
    my $func = $q->param('func');
	if 	($q->param('tableops') =~ /execute/i) {execExecuteQuery({'page' => 'connect'})}
	elsif ($q->param('cancel')){&loadSelectDB()}
	elsif ($q->param('tableops') =~ /drop/i) {dropcreatedb('drop')}
	elsif ($q->param('tableops') =~ /create/i) {dropcreatedb('create')}
	elsif ($func =~ /backup/i){&loadBackup()}
	elsif ($func =~ /restore/i){&loadRestore()}
	else  {&loadSelectTables()}
}
elsif (!$database) {
	if ($page eq 'ddl') {
		$database	= $q->param('database');
		execExecuteQuery({page => 'tables', dbname => "$database", script => 'back'})  if ($q->param('apply'));
	}
	   else {&loadSelectDB()}
}
elsif ($page eq 'tables') {
    my $func = $q->param('func');
	if 	  ($func =~ /describe/i){&execDescribeTables()}
	elsif ($func =~ /(alter)|(create)/i){&loadAlterTable()}
	elsif ($func =~ /(insert)|(search)/i){&loadInsertForm()}
	elsif ($func =~ /update/i){&loadUpdateForm()}
	elsif ($func =~ /select/i){&execSelectFromTable()}
	elsif ($func =~ /drop/i){&loadDropPreview()}
	elsif ($func =~ /delete/i){&loadDeletePreview()}
	elsif ($func =~ /ddl/i){&execGenerateDDL()}
	elsif ($func =~ /(import)|(export)/i){&loadImportExportFile()}
	elsif ($func =~ /script/i){&loadexecscript()}
	elsif ($func =~ /backup/i){&loadBackup()}
	elsif ($func =~ /restore/i){&loadRestore()}
	else  {print "<P>Select something!"}
}
elsif ($page eq 'search') {
	my $func = $q->param('func');
	if ($func =~ /return/i){&loadInsertForm()}
	else {&execSearch}
}elsif ($page eq 'searchresult') {
	my $func = $q->param('func');
	if		(($func =~ /prev/i) or ($func =~ /next/i)){&searchresult()}
	elsif	($func =~ /back/i){&loadInsertForm()}
	elsif	($func =~ /edit/i){&loadInsertForm()}
	elsif	($func =~ /new/i){&loadInsertForm()}
	elsif	($func =~ /return/i){&searchresult()}
	elsif	($func =~ /insert/i){&execInsertData()}
	elsif	($func =~ /delete/i){&searchresult()}
	elsif	($print){&searchresult()}
	else	{&execSearch}
}
elsif($page eq 'create'){&execAlterTable}
elsif ($page eq 'insert') {&execInsertData}
elsif ($page eq 'alter') {&execAlterTable}
elsif ($page eq 'update') {&execUpdateData}
elsif ($page eq 'updateAfterPreview') {&execUpdateAfterPreview}
elsif ($page eq 'alterAfterPreview') {&execAlterAfterPreview}
elsif ($page eq 'drop') {&execDropTable}
elsif ($page eq 'delete') {&execDeleteFromTable}
elsif ($page eq 'ddl') {
	if ($q->param('apply')){&execExecuteQuery({page => 'tables', dbname => $database, script => 'back'})}
	else {&loadSelectTables()}
}

#++++++++++++++++++++++++++++++++++++++

else {print "<B>WRONG DATA</BR>"}
print "\n\n<!-- END OF PROCEDURE BODY -->\n\n";

print "\n\n\t\t</TD>\n\t</TR>\n</TABLE><!-- END OF MARGIN TABLE -->\n\n\n\n" unless $print;


print $q->end_html;
$dbh->disconnect;

&printparam;
printPopUp() if $print;
exit;
####################################################
#-----------------S U B R O U T I N S--------------#
####################################################
sub quoteit {
	my @output = @_;
	for (my $i=0; $i<@output; $i++) {
		$output[$i] =~ s{(.)}{
			if    ($1 eq '<')		{ '&lt;'    }
			elsif ($1 eq '>')		{ '&gt;'    }
			elsif ($1 eq '&')		{ '&amp;'   }
			elsif ($1 eq '"')		{ '&quot;'  }
#			elsif ($1 eq "\x8b")	{ '&#139;'  }
#			elsif ($1 eq "\x9b")	{ '&#155;'  }
			else					{ $1        }
       }gsex;
	}
	if (wantarray) {return (@output)}
	else {return $output[0];}
}

sub printparam {
	return;
	my @x=$q->param();
	my @values;
	print "\n\n\n\n<!-- PARAMETERS -->\n\n";
	print qq!<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=2 BGCOLOR="#CCCCCC">\n\t<TR VALIGN=TOP>!;
	my $max=1;
	for (my $i=0; $i<@x; $i++) {
		my @y = $q->param($x[$i]);
		$values[$i] = \@y;
		$max = scalar (@y) if (@y>$max);
		print qq!\n\t\t<TD BGCOLOR="#DDDDDD">&nbsp;$x[$i]</TD>!;
	}
	print "</TR>\n";
	for (my $j=0; $j<$max; $j++) {
		print "\t<TR VALIGN=TOP>\n";
		for (my $i=0; $i<@x; $i++) {
			${$values[$i]}[$j] =~ s/&/&amp;/g;
			${$values[$i]}[$j] =~ s/</&lt;/g;
			${$values[$i]}[$j] =~ s/>/&gt;/g;
			print qq!\t\t<TD BGCOLOR="#DDDDDD">&nbsp;!. ${$values[$i]}[$j] . qq!</TD>\n!;
		}
		print "\t</TR>\n";
	}
	print	"</TABLE>\n";
}

sub gethost {
	my $myhost = $_[0];
	my ($host,$port);
	if ($myhost =~ /host=(.*):(\d*)/){$host = $1; $port = $2}	#a ...;host=hostname:3306...
	elsif ($myhost =~ /host=([^;]*);/){$host = $1;}				#b ...;host=hostname;...
	elsif ($myhost =~ /^(.*):(\d*)/){$host = $1; $port = $2}	#c hostname:3306...
	elsif ($myhost =~ /^(.*);/){$host = $1}						#d hostname;...
	elsif ($myhost =~ /host=(\S+)\s*$/){$host = $1;}			#b+ ...;host=hostname;...
	elsif ($myhost =~ /=/){$host = ''}							#e no hostname, but other params
	else {$host = $myhost}										#f hostname only
	if ($myhost =~ /port=(\d*)/){$port = $1}
#	my ($sth,$res) = prepare_execute("SELECT USER()", {});
#	my ($host) = $sth->fetchrow_array();
#	$host = s/.*@(.*)/$1/;
#	($sth,$res) = prepare_execute("SELECT VARIABLES() LIKE 'PORT'");
#	my $port = $sth->fetchrow_array();
	if (wantarray){return($host, $port)}
	else {return($host)}
}
sub myhost_ {
	my $myhost;
	unless (defined $_[0]){$myhost = $MySQLhost}
	else {$myhost = $_[0]}
	my ($host,$port);
	if ($MySQLhost =~ /host=(.*):(\d*)/){$host = $1; $port = $2} #a ...;host=hostname:3306...
	elsif ($MySQLhost =~ /host=([^;]*);/){$host = $1;}			 #b ...;host=hostname;...
	elsif ($MySQLhost =~ /^(.*):(\d*)/){$host = $1; $port = $2}	 #c hostname:3306...
	elsif ($MySQLhost =~ /^(.*);/){$host = $1}					 #d hostname;...
	elsif ($MySQLhost =~ /host=(\S+)\s*$/){$host = $1;}			 #b+ ...;host=hostname;...
	elsif ($MySQLhost =~ /=/){$host = ''}						 #e no hostname, but other params
	else {$host = $MySQLhost}									 #f hostname only
	if ($MySQLhost =~ /port=(\d*)/){$port = $1}
#	my ($sth,$res) = prepare_execute("SELECT USER()", {});
#	my ($host) = $sth->fetchrow_array();
#	$host = s/.*@(.*)/$1/;
#	($sth,$res) = prepare_execute("SELECT VARIABLES() LIKE 'PORT'");
#	my $port = $sth->fetchrow_array();
	if (wantarray){return($host, $port)}
	else {return($host)}
}
sub printPopUp {
	print "<script language=\"JavaScript1.2\">window.print()</script>" if $PRINT_POP_UP;
}

sub startpage {
	my $user_				= "USER:&nbsp;$_[0]" if ($page and ($page ne 'logout' and $page ne 'setup'));
	my $databasename		= $database || "<B>NOT SELECTED</B>";
	my $dbname_ 			= 'DATABASE:&nbsp;'.$databasename if ($page and $page ne 'logout' and $page ne 'connect' and $page ne 'setup');
	my ($hostname,$port) 	= myhost();
	$hostname 				.= ":$port" if $port;
	my $demomarker; 
#++++++++++++++++++++++++++++++++++++++

	my $host_ = "HOST:&nbsp;$hostname" if ($page and ($page ne 'logout' and $page ne 'setup'));
	
	my $title = $print ? quoteit($q->param('title')) : "MYSQL DATA MANAGER $VERSION";
	$title = "Untitled" if ($title =~ /^\s*$/);
print <<EndOfHead
<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=$CHARSET">
<TITLE>$title</TITLE>
</HEAD>

EndOfHead
;
#
	unless ($print){
		print <<EndOfStyle
<STYLE TYPE="text/css">
<!--
TD.header {height: 35px}
P.headh5 			{color: white; font-size: 16px; font-weight: bold; font-family: "Verdana", "Tahoma", "Arial", "Geneva"}
A.button			{color: white; font-size: 10px; font-weight: bold; font-family: "Verdana", "Tahoma", "Arial", "Geneva"}
A.button:hover		{color: white; text-decoration: none}
A.button:visited	{color: white; text-decoration: none}
p.shead				{font-size: 9px; font-weight: bold; font-family: "Verdana", "Tahoma", "Arial", "Geneva"}
body		{background: #CCCCCC; font-size: 11px; font-family: "Verdana", "Tahoma", "Arial", "Geneva"}
A			{color: #CC0000; font-weight: bold; text-decoration: none}
A:hover		{color: #CC0000; font-weight: bold; text-decoration: none}
A:visited	{color: #CC0000; font-weight: bold; text-decoration: none}
select, textarea, input, TD,UL, TR, P,BR	 {font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: 11px}
TH			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-weight: bold; font-size: 11px; color: #003466}
CODE		{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-weight: bold; font-size: 12px}
H5			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-weight: bold; font-size: 16px; color: $SLOGANCOLOR}
H3			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-weight: bold; font-size: 12px; color: #003466}
EM			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: 10px}
-->
</STYLE>
EndOfStyle
;
}
	else {
		print <<EndOfStyle
<STYLE TYPE="text/css">
<!--
body		{background: #FFFFFF; font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: x-small}
P,BR		{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: x-small}
TD,UL       {font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: x-small}
TR			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: x-small}
TH			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-weight: bold; ; font-size: x-small}
CODE		{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: small}
H5			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"; font-size: medium}
H3			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"}
EM			{font-family: "Verdana", "Tahoma", "Arial", "Geneva"}
-->
</STYLE>
<BODY bgcolor="#FFFFFF">
EndOfStyle

;
		return;
	}
	my $uprow;
	if ($LOGO){$LOGO = qq!<img src="$LOGO" BORDER=0>!}
	if ($LOGOLINK){
		if ($LOGOTARGET){$LOGOTARGET = qq!target="$LOGOTARGET"!}
		$LOGO = qq!<A HREF="$LOGOLINK" $LOGOTARGET>$LOGO</A>!;
	}
	else {$uprow = <<EOT
	<TR BGCOLOR="$BGCOLOR1">
		<TD WIDTH=20 HEIGHT=15 BGCOLOR="$BGCOLOR1">&nbsp;</TD>
		<TD BGCOLOR="$BGCOLOR1">&nbsp;</TD>
	</TR>
EOT
}
#++++++++++++++++++++++++++++++++++++++
	
	my $links = 	links();
	print <<HeadTable
<BODY bgcolor="#CCCCCC" link="#CC0000" vlink="#CC0000" alink="#CC0000" text="#000000" TOPMARGIN=0 LEFTMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
$uprow
	<TR>
		<TD COLSPAN=2 BGCOLOR="$BGCOLOR1">
<!-- LOGO TABLE -->
	<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
		<TR>
			<TD WIDTH=20>&nbsp;</TD>
			<TD  ALIGN=LEFT HEIGHT=35 WIDTH=600><P CLASS="headh5"><FONT COLOR="$SLOGANCOLOR"><B>&nbsp;$SLOGAN&nbsp;$demomarker&nbsp;</B></FONT></P></TD>
			<TD WIDTH=100 ALIGN=RIGHT><P>$LOGO</TD>
		</TR>
	</TABLE>
		</TD>
	</TR>
	<TR BGCOLOR="$BGCOLOR2">
		<TD COLSPAN=2 BGCOLOR="$BGCOLOR2" HEIGHT=17>
<!-- INFO TABLE -->
	<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0 WIDTH="100%">
		<TR>
			<TD WIDTH=20>&nbsp;</TD>
			<TD><FONT COLOR="$STATUSFONTCOLOR"><NOBR>&nbsp;$user_ &nbsp;&nbsp;&nbsp;$host_ &nbsp;&nbsp;&nbsp;$dbname_ </NOBR></FONT></TD>
			<TD ALIGN=RIGHT><FONT COLOR="$STATUSFONTCOLOR"><NOBR>&nbsp;</NOBR></FONT></TD>
		</TR>
	</TABLE>
		</TD>
	</TR>
	<TR>
		<TD WIDTH=20 HEIGHT=15>&nbsp;</TD>
		<TD>&nbsp;</TD>
	</TR>
	<TR>
		<TD COLSPAN=2>
HeadTable
;
	print links();
	print <<EOT
		</TD>
	</TR>
	<TR>
		<TD WIDTH=20>&nbsp;</TD>
		<TD><BR>
<!-- PROCEDURE BODY STARTS HERE -->
EOT
;


#++++++++++++++++++++++++++++++++++++++
}#startpage

sub links {
	my ($url1, $url2, $url3, $url4, $url5, $url6);
	my $func = $q->param('func');
	if ($page and ($page ne 'logout') and $page ne 'setup'){
    	if ($database) {
    		$url2 = qq!<nobr><A HREF="$full_url?page=select_db&dbname=$database">MAIN&nbsp;PAGE</A></nobr>\n!;
    	}
    	else {
    		$url2 = qq!<nobr><FONT COLOR="#999999">MAIN&nbsp;PAGE</FONT></nobr>\n!;
    	}
		my $selectdbname_ = "&selectdbname_=".$q->param('selectdbname_') if $q->param('selectdbname_');
		$url1 = qq!<nobr><A HREF="$full_url?page=connect">SELECT&nbsp;DATABASE</A></nobr>\n!;
		$url3 = qq!<A HREF="$full_url?page=logout">LOG&nbsp;OUT</A>\n!;
		$url5 = qq!<A HREF="$full_url?page=admin&dbname=$database$selectdbname_">ADMINISTRATION</A>\n!;
		$url4 = qq!<A HREF="$HOME">HOME</A>\n! if $HOME;
		$url6 = qq!<A HREF="$HELP" TARGET="_blank">HELP</A>\n! if $HELP;
	}
	elsif($configFile) {
		$url1 = qq!<A HREF="$HOME">HOME</A>\n! if $HOME;
		$url6 = qq!<A HREF="$HELP" TARGET="_blank">HELP</A>\n! if $HELP;
		$url2 = qq!<A HREF="$full_url?page=setup">SETUP</A>\n!;
		$url5 = qq!<A HREF="$full_url?page=logout">EXIT SETUP</A>\n! if ($page eq 'setup');
	}
	else {
		$url1 = qq!<A HREF="$HOME">HOME</A>\n! if $HOME;
		$url2 = qq!<A HREF="$HELP" TARGET="_blank">HELP</A>\n! if $HELP;
	}
return <<EOT

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<TR>
		<TD WIDTH="20">&nbsp;</TD>
		<TD WIDTH="140">$url1</TD>
		<TD WIDTH="90">$url2</TD>
		<TD WIDTH="150">$url5</TD>
		<TD WIDTH="100">$url3</TD>
		<TD WIDTH="100">$url4</TD>
		<TD WIDTH="130" ALIGN=RIGHT>$url6</TD>
	</TR>
</TABLE>

EOT
;
}

sub dropcreatedb{
	my $back = {page => "connect"};
	if ($_[0] eq 'drop') {
		if ($q->param('confirm')) {
			bail_out("Database is not selected",$back) unless $q->param('dbdrop');
#++++++++++++++++++++++++++++++++++++++
			my $query = "DROP DATABASE ".$q->param('dbdrop');
			bail_out("Cannot do query:\n$query", $back) unless ($dbh->do($query));
			&loadSelectDB();     
		}
		else {
			bail_out("Database is not selected",$back) unless $database;
			print "<BR><BR><B>Database $database will be dropped.</B><BR>\n";
  			print qq?<BR><B><FONT COLOR="#FF0000"><U>CAUTION!</U> SELECTED DATABASE IS NOT EMPTY</FONT></B><BR>\n? 
    			if (@{getTablelist($database)});
			print <<EndOfDrop
		<FORM METHOD=POST ACTION="$full_url">
		<INPUT TYPE=SUBMIT NAME="confirm" 	VALUE="CONFIRM">
		<INPUT TYPE=SUBMIT NAME="cancel" 	VALUE="CANCEL">
		<INPUT TYPE=HIDDEN NAME="page" 		VALUE="select_db">
		<INPUT TYPE=HIDDEN NAME="dbdrop" 	VALUE="$database">
		<INPUT TYPE=HIDDEN NAME="tableops" 	VALUE="drop">
		
		</FORM>
EndOfDrop
;
 		 
  		}
     
     }
	 elsif($_[0] eq 'create'){
	 	my $newdb = $q->param('newDB');
		
	 	if (($newdb eq '') or ($newdb eq 'NEW DATABASE NAME')){bail_out("Please type new database name in the text field", $back)}
		my $query = "CREATE DATABASE $newdb";
		bail_out("Cannot do query:\n$query", $back) unless ($dbh->do($query));
		&loadSelectDB();	 
	 }
}

sub getuserlist{
	my $query		= "SELECT host, user FROM mysql.user ORDER BY user";
	my $back 		= {page => 'connect'};
	$back 			= {page => 'select_db', dbname => $database} if $database;
	my $sth 		= $dbh->prepare($query) || bail_out ("Cannot prepare query:\n$query", $back);
	my $res 		= $sth->execute();
	my @userlist	= ();
	my $labelhash	= ();
	if ($DBI::err){push @userlist, '1'; $labelhash->{'1'} = 'ACCESS DENIED'}
#	elsif (???) {	bail_out ("Cannot execute:\n$query", $back)	}
	else {
		while (my $usersref		= $sth->fetchrow_arrayref) {
			my $label = $usersref->[1].'@'.$usersref->[0];
			$usersref->[0]	= $dbh->quote($usersref->[0]);
			$usersref->[1]	= $dbh->quote($usersref->[1]);
			my $value = $usersref->[1].'@'.$usersref->[0];
			push @userlist, $value;
			$labelhash->{$value} = $label;
		}
	}
	$sth->finish;
	if (@userlist == 0){$userlist[0] = '0'; $labelhash->{'0'} = "User List is empty"}
	if (wantarray){return \@userlist, $labelhash}
	else {return \@userlist}
}
sub getdblist {
	my $dbh					= shift;
	my $back				= {page => 'select_db', dbname => $q->param('dbname')} if $q->param('dbname');
	my $driversref			= $dbh->selectcol_arrayref("SHOW DATABASES");
	if ($DBI::err){
		if ($DBI::errstr =~ /access/i){$driversref->[0]	= $database if $database}
		else {bail_out("Cannot select Databases", $back)}
	}
	
	#unless ($driversref->[0]) {$driversref->[0]	= ''};
	return $driversref
}
sub getTablelist {
	my $query 				= "SHOW TABLES";
	$query 					.= " FROM $_[0]" if ($_[0]);
	my $back;
	unless ($back = $_[1]){$back = {page => 'connect'}}
	return  $dbh->selectcol_arrayref($query) || bail_out("Failed to execute:\n$query", $back);
}

sub getlimit {
	#input: $tabs - number of selected tables
	#output (for each table):
	# limit x,y  - arrayref
	# offset x - arrayref
	# rows y - arrayref
	my $tabs = shift;
	my (@limit, @offset, @rows);
	unless (defined $q->param('limit')) {
		@offset		= $q->param('offset');
        @rows 		= $q->param('rows');
		for(my $i=0; $i<$tabs; $i++) {
			$rows[$i]		= $rows[0] unless defined $rows[$i];
			$offset[$i]		= $offset[0] unless defined $offset[$i];
			$limit[$i]		= "$rows[$i]" if (($rows[$i] ne '') and ($offset[$i] eq ''));
			$limit[$i]		="$offset[$i], $rows[$i]" if (($rows[$i] ne '') and ($offset[$i] ne ''));
		}
	}
	else {
		@limit = $q->param('limit');
		for(my $i=0; $i<$tabs; $i++) {
			$limit[$i] = $limit[0] unless defined $limit[$i];
			if ($limit[$i] =~ /^(.+),(.+)$/){
			   $offset[$i] = $1;
			   $rows[$i] = $2;
			}
			elsif ($limit[$i] !~ /,/) {
			   $offset[$i] = '';
			   $rows[$i] = $limit[$i];
			}
		}	
	}
	return (\@limit, \@offset, \@rows)
}

sub bail_out {
# $_[0] - error message
# $_[1] - link back if $_[2] is not defined or zero or HIDDEN INPUTs leading back if $_[2]
# $_[2] - if zero $_[1] is interpreted as part of URL, if set $_[1] is HIDDEN INPUTs
	if ($NO_HEADER){
		print $q->header(-expire=>0);
		&startpage($user, $database);	
	}
	my $message = quoteit($_[0]);
	$message =~ s/$/<BR>/mg;
	print "\n\n<!--   ------BAIL_OUT------   -->";
    print "\n\n<P><B>$message</B><BR>";
	if ($DBI::err){
		my $message_ = quoteit($DBI::errstr);
		$message_ 	 =~ s/^/<BR>/mg;
		print "Error  $DBI::err ($message_)\n</P>\n" ;
	}
	if ($_[2] eq 2){
		print qq!</FORM><FORM METHOD=POST ACTION=$full_url>\n!;
	}
	elsif (!$_[2]){
		print qq!<FORM METHOD=POST ACTION=$full_url>\n!;
	}
	my $input = $_[1];
	print qq!<INPUT TYPE=SUBMIT VALUE="Back">\n! unless ($_[2] == 3);
	foreach (keys %$input){
		print $q->hidden(-name=>$_, -value=>$_[1]->{$_}, -override=>1),"\n";
	}
	print "\n\t\t</FORM></TD>\n\t</TR>\n</TABLE>\n\n\n\n" unless $print;
	print $q->end_html;
#---errlog---
#++++++++++++++++++++++++++++++++++++++
	

    $dbh->disconnect() if defined $dbh;
	$dbh_->disconnect() if defined $dbh_;
	&printparam();
	exit 0;
}

sub ErrMessage {
    print $_[0];
	print qq!<BR><B><FONT COLOR="#FF0000">Error $DBI::err (!, quoteit($DBI::errstr),")</FONT></B><P>" if ($DBI::err);
	print "\n</FORM>" if $_[1];
	print "\n</TD></TR></TABLE>" if ($_[1] == 2);
	
#++++++++++++++++++++++++++++++++++++++

}

sub printresult {
#input:
# $_[0] - \$sth
# $_[1] - offset (running number)
# $_[2] - if set - mark primary keys
    my $sthref		= $_[0];
    my $sth 		= $$sthref;
	my $offset 		= ($_[1] + 0);
	my $array		= [];
	$array->[0][0]	= qq!<TD BGCOLOR="#CCCCCC">No</TD>\n! if (defined $_[1] and !$print);
	my $pri			= get_mysql_pri($sth);
	unless (defined $pri) {$pri = []}
	my ($bgcolorH, $bgcolor, $bgcolorL, $bordercolor, $cellspacing, $rowheight, $headerheight);
	my ($border, $bordercolorlight, $bordercolordark, $printtitle);
	if ($print){
		$bgcolor=$bgcolorH=$bgcolorL='#FFFFFF';
		$bordercolor				='#000000';
		$cellspacing 				= 0;
		$rowheight					= $q->param('rowheight');
		$headerheight				= $q->param('headerheight');
		$bordercolorlight 			= qq!bordercolorlight="#000000"!;
		$bordercolordark  			= qq!bordercolordark="#000000"!;
		$border						= '1';
		my $title					= quoteit($q->param('title'));
		if ($title){
			my $align				= $q->param('align');
			my @style				= $q->param('style');
			
			foreach(@style){
				$title = "<$_>$title</$_>"
			}					
			$printtitle				= "<DIV ALIGN=$align><CODE>$title</CODE></DIV><P>"
		}
		$printtitle .= "\n$demomsg2";
	}
	else {
		$bgcolor  					= '#EEEEEE';
		$bgcolorH 					= '#EEEEEE';
		$bgcolorL 					= '#CCCCCC';
		$bordercolor 				= '#CCCCCC';
		$cellspacing 				= 2;
		$border						= '0';
		$bordercolorlight 			= "";
		$bordercolordark  			= "";

	}
    for(my $i=0; $i < $sth->{NUM_OF_FIELDS}; $i++) {
        if ($_[2] and $pri->[$i] and !$print){
			$array->[0][$i+1] = qq!<TH BGCOLOR="$bgcolorH"><FONT COLOR="#FF0000">$sth->{NAME}[$i]</FONT></TH>!;
		}
		else{
			$array->[0][$i+1] = qq!<TH BGCOLOR="$bgcolorH"><FONT COLOR="#000000">$sth->{NAME}[$i]</FONT></TH>!;
		}
    }
	my $j=1;
    while (@ary = $sth->fetchrow_array ())	{
		@ary			= quoteit(@ary);
		$array->[$j][0] = qq!<TD BGCOLOR="$bgcolorL">!.$offset++ .qq!</TD>! if (defined $_[1] and !$print);
		for (my $i = 0; $i < @ary; $i++) {
			$ary[$i] = '&nbsp;' if ($ary[$i] eq '' or !defined $ary[$i]);
			$ary[$i] =~ s/(\r\n)|\n/<BR>/mg;
			$array->[$j][$i+1] = qq!<TD BGCOLOR="$bgcolor">$ary[$i]</TD>!;
		}
		$j++;
	}
	unless (defined $array->[0]){$array = [[],[]]}
	my $result =  "\n<!-- printresult subroutine -->\n";
	$result    .=  "$printtitle\n";
	$result    .=  qq!\n\<TABLE BORDER=0  BGCOLOR="$bordercolor" CELLSPACING=0 CELLPADDING=0><TR BGCOLOR="$bordercolor"><TD BGCOLOR="$bordercolor">!;
	$result	   .=  qq!<TABLE BORDER=$border $bordercolorlight $bordercolordark CELLSPACING=$cellspacing CELLPADDING=1>\n!;
	$result    .= qq!<TR $headerheight>@{$array->[0]}</TR>\n!;
	for (my $i = 1; $i < @$array; $i++)
	{$result .=  qq!\t<TR $rowheight>@{$array->[$i]}</TR>\n!;}
	$result    .= qq!</TABLE></TD>\n!;
	$result	   .= qq!</TR></TABLE>\n!;
	$result    .= "\n<!-- end of printresult subroutine -->\n";
	return ($result);
}
						
sub loadSelectDB {
	my $databasesref	= getdblist($dbh);
	my $DBlist;
	my ($textsize, $textareasize) = $agent ? (16, 35 ) : (25, 50 );

	if ((not defined $databasesref) and $DBI::err){
		$DBlist 		= $q->scrolling_list(
						-labels		=> {'' => 'ACCESS DENIED'},
                		-name		=>'dbname',
                		-values		=>[''],
                		-default	=>'',
                		-size		=>15,
						-title		=>'Select database'
					);
	}
	else {
		if (@$databasesref == 0){
			$DBlist 	= $q->scrolling_list(
						-labels		=> {'' => 'List is emplty'},
                		-name		=>'dbname',
                		-values		=>[''],
                		-size		=>15,
						-title		=>'Select database'
					);
		}
		else {
			$DBlist 	= $q->scrolling_list(
                		-name		=>'dbname',
                		-values		=>['',@$databasesref],
                		-default	=>'',
                		-size		=>15,
						-title		=>'Select database'
					);
		}
	}
	my $headtab = {
		name	=> 'SELECT DATABASE'
	};
	my $SQL = quoteit($q->param('SQL'));
	print "<FORM METHOD=POST ACTION=\"$full_url\">";
	printHeaderTable($headtab);			
print <<EndSelectDB		
         <INPUT TYPE=HIDDEN NAME="page" VALUE="select_db">
         <TABLE BORDER=0 CELLSPACING=1 CELLPADDING=1>
             <TR VALIGN=TOP ALIGN=LEFT>
                 <TD>
    <!-- internal BIG table -->
	<TABLE BORDER=0 BGCOLOR="#AAAAAA" CELLPADDING=1 CELLSPACING=0><TR><TD>	
	<TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
 		<TR HEIGHT=220>
   			<TD VALIGN=TOP HEIGHT=220>
<!-- database list  -->
$DBlist
			</TD>             
       		<TD VALIGN=TOP HEIGHT=220>
         <!-- control table -->
		<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%">
			<TR VALIGN=TOP>
				<TD VALIGN=TOP><INPUT TYPE=SUBMIT NAME="tableops" VALUE="  CONNECT  " style="Width: 160px" TITLE="Show tables in selected database"><BR><HR SIZE=1></TD>
			</TR>
			<TR>
				<TD VALIGN=TOP><A><INPUT TYPE=SUBMIT NAME="tableops" VALUE="   Drop Database    " style="width: 160px; color=#CC0000" TITLE="DROP SELECTED DATABASE"></A><BR><HR SIZE=1></TD>
          	</TR>
			<TR>
				<TD VALIGN=TOP><INPUT TYPE=SUBMIT NAME="tableops" VALUE="  Create Database  " style="width: 160px" TITLE="Create new database"></TD>
			</TR>
			<TR>
				<TD VALIGN=TOP><INPUT TYPE=TEXT SIZE=$textsize NAME="newDB" TITLE="Type the name of the new database to create"  style="width: 160px" 
				 onFocus="if(this.value=='NEW DATABASE NAME')this.value='';" onBlur="if(this.value=='')this.value='NEW DATABASE NAME';" VALUE="NEW DATABASE NAME"></TD>
			</TR>
			<TR>
				<TD VALIGN=TOP>&nbsp;</TD>
			</TR>
			<TR>
				<TD VALIGN=TOP>&nbsp;</TD>
			</TR>
			<TR>
				<TD VALIGN=TOP><INPUT TYPE=SUBMIT NAME="func" VALUE="  Create Backup  " style="width: 160px" TITLE="Create new database"><BR><HR SIZE=1></TD>
			</TR>
			<TR>
				<TD VALIGN=TOP><INPUT TYPE=SUBMIT NAME="func" VALUE="     Restore     " style="width: 160px" TITLE="Create new database"></TD>
			</TR>
			<TR>
				<TD HEIGHT=4></TD>
			</TR>
		</TABLE>
<!-- end of control table -->
			</TD>
		</TR>
  	</TABLE>
	</TD></TR></TABLE>
	
                 </TD>
				 <TD>
<!-- query table -->
	<TABLE BORDER=0 BGCOLOR="#AAAAAA" CELLPADDING=1 CELLSPACING=0><TR><TD>	
	<TABLE BORDER=0 BGCOLOR="#CCCCCC" CELLPADDING=1 CELLSPACING=0>
		<TR HEIGHT=220 VALIGN=TOP><TD HEIGHT=220 VALIGN=TOP>	
         	
			<TABLE BORDER=0>
			<TR>
          		<TD><INPUT TYPE=SUBMIT NAME="tableops" VALUE="    Execute Query    " style="width: 150px;" TITLE="Execute SQL Statement"></TD>
			</TR>
			<TR><TD><TEXTAREA WRAP=PHYSICAL NAME="SQL" ROWS=8 COLS=$textareasize TITLE="Type SQL Statement to execute">$SQL</TEXTAREA></TD>
          	</TR>
			</TABLE>
				
			
	</TD></TR></TABLE>
	</TD></TR></TABLE>

<!-- end of query table -->				 
				 </TD>
             </TR>
		</TABLE>
</FORM>
EndSelectDB
;		
}

sub belongsb {
#	syntax: &belong($ref_array, value)	
	foreach (@{$_[0]}){if ($_[1] eq $_){return 1}}
	return 0;
}
sub belongs {
#	syntax: &belong($ref_array, value)	
	foreach (@{$_[0]}){if ($_[1] =~ /^$_$/i){return 1}}
	return 0;
}

sub prepare_execute {
	my $query 	= $_[0];
	my $sth		= $dbh->prepare($query) || bail_out ("Cannot prepare query:\n$query", $_[1], $_[2]);
	my $res		= $sth->execute() 		|| bail_out ("Can not execute query:\n$query", $_[1], $_[2]);
return ($sth, $res)
}

sub count_rows {
#input: $table = @_[0];
	my $query	= "SELECT COUNT(*) FROM $_[0]";
	my $count	= $dbh->selectrow_array($query, \%attr);
	my $msg 	= "WRONG PARAMETERS.";
	$msg 		.= " CHECK YOUR INPUTS!\n\n" if $page =~ /[(insert)|(search)]/;
	if ($DBI::errstr){
		my $back;
		if ($_[1]){bail_out($msg, $_[1],$_[2])}
		elsif($database) {bail_out($msg, {page => 'select_db', dbname => "$database"})}
		else {bail_out($msg, {page => 'connect'})}
	}
	
	return ($count)
}

sub loadSelectTables {
	unless ($database or $q->param('dbname')){bail_out("Database is not selected", {page => "connect"})}
	$query						= "SHOW TABLES" ;
	my ($sth, $res)				= &prepare_execute($query, {page => "connect"});
	my $table;
	my $i=0;
	while (my ($y) = $sth->fetchrow_array ())	{
		$table .= qq!<OPTION VALUE=$y>$y\n!;
		$i++;
	}
	$sth->finish();

	if ($i == 0){$table .= qq!<OPTION VALUE="">Table list is empty\n!;}

	my ($wheresize1, $wheresize2, $limitsize) = $agent ?
		(18, 18, 5) :
		(31, 31, 8) ;
	my $buttonwidth 	= '123px';
	my $buttonwidth2	= $buttonwidth * 2;


print <<EOT
<FORM METHOD=POST ACTION=$full_url>
<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">


<TABLE BORDER=0><!-- main table -->
	<TR>
		<TD VALIGN=TOP>
		<TABLE BORDER=0 WIDTH="100%"><!-- left table -->
			<TR>
				<TH ALIGN=LEFT>&nbsp;TABLES IN "$database"</TH>
			</TR>
			<TR>
				<TD>
<SELECT NAME="tables" SIZE=13 MULTIPLE>
$table
</SELECT></TD>
			</TR>		
		</TABLE>
<!-- EXTENDER --><TABLE BORDER=0 WIDTH=210 CELLPADDING=0 CELLSPACING=0><TR><TD>&nbsp;</TD></TR></TABLE>
		</TD>
		<TD  VALIGN=TOP>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><!-- right table-->
	<TR>
		<TD>
		
<!-- SEARCH-MODIFY -->

	 	<!-- BORDER START -->
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD width="100%"><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD>


			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
				<TR>
					<TD><INPUT TYPE=SUBMIT NAME="func" VALUE="Search/Modify" 	style="width: $buttonwidth" TITLE="Search/Modify records in selected table"></TD>
					<TD><INPUT TYPE=SUBMIT NAME="func" VALUE="       DDL      "	style="width: $buttonwidth" TITLE="Generate CREATE TABLE statements for selected tables"></TD>
					<TD><INPUT TYPE=SUBMIT NAME="func" VALUE="    IMPORT    "	style="width: $buttonwidth" TITLE="Import data into table from ASCII file"></TD>
					<TD><INPUT TYPE=SUBMIT NAME="func" VALUE="    EXPORT   "	style="width: $buttonwidth" TITLE="Export data from table into ASCII file"></TD>
				</TR>
			</TABLE>
			<!-- BORDER END --></TD></TR></TABLE></TD></TR></TABLE>
			
<!-- END OF SEARCH-MODIFY -->
		
		</TD>
	</TR>
	<TR>
		<TD HEIGHT=2></TD>
	</TR>
	<TR>		
		<TD>
		
		
<!-- DESCRIBE, INSERT, ALTER, CREATE -->
		<!-- BORDER START -->
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD WIDTH="100%"><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD>

			
			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>		
				<TR><TD><INPUT TYPE=SUBMIT NAME="func" VALUE="DESCRIBE"  style="width: $buttonwidth" TITLE="List columns for selected tables"></TD>
					<TD><INPUT TYPE=SUBMIT NAME="func" VALUE="  INSERT  " style="width: $buttonwidth" TITLE="Insert new record into selected table"></TD>
					<TD><INPUT TYPE=SUBMIT NAME="func" VALUE="   ALTER  "  style="width: $buttonwidth" TITLE="Alter selected table"></TD>
					<TD><INPUT TYPE=SUBMIT NAME="func" VALUE="  CREATE  "  style="width: $buttonwidth" TITLE="Create new table"></TD>
				</TR>
			</TABLE>
			<!-- BORDER END --></TD></TR></TABLE></TD></TR></TABLE>
			
<!-- END OF DESCRIBE, INSERT, ALTER, CREATE -->			
		</TD>
	</TR>
	<TR>
		<TD HEIGHT=2></TD>
	</TR>
	<TR>		
		<TD>
<!-- UPDATE -->

		<!-- BORDER START -->
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD WIDTH="100%"><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD>


			<TABLE BORDER=0  CELLPADDING=0 CELLSPACING=0>
				<TR><TD WIDTH=100><INPUT TYPE=SUBMIT NAME="func" VALUE="  UPDATE "  style="width: $buttonwidth"  TITLE="Edit records in selected table"></TD>
					<TD>&nbsp;where&nbsp;<INPUT TYPE=TEXT NAME="updateWhere" VALUE="" SIZE=$wheresize1 TITLE="Define which records to display for editing"></TD>
					<TD>&nbsp;limit&nbsp;<INPUT TYPE=TEXT NAME="updateLimit" VALUE="0,$UpdateRows" SIZE=$limitsize TITLE="Define start record and number of records to be displayed"></TD>
				</TR>
			</TABLE>
			<TABLE BORDER=0  CELLPADDING=0 CELLSPACING=0 WIDTH="100%">
				<TR><TD HEIGHT=2 COLSPAN=3></TD>
				</TR> 

			<!--	<TR><TD WIDTH=10>&nbsp;</TD>
					<TD>&nbsp;order&nbsp;by&nbsp;<INPUT TYPE=TEXT NAME="updateOrder" VALUE="" SIZE=10>&nbsp;</TD>
					<TD>&nbsp;offset&nbsp;<INPUT TYPE="TEXT" NAME="updateStart" VALUE="0" SIZE=5>&nbsp;rows&nbsp;<INPUT TYPE=TEXT NAME="updateRows" VALUE="$UpdateRows" SIZE=5 MAXLENGTH=3></TD>
				</TR> -->
			</TABLE>
			
			 <!-- BORDER END --></TD></TR></TABLE></TD></TR></TABLE>
			
<!-- END OF UPDATE -->
		</TD>
	</TR>
	<TR>
		<TD HEIGHT=2></TD>
	</TR>
	<TR>
		<TD>
<!-- SELECT -->	
	 	<!-- BORDER START -->
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD width="100%"><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD>
		
			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 BGCOLOR="#CCCCCC">
				<TR>
					<TD WIDTH=100><INPUT TYPE=SUBMIT NAME="func" VALUE="SELECT all" style="width: $buttonwidth"  TITLE="Show records in selected tables"></TD>
					<TD>&nbsp;where&nbsp;<INPUT TYPE=TEXT NAME="where" VALUE="" SIZE=$wheresize1 TITLE="Define which records to be displayed"></TD>
					<TD>&nbsp;limit&nbsp;<INPUT TYPE=TEXT NAME="limit" VALUE="0,$SelectRows" SIZE=$limitsize TITLE="Define start record and number of records to be displayed"></TD>
				</TR>
			</TABLE>
			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%" BGCOLOR="#CCCCCC">
				<TR><TD HEIGHT=2 COLSPAN=5></TD>
				</TR> 
			<!--	<TR><TD WIDTH=10>&nbsp;</TD>
					<TD ALIGN=RIGHT>group&nbsp;by&nbsp;</TD>
					<TD><INPUT TYPE=TEXT NAME="groupby" SIZE=11  TITLE="Define the columns to group selected records by">&nbsp;</TD>
					<TD ALIGN=RIGHT>order&nbsp;by&nbsp;</TD>
					<TD><INPUT TYPE=TEXT NAME="orderby" SIZE=11 TITLE="Define the columns to order selected records by">&nbsp;</TD>
					<TD>limit&nbsp;</TD>
					<TD>&nbsp;</TD>
				</TR>	-->
			</TABLE> <!-- BORDER END --></TD></TR></TABLE></TD></TR></TABLE>
<!-- END OF SELECT -->
		</TD>
	</TR>				
	<TR><TD HEIGHT=2></TD>
	</TR>
	<TR>
		<TD>
<!-- DELETE -->

	 	<!-- BORDER START -->
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD width="100%"><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD>


			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%">
				<TR>
					<TD WIDTH=100><INPUT TYPE=SUBMIT NAME="func" VALUE="  DELETE  " style="width: $buttonwidth; color: #CC0000"  TITLE="DELETE RECORDS FROM SELECTED TABLE"></TD>
					<TD>&nbsp;where&nbsp;<INPUT TYPE=TEXT NAME="wheredelete" VALUE="" TITLE="Define which record to delete from selected table.\nIF THIS FIELD IS BLANK, ALL RECORDS WILL BE DELETED" SIZE=$wheresize2></TD>
				</TR>
			</TABLE>
			<!-- BORDER END --></TD></TR></TABLE></TD></TR></TABLE>
<!-- END OF DELETE -->
		</TD>
	</TR>
	<TR><TD HEIGHT=2></TD>
	</TR>
	<TR>
		<TD>
<!-- DROP -->

	 	<!-- BORDER START -->
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD width="100%"><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD>


			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%">
				<TR>
					<TD WIDTH=100><INPUT TYPE=SUBMIT NAME="func" VALUE="   DROP   "  style="width: $buttonwidth; color: #CC0000" TITLE="DROP SELECTED TABLES"></TD>
				</TR>
			</TABLE>
			<!-- BORDER END --></TD></TR></TABLE></TD></TR></TABLE>
<!-- END OF DROP -->
		</TD>
	</TR>
	<TR><TD HEIGHT=2></TD>
	<TR>			
		<TD>
<!-- EXECUTE SCRIPT CONTROL -->

	 	<!-- BORDER START -->
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD width="100%"><TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD>


			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%">
				<TR>
					<TD WIDTH="25%"><INPUT TYPE=SUBMIT NAME="func" VALUE="SQL SCRIPTS" style="width: $buttonwidth" TITLE="CREATE, RUN AND SAVE SQL SCRIPTS"></TD>
					<TD WIDTH="25%"><INPUT TYPE=SUBMIT NAME="func" VALUE=" BACKUP DB " style="width: $buttonwidth" TITLE="CREATE DUMP FILES"></TD>
					<TD WIDTH="25%"><INPUT TYPE=SUBMIT NAME="func" VALUE="RESTORE DB " style="width: $buttonwidth" TITLE="RESTORE FROM DUMP FILES"></TD>
					<TD WIDTH="25%"></TD>
				</TR>
			</TABLE>
			<!-- BORDER END --></TD></TR></TABLE></TD></TR></TABLE>
<!-- END EXECUTE SCRIPT CONTROL -->		
		
		
		</TD>
	</TR>
</TABLE> <!-- END OF RIGHT INNER TABLE -->

		</TD>
	</TR>
</TABLE><!-- END OF MAIN TABLE -->
</FORM>
EOT
;

	return
}

sub execDescribeTables {
	print "\n<!-- Describe procedure starts here -->\n";
	my $headtab = {name	=> 'DESCRIBE'};
	printHeaderTable({name => 'DESCRIBE'});
	my @tabs = $q->param('tables');
	if (@tabs == 0 or !$tabs[0]){
		bail_out ("Table is not specified.", {page => 'select_db', dbname => "$database"});
	}
	
AA:	foreach my $table (@tabs) {
		print qq!<CODE TITLE="Colums and keys info on table &quot;$table&quot;">TABLE:&nbsp;&nbsp;$table</CODE><BR>!;
		my @query = ("DESCRIBE $table", "SHOW INDEX FROM $table");
		foreach (@query) {
			my $sth = $dbh->prepare($_);
			my $res = $sth->execute();
			if ($DBI::err) {
				print "<BR><B>Error $DBI::err (", quoteit($DBI::errstr),")</B><P>";
				$sth->finish;
				next AA;
			}
			print &printresult(\$sth);
			if ($DBI::err) {ErrMessage ("(Table $table)Print Result Error. $DBI::err $DBI::errstr")}
			print "<BR>";
			$sth->finish;
		}
		print "\n<HR SIZE=1 LENGTH=700><P>\n"	
	}
	print "\n<!-- Describe procedure ends here -->\n";
	return;
}
	
sub	loadInsertForm {
# INSERT / SEARCH / EDIT DATA FORM
	print "<!-- Insert/Search/Modify procedure starts here -->" unless $q->param('update');
	my @tabs = $q->param('tables');
	my $array;
	my $back = {dbname => "$database", page => "select_db"};

	if ((@tabs == 0) or !$tabs[0]){
		bail_out("Table is not specified.", $back);
	}
	elsif  (@tabs >=2) {
		bail_out("Too many tables were selected.", $back);
	}
	$back->{tables}	= "$tabs[0]";
	$back->{page}	= '';
	$back->{func}	= 'return';
	
	my $ProcName;
	my $func = $q->param('func');
	my $editdata;
	my $goback;
	my ($hiddeninput, $hiddeninput1);
	my $msg 		= $_[0];
	my $rowhint;
	
	if ($page eq 'searchresult')  {
		my @fields 		= $q->param('fields');
		my $where 		= $q->param('where');
		my $order 		= $q->param('order');
		my $start 		= $q->param('start');
		my $rows  		= $q->param('rows');
		my $where_		= quoteit($where);
		my $count		= $q->param('count');
		$hiddeninput = $q->hidden(-name=>'fields', -value=>\@fields, -override=>1);
		$hiddeninput .= <<EndOfInsHidden
<INPUT TYPE=HIDDEN NAME="order" VALUE="$order">
<INPUT TYPE=HIDDEN NAME="where" VALUE="$where_">
<INPUT TYPE=HIDDEN NAME="start" VALUE="$start">
<INPUT TYPE=HIDDEN NAME="rows" VALUE="$rows">
<INPUT TYPE=HIDDEN NAME="count" VALUE="$count">
EndOfInsHidden
;
 		$hiddeninput1 = $hiddeninput unless ($func =~ /back/i);

		$back->{page}	= 'searchresult';
		$back->{start}	= "$start";
		$back->{rows} 	= "$rows";
		$back->{fields}	= \@fields;
		$back->{where}	= "$where";
		$back->{order}	= "$order";

		$goback = <<EndGoBack
<FORM ACTION="$full_url" METHOD=POST>
<INPUT TYPE=SUBMIT VALUE="Back to search result" TITLE="Go back to Search Result page" style="width: 190px">
<INPUT TYPE=HIDDEN NAME="tables" VALUE="$tabs[0]">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="func" VALUE="return">
<INPUT TYPE=HIDDEN NAME="page" VALUE="searchresult">
$hiddeninput
</FORM>
EndGoBack
;
		if ($func =~ /^\s*edit/i){
			$rowhint = 'Edit this value';
			my $query;
			my @updatewhere;
			my @selectrow		= $q->param('SelectRow');
			if (@selectrow and !$msg){
				$msg = "<CODE>ROW No $selectrow[0]</CODE>"
			} 
			if ($q->param('update')){
				@updatewhere = $q->param('updatewhere');
				$where = shift @updatewhere; #process curent row
				execSearchupdate($back, $where);
				unless (@updatewhere) {searchresult(); return}
			}
			else {

				bail_out('Please select a row(s)', $back) unless (@selectrow);
				$query 		= "SELECT *  FROM $tabs[0]";
				$query 		.= " $where" if $where;
				$query 		.= " $order";
				my $callgetwhere = {
					count => "$count", 
					table => "$tabs[0]", 
					start => "$start", 
					rows => "$rows", 
					query => "$query", 
					back => $back, 
					returnarray => 1
				};
				my $updatewhere 	= getwhere($callgetwhere);
				@updatewhere		= @$updatewhere;
			}
			my $selectedrow = $selectrow[0] + 1;
			$hiddeninput1 .= qq!<INPUT TYPE=HIDDEN NAME="SelectRow" VALUE="$selectedrow">\n!; 
			$where = $updatewhere[0];  #show next row
			$query	= "SELECT * FROM $tabs[0] WHERE $where";
			$ProcName 		= 'EDIT RECORD';
			$func 	  		= 'edit';
#			print "QUERY = $query<BR>";
			my($sth,$res)	= prepare_execute($query, {page=>'select_db', dbname=>"$database"});
			bail_out("Too many results. Please report this event to tech\@edatanew.com", $back ) if ($res > 1);
			bail_out("Record was not found. Please report this event to tech\@edatanew.com", $back) if ($res == 0);
			$editdata = $sth->fetchrow_hashref();
			$sth->finish;
			foreach (@updatewhere){$hiddeninput1 .= qq!<INPUT TYPE=HIDDEN NAME="updatewhere" VALUE="$_">\n!;}
			$hiddeninput1 .= qq!<INPUT TYPE=HIDDEN NAME="update" VALUE="1">!; 
		}
		elsif ($func =~ /new/i){$func = 'insert'}
		elsif ($func =~ /back/i){$func = 'search'; $page= 'search';}
	}
	elsif ($page eq 'tables'){
		if($func =~ /insert/i){$func= 'insert'; $page= 'insert';}
		if($func =~ /search/i){$func= 'search'; $page= 'search';}
	}
	if($func eq 'insert'){
		$ProcName = 'INSERT DATA';
		$rowhint  = 'Type new value to insert'; 
	}
	elsif ($func =~ /^\s*search/i or $page eq 'search'){
		$ProcName = 'SEARCH RECORDS';$func= 'search';
		$rowhint  = 'Type search pattern or values (delimited by comma, if applicable)';
	}
	
	my $query 		= "DESCRIBE $tabs[0]";
	my $sth			= $dbh->prepare($query) || bail_out("Cannot prepare query:\n$query",{page => 'select_db', dbname => "$database"});
	my $res			= $sth->execute 		|| bail_out("Cannot execute query:\n$query",{page => 'select_db', dbname => "$database"});
	my $count		= count_rows($tabs[0],{page => 'select_db', dbname => "$database"});
	my $textsize;
	my $textareasize;
	my $namelist;
	my $insertOptions;
	my $showfields;
	my $delayed		= qq!<I>Delayed</I><INPUT TYPE=RADIO NAME="insert_option1" VALUE="DELAYED" TITLE="Delayed Insertion">!	if $func eq 'insert';
	
	$array->[0][0]	= qq!<TH ALIGN=LEFT>&nbsp;$sth->{NAME}->[0]</TH>!;

	# CORRECT THIS LINE TO USE UNQUOTED DATA FOR SEARCHING (DELETE unless CONDITION).
	$array->[0][1]	= qq!<TH>&nbsp;Unquoted&nbsp;<BR>Data<BR>(funcion)</TH>! 			unless ($func eq 'search');

	$array->[0][2]	= qq!<TH>&nbsp;Upload&nbsp;</TH>! 									unless ($func eq 'search');
	$array->[0][3]	= qq!<TH ALIGN=CENTER>I n s e r t&nbsp;&nbsp;D a t a</TH>! 			if $func eq 'insert';
	$array->[0][3]	= qq!<TH ALIGN=CENTER>S e a r c h&nbsp;&nbsp;P a t t e r n</TH>! 	if $func eq 'search';
	$array->[0][3]	= qq!<TH ALIGN=CENTER>M o d i f y&nbsp;&nbsp;D a t a</TH>! 			if $func eq 'edit';
	
	my $i;
	if ($func eq 'search'){
		$array->[0][5]	= qq!<TH ALIGN=CENTER COLSPAN=2 ALIGN=TOP>Advanced search</TH>!;
		$textsize		= $agent ? 18 : 31;
		$textareasize	= $agent ? 17 : 30;
		$namelist		= qq!<SELECT NAME="sort" TITLE="Select column to sort by">\n<OPTION VALUE="">\n!;
	}
	else {
		for ($i=1; $i<($sth->{NUM_OF_FIELDS}-1); $i++) {
			$array->[0][$i+3] = qq!<TH ALIGN=CENTER> $sth->{NAME}->[$i] </TH>\n!;
		}
		$textsize		= $agent ? 36 : 60;
		$textareasize	= $agent ? 35 : 59;
	}
	my $textflag;
	my $bottomMessage;
	my $j = 1;
	while (@ary = $sth->fetchrow_array ())	{
		my $k=$j-1;
		($ary[1],$ary[4],$editdata->{$ary[0]}) = quoteit($ary[1],$ary[4],$editdata->{$ary[0]});
		my $value = $editdata->{$ary[0]};
		$array->[$j][0]= qq!<TD>&nbsp;<B>$ary[0]&nbsp;</B></TD>!;
		if ($ary[1] =~ /^\s*enum/ or $ary[1] =~ /^\s*set/){
		   $array->[$j][1]= qq!<TD ALIGN=CENTER>&nbsp;-&nbsp;</TD>!;
		}
		else {

			$array->[$j][1]= qq!<TD ALIGN=CENTER>&nbsp;<INPUT TYPE=CHECKBOX NAME="unquote" VALUE="$ary[0]" TITLE="Check to insert Functions">&nbsp;</TD>!;
		}
		my $ary1 = $ary[1];
		$ary1 =~ s/^\s*//;
		$ary1 =~ s/\W.*//g;
		my $type = $ary[1];
		if (belongs(\@textdata, $ary1)){
			if ($func eq 'search'){
				$array->[$j][3]= qq!<TD>&nbsp;<TEXTAREA NAME="$ary[0]_data" COLS=$textareasize ROWS=1 WRAP=OFF TITLE="$rowhint"></TEXTAREA>&nbsp;</TD>\n!;
			}
			else {
				$array->[$j][2]	= qq!<TD ALIGN=CENTER>&nbsp;<INPUT TYPE = CHECKBOX \t NAME = "upload"\tVALUE = "$ary[0]" TITLE="Check to upload file">&nbsp;</TD>!;
				$array->[$j][3]	= qq!<TD><TEXTAREA NAME="$ary[0]_data" COLS=$textareasize ROWS=5 WRAP=OFF TITLE="$rowhint">$editdata->{$ary[0]}</TEXTAREA>&nbsp;<BR>\n!;
				$array->[$j][3] .= qq!&nbsp;<INPUT TYPE=FILE \t\t NAME="$ary[0]_data_upload" \tVALUE="" TITLE="Select file to upload">&nbsp;</TD>!;
				$textflag = 1;
			}
		} 
		elsif($ary[1] =~ /^\s*enum\s*\((.*)\)/){
			$type = 'enum';
			$array->[$j][2]		= qq!<TD ALIGN=CENTER>&nbsp;-&nbsp;</TD>!;
			$array->[$j][3]		= qq!<TD>&nbsp;<SELECT NAME="$ary[0]_data" TITLE="Select value">\n!;
			$array->[$j][3] 	.= qq!\t<OPTION VALUE="">\n!;
			my @enumval = split ',',$1;
			foreach (@enumval){
				s/^'(.*)'$/$1/;
				s/''/'/g;
				my $selected	= 'SELECTED' if (($_ eq $editdata->{$ary[0]}) and ($func eq 'edit'));
				$array->[$j][3]	.= qq!\t<OPTION VALUE="$_" $selected>$_\n!;
			}
			$array->[$j][3]		.= qq!</SELECT>&nbsp;</TD>!;
		}
		else {
			 $array->[$j][2]	= qq!<TD ALIGN=CENTER>&nbsp;-&nbsp;</TD>!;
			 $array->[$j][3]	= qq!<TD><INPUT TYPE=TEXT \t\t NAME="$ary[0]_data"\tVALUE="$editdata->{$ary[0]}" SIZE=$textsize TITLE="$rowhint"></TD>!;
		}
		if ($func eq 'search'){
			
			#DELETE THIS LINE IF YOU NEED TO SEARCH BY UNQUOTED DATA
			$array->[$j][1] = ''; 
			
			#THE REMARKED 'OPTIONS' ARE SUPPORTED BY THE PROGRAM. UNREMARK THEM IF NEEDED.
			
			$array->[$j][6]		= qq!<TD ALIGN=LEFT>&nbsp;<EM>$type</EM>&nbsp;</TD>!;
			my $typename		= $ary[1];
			$typename			=~ s/^\s*([a-zA-z])\s*\W.*//i;
			$namelist			.= qq!<OPTION VALUE="$ary[0]">$ary[0]\n!;
			$showfields			.= qq!<OPTION VALUE="$ary[0]" SELECTED>$ary[0]\n!;
			my $oper_options	= qq!<OPTION VALUE="">\n!;
			$oper_options 		.= qq!<OPTION VALUE="start">Starts with\n!	unless ($type eq 'enum');
			$oper_options 		.= qq!<OPTION VALUE="end">Ends with\n!		unless ($type eq 'enum');
			$oper_options 		.= qq!<OPTION VALUE="AND">AND (ALL)\n!		unless ($type eq 'enum');
			$oper_options 		.= qq!<OPTION VALUE="OR">OR (ANY)\n!		unless ($type eq 'enum');
			$oper_options 		.= qq!<OPTION VALUE="&gt;">&gt;\n!;
#			$oper_options 		.= qq!<OPTION VALUE="&gt;=">&gt;=\n!;
			$oper_options 		.= qq!<OPTION VALUE="&lt;">&lt;\n!;
#			$oper_options 		.= qq!<OPTION VALUE="&lt;=">&lt;=\n!;
			$oper_options 		.= qq!<OPTION VALUE="=">=\n!;
			$oper_options 		.= qq!<OPTION VALUE="BETWEEN">BETWEEN\n!	unless (($type eq 'enum') or (!check_version("3.21.2")));
			$oper_options 		.= qq!<OPTION VALUE="IN">IN\n!				unless ($type eq 'enum');
#			$oper_options 		.= qq!<OPTION VALUE="REGEXP">REGEXP\n!		unless ($type eq 'enum');
#			$oper_options 		.= qq!<OPTION VALUE="LIKE">LIKE\n!;
			$oper_options 		.= qq!<OPTION VALUE="NULL">NULL\n!;
#			$oper_options 		.= qq!<OPTION VALUE="FUNCTION">FUNCTION\n!;

			$array->[$j][$i+4] =
			qq!<TD>&nbsp;<SELECT NAME="operator_$ary[0]" TITLE="Select search criterion">$oper_options</SELECT>&nbsp;</TD>!;
		
 		   	my $matchcase		= qq!<INPUT TYPE=CHECKBOX NAME="case_$ary[0]" TITLE="Case sensitive searching">match&nbsp;case&nbsp;! if check_version("3.23.00");
			$array->[$j][$i+5]	= qq!<TD><nobr><INPUT TYPE=CHECKBOX NAME="not_$ary[0]" TITLE="Inverse search criterion">not&nbsp;$matchcase</nobr></TD>!;
		}		
		else {
			my $i;
			$array->[$j][4]		= qq!<TD ALIGN=LEFT>&nbsp;<EM>$type</EM>&nbsp;</TD>!;
			for (my $i=2; $i<(@ary - 1); $i++){
				my $color1;
				my $color2		= "</FONT>";
				my $font1		= '<EM>';
				my $font2		= '</EM>';
				if (($i==3 and ($ary[3] =~ /PRI/)) or ($i == 5 and ($ary[5] =~ /auto/i))){
					$color1		= qq!<FONT COLOR = '#CC0000'>!;
					$font1		= '';
					$font2		= '';
				}
				$array->[$j][$i+3] = qq!<TD>&nbsp;$font1$color1$ary[$i]$color2$font2&nbsp;</TD>!;
			}
		}
		
		$j++;
	} #WHILE
	$sth->finish();
	if ($func eq 'search'){
		my $rowspan 			= $j + 1;
		my $size 				= $j - 1;
		$namelist 				.= qq!</SELECT>&nbsp;\n!;
		$showfields 			= qq!<SELECT MULTIPLE NAME="fields" SIZE=$size TITLE="Select columns to be displayed in the result">\n!.$showfields;
		$showfields 			.= qq!</SELECT>&nbsp;\n!;
		$bottomMessage 			= "<LI>The Arguments are <U>comma separated</U>.";
		my $criterion 			= <<EndOfCriterion
<TABLE BORDER=0 CELLPADDIND=2 CELLSPACING=1>
	<TR>
		<TD>&nbsp;
		</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT>Sort by&nbsp;<BR>$namelist</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT>Sort&nbsp;Order&nbsp;<BR><SELECT NAME="sortorder" TITLE="Select between ascending and descending ordering">
<OPTION VALUE="ASC">Ascending
<OPTION VALUE="DESC">Descending
</SELECT>&nbsp;</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT HEIGHT=6></TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT>Start&nbsp;<INPUT TYPE=TEXT SIZE=4 NAME="start" VALUE=0 TITLE="Define record search result displaing will start from">&nbsp;</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT>Hits&nbsp;<INPUT TYPE=TEXT SIZE=4 NAME="rows" VALUE=10 TITLE="Define number of records per page to be displayed">&nbsp;</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT TITLE="Select logical operator OR or AND">logical&nbsp;<SELECT NAME="andor" TITLE="Select logical operator OR or AND">
<OPTION VALUE="OR" SELECTED>OR
<OPTION VALUE="AND">AND
</SELECT>&nbsp;</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT>Show&nbsp;columns&nbsp;<BR>in&nbsp;search&nbsp;result&nbsp;<BR>$showfields</TD>
	</TR>

</TABLE>
EndOfCriterion
;
		push @{$array->[0]},"<TD ROWSPAN=$rowspan VALIGN=TOP>$criterion </TD>";
		push @{$array->[0]},"<TH ALIGN=CENTER> $sth->{NAME}->[1] </TH>\n";

	}
	else {
		my $word = 'UPDATE';
		 
		if ($func eq 'insert'){
			my @insmethod = (
					$q->radio_group(
						-name=>'insmethod', 
						-values=>['INSERT'], 
						-default=>'INSERT', 
						-labels=>{INSERT => ''}
						),
					$q->radio_group(
						-name=>'insmethod', 
						-values=>['REPLACE'], 
						-default=>'-', 
						-labels=>{REPLACE => ''}
						)
			);
			
			$word =  qq![INSERT&nbsp;$insmethod[0]&nbsp;|&nbsp;REPLACE&nbsp;$insmethod[1]]!;
		}
		my $ignore = qq![<I> Ignore</I><INPUT TYPE=CHECKBOX NAME="insert_option2" VALUE = "IGNORE" TITLE="Ignore rows that duplicate values for unique keys">]! if (($func eq 'insert') or check_version('3.23.16'));
		$insertOptions = <<EOT
			$word [<I> Low_Priority</I><INPUT TYPE=RADIO NAME="insert_option1" VALUE = "LOW_PRIORITY" TITLE="Defer the statement until no clients are reading from the table">
			$delayed ]
			$ignore
EOT
;
		$bottomMessage = <<EOT
		
<LI>To import data into<B> Text </B>and <B>Blob</B> fields from local file, select the checkbox "Upload".<BR>
Otherwise use textatrea to insert data (any information in the file field will be ignored).
<LI>Check "Unquoted Data" to use SQL functions or numeric values. <BR><U>NEVER USE IT IF YOU ARE NOT SURE WHAT IT DOES</U><BR>&nbsp;

EOT
;
	
	}
	my $headtab = {
		name	=> "$ProcName",
		table	=> "TABLE&nbsp;\"$tabs[0]\"",
		rows	=> "Total&nbsp;rows:&nbsp;$count",
		msg		=> "$msg"
	};
	printHeaderTable($headtab);
	print <<InsertHead
	

<FORM ACTION="$full_url" METHOD="POST"  ENCTYPE="multipart/form-data">

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 BGCOLOR="#AAAAAA">
			<TR>
				<TD WIDTH="100%">
				
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=1 BGCOLOR="#AAAAAA" WIDTH="100%"><!-- Insert Form Table -->

InsertHead
;

	foreach (@$array) {
		${$_}[2] = '' unless $textflag;
		print qq!\t<TR BGCOLOR="#CCCCCC" HEIGHT=22>@{$_}</TR>\n!;

	}
	print <<InsertBottom

</TABLE>
</TD></TR></TABLE>
<P>
<INPUT TYPE = HIDDEN NAME="tables" VALUE="$tabs[0]">
<INPUT TYPE = HIDDEN NAME="page" VALUE="$page">
<INPUT TYPE = HIDDEN NAME="func" VALUE="$func">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
$hiddeninput1

<!-- Option Table -->

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<TR>
		<TD><INPUT TYPE = SUBMIT NAME="submit" VALUE="Submit" TITLE="Submit" style="width: 190px">&nbsp;</TD>
		<TD><INPUT TYPE=RESET TITLE="Reset form">&nbsp;</TD>
		<TD>$insertOptions</TD>
	</TR>
</TABLE>
<!--End of Option Table -->
</FORM><P>
$goback
<UL>
$bottomMessage
<!-- loadInsertForm procedure ends here -->
</UL>
InsertBottom
;
	return;
}

sub loadZoom {
	my ($table)			= $q->param('tables');
	my @fields 			= $q->param($table.'_fields');
	my $dbname 			= $q->param('dbname');
	my $updateWhere 	= $q->param('updateWhere');
	my $updateOrder 	= $q->param('updateOrder');
	$updateWhere 		= '' unless ($updateWhere =~ /\S/);
	$updateOrder 		= '' unless ($updateOrder =~ /\S/);
	my $updateRows 		= $q->param('updateRows');
	my $updateStart 	= $q->param('updateStart');
	my $zoomselect 		= $q->param('zoomselect');
	my $where 			= $q->param('where');
	my $order 			= $q->param('order');
	my $start 			= $q->param('SelectRow') + 0;
	my $rows 			= 1;
	$updateRows 		= '' if ($updateRows =~ /ALL/i);

	my $back = {
		dbname			=> "$database",
		tables			=> $table,
		page			=> "tables",
		func			=> "update",
		updateStart		=> $q->param('start'),
		updateRows		=> $q->param('rows'),
		updateWhere		=> "$where",
		updateOrder		=> "$order",
	};
	my @hidfields 		= $q->param('fields');
	$back->{"$table\_fields"} = \@hidfields;
	
    my $query 			= "SELECT $zoomselect FROM $table";
    $query 				.= " WHERE $where" if $where;
	$query 				.= " ORDER BY $order" if $order;
    $query 				.= " LIMIT $start, $rows ";
	my ($sth,$res) 		= prepare_execute($query,$back);
	my ($array) 		= $sth->fetchrow_array() or bail_out ("(zoom) Retrieve Error", $back);
	$sth->finish();
	($array,$updateOrder,$updateWhere,$order,$where) = quoteit($array,$updateOrder,$updateWhere,$order,$where);

	print qq?\n\n<!-- loadZoom Procedure starts here -->\n\n?;
	print qq?<FORM METHOD=POST METHOD="$full_url">?;
	my $headtab = {
		name	=> "UPDATE (Zoom)",
		table	=> "TABLE:&nbsp;$table",
		rows	=> 'row# = '."$start",
		title2	=> "This is column $zoomselect, row number $start"
	};
	printHeaderTable($headtab);
	my $textareasize	= $agent ? 60 : 90;
	print <<ZoomContinue
<!-- Update Table -->
<TABLE BORDER=0>
	<TR BGCOLOR="#cccccc">
		<TH BGCOLOR="#EEEEEE">$zoomselect</TH>
	</TR>
	<TR VALIGN=TOP>
		<TD><TEXTAREA ROWS=15 COLS=$textareasize NAME="n0_0" WRAP=OFF TITLE="Edit this value">$array</TEXTAREA></TD>
	</TR>
</TABLE>

<!-- Submit Buttons Table -->
	<TABLE BORDER=0>
		<TR>
			<TD><INPUT TYPE=SUBMIT NAME="update" VALUE="Update"  TITLE="Save changes"></TD>
			<TD><INPUT TYPE=SUBMIT NAME="reload" VALUE="Zoom Out" TITLE="Go back to Update Page"></TD>
			<TD><INPUT TYPE=RESET TITLE="Reset form"></TD>
			<TD WIDTH=15></TD>
			<TD>UPDATE&nbsp;[&nbsp;low priority<INPUT TYPE=CHECKBOX NAME="update_option1" VALUE="LOW_PRIORITY" TITLE="Defer the statement until no clients are reading from the table">&nbsp;]&nbsp;[
		   				   ignore&nbsp;<INPUT TYPE=CHECKBOX NAME="update_option2" VALUE="IGNORE"  TITLE="Ignore rows that duplicate values for unique keys">&nbsp;]</TD>
		</TR>
	</TABLE>

<INPUT TYPE=HIDDEN NAME="page" VALUE="update">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$dbname">
<INPUT TYPE=HIDDEN NAME="tables" VALUE="$table">
<INPUT TYPE=HIDDEN NAME="updateStart" VALUE="$updateStart">
<INPUT TYPE=HIDDEN NAME="updateRows" VALUE="$updateRows">
<INPUT TYPE=HIDDEN NAME="updateWhere" VALUE="$updateWhere">
<INPUT TYPE=HIDDEN NAME="updateOrder" VALUE="$updateOrder">
<INPUT TYPE=HIDDEN NAME="where" VALUE="$where">
<INPUT TYPE=HIDDEN NAME="order" VALUE="$order">
<INPUT TYPE=HIDDEN NAME="start" VALUE="$start">
<INPUT TYPE=HIDDEN NAME="rows" VALUE="$rows">
<INPUT TYPE=HIDDEN NAME="fields" VALUE="$zoomselect">
ZoomContinue
;
	print $q->hidden(	-name=>"$table\_fields",
		  				-default=>[@fields],
						-override=>1);

	print "\n\n</FORM>\n\n<!-- loadZoom Procedure ends here -->\n\n";
	return
}
sub loadUpdateForm {
	print "<!-- loadUpdateForm Procedure starts here -->\n\n";
	my @tabs = $q->param('tables');
	my $back = {dbname => "$database", page => 'select_db'};
    if  (@tabs >=2) {
		bail_out("Too many tables were selected!", $back)
    }
    if ((@tabs == 0) or !$tabs[0]){
		bail_out("Table was not specified.", $back);
    }
	if ($page eq 'tables') {$back = {page => 'select_db', dbname => "$database"}}
	elsif ($page eq 'update'){
		$back->{tables}				= "$tabs[0]";
		$back->{page}				= "update";
		$back->{reload}				= "Reload";
		$back->{updateStart}		= $q->param('start');
		$back->{updateRows}			= $q->param('rows');
		$back->{updateWhere}		= $q->param('where');
		$back->{updateOrder}		= $q->param('order');
		my @hidfields 				= $q->param('fields');
		$back->{"$tabs[0]\_fields"}	= \@hidfields;
	}
	
	my $order = $q->param('updateOrder');
	$order = '' unless ($order =~ /\S/);
	my $where = $q->param('updateWhere');
	$where = '' unless ($where =~ /\S/);
	my $rows; my $start;
	if (defined $q->param('updateLimit')) {
		($start, $rows) = split ',',$q->param('updateLimit')
	}
	else {
		$rows = $q->param('updateRows');
		$start = $q->param('updateStart');
	}

	my $count = count_rows($tabs[0]);
	$rows = '' if ($rows =~ /ALL/i);
		
	my @fields = $q->param("$tabs[0]\_fields");
	@fields = $q->param("fields") if $q->param('error');
	my $fields = join (', ', @fields);
	my $query = "DESCRIBE $tabs[0]";
	my ($sth,$res) = prepare_execute($query, $back);

	my @descrlist;
	my @printType;
	my @names;
	my @types;
	my $enums;
	my @fullname;
	my $primary_flag;
	while (@descrlist = $sth->fetchrow_array()) {
		$primary_flag = '1' if ($descrlist[3] =~ /pri/i ) ;
		if (belongs(\@fields,$descrlist[0]) or @fields == 0) {
			push @printType,$descrlist[1];
			if (($descrlist[1] =~ /^\s*\w*blob/i) or ($descrlist[1] =~ /^\s*\w*text/i)){push @types, "-1"}
			elsif($descrlist[1] =~ /^\s*enum\s*\((.*)\)/){
				push @types,'enum';
				my @enumval = ('',split ',',$1);
				@enumval = quoteit(@enumval);
				for (my $i = 0; $i < @enumval; $i++){
					$enumval[$i] =~ s/^'(.*)'$/$1/;
					$enumval[$i] =~ s/''/'/g;
					$enums->{$descrlist[0]}[$i] = $enumval[$i];
				}
			}
			else {push @types, 0}
			push @names,$descrlist[0];
		}
		push @fullname,$descrlist[0];
	}
	$sth->finish();
	
	my $types = \@types;
	my $size = scalar @fullname;
	if (!$fields or ($size == scalar @fields)){$fields = '*'; @fields = @fullname}

	my ($where_, $order_) = quoteit($where, $order);
	print $q->start_multipart_form(-method=>"POST",
		  						   -action=>$full_url);

	my $headtab = {
		name	=> 'UPDATE',
		table	=> "TABLE:&nbsp;$tabs[0]",
		rows	=> "Total&nbsp;rows:&nbsp;$count",
		msg		=> "$_[0]"
		
	};
	my ($wheresize, $textsize, $textareasize) = $agent ? (20, 15, 20 ) : (30, 20, 30 );
	printHeaderTable($headtab);
	print qq?
<TABLE BORDER=0><TR><TD>


    <!-- Parameter Table -->
    <TABLE BORDER=0 CELLPADDING=2 WIDTH="100%">
    	<TR>
    		<TD>&nbsp;where&nbsp;<INPUT TYPE=TEXT NAME="updateWhere" VALUE="$where_" SIZE=$wheresize TITLE="Specify records to display"></TD>
    		<TD>&nbsp;order&nbsp;by&nbsp;<INPUT TYPE=TEXT NAME="updateOrder" VALUE="$order_" SIZE=15 TITLE="Specify column to order the records by"></TD>
    		
    		<TD>&nbsp;offset&nbsp;<INPUT TYPE=TEXT NAME="updateStart" VALUE="$start" SIZE=5 TITLE="Specify start record"></TD>
    		<TD>&nbsp;rows&nbsp;<INPUT TYPE=TEXT NAME="updateRows" VALUE="$rows" SIZE=3 MAXLENGTH=3 TITLE="Specify number of records to be displayed"></TD>
    		<TD>&nbsp;<INPUT TYPE=SUBMIT NAME="reload" VALUE="Reload" TITLE="Reload the page applying new display options only."></TD>
    	</TR>
    	<TR>
    		<TD COLSPAN=5 ALIGN=LEFT HEIGHT=6></TD>
    	</TR>
    </TABLE>
</TD></TR></TABLE>
?;

print qq?		
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="tables" VALUE="$tabs[0]">
<INPUT TYPE=HIDDEN NAME="page" VALUE="update">
<INPUT TYPE=HIDDEN NAME="start" VALUE="$start">
<INPUT TYPE=HIDDEN NAME="rows" VALUE="$rows">
<INPUT TYPE=HIDDEN NAME="where" VALUE="$where_">
<INPUT TYPE=HIDDEN NAME="order" VALUE="$order_">
?;
	foreach (@fields){
		last if ($fields eq '*');
		print "<INPUT TYPE=HIDDEN NAME=\"fields\" VALUE=\"$_\">\n";
	}
	my $priref;
	if (($start =~ /[\D]/) or ($rows =~ /[\D]/)) {
		ErrMessage("<P><B>The values OFFSET and ROWS must be numeric!</B><P>");
		print $q->hidden(-name=>'error', -value=>'1');
	}
	else {


		$query  = "SELECT $fields FROM $tabs[0]";
		$query .= " WHERE $where" if $where;
		$query .= " ORDER BY $order" if $order;
    	$query .= " LIMIT $start, $rows"			if ($start and ($rows or ($rows eq '0')));
    	$query .= " LIMIT $rows" 					if (!$start and ($rows or ($rows eq '0')));
    	$query .= " LIMIT $start, ".($count-$start)	if ($start and (!$rows and ($rows ne '0')));

		$sth = $dbh->prepare($query) || do {print $q->hidden(-name=>'error', -value=>'1'); ErrMessage("Something wrong")};
		$res = $sth->execute		 || do {print $q->hidden(-name=>'error', -value=>'1'); ErrMessage("Wrong parameters")};


		$priref = get_mysql_pri($sth);
		unless (defined $priref){$priref = []}
		print "<P><B>The Table contains no Data!</B><BR>\n\n" if ($count == 0);
	}
	print "<!-- Update Table -->\n\n";
	print "<TABLE BORDER=0>\n";
	print "\t<TR BGCOLOR=\"#cccccc\">\n\t\t<TD>&nbsp;&nbsp;</TD>\n\t\t<TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>\n";
	my $i = 0;
	my $zoom_ok = '';
	foreach (@fields) {
		my $color = '#000000';
		$color = '#ff0000' if $priref->[$i];
		my $zoomselect = '';
		if ($types[$i] == -1) {
		   $zoomselect = qq!<INPUT TYPE=RADIO NAME="zoomselect" VALUE="$_" TITLE="Select column to zoom">! ;
		   $zoom_ok = 1;
		}
		print 	qq!\t\t<TH BGCOLOR="#EEEEEE"><FONT COLOR="$color"> $zoomselect $_</TH>\n!;
		$i++;
	}
	print "\t</TR>\n";

	$i = 0;
	my $j;
	while (@ary = $sth->fetchrow_array()) {
		print "\t<TR VALIGN=TOP>\n\t\t<TD>".($i+$start)."</TD>\n";
		print qq!\t\t<TD><INPUT TYPE="CHECKBOX" NAME="SelectRow" VALUE="!.($i+$start).qq!" TITLE="Select row (to zoom or delete)"></TD>\n!;
		my $jj=0;
		for ($j=0; $j<@ary; $j++) {
			$ary[$j] = quoteit($ary[$j]);
			if ($types[$jj] == -1){
				print "\t\t<TD ALIGN=CENTER>";
				print "<TEXTAREA ROWS=2 COLS=$textareasize NAME=\"n".$i."_".$jj."\" WRAP=OFF TITLE=\"Edit this value\">$ary[$j]</TEXTAREA></TD>\n";
			}
			elsif ($types[$jj] eq 'enum'){
				print "\t\t<TD ALIGN=CENTER><SELECT NAME=\"n".$i."_".$jj."\" TITLE=\"Select another value\">\n";
				foreach (@{$enums->{$names[$j]}}) {
					my $selected = 'SELECTED' if ($_ eq "$ary[$j]");
					print qq!<OPTION VALUE="$_" $selected>$_\n!;
				}
				print "</SELECT></TD>\n";
			}
			else {
				print "\t\t<TD ALIGN=CENTER><INPUT TYPE=TEXT NAME=\"n".$i."_".$jj."\" VALUE = \"$ary[$j]\" TITLE=\"Edit this value\" SIZE=$textsize></TD>\n";
			}
			$jj++	
		}#for
		print "\t</TR>\n";
		$i++;
	}#while
	$sth->finish();
	my $DBIerr 				= $DBI::err;
	$DBIerr 				+= 0;
	$DBIerr == 0 or bail_out ("Retrieve Error");
		
	print "\t<TR>\n\t\t<TD COLSPAN=\"". (scalar (@$types)+2) ."\"><HR SIZE=\"1\"></TD>\n\t</TR>\n";
	print "\t<TR>\n\t\t<TD COLSPAN=\"". (scalar (@$types)+2) ."\">Insert new row:</TD>\n\t</TR>\n";
	print "\t<TR>\n\t\t<TD>&nbsp;</TD>\n\t\t<TD>&nbsp;</TD>\n";
	@printType = quoteit(@printType);
	foreach (@printType) {
		s/^\s*enum.*/enum/i;
		print "\t\t<TD ALIGN=CENTER>$_</TD>\n";		
	}
	print "\t</TR>\n";
		
	print "\t<TR>\n\t\t<TD>$count</TD>\n\t\t<TD>&nbsp;</TD>\n";
	$i = 0;	
	foreach (@types) {
		if ($_ == -1){
		   print qq!\t\t<TD ALIGN=CENTER><TEXTAREA WRAP=OFF ROWS=2 COLS =$textareasize NAME="$fields[$i]\_data" TITLE="Insert value"></TEXTAREA></TD>\n!;
		}
		elsif ($_ eq 'enum'){
			print qq!\t\t<TD ALIGN=CENTER><SELECT NAME="$fields[$i]\_data">\n!;
			foreach (@{$enums->{$names[$i]}}) {
				print qq!<OPTION VALUE="$_">$_\n!;
			}
				print "</SELECT></TD>\n";
		}
		else {
			print qq!\t\t<TD ALIGN=CENTER><INPUT TYPE=TEXT NAME="$fields[$i]\_data" TITLE="Insert value" SIZE=$textsize></TD>\n!;
		}	
		$i++;
	}#foreach
	my $zoombutton = '<INPUT TYPE=SUBMIT NAME="zoom" VALUE="Zoom" TITLE="Zoom selected value">' if $zoom_ok;

			my @insmethod = (
					$q->radio_group(
						-name=>'insmethod', 
						-values=>['INSERT'], 
						-default=>'INSERT', 
						-labels=>{INSERT => ''}
						),
					$q->radio_group(
						-name=>'insmethod', 
						-values=>['REPLACE'], 
						-default=>'-', 
						-labels=>{REPLACE => ''}
						)
			);
			my $word =  qq![INSERT&nbsp;$insmethod[0]&nbsp;|&nbsp;REPLACE&nbsp;$insmethod[1]]!;
	print <<EndSubmit
	</TR>
		 </TABLE>
<!-- Footer Table Starts Here -->

<TABLE BORDER=0>
	<TR>
		<TD ALIGN=LEFT VALIGN=TOP>
<!-- PREVIEW -->	
    <TABLE BORDER=0>
    	<TR>
    		<TD><P><INPUT TYPE=CHECKBOX NAME="preview" TITLE="Check to preview generated command"></TD>
    		<TD VALIGN=MIDDLE TITLE="Check to preview generated command">Preview SQL query.</TD>
    	</TR>
    </TABLE><BR>		
		
<!-- Submit Buttons -->	
	<TABLE BORDER=0>
		<TR>
	   	   <TD><INPUT TYPE=SUBMIT NAME="update" VALUE="Update" TITLE="Update the table"></TD>
		   <TD><INPUT TYPE=SUBMIT NAME="insert" VALUE="Insert" TITLE="Insert new row"></TD>
		   <TD>$zoombutton</TD>
		   <TD><INPUT TYPE=SUBMIT NAME="delete" VALUE="Delete" style="color: #CC0000" TITLE="Delete selected rows"></TD>
		   <TD><INPUT TYPE=RESET TITLE="Reset changes"></TD>
		</TR>
	</TABLE>

	<TABLE BORDER=0>
		<TR>
			<TD>UPDATE&nbsp;[&nbsp;low priority<INPUT TYPE=CHECKBOX NAME="update_option1" VALUE="LOW_PRIORITY" TITLE="Defer the statement until no clients are reading from the table">&nbsp;]&nbsp;[
		   				   ignore&nbsp;<INPUT TYPE=CHECKBOX NAME="update_option2" VALUE="IGNORE"  TITLE="Ignore rows that duplicate values for unique keys">&nbsp;]</TD>
		</TR>
		<TR>
			<TD>$word&nbsp;[&nbsp;low priority<INPUT TYPE=RADIO NAME="insert_option1" VALUE="low_priority" TITLE="Defer the statement until no clients are reading from the table">/
		   				   delayed&nbsp;<INPUT TYPE=RADIO NAME="insert_option1" VALUE="DELAYED" TITLE="Delayed Insertion">&nbsp;]&nbsp;[
						   ignore&nbsp;<INPUT TYPE=CHECKBOX NAME="insert_option2" VALUE="IGNORE"  TITLE="Ignore rows that duplicate values for unique keys">&nbsp;]</TD>
		</TR>
		<TR>
			<TD>DELETE&nbsp;[&nbsp;low priority<INPUT TYPE=CHECKBOX NAME="delete_option1" VALUE="LOW_PRIORITY" TITLE="Defer the statement until no clients are reading from the table">&nbsp;]</TD>
		</TR>

	</TABLE>
	</TD><TD VALIGN=TOP>
<!-- Select columns Table -->
	 <TABLE><TR><TD TITLE="Select columns to display"><B>Select columns</B><BR>
	 
EndSubmit
;	
	print "<SELECT SIZE=$size NAME=$tabs[0]\_fields MULTIPLE>\n";
	foreach (@fullname){
		my $selected = 'SELECTED' if (belongs(\@fields, $_) or !@fields);
		print qq!<OPTION VALUE="$_" $selected>$_ \n!;
	}
	print "\t\t</SELECT></TD>\n\t\t</TR>\n\t</TABLE>\n\n";
	print "\t\t</TD>\n\t</TR>\n</TABLE><!-- Footer Table Ends Here -->\n\n";
	print $q->end_form;
	print "\n\n<!-- loadUpdateForm Procedure ends here -->\n\n";	
	
}
sub execSelectFromTable {
	my @tabs = $q->param('tables');
	my $back 		= {page => 'select_db', dbname => "$database"};
	if ((@tabs == 0) or !$tabs[0]){
		bail_out("Table is not specified.", $back);
	}
	print "\n\n<!-- Select from Table procedure starts here -->\n\n";
	my $dbname		= $q->param ('dbname');
	my @where 		= $q->param ('where');
	for (my $i=0; $i<@where; $i++){
		$where[$i] = '' unless ($where[$i] =~ /\S/);
	}

    my @groupby 	= $q->param ('groupby');
    my @orderby 	= $q->param('orderby');
	my @select 		= $q->param('select');
	my @limitref 	= getlimit(scalar @tabs);
	
	my @limit 		= @{$limitref[0]};
	my @offset 		= @{$limitref[1]};
	my @rows 		= @{$limitref[2]};
	my @exclude = $q->param('exclude');
	if ((@tabs - @exclude) > 1){
		print <<EOT
<FORM METHOD=POST ACTION="$full_url">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$dbname">
<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">
<INPUT TYPE=HIDDEN NAME="func" VALUE="select">
EOT
;
	}
	my $i = -1;
	foreach (@tabs) {
		$i++;
		unless (defined $where[$i]) {$where[$i] = $where[0]}
		
		my $exclude = qq!&nbsp;&nbsp;&nbsp;&nbsp;<INPUT TYPE=CHECKBOX NAME="exclude" VALUE="$_" TITLE="Exclude this table next time the page is reloaded"> Exclude! if ((@tabs - @exclude) > 1);
		next if (belongs (\@exclude, $_));
		
		my (
		$orderby_,
		$groupby_,
		$limit_,
		$select_,
		$tabs_,
		$where_,
		) = quoteit(
				   	 		 $orderby[$i],
							 $groupby[$i],
							 $limit[$i],
							 $select[$i],
							 $tabs[$i],
							 $where[$i],
							 );
		

		my $tableform =  <<EOT
<TABLE>
	<TR>
		<TD><INPUT TYPE="SUBMIT" VALUE="Go" TITLE="Reload page"></TD>
		<TD>SELECT</TD>
		<TD><INPUT TYPE="TEXT" SIZE="10" NAME="select" 	VALUE="$select_" TITLE="List of columns and aliases"></TD>
		<TD>FROM</TD>
		<TD><INPUT TYPE="TEXT" SIZE="10" NAME="tables"	VALUE="$tabs_" TITLE="List of tables and aliases"></TD>
		<TD>WHERE</TD>
		<TD><INPUT TYPE="TEXT" SIZE="10" NAME="where"	VALUE="$where_" TITLE="Specify conditions of WHERE clause"></TD>
		<TD>GROUP&nbsp;BY</TD>
		<TD><INPUT TYPE="TEXT" SIZE="10" NAME="groupby"	VALUE="$groupby_" TITLE="Specify columns to group by"></TD>
		<TD>ORDER&nbsp;BY</TD>
		<TD><INPUT TYPE="TEXT" SIZE="10" NAME="orderby"	VALUE="$orderby_" TITLE="Specify columns to order by"></TD>
		<TD>LIMIT</TD>
		<TD><INPUT TYPE="TEXT" SIZE="10" NAME="limit"	VALUE="$limit_" TITLE="Limit the output"></TD>
	</TR>
</TABLE>
EOT
;

		my @total;
		my $tabs;
		my $query 		= "SELECT * FROM $_ WHERE 1=0";
		my $sth		= $dbh->prepare($query);
		my $res		= $sth->execute();
		if ($DBI::err){
			unless ((@tabs - @exclude) > 1){
			 	print <<EOT
<FORM METHOD=POST ACTION="$full_url">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$dbname">
<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">
<INPUT TYPE=HIDDEN NAME="func" VALUE="select">
EOT
;
			}
			print $tableform;
			print qq!<code>TABLE: $tabs_</code> $exclude<p>\n!;
			print qq!<font color="#cc0000"><b>Cannot select from this table</b></font><BR>$DBI::errstr<BR>\n!;
			print "<hr size=1><BR>\n";
			unless ((@tabs - @exclude) > 1){
				print "\n</FORM>";
			}
			next
		}

		my $fieldsref 		= $sth->{NAME};
		my $size		= $sth->{NUM_OF_FIELDS};
		if ($tabs[$i] =~ /\W/){ 
			my $tables;
			if ((eval {local $SIG{__DIE__};  $tables = $sth->{mysql_table}}) or (eval {local $SIG{__DIE__};  $tables = $sth->{table}})) {
				my @unitabs;
				for (my $j=0; $j<$size; $j++){
					$fieldsref->[$j] = "$tables->[$j]\.$fieldsref->[$j]" ;
					unless (belongs(\@unitabs,$tables->[$j])) {
						push @unitabs, $tables->[$j];
						push @total, count_rows($tables->[$j]);
					}
				}
				$tabs = join(', ', @unitabs);
			}
			else {
				unless ((@tabs - @exclude) > 1){
		 			print <<EOT
<FORM METHOD=POST ACTION="$full_url">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$dbname">
<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">
<INPUT TYPE=HIDDEN NAME="func" VALUE="select">
EOT
;
				 }
				print $tableform;
				print qq!<code>TABLE: $tabs_</code> $exclude<p>\n!;
				print qq!<font color="#cc0000"><b>Perl module DBD::mysql must be updated in order to use multiple table names</b></font><BR>\n!;
				print "<hr size=1><BR>\n";
				unless ((@tabs - @exclude) > 1){
					print "\n</FORM>";
				}

				next
			}
		}
		else {push @total, count_rows($tabs[$i]); $tabs = $tabs[$i]}
		$sth->finish();
		my $total		= join(', ',@total);		
		my @fields 		= $q->param("fields_$tabs[$i]");
		my $fields 		= join (', ', @fields);
		$fields = '*' if (!$fields or ($size == scalar @fields));
		if ($select[$i]) {$query = "SELECT $select[$i] FROM $tabs[$i] "}
		else {$query = "SELECT $fields FROM ".$tabs[$i]}
#		unless (defined $where[$i]) {$where[$i] = $where[0]}
		$query .= " WHERE $where[$i]"		  if ($where[$i]);
		unless (defined $groupby[$i]) {$groupby[$i] = $groupby[0]}
		$query .= " GROUP BY $groupby[$i]" 	  if ($groupby[$i]);
		unless (defined $orderby[$i]) {$orderby[$i] = $orderby[0]}
		$query .= " ORDER BY $orderby[$i]" 	  if ($orderby[$i]);

		$query .= " LIMIT $limit[$i]" if  ($limit[$i] ne '');
		my $query_ = quoteit($query);
		unless ((@tabs - @exclude) > 1){
			printform({query => $query_});
			
		 	print <<EOT
<FORM METHOD=POST ACTION="$full_url">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$dbname">
<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">
<INPUT TYPE=HIDDEN NAME="func" VALUE="select">
<INPUT TYPE=HIDDEN NAME="query" VALUE="$query_">
EOT
;
		}
		print qq!<P TITLE="Executed query">$query_</P>\n!;
		print $tableform;

		$sth = $dbh->prepare($query) || ErrMessage; 
		$res = $sth->execute		 || ErrMessage;
    	print <<EOT
<TABLE BORDER=0>
	<TR>
		<TD COLSPAN=2>
			<TABLE WIDTH=700 BORDER=0>
				<TR>
					<TD><CODE>TABLE:&nbsp;&nbsp;$tabs</CODE>$exclude</TD>	
					<TD WIDTH=30 ALIGN=RIGHT>&nbsp;</TD>
					<TD WIDTH=270><CODE>Total Rows:&nbsp;&nbsp;$total</CODE></TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
	<TR VALIGN=TOP>
		<TD VALIGN=TOP><!-- printresult -->
EOT
;
		print &printresult(\$sth, $offset[$i], 1) unless $DBI::err;
		
		$sth->finish();
		
		print <<EOT
		
<!-- /endprintresult -->
		</TD>
		<TD VALIGN=TOP>
		
<TABLE>
	<TR>
		<TD TITLE="List of selected columns.
The columns can alternatively be selected from this list"><P><B>SHOW COLUMNS</B></TD>
	</TR>
	<TR>
		<TD>
<SELECT MULTIPLE NAME="fields_$tabs[$i]" SIZE=$size>
EOT
;
		for (my $j=0; $j<$size; $j++){
			my $selected = "SELECTED" if (belongs(\@fields, $fieldsref->[$j]) or !@fields);
			print qq!<OPTION VALUE="$fieldsref->[$j]" $selected>$fieldsref->[$j] \n!;
		}
		print <<EOT
</SELECT></TD></TR></TABLE>
		</TD>
	</TR>
</TABLE>
<BR><HR SIZE=1><BR>
EOT
;
		unless ((@tabs - @exclude) > 1){
			print "\n</FORM>";
		}
	}
	print "\n</FORM>" if ((@tabs - @exclude) > 1);
	print "\n\n<!-- Select from Table procedure endss here -->\n\n";
return
}

sub execExecuteQuery {

	my $back = shift;
	
	my $queries				= $back->{SQL} || $q->param('SQL');
	my $selectedscript		= $back->{selectedscript} || $q->param('selectscript');
	unless ($print){
		print "\n<!-- EXECUTE QUERY starts here -->\n";
	}	
	bail_out ("Query was emptY!", $back) unless ($queries =~ /\S/);
	
	$queries 				=~ s/\/\*.*\*\///sg;
	$queries				=~ s/^\s*#.*$//mg;
	my $newline				="\n";
	$queries 				.= "\n";
	my @queryarray			= ();
	my $jj 					= 0;
	$_ 						= $queries;
	my $newquery 			= 1;
	while (
		m/
		(.*?)				# $1
		(					# $2
			(?<!\\)(["'])	# $3
			(.*?)			# $4
			(?<!\\)(\3)		# $5
			|;|\Z			# 
		)
		(;?)				# $6
		/gxs
	)
	{
		if ($newquery){
			push @queryarray, "$1";
			if ($2 ne ';'){
				$queryarray[-1] .= $2;
				if ($6 ne ';'){$newquery = 0}
			}
		}
		else {
			$queryarray[-1] .= $1;
			if ($2 ne ';'){$queryarray[-1] .= $2}
			else {$newquery = 1}
			if ($6 eq ';'){$newquery = 1}
		}
		$jj++;
		last if ($jj > 50000);
	}

	bail_out ("Query was empty!", $back, '1')if (@queryarray == 0);
	unless ($print){
		print "Script Name: ", quoteit($q->param('selectscript')) if ($q->param('script') =~ /run/i);
	}
	for (my $i = 0; $i < @queryarray; $i++){
		$query = $queryarray[$i];
		next unless ($query =~ /\w./);
   		my $keyword = '';
   		$query =~ /^\s*(\w*)\s.*/; $keyword = $1;
#++++++++++++++++++++++++++++++++++++++
    	my $sth = $dbh->prepare ($query);
    	my $res = $sth->execute;
		if ($DBI::err){
			bail_out ("Cannot execute query $query", $back) if $q->param('abortsql');
			ErrMessage ("Cannot execute query");
		}
		else {
			$query = quoteit($query);
		
       		if (belongs(\@selectlike,$keyword) and $query !~ /^\s*SELECT\s+.+\s+INTO\s+OUTFILE\s+/i) {
				printform({query => $query, SQL =>$queries, selectedscript => $selectedscript}) unless ($print or ($page eq 'select_db'));


 				print &printresult(\$sth,undef,1);
				ErrMessage("Print Result Error $DBI::errstr") if $DBI::err;
			}		
		}
		if ($page eq 'select_db'){
				my $sql_ = quoteit($q->param('SQL'));
				print <<EOT
<FORM ACTION="$full_url" METHOD=POST>
<INPUT TYPE=SUBMIT VALUE="BACK">
<INPUT TYPE=HIDDEN NAME="page" VALUE="connect">
<INPUT TYPE=HIDDEN NAME="SQL" VALUE="$sql_">
</FORM>
EOT
;
		}
			$query =~ s/^\s*$//mg;
			$query =~ s/^/<BR>/mg;
			$query =~ s/\t/&nbsp;&nbsp;&nbsp;&nbsp;/g;
			print <<EOT
<P>Executed Query:<b>$query</b><BR>
Result: $res <P>
<HR SIZE=1 LENGTH="100%"><BR>

EOT
unless $print;
	}
	print "<!-- End of EXECUTE QUERY -->\n\n" ;
	return;
}# END EXECUTE

sub loadDropPreview {
	print "\n\n<!-- loadDropPreview Procedure starts here -->\n\n";
	my @tabs = $q->param('tables');
	bail_out("Table is not specified.", {dbname => "$database", page => 'select_db'}) unless @tabs;
	print qq!<FORM METHOD=POST ACTION="$full_url">!;
	printHeaderTable({name => "DROP"});
	print qq!<TABLE BORDER=0>\n!;
    foreach (@tabs){
    	print qq!<TR><TD><B>DROP TABLE $_</B></TD>!;
		print qq!<TD><INPUT TYPE=CHECKBOX NAME="tables" VALUE="$_" CHECKED></TD></TR>\n!;
    }
    print qq!</TABLE><P>!;
    print qq!<INPUT TYPE=SUBMIT NAME="drop" VALUE="Submit">\n !;
	print qq!<INPUT TYPE=HIDDEN NAME="dbname" VALUE="!.$q->param('dbname').qq!">\n!;
	print qq!<INPUT TYPE=SUBMIT NAME="return" VALUE="Return">\n!;
   	print qq!<INPUT TYPE=HIDDEN NAME="page" VALUE="drop">\n!;
	print qq?\n\n<!-- loadDropPreview Procedure ends here -->\n\n?;
	print qq!</FORM>!;
	return;
}


sub execDropTable {
	if ($q->param('drop')){ 
    	my @tabs = $q->param('tables');
   		bail_out("Table is not specified.", {dbname => "$database", page => 'select_db'}) unless @tabs;
    	foreach (@tabs){
    		my $query = "DROP TABLE $_";
    		$dbh ->do($query) || bail_out("Cannot drop table", {page=>'select_db', dbname=>"$database"});
    	}
	}
	&loadSelectTables();
	return;
}
sub loadDeletePreview {
	print "\n\n<!-- loadDeletePreview Procedure starts here -->\n\n";
	print qq!<FORM METHOD=POST ACTION="$full_url">!;
	printHeaderTable({name => "DELETE"});
	my @tabs = $q->param('tables');
	my $back = {dbname => "$database", page => 'select_db'};

	bail_out("Table is not specified.", $back) unless @tabs;
	bail_out("Too Many Tables were selected.", $back) if (@tabs >= 2);

    my $where = quoteit($q->param('wheredelete'));
    my $query;
    if ($where) {$query = "DELETE FROM $tabs[0] WHERE $where"}
    else {$query = "DELETE FROM $tabs[0] WHERE 1=1"}

    print "<BR>QUERY:<B> $query</B><P>\n";
    print "<INPUT TYPE=\"SUBMIT\" NAME=\"delete\" VALUE=\"Submit\">\n";
	print "<INPUT TYPE=\"SUBMIT\" NAME=\"return\" VALUE=\"Return\">";
    print "<INPUT TYPE=\"HIDDEN\" NAME=\"tables\" VALUE=\"$tabs[0]\">\n";
    print "<INPUT TYPE=\"HIDDEN\" NAME=\"wheredelete\" VALUE=\"$where\">\n";
	print "\n<INPUT TYPE=\"HIDDEN\" NAME=\"dbname\" VALUE=\"".$q->param('dbname')."\">\n";
   	print "<INPUT TYPE=\"HIDDEN\" NAME=\"page\" VALUE=\"delete\">\n";
	print "</FORM>";
	print "<!-- loadDeletePreview Procedure endss here -->";

	return;
}
sub loadAlterTable {
	my $input		= shift;
	my $back 		= $input->{back} || {page => 'select_db', dbname => "$database"};
	if (($q->param('action')=~/import/i) or ($q->param('action')=~/export/i)){
		$back = {page => 'tables', dbname => "$database", func => $q->param('action')}
	}
	my (@tabs, $del, $hr, $newcolumn, $sth, $res);
	if ($page eq 'alterAfterPreview'){
		if ($q->param('back')){@tabs = $q->param('tables')}
		else{@tabs = $q->param('newtablename')}
		unless ($tabs[0]){@tabs = ()}
		$page = 'alter';
	}
	elsif 	((($q->param('func')=~/create/i) or 	($q->param('action')=~/create/i) or 	$page eq 'create') and ($q->param('alter') !~ 'SAVE')){
		@tabs=();
		$page = 'create';
	}
	else {
		unless (@tabs = $q->param('newtablename') and ($q->param('alter') or $q->param('saveas'))) {@tabs = $q->param('tables')};
		if (@tabs >=2) {
			bail_out("Too many tables!", $back);
		}
		elsif (!$tabs[0]){
			bail_out("Table is not selected.", $back) if (($q->param('func')=~/ALTER/i) or (($q->param('action')=~/ALTER/i)));
			@tabs=();
		}
		$page = 'alter';
	}

	print "<!-- Alter procedure starts here -->\n";
	my $proof = qq!<NOSCRIPT><INPUT TYPE=SUBMIT VALUE="<"></NOSCRIPT>!;
	my $proof_ = qq!<INPUT TYPE=SUBMIT VALUE="<">!;
	my $autoincr;
	my $tabletype;
	my $comment;
	
	my $min_rows;
	my $max_rows;
	my $avgrowlength;
	my $reload			= 1 if ($q->param('alter') or $q->param('saveas') or $q->param('reload') or ($q->param('page') eq 'tables'));
	if (@tabs > 0){
		($sth, $res) = prepare_execute("DESCRIBE $tabs[0]", $back);
		$autoincr = '<p CLASS="shead">Auto<BR>Column</p>';
		$del = "Del.";
		$newcolumn = "ADD NEW COLUMN:";
		$hr = "<HR SIZE=1>";
	}
	my @option;
	my %option_;
	if (check_version("3.23.0")){
		my $par = {};
		my @selected;
		my @types = ("MyISAM", "ISAM", "HEAP", "BDB", "InnoDB", "MERGE");
		if ($tabs[0]){
			my ($sth, $res)		= prepare_execute("SHOW TABLE STATUS LIKE '$tabs[0]'", $back);
			$par				= $sth->fetchrow_hashref();
			$sth->finish();
#this doesn't work with older DBI modules
#			$par				= $dbh->selectrow_hashref("SHOW TABLE STATUS LIKE '$tabs[0]'");
		}
		my $type = $reload ? $par->{Type} : $q->param('tabletype');
		if ($type =~ /myisam/i){$selected[1] = 'SELECTED'; 				$type	= 'myisam'}
		elsif ($type =~ /isam/i){$selected[2] = 'SELECTED'; 			$type	= 'isam'}
		elsif ($type =~ /heap/i){$selected[3] = 'SELECTED';				$type	= 'heap'}
		elsif ($type =~ /inno/i){$selected[5] = 'SELECTED';				$type	= 'innodb'}
		elsif ($type =~ /(?:db|berkeley)/i){$selected[4] = 'SELECTED';	$type	= 'bdb'}
		elsif ($type =~ /(?:merge|mrg)/i){$selected[6] = 'SELECTED';	$type	= 'merge'}
		else  {$selected[0] = 'SELECTED'}
		my $value_			= $par->{Comment};
		{$value_			=~ s/^(.*?)(?:;\s*InnoDB free: \d+ \wB;?.*)$/$1/i if $type eq 'innodb';}
		my $value 			= $reload ? $value_ : $q->param('comment');
		($value, $value_)	= quoteit($value, $value_);
		my $comentlength 	= $agent ? 30 : 50;
		$option_{COMMENT_}	= "$value_";
		$comment			= qq!<INPUT NAME="comment" TYPE=TEXT VALUE="$value" MAXLENGTH=60 size=$comentlength>!;
			

		$tabletype		= <<EOT
<B>TYPE:</B> <SELECT NAME="tabletype" ID="tabtype" onChange="this.form.submit()">
<OPTION VALUE="" $selected[0]>
<OPTION VALUE="MyISAM" $selected[1]>MyISAM
<OPTION VALUE="ISAM" $selected[2]>ISAM
<OPTION VALUE="HEAP" $selected[3]>HEAP
EOT
;
		$tabletype		.= qq!<OPTION VALUE="BDB" $selected[4]>BDB\n! if check_version("3.23.17");
		$tabletype		.= qq!<OPTION VALUE="InnoDB" $selected[5]>InnoDB\n! if check_version("3.23.29");
		$tabletype		.= qq!<OPTION VALUE="MERGE" $selected[6]>MERGE\n! if (check_version("3.23.25") and $tabs[0] and $selected[6]);
		$tabletype		.= qq!</SELECT>$proof\n!;
		$tabletype		.= qq!<INPUT TYPE=HIDDEN NAME="tabletype_" VALUE="$par->{Type}">\n!;
#		my ($minrows, $maxrows, $avgrow, $autoincr, $rowformat, $packkeys, $delaykey, $checksum);
		my $create_options;
		my $create_options_ = $par->{Create_options};
		my $auto_increment;
		if ($reload){
			$create_options	= $create_options_;
			my $Type 	= $q->param('tabletype');
			my $Type_	= $par->{Type};
			$auto_increment	= $par->{Auto_increment} if ($par->{Type} =~ /MyISAM/i) or (check_version("4.1.0") and $par->{Type} =~/HEAP/i); 
		}
		else {
			my $MIN_ROWS		= $q->param('MIN_ROWS');
			my $PACK_KEYS		= $q->param('PACK_KEYS');
			my $MAX_ROWS		= $q->param('MAX_ROWS');
			my $CHECKSUM		= $q->param('CHECKSUM');
			my $AVG_ROW_LENGTH	= $q->param('AVG_ROW_LENGTH');
			my $DELAY_KEY_WRITE = $q->param('DELAY_KEY_WRITE');
			my $ROW_FORMAT 		= $q->param('ROW_FORMAT');

			$create_options	.= "MIN_ROWS=$MIN_ROWS " if $MIN_ROWS ne '';
			$create_options	.= "PACK_KEYS=$PACK_KEYS " if $PACK_KEYS ne '';
			$create_options	.= "MAX_ROWS=$MAX_ROWS " if $MAX_ROWS ne '';
			$create_options	.= "CHECKSUM=$CHECKSUM " if $CHECKSUM ne '';
			$create_options	.= "AVG_ROW_LENGTH=$AVG_ROW_LENGTH " if $AVG_ROW_LENGTH ne '';
			$create_options	.= "DELAY_KEY_WRITE=$DELAY_KEY_WRITE " if $DELAY_KEY_WRITE ne '';
			$create_options	.= "ROW_FORMAT=$ROW_FORMAT " if $ROW_FORMAT ne '';
			$auto_increment	=  deletespace($q->param('auto_increment'));
		}
		{
			if ($create_options_ =~ /MIN_ROWS=(\w+)\s?/i){$option_{MIN_ROWS_} = "$1"}
		}
		{
			if ($create_options_	=~ /PACK_KEYS=(\w+)\s?/i){$option_{PACK_KEYS_} = "$1"}
		}
		{
			if($create_options_ =~ /MAX_ROWS=(\w+)\s?/i){$option_{MAX_ROWS_} = "$1"}
		}
		{
			if($create_options_ =~ /CHECKSUM=(\w+)\s?/i){$option_{CHECKSUM_} = "$1"}
		}
		{
			if($create_options_ =~ /AVG_ROW_LENGTH=(\w+)\s?/i){$option_{AVG_ROW_LENGTH_} = "$1"}
		}
		{
			if($create_options_ =~ /DELAY_KEY_WRITE=(\w+)\s?/i){$option_{DELAY_KEY_WRITE_} = "$1"}
		}
		$option_{AUTO_INCREMENT_} = "$par->{Auto_increment}";
		{
			if($create_options_ =~ /ROW_FORMAT=(\w+)\s?/i){$option_{ROW_FORMAT_} = "$1"}
		}

		
		my $selected;
		{
			$create_options =~ /MIN_ROWS=(\w+)\s?/i;
			$option[0] = qq!MIN_ROWS</TD><TD><INPUT TYPE=TEXT NAME="MIN_ROWS" VALUE="$1" TITLE="The minimum number of rows you plan to store in the table.">!;
		}
		{
			$create_options	=~ /PACK_KEYS=(\w+)\s?/i;
			$option[1]		= qq!PACK_KEYS</TD><TD TITLE="Index compression for MyISAM and ISAM tables. A value of 1 specifies compression for string values and (MyISAM) Numeric index values. A value of 0 specifies no index compression"><SELECT NAME="PACK_KEYS">\n!;
			if (check_version('4.0.0')){
				$selected		= $1 eq '' ? 'SELECTED' : '';
				$option[1]		.= qq!<OPTION VALUE="DEFAULT" $selected>DEFAULT\n! ;
			}
			elsif($1 eq ''){
				$option[1]		.= qq!<OPTION VALUE="" SELECTED>\n!;
			}
			$selected		= $1 eq '0' 		? 'SELECTED' : '';
			$option[1]		.= qq!<OPTION VALUE="0" $selected>0\n!;
			$selected		= $1 eq '1' 		? 'SELECTED' : '';
			$option[1]		.= qq!<OPTION VALUE="1" $selected>1\n!;
			$option[1]		.= qq!</SELECT>\n!;
		}
		{
			$create_options =~ /MAX_ROWS=(\w+)\s?/i;
			$option[2] = qq!MAX_ROWS</TD><TD><INPUT TYPE=TEXT NAME="MAX_ROWS" VALUE="$1" TITLE="The maximum number of rows you plan to store in the table. (MyISAM tables) See the description of AVG_ROW_LENGTH in MySQL manual.">!;
		}
		{
			$create_options	=~ /CHECKSUM=(\w+)\s?/i;
			$option[3]		= qq!CHECKSUM</TD><TD TITLE="If set to 1, MySQL maintains a checksum for each table row. (MyISAM tables)"><SELECT NAME="CHECKSUM">\n!;
			$selected		= $1 eq '' ? 'SELECTED' : '';
			$option[3]		.= qq!<OPTION VALUE="" $selected>\n!;
			$selected		= $1 eq '0' ? 'SELECTED' : '';
			$option[3]		.= qq!<OPTION VALUE="0" $selected>0\n!;
			$selected		= $1 eq '1' ? 'SELECTED' : '';
			$option[3]		.= qq!<OPTION VALUE="1" $selected>1\n!;
			$option[3]		.= qq!</SELECT>\n!;
		}
		{
			$create_options =~ /AVG_ROW_LENGTH=(\w+)\s?/i;
			$option[4] = qq!AVG_ROW_LENGTH</TD><TD><INPUT TYPE=TEXT NAME="AVG_ROW_LENGTH" VALUE="$1" TITLE="The approximate average row length of your table. (MyISAM tables) Together with MAX_ROWS it determines the maximum datafile size. See MySQL manual for more info">!;
		}
		if (check_version('3.23.3')){
			$create_options	=~ /DELAY_KEY_WRITE=(\w+)\s?/i;
			$option[5]		= qq!DELAY_KEY_WRITE</TD><TD TITLE="If this is set to 1, the index cache is flushed only occasionally for the table, rather then after each INSERT operation. (MyISAM tables)"><SELECT NAME="DELAY_KEY_WRITE">\n!;
			$selected		= $1 eq '' ? 'SELECTED' : '';
			$option[5]		.= qq!<OPTION VALUE="" $selected>\n!;
			$selected		= $1 eq '0' ? 'SELECTED' : '';
			$option[5]		.= qq!<OPTION VALUE="0" $selected>0\n!;
			$selected		= $1 ? 'SELECTED' : '' ;
			$option[5]		.= qq!<OPTION VALUE="1" $selected>1\n!;
			$option[5]		.= qq!</SELECT>\n!;
		}
		$option[6]		= qq!AUTO_INCREMENT</TD><TD><INPUT TYPE=TEXT NAME="auto_increment" VALUE="$auto_increment" TITLE="The next AUTO_INCREMENT value to be generated. MyISAM tables and HEAP tables as of MySQL 4.1.">!;
		
		if (check_version('3.23.6')){
			$create_options	=~ /ROW_FORMAT=(\w+)\s?/i;
			$option[7]		= qq!ROW_FORMAT</TD><TD TITLE="This option specifies the row storage type. (MyISAM tables)"><SELECT NAME="ROW_FORMAT">\n!;
			$selected		= $1 eq '' ? 'SELECTED' : '';
			$option[7]		.= qq!<OPTION VALUE="DEFAULT" $selected>DEFAULT\n!;
			$selected		= $1 eq 'FIXED' ? 'SELECTED' : '';
			$option[7]		.= qq!<OPTION VALUE="FIXED" $selected>FIXED\n!;
			$selected		= $1 eq 'DYNAMIC' ? 'SELECTED' : '';
			$option[7]		.= qq!<OPTION VALUE="DYNAMIC" $selected>DYNAMIC\n!;
			$selected		= $1 eq 'COMPRESSED' ? 'SELECTED' : '';
			$option[7]		.= qq!<OPTION VALUE="COMPRESSED" $selected>COMPRESSED\n!;
			$option[7]		.= qq!</SELECT>\n!;
		}
	}
	my $typeoptionlistref = sub  {
		my @optionlist;
		my $type = shift;
		$type =~ s/^\s*(\w*)(\(.*\))?(.*)/$1/;
		my $symbols = $2; 
		my $therest = $3;
		$symbols =~ s/^\((.*)\)/$1/ if $symbols;
		
		my $unsigned = '';
		my $zerofill = '';
		my $binary = '';
		$symbols = quoteit($symbols);
		$unsigned = 'CHECKED' if ($therest =~ /unsign/i);
		$zerofill = 'CHECKED' if ($therest =~ /zerofill/i);
		$binary = 'CHECKED' if ($therest =~ /binary/i);
		for (my $i=0; $i<@typelist; $i++) {
			my $selected = 'SELECTED' if ($typelist[$i] =~ /^($type)$/i);
			push @optionlist, qq!<OPTION VALUE="$typelist[$i]" $selected>$typelist[$i] \n!;
		}

return (\@optionlist, $type, $symbols, $unsigned, $zerofill, $binary) if wantarray;
return (\@optionlist) if defined wantarray;
};
	my ($newtablength, $textsize, $textsize1, $lengthsize, $textareasize) = $agent ? (23, 13, 10, 10, 30 ) : (30, 20, 15, 16, 40 );

	print qq!<FORM METHOD=POST ACTION="$full_url" ID="form1">!;
	my ($procname, $tabtitle, $colnametitle, $saveastitle, $saveas1, $ignore);
	my $ignoreselected = 'CHECKED' if ($q->param('ignore') and !$reload);
	if (@tabs) {
		$procname 		= qq!ALTER TABLE!;
		$tabtitle 		= qq!Edit table name.\nAlphanumeric characters and underscore only!;
		$colnametitle 	= qq!Edit column name.\nAlphanumeric characters and underscore only!;
		$saveastitle 	= qq!Type the name of a new table.\nAlphanumeric characters and underscore only!;
		$saveas1		= qq!<INPUT TYPE=SUBMIT NAME="saveas" VALUE="Save as"  style="width: 80" TITLE="Create new table with the same structure. All changes will be applied to new table">!;
		$ignore			= qq?&nbsp;&nbsp;&nbsp;<INPUT TYPE=CHECKBOX NAME="ignore" VALUE="1" $ignoreselected TITLE="The rows that duplicate values for unique key values will be deleted!"><FONT COLOR="#CC0000" TITLE="The rows that duplicate values for unique key values will be deleted!">IGNORE</FONT>?;
	}
	else {
		$procname 		= "CREATE NEW TABLE";
		$tabtitle 		= "Type the name of new table.\nAlphanumeric characters and underscore only";
		$colnametitle 	= "Type column name in this field.\nAlphanumeric characters and underscore only";
	}
	my $newtabvalue = $reload ?  $tabs[0] : quoteit($q->param('newtablename'));
	
	print <<EOT
<!-- Header Table -->
<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=2>
	<TR><TD ALIGN=LEFT COLSPAN=2><FONT COLOR="#003466"><B>$procname</B></FONT>$ignore</TD><TD COLSPAN=3>&nbsp;$input->{msg}</TD><TR>
	<TR VALIGN=MIDDLE>
		<TD COLSPAN=2 ><nobr><CODE>TABLE&nbsp;NAME:&nbsp;</CODE><INPUT TYPE=TEXT NAME="newtablename" VALUE="$newtabvalue" SIZE=$newtablength TITLE="$tabtitle">&nbsp;</nobr></TD>
		<TD><NOBR>$tabletype</NOBR></TD><TD ALIGN=RIGHT>COMMENT</TD><TD>$comment</TD>
	</TR>
<!-- <TR><TH COLSPAN=5 ALIGN=LEFT HEIGHT=0></TH><TR> -->
<!-- End of Header Table -->
EOT
;
if (@option){
	my $tr;
	my $j;
	for (my $i=0; $i < 8; $i++){
		if (my $option = shift @option){
			unless ($tr){print "<TR><TD ALIGN=RIGHT>$option</TD>"; $tr = 1}
			else {print "<TD ALIGN=RIGHT COLSPAN=2>$option</TD></TR>\n"; $tr = 0}
		}
		elsif ($j){$j=0}
		else {$j++}
	}
	for (1..$j){
		if($tr){print "<TD COLSPAN=2>&nbsp;</TD><TD>&nbsp;</TD></TR>"; $tr=0}
		else{print "<TR><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>"; $tr=1}
	}
}
	print "</TABLE>";



	print <<EOT
<TABLE ID="MAIN" BORDER=0 CELLPADDING=2 CELLSPACING=2>	
	<TR>
		<TD><p CLASS="shead">$del</p></TD>
		<TD TITLE="$colnametitle"><p CLASS="shead">COLUMN NAME</p></TD>
		<TD TITLE="Select column type"><p CLASS="shead">Type</p></TD>
		<TD TITLE="Type column length or values of ENUM or SET types (quoted and comma separated)"><p CLASS="shead">Length or<BR>enum/set elements</p></TD>
		<TD TITLE="This attribute disallows negative values.\n(Numerics only)"><p CLASS="shead">Unsigned</p></TD>
		<TD TITLE="This attribute causes the displayed value to be padded with leading zeros to the display width.\n(Nimerics only)"><p CLASS="shead">Zerofill</p></TD>
		<TD TITLE="This attribute causes column value to be treated as binary string and case sensitive in comparation and sorting operations.\n(String types only)"><p CLASS="shead">Binary</p></TD>
		<TD TITLE="This attribute specifies whethere or not the column may contain NULL values. If not specified, NULL is the default."><p CLASS="shead">Not Null</p></TD>
		<TD TITLE="Specifies the default value for the column. This can not be used for BLOB or TEXT types."><p CLASS="shead">Default</p></TD>
		<TD TITLE="Selected column will be turned into Autocolumn.\nOnly one column can be Autocolumn">$autoincr</TD>
	</TR>
EOT
;
#	my @columns;
	my @colname			= $q->param('colname');
	my $pri_flag;
	my $firstafteroption;

	if (@tabs > 0){
    	my @type			= $q->param('type');
		my @length			= $q->param('length');
		my @unsigned		= $q->param('unsigned');
		my @notnull			= $q->param('notnull');
		my @zerofill		= $q->param('zerofill');
		my @default			= $q->param('default');
		my @binary			= $q->param('binary');
		my $autoincrement	= $q->param('autoincrement');
		my $i 				= 0;
		while (my @row = $sth->fetchrow_array()) {
			my ($checkdrop, $colname, $coltype, $default, $type,
			$symbols, $notnull_selected, $unsigned_selected, $zerofill_selected,
			$binary_selected, $autoincrement_selected, $drop, $firstafter_selected);
			my $typeoptionref = [];
			$drop				= $q->param("drop_column_$row[0]");
			if ($reload){
    			$colname[$i]			= $row[0];
				$coltype 				= $row[1];
				($typeoptionref, $type, $symbols, $unsigned_selected, $zerofill_selected, $binary_selected, $autoincrement_selected) = &$typeoptionlistref($coltype);
				$autoincrement_selected	= 'CHECKED' if ($row[5] =~ /^.*auto.*increment.*$/i);
				$default 				= quoteit($row[4]); # defaults
				$colname 				= $row[0];
				$notnull_selected		= 'CHECKED' unless ($row[2] =~ /yes/i);
			}
			else{
				$type 					= $type[$i];
				$symbols				= quoteit($length[$i]);
				$unsigned_selected		= 'CHECKED' if (belongs(\@unsigned, $row[0]));
				$zerofill_selected		= 'CHECKED' if (belongs(\@zerofill, $row[0]));
				$notnull_selected		= 'CHECKED' if (belongs(\@notnull, $row[0]));
				$binary_selected		= 'CHECKED' if (belongs(\@binary, $row[0]));
				$autoincrement_selected	= 'CHECKED' if ($autoincrement eq $row[0]);
				$default				= quoteit($default[$i]);
				$typeoptionref			= &$typeoptionlistref($type[$i]);
				$firstafter_selected	= 'SELECTED' if ($q->param('firstafterwhat') eq $colname[$i]);
				$colname[$i]			= quoteit($colname[$i]);
			}
			$firstafteroption .= qq!<OPTION VALUE="$colname[$i]" $firstafter_selected>$colname[$i]\n! if (!$q->param("drop_column_$row[0]") xor $q->param("release_column_$row[0]"));
    	

    		my $auto = '';
    		if ($row[3] =~ /PRI/i){
    			if ($auto_type{uc $type}){$auto = qq!<INPUT TYPE=CHECKBOX NAME="autoincrement" VALUE="$row[0]" $autoincrement_selected TITLE="AUTO_INCREMENT columns">!}
				else {$auto = qq!<INPUT TYPE=CHECKBOX TITLE="Selected column type doesn't support AUTO_INCREMENT columns" DISABLED>!}
    			$pri_flag = 1;
    		}
			else {$auto = qq!<INPUT TYPE=CHECKBOX TITLE="AUTO_INCREMENT column must be defined as PRIMARY KEY" DISABLED>!}
    		
			if ($drop and !$q->param("release_column_$row[0]")){
				$type 				= $row[1];
				$type 				=~ s/^\s*(\w*)(\(.*\))?(.*)/$1/;
				$type				= uc $type;
				$symbols			= $2; 
				my $therest			= $3;
				$symbols			=~ s/^\((.*)\)/$1/ if $symbols;
				$symbols			= quoteit($symbols);
				my $unsigned		= $row[0] if ($therest =~ /unsign/i);
				my $zerofill		= $row[0] if ($therest =~ /zerofill/i);
				my $binary			= $row[0] if ($therest =~ /binary/i);
				my $notnull			= $row[0] unless ($row[2] =~ /yes/i);
				$default 			= quoteit($row[4]); # defaults
				$autoincrement		= ($row[5] =~ /^.*auto.*increment.*$/i) ? $row[0] : '';
				print <<EOT
	<TR>
		<TD><INPUT TYPE=SUBMIT NAME="release_column_$row[0]" VALUE="O" TITLE="CLICL TO KEEP THIS COLUMN" style="width: 20" notab  tabindex=0 taborder=0></TD>
		<TD  COLSPAN=3>
		$row[0]
		<INPUT TYPE=HIDDEN NAME="colname" 				VALUE="$row[0]">
		<INPUT TYPE=HIDDEN NAME="type" 					VALUE="$type">
		<INPUT TYPE=HIDDEN NAME="length" 				VALUE="$symbols">
		<INPUT TYPE=HIDDEN NAME="unsigned" 				VALUE="$unsigned">
		<INPUT TYPE=HIDDEN NAME="zerofill" 				VALUE="$zerofill">
		<INPUT TYPE=HIDDEN NAME="binary" 				VALUE="$binary">
		<INPUT TYPE=HIDDEN NAME="notnull"				VALUE="$notnull">
		<INPUT TYPE=HIDDEN NAME="default" 				VALUE="$default">
		<INPUT TYPE=HIDDEN NAME="autoincrement"			VALUE="$autoincrement">
		<INPUT TYPE=HIDDEN NAME="drop_column_$row[0]"	VALUE="X">
		</TD>
		<TD COLSPAN=6>THIS COLUMN WILL BE DROPPED</TD>
	<TR>
EOT
;
			}
			else{
				my $DisabledTitle1 = 'This column type can not have Default Values';
				my $DisabledTitle2 = 'This column type does not allow such values';
				my ($unsigned, $zerofill, $binary);
				if ($type =~ /int|decimal/i or (check_version('4.0.2') and $type =~/double|float/i)){
					$unsigned = qq!<INPUT TYPE=CHECKBOX NAME="unsigned" VALUE="$row[0]" $unsigned_selected TITLE="This attribute disallows negative values.\n(Numerics only)">! 
				}
				else {
					$unsigned = qq!<INPUT TYPE=CHECKBOX TITLE="This column type does not allow this option" DISABLED>!;
					$unsigned .= qq!<INPUT TYPE=HIDDEN NAME="unsigned" VALUE="$row[0]">! if $unsigned_selected
				} 

				
				if ($type =~ /int|decimal|double|float/i){
					$zerofill	= qq!<INPUT TYPE=CHECKBOX NAME="zerofill" VALUE="$row[0]" $zerofill_selected TITLE="This attribute causes the displayed value to be padded with leading zeros to the display width.\n(Nimerics only)">!
				}
				else {
					$zerofill	= qq!<INPUT TYPE=CHECKBOX TITLE="This column type does not allow this option" DISABLED>!;
					$zerofill	.= qq!<INPUT TYPE=HIDDEN NAME="zerofill" VALUE="$row[0]">! if $zerofill_selected
				}
				
				
				if ($type =~ /char/i) {
					$binary	= qq!<INPUT TYPE=CHECKBOX NAME="binary" VALUE="$row[0]" $binary_selected TITLE="This attribute causes column value to be treated as binary string and case sensitive in comparation and sorting operations.\n(String types only)">!
				}
				else{
					$binary	= qq!<INPUT TYPE=CHECKBOX TITLE="This column type does not allow this option" DISABLED>!;
					$binary	.= qq!<INPUT TYPE=HIDDEN NAME="binary" VALUE="$row[0]">! if $binary_selected
				}
				
				my $notnull	= qq!<INPUT TYPE=CHECKBOX NAME="notnull" VALUE="$row[0]" $notnull_selected TITLE="This attribute specifies whethere or not the column may contain NULL values. If not specified, NULL is the default.">!;
				my $defaultvalue = 
				($type !~ /text|blob/i) ? 
				qq!<INPUT TYPE=TEXT NAME="default" VALUE="$default" SIZE=$textsize1 TITLE="Specifies the default value for the column. This can not be used for BLOB or TEXT types.">!
				: qq!<INPUT TYPE=TEXT VALUE="" DISABLED SIZE=$textsize1 TITLE="$DisabledTitle1" style="background color: #CCCCCC"><INPUT TYPE=HIDDEN NAME="default" VALUE="$default">!;
				my $length		= 
				($type =~ /int|decimal|double|float|char|enum|set|year|timestamp/i) ? 
				qq!<INPUT TYPE=TEXT NAME="length" SIZE=$lengthsize VALUE="$symbols"  TITLE="Type column length or values of ENUM or SET types (quoted and comma separated)">! 
				: qq!<INPUT TYPE=TEXT SIZE=$lengthsize VALUE="" DISABLED SIZE=$lengthsize TITLE="$DisabledTitle2" style="background color: #CCCCCC"><INPUT TYPE=HIDDEN NAME="length" VALUE="$symbols" >!;
				print <<EOT
	<TR>
		<TD><INPUT TYPE=SUBMIT NAME="drop_column_$row[0]" VALUE="X" TITLE="Click to drop this column" style="width: 20" notab tabindex=0 taborder=0></TD>
		<TD><INPUT TYPE=TEXT NAME="colname" VALUE="$colname[$i]" TITLE="Edit column name" SIZE=$textsize></TD>
		<TD TITLE="Select column type"><SELECT NAME="type" TITLE="Select column type"  onChange="this.form.submit()">
@$typeoptionref
			</SELECT></TD>
		<TD><NOBR>$proof&nbsp;$length</NOBR></TD>	
		<TD>$unsigned</TD>
		<TD>$zerofill</TD>
		<TD>$binary</TD>
		<TD>$notnull</TD>
		<TD>$defaultvalue</TD>
		<TD>$auto</TD>		
	<TR>
EOT
;
			}
			$i++;
		}#WHILE
    	$sth->finish();
	}#if tabs>0
	print "\t<TR><TD COLSPAN=10>$hr</TD></TR>\n";
	print "\t<TR><TD COLSPAN=10><B>$newcolumn</B></TD></TR>\n";
	my ($newcoltyperef, $newcolname, $newcollength, $newcoldefault, $unsigned_new, $zerofill_new, $binary_new, $notnull_new);
	if ($reload){
		$newcoltyperef	= &$typeoptionlistref();
		$newcollength	= qq!<INPUT TYPE=TEXT style="background color: #CCCCCC" DISABLED SIZE=$lengthsize TITLE="Please select column type">!;
		$newcoldefault	= qq!<INPUT TYPE=TEXT style="background color: #CCCCCC" DISABLED SIZE=$textsize1 TITLE="Please select column type">!;
		$unsigned_new	= $zerofill_new = $binary_new = $notnull_new = qq!<INPUT TYPE=CHECKBOX TITLE="Please select column type" DISABLED>!
	}
	else{
		my $type		= $q->param('newcoltype');
		$newcolname		= quoteit($q->param('newcolname'));
		$newcollength	= quoteit($q->param('newcollength'));
		$newcoldefault	= quoteit($q->param('newcoldefault'));
		$unsigned_new	= 'CHECKED' if $q->param('unsigned_new');
		$zerofill_new	= 'CHECKED' if $q->param('zerofill_new');
		$binary_new		= 'CHECKED' if $q->param('binary_new');
		$notnull_new	= 'CHECKED' if $q->param('notnull_new');
		$newcoltyperef	= &$typeoptionlistref($type);
		
		if ($type =~ /(int)|(decimal)|(double)|(float)|(char)|(enum)|(set)|(year)|(timestamp)/i){
			$newcollength = qq!<INPUT TYPE=TEXT NAME="newcollength" SIZE=$lengthsize VALUE="$newcollength" TITLE="Type column length or values of ENUM or SET types (quoted and comma separated)">!;
		}
		else {
			$newcollength = qq!<INPUT TYPE=TEXT style="background color: #CCCCCC" DISABLED SIZE=$lengthsize TITLE="This column type does not allow such values">!;
		}
		if ($type and $type !~ /(text)|(blob)/i){
			$newcoldefault = qq!<INPUT TYPE=TEXT NAME="newcoldefault" VALUE="$newcoldefault" size=$textsize1 TITLE="Specifies the default value for the column. This can not be used for BLOB or TEXT types.">!;
		}
		else {
			$newcoldefault = qq!<INPUT TYPE=TEXT style="background color: #CCCCCC" DISABLED size=$textsize1 TITLE="This column type can not have Default Values">!
		}
		if ($type =~ /(int)|(decimal)/i or (check_version('4.0.2') and $type =~/(double)|(float)/i)){
			$unsigned_new = qq!<INPUT TYPE=CHECKBOX NAME="unsigned_new" $unsigned_new TITLE="This attribute disallows negative values \n(Numerics only)">!
		}
		else{
			$unsigned_new = qq!<INPUT TYPE=CHECKBOX TITLE="This column type does not allow this option" DISABLED>!
		}
		if ($type =~ /(int)|(decimal)|(double)|(float)/i){
			$zerofill_new = qq!<INPUT TYPE=CHECKBOX NAME="zerofill_new" $zerofill_new TITLE="This attribute causes the displayed value to be padded with leading zeros to the display width.\n(Nimerics only)">!
		}
		else{
			$zerofill_new = qq!<INPUT TYPE=CHECKBOX TITLE="This column type does not allow this option" DISABLED>!
		}
		if ($type =~ /char/i){
			$binary_new = qq!<INPUT TYPE=CHECKBOX NAME="binary_new" $binary_new TITLE="This attribute causes column value to be treated as binary string and case sensitive in comparation and sorting operations.\n(String types only)">!
		}
		else{
			$binary_new = qq!<INPUT TYPE=CHECKBOX TITLE="This column type does not allow this option" DISABLED>!
		}
		if($type){
			$notnull_new = qq!<INPUT TYPE=CHECKBOX NAME="notnull_new" $notnull_new TITLE="This attribute specifies whethere or not the column may contain NULL values. If not specified, NULL is the default.">!
		}
		else{
			$notnull_new = qq!<INPUT TYPE=CHECKBOX TITLE="This column type does not allow this option" DISABLED>!
		}
	}

	print <<EOT
	<TR>
		<TD>&nbsp;</TD>
		<TD><INPUT TYPE=TEXT NAME="newcolname" VALUE="$newcolname" SIZE=$textsize TITLE="Type new column name. The name must be unique and consist of alphanumeric and underscore characters only."></TD>
		<TD TITLE="Select column type"><SELECT SIZE=1 NAME="newcoltype" TITLE="Select column type" onChange="this.form.submit()">
		<OPTION VALUE="" SELECTED> 
@$newcoltyperef
		</SELECT></TD>
		<TD><NOBR>$proof&nbsp;$newcollength</NOBR></TD>
		<TD>$unsigned_new</TD>
		<TD>$zerofill_new</TD>
		<TD>$binary_new</TD>
		<TD>$notnull_new</TD>
		<TD>$newcoldefault</TD>
		<TD>&nbsp;</TD>		
	</TR>
EOT
;	
# first / after
	if (@tabs > 0){
		my ($selected_f, $selected_a, $enkeysselected, $diskeysselected, $orderby, $enkeys, $orderbyvalye, $ascchecked, $desccheched);
		unless($reload){
			my $firstafter		= $q->param('firstafter');
			$selected_f			= 'SELECTED'	if $firstafter eq 'FIRST';
			$selected_a			= 'SELECTED'	if $firstafter eq 'AFTER';
			$enkeysselected 	= 'CHECKED'		if $q->param('enkeys') eq 'ENABLE';
			$diskeysselected	= 'CHECKED'		if $q->param('enkeys') eq 'DISABLE';
			$ascchecked			= 'CHECKED'	if $q->param('order') eq 'ASC';
			$desccheched		= 'CHECKED'	if $q->param('order') eq 'DESC';
			
			$orderbyvalye		= quoteit(deletespace($q->param('orderby')));
		}
		if (check_version("4.0.0")){
			$enkeys = <<EOT
		<TD><INPUT TYPE=RADIO NAME="enkeys" VALUE="ENABLE" $enkeysselected></TD>
		<TD>ENABLE KEYS</TD>
		<TD><INPUT TYPE=RADIO NAME="enkeys" VALUE="DISABLE" $diskeysselected></TD>
		<TD>DISABLE KEYS</TD>
EOT
;
		}
		if (check_version("3.23.28")){
			my $size = $agent ? 40 : 55;
			$orderby = <<EOT
		<TD>ORDER BY</TD>
		<TD><INPUT TYPE=TEXT NAME="orderby" SIZE=$size TITLE="Column names separated by comma" VALUE="$orderbyvalye"></TD>
		<TD><INPUT TYPE=RADIO NAME="order" VALUE="ASC" $ascchecked></TD>
		<TD>ASC</TD>
		<TD><INPUT TYPE=RADIO NAME="order" VALUE="DESC" $desccheched></TD>
		<TD>DESC</TD>
EOT
;
		}
		 
		print <<EOT
	<TR>
		<TD>&nbsp;</TD>
		<TD ALIGN=RIGHT><SELECT NAME="firstafter" SIZE=1>
<OPTION VALUE="" SELECTED>
<OPTION VALUE="FIRST" $selected_f>FIRST
<OPTION VALUE="AFTER" $selected_a>AFTER
</SELECT></TD>
		<TD COLSPAN=8 TITLE="Define where to place new column">
<SELECT NAME="firstafterwhat" SIZE=1 TITLE="Define where to place new column">
<OPTION VALUE="">SELECT COLUMN
<OPTION VALUE="">-------------
$firstafteroption
</SELECT></TD>
	</TR>
</TABLE>
<HR SIZE="1" LENGTH="700">
EOT
;
if ($orderby or $enkeys){
	print <<EOT
<TABLE>
	<TR>
$enkeys
		<TD>&nbsp;</TD>
$orderby
	</TR>
</TABLE>
<HR SIZE="1" LENGTH="700">
EOT
;
}
# KEYS

		$query			= "SHOW INDEX FROM $tabs[0]";
		($sth, $res)	= prepare_execute($query, $back,'2');
		if ($res > 0){
        	print <<EOT
<BR><CODE>Drop the Key:</CODE><BR>
<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=2>
	<TR>
		<TD><B>Select</B></TD>
		<TD><B>KEY NAME</B></TD>
		<TD><B>KEY</B></TD>
		<TD><B>COLUMN NAME (SUB PART)</B></TD>
	</TR>
EOT
;
    		my $matrix_ref	= $sth->fetchall_arrayref();
    		my ($rows)		= (!defined($matrix_ref)? 0: scalar(@{$matrix_ref}));
    		my ($cols)		= 10;
    		my @matrix		= @{$matrix_ref};
    		my $k			= 0;
	    	$sth->finish();
    		my $ref;
    		while (scalar  @matrix){
    			my %hashmatrix	= ();
    			my $thekey		= $matrix[0][2];
    			for (my $j = 0; $j < @matrix; $j++){
    				if ($matrix[$j][2] eq $thekey) {
    					$hashmatrix{$matrix[$j][3]}	= $matrix[$j];
    					$ref 						= splice (@matrix, $j, 1);
    					$j--;
    				}#IF 
    			}#FOR
    			if ((keys %hashmatrix) > 0) {
    				my @row =  @{$hashmatrix{1}};
            		my $keytype;
					if ($row[1] == 0){
						if ($row[2] 	=~ /^\s*primary\s*$/i){$keytype = 'PRIMARY KEY'}
						else {$keytype	= 'UNIQUE'}
					}
					else {
						if (($row[9] =~ /^\s*FULLTEXT\s*$/i) or ($row[10] =~ /^\s*FULLTEXT\s*$/i)){$keytype = 'FULLTEXT';}
						else {$keytype = 'INDEX' }
					}
    			
    				my $options;
        			foreach (sort {$a <=> $b}(keys %hashmatrix)) {
        				my @row = @{$hashmatrix{$_}};
        				my $subpart = "($row[7])" if ($row[7]);
    					$options .= qq!<OPTION VALUE="">$row[4]$subpart\n!;
        			}#FOREACH
					my $checked = '';
					unless ($reload){
						my @drop_key	= $q->param('drop_key');
						$checked		= 'CHECKED' if (belongs(\@drop_key, $row[2]));
					}
					print qq!
	<TR><TD><INPUT TYPE=CHECKBOX NAME="drop_key" VALUE="$row[2]" TITLE="Select key to drop" $checked></TD>
		<TD BGCOLOR="#EEEEEE">$row[2]</TD>
		<TD BGCOLOR="#EEEEEE">$keytype</TD>
		<TD BGCOLOR="#EEEEEE"><SELECT SIZE=1 style="color: #a0a0a0">$options</SELECT></TD>
	</TR>\n!;
				}#IF

				bail_out("Counter Overflow. Sorry!") if ($k++ > 100000);
			}#WHILE
    	print "</TABLE>\n<HR SIZE=1 LENGTH=700><BR>";
		}#if res > 0
		my $keyname		= '';
		my @keytype		= ();
		my $indcolname	= '';
		unless ($reload){
			$keyname	= quoteit($q->param('keyname'));
			my $i		= 0;
			foreach ('PRIMARY KEY', 'UNIQUE', 'INDEX', 'FULLTEXT'){
				$keytype[$i] = 'SELECTED' if ($q->param('keytype') eq $_);
				$i++;
			}
			$indcolname = quoteit($q->param('indcolname'));
		}
		my $fulltext	= qq!<OPTION VALUE="FULLTEXT" $keytype[3]>FULLTEXT! if (check_version('3.23.23'));
		print <<EndNewIndex
<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=2>
	<TR>
		<TD COLSPAN=3><CODE>Add New Key:</CODE></TD>
    <TR>
		<TD><B>KEY NAME</B></TD>
		<TD><B>KEY</B></TD>
		<TD><B>COLUMN NAMES</B><i> comma separated</i></TD>
	</TR>
	<TR>
		<TD><I>optionally</I><br><INPUT TYPE=TEXT NAME="keyname" VALUE="$keyname" SIZE=12 TITLE="Type key name. Alphanumeric and underscore characters only"></TD>
		<TD TITLE="Select the key type">&nbsp;<BR><SELECT SIZE=1 NAME="keytype" TITLE="Select the key type">
			<OPTION VALUE="">
			<OPTION VALUE="PRIMARY KEY" $keytype[0]>PRIMARY
			<OPTION VALUE="UNIQUE" $keytype[1]>UNIQUE
			<OPTION VALUE="INDEX" $keytype[2]>INDEX
			$fulltext
			</SELECT></TD>
		<TD><TEXTAREA ROWS=3 COLS=$textareasize NAME="indcolname" TITLE="Type the column names comprising the key.\nComma separated">$indcolname</TEXTAREA></TD>
	</TR>
</TABLE>
<HR SIZE=1 LENGTH=700>
EndNewIndex
;
    
	}#if @tabs>0 (for keys)
	else {print "</TABLE><P>";}
	my $action = '';
    if (($q->param('func') =~ /import/i) or ($q->param('func') =~ /export/i)){
		$action = $q->param('func');
	}
	elsif (($q->param('action') =~ /import/i) or ($q->param('action') =~ /export/i)){
		$action = $q->param('action');
	}
	if ($action){print qq!\n<INPUT TYPE=HIDDEN NAME="action" VALUE="$action">\n!;}
	my $sqlchecked = 'CHECKED' if $q->param('preview');
	foreach (keys %option_){print qq!<INPUT TYPE=HIDDEN NAME="$_" VALUE="$option_{$_}">\n!}

	print <<EOT
<INPUT TYPE=HIDDEN NAME="tables" VALUE="$tabs[0]">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="page" VALUE="$page">
<TABLE BORDER=0 CELLPADDIND=0 CELLSPACING=0>
	<TR>
		<TD COLSPAN=5 TITLE="Check to preview generated command">
		<INPUT TYPE=CHECKBOX NAME="preview" TITLE="Check to preview generated command" $sqlchecked>&nbsp;Preview&nbsp;SQL&nbsp;query.</TD>
	</TR>
	<TR>
		<TD><INPUT TYPE=SUBMIT VALUE="   SAVE   " NAME="alter" TITLE="Apply changes" onLoad="focus=on" tabindex=1 taborder=1 style="width: 80; color: #cc0000">&nbsp;</TD>
		<TD>$saveas1</TD>
		<TD><INPUT TYPE=SUBMIT NAME="reload" VALUE="RELOAD" TITLE="READ ORIGINAL VALUES. ALL CHANGE WILL BE LOST" style="width: 80"></TD>
		<TD><INPUT TYPE=SUBMIT VALUE="PROOF" TITLE="READ ORIGINAL VALUES. ALL CHANGE WILL BE LOST" style="width: 120"></TD>
		<TD><INPUT TYPE=RESET TITLE="Reset form" style="width: 80"></TD>
	</TR>
</TABLE>
</FORM>


EOT
;
	print "<FORM ACTION=$full_url METHOD=POST>\n";
	print qq!<INPUT TYPE=SUBMIT NAME="back" VALUE="Back">\n!;
	foreach (keys %$back){print qq!<INPUT TYPE=HIDDEN NAME="$_" VALUE="$back->{$_}">\n!}
	print "</FORM>\n\n";
	print "<!-- Alter procedure ends here -->\n\n";

	return;

}

sub execAlterTable {
	unless ($q->param('alter') or $q->param('saveas')){&loadAlterTable(); return}
	my $table 			= deletespace($q->param('tables'));
	my $scl;
	my $newtablename 	= deletespace($q->param('newtablename'));
	my $back			= {};
	$back->{page} 		= 'tables';
	$back->{dbname}		= $database;
	$back->{func}		= $table ? 'alter' : 'create';
	$back->{tables} 	= "$table" if $table;
	if (my $action = $q->param('action')){$back->{action} = $action}

	my $saveas;
	my @drop_key		= ();
	my $rename;
	my @drop_column		= ();
	my @change_column	= ();
	my $add_column		= ();
	my $add_ind;
	my $options;
	my $order	= '';
	my $enkeys	= '';
	if ($table) {
	
#1) DROP KEYS
		my @dropind 				= $q->param('drop_key');
		foreach (@dropind){
	 		push @drop_key,((/^\s*primary\s*/i)? "\nDROP PRIMARY KEY" : "\nDROP INDEX $_");
		}

#2) RENAME OR SAVE AS
		if ($newtablename ne $table) {
			if ($q->param('saveas')){
				my $include		= $q->param('savewhat');
				$include		= 'both' if ($include eq 'data');
				my $hashref	 = {
					newtablelist	=> [$newtablename],
					tablelist 		=> [$table],
					include			=> 'structure',
					dropifexists	=> '0',
					back			=> '$back',
					comments		=> '0',
					lock			=> '0'
				};
				$saveas			= getdatanstructure($hashref);
				$saveas			=~ s/^(.*)\s*;$/$1/m;
				
			}
			else{
    			$rename = "\nRENAME $newtablename";
			}
    	}
    	my @colname 		= $q->param('colname');
    	my @type 			= $q->param('type');
    	my @length 			= $q->param('length');
    	my @unsigned 		= $q->param('unsigned');
    	my @zerofill 		= $q->param('zerofill');
    	my @binary 			= $q->param('binary');
    	my @notnull 		= $q->param('notnull');
    	my @default 		= $q->param('default');
    	my @autoincrement 	= $q->param('autoincrement');
    
    	my $query 			= "DESCRIBE $table";
    	my ($sth, $res) 	= prepare_execute($query,$back);
	$scl				= scalar @colname;
	if ($newtablename ne $table) {if ($scl > 4){bail_out ($demomsg1, $back)}}
    	my $typeref 		= sub  {
    		my $type 			= shift;
    		$type 				=~ s/^\s*(\w*)(\(.*\))?(.*)/$1/;
    		my $symbols 		= $2; 
    		my $therest 		= $3;
    		$symbols 			=~ s/^\((.*)\)/$1/ if ($symbols);
    		my $unsigned 		= '';
    		my $zerofill 		= '';
    		my $binary 			= '';
    		$symbols 			= quoteit($symbols);
    		$unsigned 			= '1' if ($therest =~ /unsign/i);
    		$zerofill 			= '1' if ($therest =~ /zerofill/i);
    		$binary 			= '1' if ($therest =~ /binary/i);
    		return ($type, $symbols, $unsigned, $zerofill, $binary);
    	};
    	my $i 				= 0;
    	while (my @row = $sth->fetchrow_array()) {
			if ($q->param("drop_column_$row[0]")){
				push @drop_column, "\nDROP COLUMN $row[0]";
			}
    		else {
    			my ($type, $length, $unsigned, $zerofill, $binary) = &$typeref($row[1]);
    			my $autoincrement 	= '1' if ($row[5] =~ /^.*auto.*increment.*$/i);
    		   	my $notnull 		= '';
    			$notnull 			= 1 unless ($row[2] =~ /yes/i);
        		my $default 		= $row[4];
        		my $unsigned_ 		= (belongs(\@unsigned,$row[0]) and ($type[$i] =~ /int|decimal/i or (check_version('4.0.2') and $type[$i] =~/double|float/i)));
				my $zerofill_ 		= (belongs(\@zerofill,$row[0]) and ($type[$i] =~ /int|decimal|double|float/i));
        		my $binary_ 		= (belongs(\@binary,$row[0]) and ($type[$i] =~ /char/i));
        		my $notnull_ 		= belongs(\@notnull,$row[0]);
        		my $autoincrement_ 	= belongs(\@autoincrement,$row[0]);
        		if ($type[$i] =~ /int|decimal|double|float|char|enum|set|year|timestamp/i){$length[$i] = deletespace($length[$i])}
				else {$length[$i] = ''}
				if ($type[$i] =~ /text|blob/i){$default[$i] = ''}
				if (
        			   	($colname[$i] ne $row[0]) 
        			or	($type[$i] !~ /^($type)$/i)
        			or	($length[$i]		ne $length)
        			or	($default[$i]		ne $default)
        			or	($unsigned_			xor $unsigned)
        			or	($zerofill_			xor $zerofill)
        			or	($binary_			xor $binary)
        			or	($notnull_			xor $notnull)
        			or	($autoincrement_ 	xor $autoincrement)
        			)
        		{
        			if ($unsigned_) {$unsigned_ 			= ' UNSIGNED'} else {$unsigned_ = ''}
        			if ($zerofill_) {$zerofill_ 			= ' ZEROFILL'} else {$zerofill_ = ''}
        			if ($binary_)   {$binary_ 				= ' BINARY'} 	else {$binary_ = ''}
        			if ($notnull_)  {$notnull_ 				= ' NOT NULL'}	else {$notnull_ = ''}
        			if ($autoincrement_) {$autoincrement_ 	= ' AUTO_INCREMENT'} else {$autoincrement_ = ''}
        			if ($default[$i]) {$default = " DEFAULT ".$dbh->quote($default[$i])} else {$default = ''}; 
        			$length[$i] = '('.$length[$i].')' if ($length[$i] ne '');
        			push @change_column, "\nCHANGE COLUMN $row[0] $colname[$i] $type[$i]$length[$i]"."$unsigned_"."$zerofill_"."$binary_"."$notnull_"."$default"."$autoincrement_";
        		}		
    					
    		}#unless
    		$i++;
    	}
    	$sth->finish();
#ORDER BY
		if ($order = $q->param('orderby')){
			my $asc		= $q->param('order');
			$order		= "ORDER BY $order $asc";
		}
#ENABLE / DISABLE KEYS
		if ($enkeys = $q->param('enkeys')){
			$enkeys .= ' KEYS' 
		}
	} #if table
#OPTIONS
		if (check_version("3.23.00")){
			my $errmsg = '';
			my $tabletype	= $q->param('tabletype');
			my $tabletype_	= $q->param('tabletype_');
			if ($tabletype){
				if ($tabletype_ !~ /^$tabletype$/i){$options = "TYPE=$tabletype "}
			}
			my $MIN_ROWS		= deletespace($q->param('MIN_ROWS'));
			my $MIN_ROWS_		= $q->param('MIN_ROWS_');
			if ($MIN_ROWS =~ /\D/){$errmsg .= "Parameter MIN_ROWS must contain integer values only\n"}
			elsif ($MIN_ROWS ne $MIN_ROWS_){
				unless ($MIN_ROWS){$options .= "MIN_ROWS=0 "}
				else{$options .= "MIN_ROWS=$MIN_ROWS "}
			}
			my $MAX_ROWS		= deletespace($q->param('MAX_ROWS'));
			my $MAX_ROWS_		= $q->param('MAX_ROWS_');
			if ($MAX_ROWS =~ /\D/){$errmsg .= "Parameter MAX_ROWS must contain integer values only\n"}
			elsif ($MAX_ROWS ne $MAX_ROWS_){
				unless ($MAX_ROWS){$options .= "MAX_ROWS=0 "}
				else{$options .= "MAX_ROWS=$MAX_ROWS "}
			}
			my $AVG_ROW_LENGTH		= deletespace($q->param('AVG_ROW_LENGTH'));
			my $AVG_ROW_LENGTH_		= $q->param('AVG_ROW_LENGTH_');
			if ($AVG_ROW_LENGTH =~ /\D/){$errmsg .= "Parameter AVG_ROW_LENGTH must contain integer values only\n"}
			elsif ($AVG_ROW_LENGTH ne $AVG_ROW_LENGTH_){
				unless ($AVG_ROW_LENGTH){$options .= "AVG_ROW_LENGTH=0 "}
				else{$options .= "AVG_ROW_LENGTH=$AVG_ROW_LENGTH "}
			}
			if (	($tabletype =~ /MyISAM/i)
				 or (!$tabletype and $tabletype_ =~ /MyISAM/i) 
				 or (
				 	check_version("4.1.0") and 
						($tabletype =~ /HEAP/i 
					or	(!$tabletype and $tabletype_ =~ /HEAP/i))
					)
				){
				my $AUTO_INCREMENT		= deletespace($q->param('auto_increment'));
				my $AUTO_INCREMENT_		= $q->param('AUTO_INCREMENT_');
				if ($AUTO_INCREMENT =~ /\D/){$errmsg .= "Parameter AUTO_INCREMENT must contain integer values only\n"}
				elsif (($AUTO_INCREMENT ne $AUTO_INCREMENT_) and ($AUTO_INCREMENT ne '')){
					$options .= "AUTO_INCREMENT=$AUTO_INCREMENT "
				}
			}
			if ($errmsg){bail_out($errmsg, $back)}

			my $ROW_FORMAT		= $q->param('ROW_FORMAT');
			my $ROW_FORMAT_		= $q->param('ROW_FORMAT_');
			if ((!$ROW_FORMAT_ and $ROW_FORMAT ne 'DEFAULT') or ($ROW_FORMAT_ and $ROW_FORMAT ne $ROW_FORMAT_)){
				$options .= "ROW_FORMAT=$ROW_FORMAT "
			}

			my $PACK_KEYS		= $q->param('PACK_KEYS');
			my $PACK_KEYS_		= $q->param('PACK_KEYS_');
			if (($PACK_KEYS_ eq '' and $PACK_KEYS ne 'DEFAULT' and $PACK_KEYS ne '') or ($PACK_KEYS_ ne '' and $PACK_KEYS ne $PACK_KEYS_)){
				$options .= "PACK_KEYS=$PACK_KEYS "
			}
			
			my $CHECKSUM		= $q->param('CHECKSUM');
			my $CHECKSUM_		= $q->param('CHECKSUM_');
			if (($CHECKSUM or $CHECKSUM_) and ($CHECKSUM ne $CHECKSUM_)){
				unless ($CHECKSUM){$options .= "CHECKSUM=0 "}
				else{$options .= "CHECKSUM=$CHECKSUM "}
			}
			my $DELAY_KEY_WRITE		= $q->param('DELAY_KEY_WRITE');
			my $DELAY_KEY_WRITE_		= $q->param('DELAY_KEY_WRITE_');
			if (($DELAY_KEY_WRITE or $DELAY_KEY_WRITE_) and ($DELAY_KEY_WRITE ne $DELAY_KEY_WRITE_)){
				unless ($DELAY_KEY_WRITE){$options .= "DELAY_KEY_WRITE=0 "}
				else{$options .= "DELAY_KEY_WRITE=$DELAY_KEY_WRITE "}
			}
			my $comment		= deletespace($q->param('comment'));
			my $COMMENT_	= $q->param('COMMENT_');
			if (($comment or $COMMENT_) and ($comment ne $COMMENT_)){
				$comment = $dbh->quote($comment);
				$options .= "COMMENT=$comment";
			}
		}
		
# NEW COLUMN
	if (my $newcolname 		= $q->param('newcolname')) {
		my $newcoltype 			= $q->param('newcoltype');
		my $newcollength 		= $q->param('newcollength');
		$newcollength 			= '('.$newcollength.')' if $newcollength;
		
		my $unsigned_new 		= ' UNSIGNED' if ($q->param('unsigned_new'));
		my $zerofill_new 		= ' ZEROFILL' if ($q->param('zerofill_new'));
		my $binary_new 			= ' BINARY'     if ($q->param('binary_new'));
		my $notnull_new 		= ' NOT NULL'  if ($q->param('notnull_new'));
		my $newcoldefault 		= ' DEFAULT '.$dbh->quote($q->param('newcoldefault')) if ($q->param('newcoldefault'));


		my $addwhere 			= $q->param('firstafter');
		if ($table) {
    			if ($addwhere eq 'AFTER') {
    				$addwhere 			.= " ".$q->param('firstafterwhat');
    			}
    			if ($scl < 5){
    				$add_column = "\nADD COLUMN $newcolname $newcoltype$newcollength$unsigned_new$zerofill_new $binary_new$notnull_new$newcoldefault $addwhere";
			}
			else {bail_out ($demomsg1, $back)}
		}
		else {$add_column = " ($newcolname $newcoltype$newcollength$unsigned_new$zerofill_new $binary_new$notnull_new$newcoldefault) "}
	}
	
# ADD NEW INDEX:
	my $keyname 				= $q->param('keyname');
	my $keytype 				= $q->param('keytype');
	my $indcolname 				= $q->param('indcolname');
	if ($keytype){
		if ($scl > 4){bail_out ($demomsg1, $back)}
		if ($keytype =~ /^primary$/i) {
			$add_ind			.= "\nADD PRIMARY KEY "
		}
		else {
			$add_ind			.= "\nADD $keytype $keyname ";
		}
#		$query 					.= "UNIQUE $keyname " if ($keytype =~ /^unique$/i);
#		$query 					.= "INDEX $keyname " if ($keytype =~ /^index$/i);
		
		$add_ind				.= "($indcolname)";
	}
	
#ASSEMBLE THE QUERY
	my @queries 				= ();
	if ($table) {
		if ($saveas){
			if ($scl > 4){bail_out ($demomsg1, $back)}
			push @queries, $saveas ;
			$table = $newtablename;
		}
#	my $rename;
		my @alter = ();
		push @alter, @drop_key		if @drop_key;
		push @alter, @drop_column	if @drop_column;
		push @alter, $enkeys		if $enkeys;
		push @alter, @change_column	if @change_column;
		push @alter, $add_column	if $add_column;
		push @alter, $add_ind		if $add_ind;
		push @alter, "\n$options"	if $options;
		push @alter, $rename		if $rename;
		push @alter, $order			if $order;
		
		if (@alter){
			my $ignore = ' IGNORE' if $q->param('ignore');
			$query	= "ALTER$ignore TABLE $table ";
			$query	.= join ', ', @alter;
			push @queries, $query;
		}

	}
	else {
		$query 	= "CREATE TABLE $newtablename $add_column";
		$query	.= "\n$options\n";
		
		push @queries, $query;
	}
	
	
	if ($q->param('preview') and @queries) {
		my $func	= ($page eq 'create') ? 'create' : $q->param('func');
		my $back = {
			page			=> "alterAfterPreview",
			func			=> "$func",
			newtablename	=> "" . $q->param('newtablename'),
			alter			=> 1,
			preview			=> "" . $q->param('preview')
		};
		printpreview(\@queries, $back);
		return;
    }
	else {
		foreach (@queries) {
    		$dbh->do($_) or bail_out("ALTER FAIL\nQUERY: $_", $back);
   		}
	}
	my $msg;
	unless (@queries){$msg = qq?<FONT COLOR="#FF0000">No Changes!</FONT>?}
	&loadAlterTable({msg => $msg})
}
sub execDeleteFromTable {
	print "<!-- DeleteFromTable Procedure starts here -->";
	my $back = {
		page		=> 'select_db',
		dbname		=> "$database",
	};
	if ($q->param('delete')) {
    	my @tabs = $q->param('tables');
    	if (@tabs == 0){print "<p><b>DELETE ERROR:</B> Table is not specified.<P>\n"}
    	elsif  (@tabs >= 2) {print "<p><b>DELETE ERROR:</B> TOO MANY TABLES.<P>\n"}
    	else {
    		my $where = $q->param('wheredelete');
        	my $query;
        	if ($where) {$query = "DELETE FROM $tabs[0] WHERE $where"}
        	else {$query = "DELETE FROM $tabs[0] WHERE 1=1"}
        	my $res = $dbh -> do($query) or bail_out ("ERROR: CAN NOT DELETE FROM $_ \nQUERY: $query", $back);
		}
	}
	&loadSelectTables();
	print "<!-- DeleteFromTable Procedure ends here -->";
	return;
}
sub getCreateTableSQL {
	my $text;
	my $hash			= shift;
	my $tabsref 		= $hash->{tabsref};
	my $dropifexists 	= $hash->{dropifexists};
	my $back			= $hash->{back};
	my @newtabs 		= @{$hash->{newtabs}} if defined $hash->{newtabs};
	my @tabs 			= @$tabsref;
	my $newtabind		= 0;
	if (check_version('3.23.20')){
		foreach my $table (@tabs) {
			$text 					.= "DROP TABLE IF EXISTS $table; \n" if  $dropifexists;
			my $query 				= "SHOW CREATE TABLE $table";
			my ($sth, $res) 		= prepare_execute($query, $back);
			my @opt   				= $sth->fetchrow_array();
			$sth->finish();
			if ($newtabs[$newtabind]){
				if ($opt[1] =~ /^CREATE TABLE (\S?)(\w+)\1(.*)$/si){$opt[1] = "CREATE TABLE $1$newtabs[$newtabind]$1 $3"}
			}
			$text					.= "$opt[1];\n\n";
			$newtabind++;
		}
		return $text;
	}
	foreach my $table (@tabs) {
		$text 					.= "DROP TABLE IF EXISTS $table; \n" if  $dropifexists;
		my $col_declaration 	= '';
		my @col_declaration 	= ();		
		
		my $query 				= "DESCRIBE $table";
		my ($sth, $res) 		= prepare_execute($query, $back);
		my $i = 0;
		while (my @column = $sth->fetchrow_array()) {
			  
			  $col_declaration[$i] .= "\t$column[0] $column[1]";
			  $col_declaration[$i] .= " NOT NULL" unless ($column[2] eq 'YES');
			  $col_declaration[$i] .= " DEFAULT ".$dbh->quote($column[4]) unless  ($column[4] eq '');
			  $col_declaration[$i] .= " AUTO_INCREMENT" if  ($column[5] =~ /AUTO_INCREMENT/i);
			  $i++;
		}
		$sth->finish or ErrMessage("Cannot finish STH (DDL-describe)");
		$col_declaration = join (",\n", @col_declaration);
		$query = "SHOW INDEX FROM $table";
		($sth, $res) = prepare_execute($query, $back);
		
		my $index;
		my $fulltext; 
		my %primary;
		my $unique;
		
		while (my @opt = $sth->fetchrow_array) {

			if ($opt[1] eq '0'){
			  	if ($opt[2] =~ /^PRIMARY$/i){
			  		$primary{$opt[3]} = $opt[4];
					$primary{$opt[3]} .= "($opt[7])" if ($opt[7]);
				}
				else{
					my $colname = $opt[4];
					$colname .= "($opt[7])" if ($opt[7]);
			  		$unique->{$opt[2]}{$opt[3]}=$colname;
				}
			}
			else {
				my $colname = $opt[4];
				$colname .= "($opt[7])" if ($opt[7]);
				if ($opt[9] =~ /FULLTEXT/i){$fulltext->{$opt[2]}{$opt[3]}=$colname;}
				else {$index->{$opt[2]}{$opt[3]}=$colname;}
			}
		}
		$sth->finish or ErrMessage("Cannot finish STH (DDL-show index)");

		my @primary_key;
		my @unique;
		my @index;
		my @fulltext; 
		
		foreach (sort keys (%primary)){
			push @primary_key, $primary{$_};
		}
		my $unique_key;
		foreach (keys %$unique) {
			my $hash = $unique->{$_};
			$unique_key .= ",\n\tUNIQUE $_ ";
			
			foreach (sort keys %$hash){
			 	push @unique, $hash->{$_};
			} 
			$unique_key .= "(".join(', ', @unique).")";
			@unique = ();
		}
		my $index_key;
		foreach (keys %$index) {
			my $hash = $index->{$_};
			$index_key .= ",\n\tINDEX $_ ";
			
			foreach ( sort keys %$hash){
				push @index, $hash->{$_};
			} 
			$index_key .= "(".join(', ', @index).")";
			@index = ();
		}
		my $fulltext_key;
		foreach (keys %$fulltext) {
			my $hash = $fulltext->{$_};
			$fulltext_key .= ",\n\tFULLTEXT $_ ";
			
			foreach ( sort keys %$hash){
				push @fulltext, $hash->{$_};
			} 
			$fulltext_key .= "(".join(', ', @fulltext).")";
			@fulltext = ();
		}
		
		my $primary_key = ",\n\n\tPRIMARY KEY (".join(', ',@primary_key).")" if (scalar(%primary));
		my $create_definition = 
            $col_declaration.
            $primary_key.
            $index_key.
			$fulltext_key.
            $unique_key
            ;

       my $table_options = "";
  	   if (check_version('3.23.00')) {
   
    		$query = "SHOW TABLE STATUS";
    		($sth, $res) = prepare_execute($query, $back);
LABLE1:	while (my @row = $sth->fetchrow_array()) {
    			if ($table eq $row[0]){
    			   if ($row[1]) {$table_options .= "\tTYPE=$row[1]\n" unless ($row[1] =~ /myisam/i)}
    			   my $opt = $row[-2];
    			   my $i = 0;
    			   while ($opt =~ /^\s*(\S*=\S*)\s*(.*)$/){
    					 my $first = $1;
    					 my $second = $2;
    					 if ($first =~ /^\s*format\s*=/) {$first = "ROW_$first"}
    					 $table_options .= "\t$first\n";
    					 $opt = $second;
    					 if ($i++ > 100) {
    					 	$table_options = '';
    						print "Table_options fail! ($i)<br>";
    						last LABLE1;
    					 }
    			   }#while
    			   if ($row[-1]) {$table_options .= "\tCOMMENT=\"$row[-1]\"\n";}
    			}#if		
    		}#while
			$sth->finish();
		} #if version = 3.23#
		$table = $newtabs[$newtabind] if $newtabs[$newtabind];
		$text .= <<EOT
CREATE TABLE $table 
(
 $create_definition
)
 $table_options
;

EOT
;
	$newtabind++;
	}
	return $text;
}
sub execGenerateDDL {

	print "<!-- GenerateDDL procedure starts here -->";
	my @tabs = $q->param('tables');
	my $back = {page => 'select_db', dbname => "$database"};
	bail_out ("Table is not specified.", $back) unless @tabs;
	my $dropifexists = $q->param('dropifexists');
	my @text;
	foreach(@tabs){
		my $fk = 0;
		my $text = getCreateTableSQL({tabsref =>[$_], dropifexists => "$dropifexists", back => $back});
		if ($text =~ /FOREIGN KEY/si){push @text, $text} else {unshift @text, $text}
	}
	
	($user, $password, $MySQLhost, $usedefault) = $q->cookie('db_manager');
	my $textsize		= $agent ? 17 : 25;
	my $textareasize	= $agent ? 45 : 70;
	my $dbname = $database;
	print <<DDLTable
<FORM METHOD=POST ACTION="$full_url">
<TABLE BORDER=1 CELLPADDING=4>
	   <TR>
	   	   <TD><TEXTAREA WRAP=OFF ROWS=22 COLS=$textareasize NAME="SQL">@text</TEXTAREA></TD>
		   <TD VALIGN=TOP><P><CODE>APPLY TO:</CODE><P>
		<!--     User name:<BR>
		 <INPUT TYPE=TEXT SIZE=$textsize NAME="user" VALUE="$user"><BR>
		   Password:<BR>
		   <INPUT TYPE=PASSWORD SIZE=$textsize NAME="password" VALUE="$password"><BR> -->
		   Database Name:<BR>
		   <INPUT TYPE=TEXT SIZE=$textsize NAME="dbname" VALUE="$database"><BR>
		  <!--   host [localhost]<BR>
		   <INPUT TYPE=TEXT SIZE=$textsize NAME="host" VALUE=""> --><P>
		   <INPUT TYPE=SUBMIT SIZE=$textsize NAME="apply" VALUE="Apply">
		   <INPUT TYPE=RESET><BR>
		   <INPUT TYPE=CHECKBOX NAME="abortsql" TITLW="Abort execution if error occurs">Abort on error
		   </TD>
		</TR>
</TABLE>
<INPUT TYPE=HIDDEN NAME="page" VALUE="ddl">   
<INPUT TYPE=HIDDEN NAME="database" VALUE="$database">   
<!-- <INPUT TYPE=HIDDEN NAME="login" VALUE="1">   -->
</FORM>
DDLTable
;
	print "\n\n<!-- GenerateDDL procedure ends here -->\n\n";

return;
}
sub execInsertData  {
	my $table = $q->param('tables');
	my $back = {dbname => $database, tables => $table};

	if ($page =~ /insert/i){
		$back->{func} = "INSERT";
		$back->{page} = "tables";
	}
	elsif ($page =~ /update/i) {
		$back->{page} = "tables";
		$back->{func} = "UPDATE";
		$back->{updateStart} = $q->param('start');
		$back->{updateRows} = $q->param('rows');
		$back->{updateWhere} = $q->param('where');
		$back->{updateOrder} = $q->param('order');

  	}
	elsif ($page eq 'searchresult'){
		my @fields = $q->param('fields');
		$back->{page} = "searchresult";
		$back->{func} = "new";
		$back->{where} = $q->param('where').'';
		$back->{start} = $q->param('start').'';
		$back->{rows} = $q->param('rows').'';
		$back->{order} = $q->param('order').'';
		$back->{count} = $q->param('count').'';
		$back->{fields} = \@fields;
	}

	my $count1 = count_rows($table, $back);
	
	my $query = "SELECT * FROM $table LIMIT 0";
	my($sth, $res)= prepare_execute ($query, $back);

	my (@insert_list, @insert_data, $set, $data); #test it
	my @names = @{$sth->{NAME}};
	
#++++++++++++++++++++++++++++++++++++++
	
	$sth->finish();

	foreach (@names) {
		my @up_list = $q->param('upload');
		if (belongs(\@up_list,$_)){
			$data = $q->param($_.'_data_upload');
			my $buf;
			binmode $data;
			my $line = '';
			while (read ($data, $buf, 1024)) {$line .= $buf}
			close $data or bail_out("$!", $back);
			$data = $line;
		}
		else {$data = $q->param($_.'_data')};
		if ($data ne ''){
			push @insert_list, $_;		

#++++++++++++++++++++++++++++++++++++++

			my @unquote = $q->param('unquote');
			$data = $dbh->quote($data) unless belongsb(\@unquote, $_);
			push @insert_data, $data;
		}#if ($data...

#++++++++++++++++++++++++++++++++++++++
		
	}#foreach...
	
#++++++++++++++++++++++++++++++++++++++
	if (@insert_list == 0){
		my @datum;
		foreach (@names) {push @datum, "''"}	
		$query = $q->param('insmethod')." ".$q->param('insert_option1')." ".$q->param('insert_option2').
			   " INTO $table \n (".join (', ', @names).") \n VALUES (".join (', ', @datum).")";
	}#End   -  empty @insert_list
	
	else {
    	$set = "\n".$insert_list[0].'='.$insert_data[0];
    	for (my $i=1; $i<@insert_list; $i++){
    		$set = $set.",\n".$insert_list[$i].'='.$insert_data[$i]
    	}
		$query = $q->param('insmethod')." ".$q->param('insert_option1')." ".$q->param('insert_option2')." INTO $table \n SET $set";
	}

	if ($q->param('preview')) {printpreview([$query]); return }
	else {bail_out($demomsg, $back)} 
#++++++++++++++++++++++++++++++++++++++
	return()
}
sub getwhere {
	my ($pri, @queryArray, @pri, @priNum);
	my $input		= shift;
	my $count		= $input->{count};
	my $table		= $input->{table};
	my $start		= $input->{start};
	my $rows		= $input->{rows};
	my $query		= $input->{query};
	my $back		= $input->{back};
	my $returnarray	= $input->{returnarray}; # 1 => return WHERE conditions as an array reference
	$query .= ' LIMIT '.$start.', '.$rows			if ($start and $rows);
	$query .= ' LIMIT '.$rows 						if (!$start and $rows);
	$query .= ' LIMIT '.$start.', '.($count-$start)	if ($start and !$rows);
	my ($sth,$res) = prepare_execute($query, $back);
	my $primary = get_mysql_pri($sth);
	unless (defined $primary){$primary = []}
	for (my $i=0; $i<@$primary; $i++){
		if ($primary->[$i]){push @priNum,$i; push @pri, $sth->{NAME}[$i]}
	}
	if (@pri == 0){
	    @pri = @{$sth->{NAME}};
		@priNum = (0..(scalar(@pri)-1));
	}
	my $i = $start;
	my @selectrows = $q->param('SelectRow');
	my @where;
	while (my @ary = $sth->fetchrow_array ()) {
		my $where;
		if (&belongs(\@selectrows, $i)) {
			my @where_;
			my $data = $dbh->quote($ary[$priNum[0]]);
   			for (my $jj = 0; $jj < @pri; $jj++) {
				my $data = $dbh->quote($ary[$priNum[$jj]]);
				if (uc($data) eq 'NULL'){push @where_, "$pri[$jj] IS NULL"}
				else {push @where_, "$pri[$jj] = $data"}
    		}
			$where = join ") AND (", @where_;
			$where = "($where)" if @where_ > 1;
			push @where, $where;
		}
		$i++
	}
	$sth->finish();
	if ($returnarray){
		return \@where
	}
	else{
		my $where = join ") OR (", @where;
		$where = "($where)" if @where > 1;
		return $where;
	}
1;
} # end of getwhere

sub execUpdateData {
	my $rows = $q->param('rows');
	my $start = $q->param('start')+0;
	my $where = $q->param('where');
	my $order = $q->param('order');
	my $count = &count_rows($q->param('tables'));
	my $table = $q->param('tables');
	my $back = {
			dbname			=> "$database",
			tables			=> "$table",
			page			=> "tables",
			func			=> "UPDATE",
			updateStart		=> "$start",
			updateRows		=> "$rows",
			updateWhere		=> "$where",
			updateOrder		=> "$order"
	};
	my @hidfields 		= $q->param('fields');
#	if ($q->param('update') eq 'Update'){
#		@hidfields 				= $q->param('$table\_fields');
#		$back->{updateStart} 	= $q->param('updateStart');
#		$back->{updateRows} 	= $q->param('updateRows');
#	}

	$back->{"$table\_fields"}	= \@hidfields;
	my $wrongparam = qq?<FONT COLOR="#FF0000"><B>WRONG PARAMETERS!</B></FONT>?;

	if ($q->param('insert')) {
		my $insert_result;
		unless ($q->param('error')) {
			$insert_result = execInsertData();
			return if $q->param('preview');
		}
		else {$insert_result = $wrongparam}
		&loadUpdateForm($insert_result);
    	return;	
	}
	if ($q->param('reload')) {
    	&loadUpdateForm;
    	return;	
	}
	if ($q->param('zoom')){

		if ($q->param('error')){&loadUpdateForm($wrongparam); return}

		unless ($q->param('zoomselect') and defined $q->param('SelectRow')) { # if nothing was selected to zoom
			my $msg = qq!<FONT COLOR="#FF0000"><B>PLEASE SELECT ONE ROW AND ONE COLUMN TO ZOOM</B></FONT>!;
			&loadUpdateForm($msg)
		}
		else {&loadZoom()}
	   return;
	}

	my ($pri, @queryArray, @pri, @priNum);

	if ($q->param('delete')) {
		if ($q->param('error')){&loadUpdateForm($wrongparam); return}
		unless (defined $q->param('SelectRow')) {
		   	  my $msg = qq!<FONT COLOR="#FF0000"><B>Nothing was selected</B></FONT>!;
           	  &loadUpdateForm($msg);
			  return;
		}

		my $query = "SELECT * FROM $table";		
		my $where =$q->param('where');
		$query .= " WHERE $where" if $where;
		$query .= " ORDER BY $order" if $order;
		my $calldelete = {
			count => "$count", table => "$table", start => "$start", rows => "$rows", query => "$query", back => $back
		};
		$query = "DELETE ".$q->param('delete_option1')." FROM  $table WHERE ";
		$query .= getwhere($calldelete);

	    if ($q->param('preview')) {
		   printpreview([$query]);
    	}

		 else {	
    		$dbh->do($query) or &bail_out("$query", $back);	
        	&loadUpdateForm;
		}
    	return;	
	
	}

#update
	if ($q->param('error')){&loadUpdateForm($wrongparam); return}

	my @fields = $q->param('fields');
	my $fields = join (', ', @fields);
	if (@fields == 0) {$fields = '*'}
	my $query = '';
	$query = "SELECT * FROM $table";		
	$query .= " WHERE $where" if $where;
	$query .= " ORDER BY $order" if $order;
	$query .= " LIMIT $start, $rows"			if ($start and $rows);
	$query .= " LIMIT $rows" 					if (!$start and $rows);
	$query .= " LIMIT $start, ".($count-$start)	if ($start and !$rows);

	my ($sth, $res) = prepare_execute($query, $back);
	
	my $primary = get_mysql_pri($sth);
	unless (defined $primary){$primary = []}
	for (my $i=0; $i<@$primary; $i++){
		if ($primary->[$i]){push @priNum, $i; push @pri, $sth->{NAME}[$i]}
	}
#---selected---------
	my $i = 0;		#Rows
	my $j;			#Columns
	my $k = 0;
	my @queries; 
  	if (@pri == 0){
       @pri = @{$sth->{NAME}};
       @priNum = (0..(scalar(@pri)-1));
    }
    

#++++++++++++++++++++++++++++++++++++++
	while (@ary = $sth->fetchrow_array ()) {
		$query = "UPDATE ".$q->param('update_option1')." ".$q->param('update_option2')." $table SET ";
		my $ii = 0;
		for ($j=0; $j<@ary; $j++) {
			next unless(belongs(\@fields,${$sth->{NAME}}[$j]) or $fields eq '*');
			my $value = $q->param('n'.$i.'_'.$ii);
			$ii++;
#++++++++++++++++++++++++++++++++++++++
			if ($ary[$j] ne $value) {
				push @queryArray, ${$sth->{NAME}}[$j]." = ".$dbh->quote($value);
				$k=1;
			}
		}#for
		if ($queryArray[0]){
			my $data = $dbh->quote($ary[$priNum[0]]);
			my $where;
			if (uc($data) eq 'NULL'){$where = " WHERE $pri[0] IS NULL"}
			else {$where = " WHERE $pri[0] = $data"}
			my $jj;
			for ($jj = 1; $jj < @pri; $jj++) {
				my $data = $dbh->quote($ary[$priNum[$jj]]);
				if (uc($data) eq 'NULL'){$where .= " AND $pri[$jj] IS NULL"}
				else {$where .= " AND $pri[$jj] = $data"}
			}
			$query .= join(", ",@queryArray)." $where";
			push @queries, $query;
		}#if($query...
		else {$query = ''}
		$i++;
		@queryArray = ();
	}#while
	$sth->finish ();
	if ($k==0) {
		my $nochanges = "<FONT COLOR=\"#FF0000\"><b>Nothing was changed</b></FONT>";
		&loadUpdateForm($nochanges);	
	}
	#UPDATE
	elsif ($q->param('update')) {
#++++++++++++++++++++++++++++++++++++++
	
	if ($q->param('preview')) {
		   printpreview(\@queries);
    	}# end preview
	else {bail_out($demomsg, $back)}  	}
	return;

} # END UPDATE

#++++++++++++++++++++++++++++++++++++++

sub execUpdateAfterPreview {
	if ($q->param('back')){&loadUpdateForm(qq!<font color="#cc0000"><b>Changes were lost</b></font>!); return}
	my $res;
	my $msg;
	my @queries = $q->param('queries');
	my $i = 0;
	my $table = $q->param('tables');
	my $back = {
			dbname			=> "$database",
			tables			=> "$table",
			page			=> "tables",
			func			=> "UPDATE",
			updateStart		=> $q->param('updateStart')."",
			updateRows		=> $q->param('updateRows')."",
			updateWhere		=> $q->param('updateWhere')."",
			updateOrder		=> $q->param('updateOrder')."",
	};
	bail_out($demomsg, $back);
	return;
}
sub execAlterAfterPreview {
	if ($q->param('back')){&loadAlterTable({msg => qq!<font color="#cc0000">Changes were lost!}); return}
	my $table	= $q->param('tables');
	my $dbname	= $q->param('dbname');
	my $func	= $q->param('func');
	unless ($func eq 'create'){$func = 'alter'}
	my $back 	= {
		page 	=> 'tables',
		func 	=> "$func",
		dbname 	=> "$dbname",
		tables 	=> "$table"
	};
	my $msg;
	my @queries = $q->param('queries');
#++++++++++++++++++++++++++++++++++++++

	foreach $query (@queries) {
		next unless ($query =~ /\w/);
		$dbh->do($query) or bail_out("ALTER FAIL.\nQUERY:\n$query", $back);
	}
	if (@queries==0) {
			$msg = qq?<B><FONT COLOR="#FF0000">No query was selected</FONT></B>? ;
	}

    	   &loadAlterTable({msg => $msg});	
	return;
}

sub logout {
	my @value = ('','','','');
	my $cookies = $q->cookie(-name=>'db_manager',
							 -value=>\@value,
							 -secure=>0);
	print 	$q->header(-cookie=>$cookies);
	&startpage();
	print <<IndexBody
<BR>

<FORM METHOD=POST ACTION="$full_url">
<INPUT TYPE=HIDDEN NAME="page" VALUE="connect">
<INPUT TYPE=HIDDEN NAME="login" VALUE="1">
<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0>
    <TR HEIGHT=100>
     <TD WIDTH=20 HEIGHT=100>&nbsp;</TD>
     <TD WIDTH=150 HEIGHT=100>&nbsp;</TD>
        <TD WIDTH=120 HEIGHT=100>&nbsp;</TD>
        <TD WIDTH=201 HEIGHT=100>&nbsp;</TD>
    </TR>

    <TR>
     <TD WIDTH=20>&nbsp;</TD>
     <TD WIDTH=150>&nbsp;</TD>
        <TD WIDTH=120>USER</TD>
        <TD WIDTH=201>
            <INPUT  TYPE=TEXT NAME="user" VALUE="" SIZE=23 MAXLENGTH=23 TITLE="User name" style="width: 160px">&nbsp;</TD>
    </TR>
    <TR>
     <TD WIDTH=20>&nbsp;</TD>
     <TD WIDTH=150>&nbsp;</TD>
        <TD WIDTH=120>PASSWORD</TD>
        <TD WIDTH=201><INPUT TYPE=PASSWORD NAME="password" VALUE="" SIZE=23 MAXLENGTH=23 TITLE="Password" style="width: 160px">&nbsp;</TD>
    </TR>
    <TR>
     <TD WIDTH=20>&nbsp;</TD>
     <TD WIDTH=150>&nbsp;</TD>
        <TD WIDTH=120>DATABASE</TD>
        <TD WIDTH=201><INPUT TYPE=TEXT NAME="dbname" VALUE="" SIZE=23 TITLE="Database name" style="width: 160px">&nbsp;</TD>
    </TR>
    <TR>
     <TD WIDTH=20>&nbsp;</TD>
     <TD WIDTH=150>&nbsp;</TD>
        <TD WIDTH=120>HOST:PORT</TD>
        <TD WIDTH=201><INPUT TYPE=TEXT NAME="host" VALUE="" SIZE=23 TITLE="Host name:Port number" style="width: 160px">&nbsp;</TD>
    </TR>

    <TR>
     <TD WIDTH=20>&nbsp;</TD>
     <TD WIDTH=150>&nbsp;</TD>
        <TD WIDTH=120>&nbsp;</TD>
        <TD WIDTH=201>&nbsp;</TD>
    </TR>
    <TR>
     <TD WIDTH=20>&nbsp;</TD>
     <TD WIDTH=150>&nbsp;</TD>
        <TD WIDTH=120>&nbsp;</TD>
        <TD WIDTH=201><INPUT TYPE=SUBMIT VALUE=SUBMIT TITLE="Log in"  style="width: 160px"></TD>
    </TR>                                                
    
</TABLE>
</FORM>

</TD></TR></TABLE>

</BODY>
</HTML>	
IndexBody
;
	

return;

}


sub printpreview {
# QUERIES_ref = $_[0];
# WAY BACK = $_[1];
	print $q->start_multipart_form(-action=>$full_url, -method=>"POST");
	print <<EndPreviewHeader
<TABLE WIDTH="100%" BORDER=0 CELLSPACING=0 CELLPADDING=0>
	   <TR><TH COLSPAN=2 ALIGN=LEFT>PREVIEW</TH></TR>
	   <TR><TD COLSPAN=2 HEIGHT=8></TD></TR>
EndPreviewHeader
;
 	my $queriesref = $_[0];
	foreach (@$queriesref) {
		my $count;
		while(/\n/g){$count++; last if $count > 8}
		my $rows = $count+1;
		if ($rows < 3){$rows = 3}
		my $cols = $agent ? 65 : 90;
		$_ = quoteit($_);
		print <<EndPreviewHere
		  <TR>
		  	  <TD VALIGN=BOTTOM><B>Statement: </B><BR>
		<TEXTAREA NAME="queries" COLS=$cols ROWS=$rows WRAP=ON>$_</TEXTAREA></TD>
			<TD VALIGN=BOTTOM> &nbsp<!--  <INPUT TYPE=CHECKBOX NAME="ok" VALUE="ok">Ok? --> </TD>
		   </TR>
		   <TR>
			   <TD COLSPAN=2 HEIGHT=8></TD>
		  </TR>
EndPreviewHere
;
	}


	print qq!
		   <TR>
		   	   <TD HEIGHT=35 VALIGN=BOTTOM><INPUT TYPE=SUBMIT VALUE="Submit"><INPUT TYPE=SUBMIT NAME="back" VALUE="CANCEL"></TD>
			   <TD HEIGHT=35 VALIGN=BOTTOM></TD>
		   </TR>
</TABLE>

<INPUT TYPE=HIDDEN NAME="dbname" VALUE="!, $q->param('dbname'), qq!">
<INPUT TYPE=HIDDEN NAME="tables" VALUE="!, $q->param('tables'), qq!">
!;
	unless ($_[1]){
		my $updateWhere = quoteit($q->param('where'));
		my $updateOrder = quoteit($q->param('order'));
		print qq!
<INPUT TYPE=HIDDEN NAME="page" VALUE="updateAfterPreview">
<INPUT TYPE=HIDDEN NAME="updateStart" VALUE="!, $q->param('start'), qq!">
<INPUT TYPE=HIDDEN NAME="updateRows" VALUE="!, $q->param('rows'), qq!">	
<INPUT TYPE=HIDDEN NAME="updateWhere" VALUE="$updateWhere">	
<INPUT TYPE=HIDDEN NAME="updateOrder" VALUE="$updateOrder">	
	!;}
	else {
		foreach (keys(%{$_[1]})){
			print $q->hidden(-name=>$_, -value=>$_[1]->{$_}, -override=>1),"\n";
		}
	}
	my $table = $q->param('tables');
	my @fields = $q->param('fields');
	foreach (@fields){
		print "<INPUT TYPE=HIDDEN NAME=\"fields\" VALUE=\"$_\">";
	}
	@fields = $q->param($table.'_fields');
	foreach (@fields){
		print "<INPUT TYPE=HIDDEN NAME=\"$table\_fields\" VALUE=\"$_\">";
	}
	print "\n</FORM>\n"
}

sub loadRestore {
	if ($q->param('gotobackup')){loadBackup(); return}
	my ($hostname,$port) 	= myhost();
	my $userhost 			= $hostname;
	$hostname 				.= ":$port" if $port;
	my ($targethost, $targetuser, $dberr);
	my $succeed;
	my $selectdbname_   	= $q->param('selectdbname_');
	$selectdbname_  		= $database unless $selectdbname_;
	
	#my $userhost = myhost();
	my $back 				= {page => "$page"};
	$back->{dbname} 		= "$database" if $database;
	$back->{selectdbname_}	= "$selectdbname_" if $selectdbname_;
	if (my $errmsg = checkuserdir('backup')){bail_out("$errmsg\n$!", $back)}
    my $userdir				= "$USER_DIR$delim$user.$userhost$delim" . "backup";
	$back ->{func} 			= 'restore';
	$back ->{userhost} 		= "$userhost";
	
	if ($q->param('disconnect')){
		$dbh_ = $dbh;
		$selectdbname_  = $database
	}
	elsif ($q->param('targetconnect')){
		$targethost			= $q->param('targethost');
		$targetuser			= $q->param('targetuser');
		my $targetpassword 	= $q->param('targetpassword');
		$selectdbname_		= $q->param('targetdb');
		unless ($targethost) {$targethost = $DEFAULTHOST}
		my $dsn				= "DBI:mysql:$selectdbname_;$targethost";
		$dbh_ 				= DBI->connect($dsn, $targetuser, $targetpassword,\%attr)
			or bail_out("Cannot connect",$back);
		$succeed			= 1;
		$back->{target}		= 1;
	}
	elsif ($q->param('target')){
		($targetuser, my $targetpassword, $targethost) = $q->cookie('target_db');
		my $dsn				= "DBI:mysql:$selectdbname_;$targethost";
		$dbh_ 				= DBI->connect($dsn, $targetuser, $targetpassword,\%attr);
		if ($DBI::err){
			if ($DBI::errstr =~ /access denied/i){
				$dsn		= "DBI:mysql:;$targethost";
				$dbh_ 		= DBI->connect($dsn, $targetuser, $targetpassword,\%attr);
				if ($DBI::err){
					if ($DBI::errstr =~ /access denied/i){$dberr = 1}
					else {bail_out("Cannot connect",$back) }
				}
			}
			else {bail_out("Cannot connect",$back)}
		}
		$succeed			= 1;
		$back->{target}		= 1;
	}
	else {
		$dbh_ = $dbh
	}

	my @databases;
	unless ($dberr){
		my $databasesref	= getdblist($dbh_);
		if ($DBI::err and (not defined $databasesref)){$dberr = 1}
		else {@databases = @$databasesref} 
	} 
	my @files = $q->param('selectfilelist');
	if ((@files == 1)and !$files[0]){@files = ()}
	my $pageHead =  sub {
	print qq!
<FORM METHOD=POST ENCTYPE="multipart/form-data" ACTION="$full_url">
<TABLE BORDER=0 WIDTH=700 ID="BIG_TABLE">
	<TR><TH ALIGN=LEFT>RESTORE DB AND TABLES FROM DUMP FILES</TH>
	</TR>
	<TR><TD>
!;
	return undef;
	};
	
	my $pageBottom = <<EndOfBottom
		</TD>
	</TR>
</TABLE><!-- END OF BIG TABLE -->
<INPUT TYPE=HIDDEN NAME="func" VALUE="restore">
<INPUT TYPE=HIDDEN NAME="page" VALUE="$page">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="target" VALUE="$succeed">
</FORM>
EndOfBottom
;

	if ($q->param('delete') and !$q->param('cancel')){
		bail_out("File(s) not selected", $back) unless @files;
		my @filestodelete;
		foreach (@files){
			s/^(.*)\s\/\d*\/\s.*/$1/;
			push @filestodelete, $_;			
		}
		unless ($q->param('deleteconfirm')) {
			&$pageHead(' -> DELETE FILE(S)');
			print qq!<BR><P TITLE="List of files to be deleted"><B>THESE FILES WILL BE DELETED:</B></P>\n!;
			foreach (@filestodelete){
				$_ = quoteit($_);
				print qq!<INPUT TYPE=CHECKBOX NAME="selectfilelist" VALUE="$_" CHECKED TITLE="Uncheck to keep this file"> $_ <BR>\n!;
			}
			print qq!<BR><INPUT TYPE=SUBMIT NAME="deleteconfirm" VALUE="DELETE" TITLE="Delete selected files">&nbsp;\n!;
			print qq!<INPUT TYPE=SUBMIT NAME="cancel" VALUE="CANCEL" TITLE="Go back to previous page without deletion">\n!;
			print qq!<INPUT TYPE=HIDDEN NAME="delete" VALUE="1">\n!;
			print qq!<INPUT TYPE=HIDDEN NAME="selectdbname_" VALUE="$selectdbname_">\n!;
			print $pageBottom;
			return;			
		}
		else {
			foreach (@files){
				my $file = "$userdir/$_";
				unlink ($file) ||bail_out("Could not unlink $_ : $!", $back) ;
				
			}
		}
	}
	if ($q->param('downloadFile')){
		if (scalar @files > 1){
			bail_out("Too many files", $back);
		}
		elsif (!@files){
			bail_out("Please select a file.", $back);
		}
		
		$files[0] =~ s/^(.*)\s\/\d*\/\s.*/$1/;
		my $file = "$userdir$delim$files[0]";
#		$| = 1; 
#		$SIG{CHLD} = 'IGNORE';
		if (my $errmsg = download($userdir, $files[0])){bail_out($errmsg, $back)}
		$dbh->disconnect if defined $dbh;
		exit 0;
	}
	if ($q->param('upload')){
		my $back = {
			page			=> "$page",
			func			=> 'restore',
			selectdbname_	=> "$selectdbname_",
			dbname			=> "$database",
			userhost		=> "$userhost"
		};
		
		if (my $sourse = $q->param('localfile')) {
			my $dest = $sourse;
			$dest =~ s/^(.*[\/|\\])*(.*)/$2/;
			my $dest_ = $dest;
			if ($dest =~ /^(.*)\.([a-zA-Z]*)$/){
				$dest_ =$1 if (($2 eq 'gz') or($2 eq 'gzip') or($2 eq 'zip'));
			}
			my $filexist = sub {
				if ($q->param('overwrite')){
					unlink $_[0]
				}
				else {
					close $sourse or bail_out("$!");
					bail_out("File $dest_ already exists",$back)
				}	
			};
			my $size_ = 0;
			if (-e "$userdir$delim$dest_") 
			{&$filexist("$userdir$delim$dest_"); $size_ = -s "$userdir$delim$dest_"}
			if (-e "$userdir/$dest_.gz")
			{&$filexist("$userdir$delim$dest_.gz"); $size_ = -s "$userdir$delim$dest_.gz"}
			if (-e "$userdir/$dest_.gzip")
			{&$filexist("$userdir$delim$dest_.gzip"); $size_ = -s "$userdir$delim$dest_.gzip"}
			if (-e "$userdir/$dest_.zip")
			{&$filexist("$userdir$delim$dest_.zip"); $size_ = -s "$userdir$delim$dest_.zip"}

    		if ($MAX_BACKUP_SIZE){
        		my $size = dirsize($userdir);
    			$size += (-s $sourse) - $size_;
            	if ($size > ($MAX_BACKUP_SIZE*1024)) {
        			my $errmsg = "Total size of backup files is limited to $MAX_BACKUP_SIZE kb.";
        			$errmsg .= "\nPlease delete some files before uploading.";			
        			bail_out("$errmsg",$back);
        		}
    		}

			$dest = "$userdir$delim$dest";
			open (DEST, ">$dest") || bail_out ("$! $dest_", $back);
			flock (DEST,2) unless $WIN32;
			#if (-B $sourse and $WIN32) {binmode $sourse; binmode DEST;};
			binmode $sourse; binmode DEST;
			my $data;
			while (read $sourse,$data,1024) {
				print DEST $data;
	    	}
			flock (DEST,8) unless $WIN32;
			close DEST;
			close $sourse or bail_out($!);
		}
		else {bail_out("Please select file to upload", $back)}
		
	}
	if ($q->param('compressFile')){
		my @files_;
		bail_out("File(s) not selected", $back) unless @files;
		foreach(@files){
			s/^(.*)\s\/\d*\/\s.*/$1/;
			my $file = "$userdir/".$_;
			my @stat = stat;
			my $size = $stat[7];
			/^.*\.([a-zA-Z]*)$/;
			my $ext = $1;
			bail_out("File $_ is already comressed", $back) if (($ext eq 'gz')or($ext eq 'zip'));
			push @files_,$file;
		}
		foreach (@files_){
    		if (($COMPRESS eq 'zip') and $ALLOW_ZIP){
				my $outfile = $_.'.zip';
    			if (system ("$ZIP $outfile $_ $ZIPLOG")){
    				bail_out("ZIP FAILED: $? $!", $back);
        		}
				unlink $_ if (-e and (-e $outfile)) || bail_out("Could not unlink the sourse $!", $back);    		
    		}
			elsif (($COMPRESS eq 'gzip') and $ALLOW_GZIP){
				if (system ("gzip -fq $_")){
					bail_out("GZIP FAILED: $? $!", $back);
				}
			}
			else {bail_out("\$COMPRESS Variable was not set up properly.", $back)}
		}

	} #COMPRESS
	if ($q->param('preview') or $q->param('runremote')){
	
		if (@files >1){bail_out "Too many files.", $back}
		if (@files == 0){bail_out "Please select a file", $back}
		my ($ext, $file, $ungzip, $unzip);
		$files[0] =~ s/^(.*)\s\/\d*\/\s.*/$1/;
		if ($files[0] =~ /^(.*)\.([a-zA-Z]*)$/){
		   $file = $1; $ext = $2
		}
		elsif ($files[0] =~ /^(.*)\.$/){
		   $file = $files[0]; $ext = '';
		}
		else {$file = $files[0]}
		#my @all = <$userdir/*>;
		my $filename = "$userdir$delim$file";
		my $fullname = "$userdir$delim$files[0]";
		bail_out ("File $files[0] not found", $back) unless (-e $fullname);
		if ($ext =~ /^gz$/i){
			if (system ("gzip -fdv $fullname")) {bail_out("Failed to ungzip $fullname - $? . $! ", $back)} 
			$ungzip = 1;
		}
		elsif ($ext =~ /^zip$/i){
#check for available temp. file name	- 
			my $i="0E0";
			my $tempcopy;
			my $tempzip;
			do {
				$tempcopy = $userdir.$delim.'temcopy'.$i;
				$tempzip = $tempcopy.'.zip';
				$i++; bail_out("Overcycled! ($i). Please contact support\@edatanew.com", $back) if ($i>999);
			}
			while ((-e "$tempzip") or (-e "$tempcopy\.gz") or (-e "$tempcopy"));

			File::Copy::copy("$fullname", "$tempzip") or bail_out("Cannot copy file $files[0] to tempcopy\.zip $!", $back);
			if (system ("gzip -df -S .zip $tempzip")) {
				unlink "$tempzip" if -e $tempzip;
				my $message = 
				"Failed to uncompress temporary file. $! \n".
				"Be sure that ZIP archive contains only ONE compressed file";
				bail_out($message, $back);
			} 
			
			$unzip = 1;
			$filename = $tempcopy;
#			chmod 0777, "$filename";
		}
		else {$filename = $fullname}
# now the file of any format is prepared to read.	
		preview($filename,$file.".$ext",$back, $pageHead, $targethost, $selectdbname_) if $q->param('preview');
		
#runremote
		my $result = runremote($filename) if ($q->param('runremote'));
		
		if ($ungzip){
			if (system ("gzip -fq $filename")) {
				bail_out("Failed to gzip $file. $? . $! ", $back)
			} 
		}
		if ($unzip){
			unlink $filename if (-e $filename);
		}
		
		bail_out($result, $back) if $result;
		
		if ($q->param('preview')){print qq!
<INPUT TYPE=SUBMIT NAME="runremote" VALUE="APPLY TO SELECTED DATABASE" TITLE="Apply this file to database &quot;$selectdbname_&quot;">&nbsp;
<INPUT TYPE=SUBMIT NAME="back" VALUE="BACK" TITLE="Go back to previous page">
<INPUT TYPE=HIDDEN NAME="selectdbname_" VALUE="!  . $q->param('selectdbname_') . qq!">
<INPUT TYPE=HIDDEN NAME="selectfilelist" VALUE="! . quoteit($q->param('selectfilelist')). qq!">
!
;
		print $pageBottom;
		return;
		}
	}
	my	$selectDBlist;
	if ($dberr) {
		$selectDBlist = $q->scrolling_list(
                		-name=>'selectdbname_',
                		-values=>[''],
                		-default=>[''],
                		-size=>1,
						-title=>'Databases available on this server',
						-labels=>{''=>'ACCESS DENIED'}
					);
	}
	else {
		unshift @databases, "" unless (belongs(\@databases, $selectdbname_) and $q->param('selectdbname_'));
		$selectDBlist = qq!<SELECT name="selectdbname_" size=1  onChange="this.form.submit()" title="Databases available on this server">\n!;
		foreach (@databases){
			my $selected	= 'SELECTED' if ($_ eq $selectdbname_);
			$selectDBlist .= "<OPTION VALUE=\"$_\" $selected>$_\n";
		}
		$selectDBlist .= "</SELECT>\n";
	}
	my $back_ = $back;
	undef $back_->{selectdbname_};

	my $query 			= "SHOW TABLES";
	$query 				.= " FROM $selectdbname_" if $selectdbname_;
	my $tablelistref	= $dbh_->selectcol_arrayref($query) if $selectdbname_;
	if ($DBI::err){
		if ($DBI::errstr =~ /Access\sdenied/i){$tablelistref = ['ACCESS DENIED']}
		else {bail_out("Failed to execute:\n$query", $back)}
	}
	my $tablelist; 
	{
		my $values = (defined $tablelistref) ? $tablelistref : ['NO DATABASE SELECTED'];
		unless (@$values){$values = ['Table list is empty']}
		{
			$tablelist = $q->scrolling_list(
                		-name		=>'',
                		-values		=>$values,
                		-default	=>[''],
                		-size		=>10,
						-style		=> "color: #bbbbbb",
						-title		=>'Tables in selected database')
		}
	};
    unless ((-e $userdir) and (-d $userdir)) {
		mkdir $userdir, 0777 or bail_out("Cannot create directory. $!", {page => 'connect'})
	}
	my $tsize;
	@files = ();
	
	opendir DIR, $userdir; 
	my @filenames	= readdir (DIR) or print "Cannot read this directory: $userdir<br>";
	closedir DIR;
	
	foreach (@filenames){
		next if (($_ eq '.') or ($_ eq '..'));
		my $file  = "$userdir$delim$_";
		unless (-d $file){
			my @stat = stat $file;
			my $size = $stat[7];
			$tsize += $size;
			my $date = scalar localtime ($stat[9]);
			$date =~ s/^\s*\w\w\w\s*(.*)/$1/;
			s/^(.*\/)*(.*)$/$2/;
			$_ .= " /$size/ $date";
			push @files, $_;
		}
	}
	$tsize = int($tsize / 1024 * 100) / 100;
	
	my $selectfilelist = qq!\n<SELECT NAME="selectfilelist" SIZE=8 MULTIPLE  TITLE="Select file">\n!;
	if (@files == 0){$selectfilelist .=  qq!\t<OPTION VALUE="">FILE LIST IS EMPTY!}
	else{foreach (@files) {$_ = quoteit($_); $selectfilelist .= qq!\t<OPTION VALUE="$_">$_\n!} }
	$selectfilelist .= "<SELECT>\n";
	
	print "\n<!-- Admin (Restore)procedure starts here -->\n\n";

	&$pageHead();
	my $max_size = "Max.&nbsp;allowed&nbsp;size $MAX_BACKUP_SIZE&nbsp;kb" if $MAX_BACKUP_SIZE;
	my $compress_button = qq!<INPUT TYPE=SUBMIT NAME="compressFile" VALUE="COMPRESS" TITLE="Compress selected file">! if ($ALLOW_GZIP or $ALLOW_ZIP);

#++++++++++++++++++++++++++++++++++++++

my $textsize = $agent ? 15 : 22 ;
my $location = $succeed ? <<EOT
	<TABLE WIDTH="100%" BORDER=0 CELLPADDING=4 CELLSPACING=0 BGCOLOR="#AAAAAA">
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="Status"><P>CONNECTED&nbsp;TO&nbsp;FOREIGN&nbsp;HOST:</TD>
		</TR>
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="Connected host name"><P><NOBR>&nbsp;<I>$targethost</I></NOBR></TD>
		</TR>
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="User name"><P><NOBR>AS&nbsp;USER:&nbsp;<I>$targetuser</I></NOBR></TD>
		</TR>
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="Click to disconnect"><P><INPUT TYPE=SUBMIT NAME="disconnect" VALUE="Disconnect">
			</TD>
		</TR>
	</TABLE>
EOT
: <<EOT

	<TABLE WIDTH="100%" BORDER=0 CELLPADDING=4 CELLSPACING=0 BGCOLOR="#AAAAAA">
		<TR VALIGN=MIDDLE>
			<TD BGCOLOR="#CCCCCC" TITLE="Click to connect to Target Location" COLSPAN=2 VALIGN=MIDDLE><P>CHANGE&nbsp;TARGET&nbsp;HOST&nbsp;<INPUT TYPE=SUBMIT NAME="targetconnect" VALUE="Connect">
			</TD>
		</TR>
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="User name on the target location"><P>User Name:</TD>
			<TD BGCOLOR="#CCCCCC" TITLE="User name on the target location"><P><INPUT TYPE=TEXT VALUE="" NAME="targetuser" TITLE="User name on the target location" SIZE=$textsize></TD>
		</TR>
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="Password on the target location"><P>Password:</TD>
			<TD BGCOLOR="#CCCCCC" TITLE="Password on the target location"><P><INPUT TYPE=PASSWORD VALUE="" NAME="targetpassword" TITLE="Password on the target location" SIZE=$textsize></TD>
		</TR>
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="Target Database"><P>Database</TD>
			<TD BGCOLOR="#CCCCCC" TITLE="Target Database"><P><INPUT TYPE=TEXT VALUE="" NAME="targetdb" TITLE="Target database" SIZE=$textsize></TD>
		</TR>
		<TR>
			<TD BGCOLOR="#CCCCCC" TITLE="Target Location"><P>Host:Port</TD>
			<TD BGCOLOR="#CCCCCC" TITLE="Target Location"><P><INPUT TYPE=TEXT NAME="targethost" VALUE="" TITLE="Target Host" SIZE=$textsize></TD>
		</TR>
	</TABLE>
EOT
;

	print <<ENDOFRESTORE
	
			<INPUT TYPE=SUBMIT VALUE="RELOAD" TITLE="Update page"><INPUT TYPE=SUBMIT NAME="gotobackup" VALUE="CREATE BACKUP">
	
<TABLE WIDTH="100%" BORDER=0 ID="FRAMES" CELLPADDING=4 >
	<TR VALIGN=TOP>
		<TD VALIGN=TOP>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%" >
			<TR>
				<TD width="100%"><!-- BORDER START -->

<TABLE WIDTH="100%" BORDER=0 ID="REMOTE_LOCATION" CELLPADDING=4 CELLSPACING=0 BGCOLOR="#AAAAAA">
	<TR>
		<TD BGCOLOR="#CCCCCC">
			<NOBR>
			<INPUT TYPE=SUBMIT NAME="runremote" VALUE="       RUN SCRIPT       " TITLE="Apply selected file to database &quot;$selectdbname_&quot;">
			<INPUT TYPE=SUBMIT NAME="preview" VALUE="PREVIEW HEADER" TITLE="Preview header of selected file"></NOBR><BR>
<I>Run plain text, .zip and .gz files only</I>
		</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC">
		<TABLE BORDER=0>
			<TR>
				<TD VALIGN=TOP TITLE="Select file"><P>
$selectfilelist</TD>
				<TD VALIGN=TOP><P>Total&nbsp;size:<BR>$tsize kb<P>
				$max_size</TD>				
			</TR>
		</TABLE>
		</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC">
<INPUT TYPE=SUBMIT NAME="delete" VALUE="DELETE" TITLE="DELETE SELECTED FILE">
<INPUT TYPE=SUBMIT NAME="downloadFile" VALUE="DOWNLOAD" TITLE="Download selected file">
$compress_button
		</TD>
	</TR>
</TABLE>
				
				</TD><!-- BORDER END -->
			</TR>
</TABLE>	<BR>	
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" width="100%">
			<TR>
				<TD width="100%"><!-- BORDER START -->

<TABLE WIDTH="100%" BORDER=0 CELLPADDING=4 CELLSPACING=0 BGCOLOR="#AAAAAA">
	<TR>
		<TD BGCOLOR="#CCCCCC">
		<INPUT TYPE=FILE NAME="localfile" TITLE="Select file to upload">
		<INPUT TYPE=SUBMIT NAME="upload" VALUE="UPLOAD FILE" TITLE="Upload file">
		<BR><INPUT TYPE=CHECKBOX NAME="overwrite" TITLE="Overwrite existing file">Overwrite if exists.</TD>
	</TR>

</TABLE></TD><!-- BORDER END -->
			</TR>
</TABLE><BR>
		
		
		</TD><TD VALIGN=TOP><!-- END OF FIRST COLUMN -->
		
		

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%" >
			<TR>
				<TD width="100%"><!-- BORDER START -->

<TABLE WIDTH="100%" BORDER=0 CELLPADDING=4 CELLSPACING=0 BGCOLOR="#AAAAAA">
	<TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Databases available on the server"><P><nobr>APPLY&nbsp;TO&nbsp;DATABASE:<BR>
$selectDBlist&nbsp;<INPUT TYPE=SUBMIT VALUE="<-" TITLE="Show tables in selected database"></nobr></TD>
		
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Tables in selected database" COLSPAN=2><P><U>TABLE LIST:</U><BR>
$tablelist
		</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC"><P>
<HR SIZE=1 WIDTH="100%">
$location
		</TD>
	</TR>

</TABLE>
				
				</TD><!-- BORDER END -->
			</TR>
</TABLE>

		</TD>
	</TR>
</TABLE><!-- END OF FRAME TABLE -->


		</TD>
	</TR>
	<TR>
		<TD>&nbsp;
$pageBottom		


<!-- Admin (Restore) procedure ends here -->

		
ENDOFRESTORE
;
}
sub loadAdmin {
	my $back		= $_[0];
	my $query;
	my $func = $q->param('func');
	my $version = get_version();
	if ($q->param('show')) {
    	my $errmsg;
		my $like		= $q->param('LIKE');
		my $show = $q->param('showparam');
		if (($show eq 'STATUS') and  ($like ne '')) {
			$errmsg = "Current version (".get_version().") of MYSQL SERVER does not support SHOW STATUS LIKE syntax."
 			unless check_version('3.23.00');
		}
		elsif ($show eq 'CHARACTER SET') {
			$errmsg = "Current version ($version) of MYSQL SERVER does not support SHOW CHARACTER SET syntax." unless check_version('4.1');
		}
		elsif ($show eq 'COLUMN TYPES') {
			$errmsg = "Current version (".get_version().") of MYSQL SERVER does not support SHOW COLUMN TYPES syntax." unless check_version('4.1');
		}
		elsif ($show eq 'INNODB STATUS') {
			$errmsg = "Current version (".get_version().") of MYSQL SERVER does not support SHOW INNODB STATUS syntax."
			unless check_version('3.23.52');
		}
		elsif ($show eq 'LOGS') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW LOGS syntax."
			unless check_version('3.23.29');
		}
		elsif ($show eq 'PRIVILEGES') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW PRIVILEGES syntax."
			unless check_version('4.1');
		}
		elsif ($show eq 'SHOW FULL PROCESSLIST') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW SHOW FULL PROCESSLIST syntax."
			unless check_version('3.23.7');
		}
		elsif ($show eq 'TABLE TYPES') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW TABLE TYPES syntax."
			unless check_version('4.1');
		}
		elsif ($show eq 'OPEN TABLES') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW OPEN TABLES syntax."
			unless check_version('3.23.33');
		}
		elsif ($show eq 'SESSION VARIABLES') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW SESSION VARIABLES syntax."
			unless check_version('4.0.3');
		}
		elsif ($show eq 'GLOBAL VARIABLES') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW GLOBAL VARIABLES syntax."
			unless check_version('4.0.3');
		}
		elsif ($show eq 'VARIABLES') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW GRANTS syntax."
			unless check_version('3.22.0');
		}
#++++++++++++++++++++++++++++++++++++++
		bail_out($errmsg, $back) if $errmsg; 
		$query = "SHOW ".$show;
		if ($show eq 'TABLE STATUS'){
			my $db = $q->param('dbname_');
			$query .= " FROM $db" if $db;
		}
		if (belongs(['STATUS', 'TABLE STATUS', 'OPEN TABLES', 'VARIABLES', 'SESSION VARIABLES', 'GLOBAL VARIABLES'], $show)){
			unless ($like =~ /%/){$like .= '%' if $like ne ''}
			$query .= ' LIKE '.$dbh->quote($like) if ($like ne '');
		}
	}
	elsif($func eq 'RESET QUERY CACHE'){
		bail_out ("Current version ($version) of MYSQL SERVER does not support RESET QUERY CACHE syntax.", $back) unless check_version('4.0.1');
		$dbh->do($func) || bail_out("Cannot RESET QUERY CACHE", $back);
	}

	if ($query){
		my ($sth,$res) = prepare_execute($query, $back);
		$query = quoteit($query);
		print "<P>Executed query: $query <BR>";
		print &printresult(\$sth);
		ErrMessage ("Print Result Error. $DBI::errstr") if $DBI::err;
		print qq!<FORM ACTION="$full_url" METHOD=POST>\n!;
		print qq!<P><INPUT TYPE=SUBMIT VALUE="Back">\n!;
		foreach (keys %$back){print qq!<INPUT TYPE=HIDDEN NAME="$_" VALUE="$back->{$_}">\n!}
		print "</FORM>";
		return;
	}
	





	my @databases;
	my $selectdbname_   = $q->param('selectdbname_');
	$selectdbname_  = $database unless $selectdbname_;
	my $databasesref = getdblist($dbh);
	my $DBlist; my $selectDBlist;
	if ($DBI::err and !$database){
		$DBlist = $q->scrolling_list(
                		-name		=>'dbname_',
                		-values		=>[''],
                		-size		=>1,
						-labels		=>{'' => 'ACCESS DENIED'},
						-title		=> 'Select database to use with TABLE STATUS option'
					);
		$selectDBlist = $q->scrolling_list(
                		-name   =>'selectdbname_',
 						-labels	=>{'' => 'ACCESS DENIED'},
               			-values =>[''],
                		-size   =>1,
					);
	}
	else {
		@databases = @$databasesref;
		$DBlist = $q->scrolling_list(
                		-name		=>'dbname_',
                		-values		=>[@databases,''],
                		-default	=>[$database],
                		-size		=>1,
						-title		=> 'Select database to use with TABLE STATUS option'
					);
					
		push @databases,'' unless $selectdbname_;					
		$selectDBlist = $q->scrolling_list(
                		-default=>[$database],
                		-name=>'selectdbname_',
                		-values=>[@databases],
                		-size=>1,
						-onChange=>'this.form.submit()'
					);
	}
	
	my $tablelist = qq!\n<SELECT NAME="tablelist" SIZE=13 MULTIPLE>\n!;
	my $tablelistref;
	if ($selectdbname_) {
		$tablelistref = $dbh->selectcol_arrayref("SHOW TABLES FROM $selectdbname_");
		if (! defined $tablelistref ) {
			if ($DBI::err){
				if ($DBI::errstr =~ /access/i){
					$tablelist .= qq!<OPTION VALUE="">ACCESS DENIED\n!;
				}
				else{
					$tablelist .= qq!<OPTION VALUE="">CANNOT SHOW TABLES\n!;
					$tablelist .= qq!<OPTION VALUE="">Check database name\n!;
				}
			}
			else {$tablelist .= qq!<OPTION VALUE="">CANNOT SHOW TABLES\n!}
		}
		elsif (@$tablelistref == 0){
			$tablelist .= qq!<OPTION VALUE="">Table list is empty\n!;
		}
		else{
			my @tblist = $q->param('tablelist');
			foreach (@$tablelistref){
				my $selected = 'SELECTED' if belongs(\@tblist, $_);
				$tablelist .= qq!<OPTION VALUE="$_" $selected>$_!
			}
		}
	}
	else {
		$tablelist .= qq!<OPTION VALUE="">SELECT DATABASE\n!;
	}
	$tablelist .= "</SELECT>\n";
	

	my  $buttonwidth 	= '110px';
	my  $buttonsmall 	= '50px';
	my  $buttonwidth2 	=  ($buttonwidth * 2) + 15;
	my $style;
	my $showselect = qq!<SELECT NAME="showparam">\n!;
	$showselect .= qq!<OPTION VALUE="" SELECTED>!;
	$showselect .= qq!<OPTION VALUE="PROCESSLIST">PROCESSLIST\n!;
	$showselect .= qq!<OPTION VALUE="STATUS">STATUS\n!;
	unless (check_version("3.22.00")){$style = qq!style="color: #bbbbbb"!}
	$showselect .= qq!<OPTION VALUE="VARIABLES" $style>VARIABLES\n!;
	unless (check_version("3.22.00")){$style = qq!style="color: #bbbbbb"!}
	$showselect .= qq!<OPTION VALUE="TABLE STATUS" $style>TABLE STATUS\n!;
	unless (check_version("3.23.29")){$style = qq!style="color: #bbbbbb"!}
	$showselect .= qq!<OPTION VALUE="LOGS" $style>LOGS\n!;
	unless (check_version("3.23.33")){$style = qq!style="color: #bbbbbb"!}
	$showselect .= qq!<OPTION VALUE="OPEN TABLES" $style>OPEN TABLES\n!;
	unless (check_version("3.23.52")){$style = qq!style="color: #bbbbbb"!}
	$showselect .= qq!<OPTION VALUE="INNODB STATUS" $style>INNODB STATUS\n!;
	unless (check_version("4.0.3")){$style = qq!style="color: #bbbbbb"!}
	$showselect .= qq!<OPTION VALUE="SESSION VARIABLES" $style>SESSION VARIABLES\n!;
	$showselect .= qq!<OPTION VALUE="GLOBAL VARIABLES" $style>GLOBAL VARIABLES\n!;
	unless (check_version("4.1")){$style = qq!style="color: #bbbbbb"!}
	$showselect .= qq!<OPTION VALUE="CHARACTER SET" $style>CHARACTER SET\n!;;
	$showselect .= qq!<OPTION VALUE="COLUMN TYPES" $style>COLUMN TYPES\n!;
	$showselect .= qq!<OPTION VALUE="TABLE TYPES" $style>TABLE TYPES\n!;
	$showselect .= qq!<OPTION VALUE="PRIVILEGES" $style>PRIVILEGES\n!;

	$showselect .= qq!</SELECT>	\n!;

	$style = '';
	unless (check_version("3.23.18")){$style = qq!style="color: #bbbbbb"!}
	my $flashselect = qq!<OPTION VALUE="TABLES WITH READ LOCK" $style>TABLES WITH READ LOCK!;
	unless (check_version("4.0.1")){$style = qq!style="color: #bbbbbb"!}
	$flashselect .= qq!<OPTION VALUE="DES_KEY_FILE" $style>DES KEYS!;
	$flashselect .= qq!<OPTION VALUE="QUERY CACHE" $style>QUERY CACHE!;
	
	unless (check_version("4.0.2")){$style = qq!style="color: #bbbbbb"!}
	$flashselect .= qq!<OPTION VALUE="USER_RESOURCES" $style>USER RESOURCES!;
	
	
	print <<ENDOFADMIN	
<!-- Admin procedure starts here -->

<FORM METHOD=POST ACTION="$full_url">
<TABLE BORDER=0>
	<TR><TH ALIGN=LEFT COLSPAN=3>ADMINISTRATION</TH></TR>
	<TR><TD VALIGN=TOP>
	

	
<!-- ACCESS CONTROL	-->
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA">
			<TR>
				<TD WIDTH=300><!-- BORDER START -->
	<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH=100%>
		<TR>
			<TD BGCOLOR="#CCCCCC"><INPUT TYPE=SUBMIT NAME="func" VALUE="  ACCESS CONTROL  " style="width: $buttonwidth2"></TD>
		</TR>
	</TABLE>
				</TD><!-- BORDER END -->
			</TR>
</TABLE>

<BR>	


<!-- -------------------- SHOW--------------- -->

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" >
			<TR>
				<TD width=300><!-- BORDER START -->

<TABLE WIDTH=100% BORDER=0 ID="FUNC_TABLE1" CELLPADDING=3 CELLSPACING=0 BGCOLOR="#AAAAAA">
	<TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Show selected option">
		<INPUT TYPE=SUBMIT NAME="show" VALUE="   SHOW   " TITLE="Show selected option" style="width: $buttonwidth"></TD></TR>
	<TR BGCOLOR="#CCCCCC">
		<TD BGCOLOR="#CCCCCC" HEIGHT=20 VALIGN=TOP TITLE="Select option to show">
$showselect
<BR></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC">[LIKE] <BR><INPUT TYPE=TEXT NAME="LIKE" SIZE=10 TITLE="Specify pattern to show result"></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Select database to use with TABLE STATUS option">[FROM DATABASE]<BR>
$DBlist
	   </TD>
	</TR>

</TABLE>


				</TD><!-- BORDER END -->
			</TR>
</TABLE><BR>
<!-- FLUSH -->
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" >
			<TR>
				<TD width=300><!-- BORDER START -->
				
<TABLE BORDER=0 BGCOLOR="#AAAAAA" CELLSPACING=0 CELLPADDING=3 WIDTH=100%>
    <TR VALIGN=TOP>
        <TD BGCOLOR="#CCCCCC" HEIGHT=25 TITLE="Select option to flush" VALIGN=TOP>
		<INPUT TYPE=SUBMIT NAME="func" VALUE="   FLUSH   " TITLE="Flush selected option" style="width: $buttonwidth"><BR></TD>
		<TD HEIGHT=15  BGCOLOR="#CCCCCC"  TITLE="Select option to flush">
<SELECT NAME="flush" TITLE="Select option to flush">
<OPTION VALUE="" SELECTED>
<OPTION VALUE="HOSTS">HOSTS
<OPTION VALUE="LOGS">LOGS
<OPTION VALUE="PRIVILEGES">PRIVILEGES
<OPTION VALUE="TABLES">TABLES
<OPTION VALUE="STATUS">STATUS
$flashselect
</SELECT></TD>
	</TR>
</TABLE>


				</TD><!-- BORDER END -->
			</TR>
</TABLE><br>

<!-- RESET -->
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" >
			<TR>
				<TD width=300><!-- BORDER START -->
				
<TABLE BORDER=0 BGCOLOR="#AAAAAA" CELLSPACING=0 CELLPADDING=3 WIDTH=100%>
    <TR VALIGN=TOP>
        <TD BGCOLOR="#CCCCCC" HEIGHT=25 TITLE="Select option to flush" VALIGN=TOP>
		<INPUT TYPE=SUBMIT NAME="func" VALUE="RESET QUERY CACHE" TITLE="Flush selected option" style="width: $buttonwidth2"><BR></TD>
	</TR>
</TABLE>


				</TD><!-- BORDER END -->
			</TR>
</TABLE>

			<!-- COLUMN 1 END -->
			</TD>
			<TD WIDTH=10>&nbsp;&nbsp;</TD>
<!-- -----select database, select tables-------- -->
			
			<TD VALIGN=TOP>
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" ><!-- BORDER START -->
			<TR>
				<TD width=260><!-- BORDER START -->
				
<TABLE BORDER=0 BGCOLOR="#AAAAAA" CELLSPACING=0 CELLPADDING=3 WIDTH=100%>
	<TR>
		<TD BGCOLOR="#CCCCCC"><INPUT TYPE=SUBMIT NAME="func" VALUE="OPTIMIZE" TITLE="Optimize selected tables" style="width: $buttonwidth"></TD>
		
		<TD BGCOLOR="#CCCCCC">&nbsp;</TD>
		
		<TD BGCOLOR="#CCCCCC"><INPUT TYPE=SUBMIT NAME="func" VALUE=" CHECK " TITLE="Check selected tables" style="width: $buttonwidth"></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC"><INPUT TYPE=SUBMIT NAME="func" VALUE="ANALYZE " TITLE="Analyze selected tables" style="width: $buttonwidth"></TD>
		
		<TD BGCOLOR="#CCCCCC">&nbsp;</TD>
		
		<TD BGCOLOR="#CCCCCC"><INPUT TYPE=SUBMIT NAME="func" VALUE=" REPAIR " TITLE="Repair selected tables" style="width: $buttonwidth"></TD>
	</TR>
	<TR>
	<TR><TD COLSPAN=3 BGCOLOR="#CCCCCC">&nbsp;</TD></TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Databases available on this server" COLSPAN=3>SELECT DATABASE:<BR><nobr>$selectDBlist&nbsp;<INPUT TYPE=SUBMIT VALUE="<-" TITLE="Show tables in selected database"></nobr></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC"  COLSPAN=3 TITLE="Select tables to use with Check, Repair, Analyze or Optimize">SELECT TABLE:<BR>$tablelist</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC"  COLSPAN=3 TITLE="Select all tables"><INPUT TYPE=CHECKBOX NAME="selectalltables" TITLE="Select all tables"> SELECT ALL TABLES</TD>
	</TR>
</TABLE>
				
				</TD><!-- BORDER END -->
			</TR>
</TABLE>



		</TD>
	</TR>
</TABLE><!-- END OF BIG TABLE -->

<INPUT TYPE=HIDDEN NAME="page" VALUE="admin">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
</FORM>


<!-- Admin procedure ends here -->
	
ENDOFADMIN
;
}
sub execBackup {

	my $ERRMSG = <<EndERRMSG
THE FOLLOWING MUST BE SELECTED:

DATABASE,
TABLES,
BACKUP FILE DESTINATION (save and/or download),
BACKUP FILE TYPE (zip, gzip, plain text),
BACKUP FILE NAME
EndERRMSG
;
	
    my $userhost = myhost();
	my $dbname				= $q->param('selectdbname_');
	my $back				= {page => "$page",
							  func => "backup"};
	$back->{dbname}			= "$database" if $database;
	$back->{selectdbname_}	= "$dbname" if $dbname;
	bail_out($ERRMSG,$back) unless $dbname;
	my $DOWNLOAD			= $q->param('downloadBackup');
	my $KEEPFILE			= $q->param('keep');
	bail_out($ERRMSG,$back) unless ($KEEPFILE or $DOWNLOAD);
	my $fyletype			= $q->param('type');
	bail_out($ERRMSG,$back) unless $fyletype;
	my $filename			= $q->param('remotefile');
	bail_out($ERRMSG,$back) unless $filename;	
	unless ($dbh->do("USE $dbname")){bail_out("Can not use $dbname", $back)}
	if (($filename =~ /[\\\/]/g) or ($filename =~ /[\/]/g)){
		bail_out("File name is incorrect", $back)
	}
	if (my $errmsg = checkuserdir('backup')){bail_out("$errmsg\n$!", $back)}
	my $userdir				= "$USER_DIR$delim$user.$userhost$delim" . "backup";
	my $file 				= "$userdir$delim$filename";
	bail_out ("File $filename already exists.", $back) if (-e $file);
	bail_out ("File $filename already exists.", $back) if (-e $file.'.gz');
	bail_out ("File $filename already exists.", $back) if (-e $file.'.zip');

	my $tablelistref;
	my @tablelist;
	if ($q->param('selectalltables')) {
		my $query = "SHOW TABLES";
		$tablelistref = $dbh->selectcol_arrayref($query) || bail_out("Cannot SHOW TABLE", $back);
		@tablelist = @$tablelistref;
	}
	else {@tablelist = $q->param('tablelist'); $tablelistref = \@tablelist}
	bail_out ($ERRMSG,$back) unless $tablelist[0];
	my $dropifexists = $q->param('dropifexists');
	my $include = $q->param('include');
	my $filecontent = "#\tDATABASE '$dbname' \n";
	$filecontent .= "#\tUser: $user\@$userhost\n#\n";
	$filecontent .= "#\tServer Version: ".get_version()."\n";
	$filecontent .= "#\tBACKUP CREATED ". scalar gmtime()." (GMT)\n";
	$filecontent .= "#\tby MYSQL DATA MANAGER (http://www.edatanew.com)\n";
	$filecontent .= "#\t----------------------------------------------------\n#\n";
	$filecontent .= "#\tOPTIONS:\n";
	$filecontent .= "#\t- \"DROP TABLE IF EXISTS\" added\n" if ($dropifexists and ($include ne 'data'));
	$filecontent .= "#\t- Only tables structure included\n" if ($include eq 'structure') ;
	$filecontent .= "#\t- Only data included\n" if ($include eq 'data');
	$filecontent .= "#\t----------------------------------------------------\n";
	$filecontent .= "#\n#\tTABLE LIST:\t\t\n#\t".join("\n#\t", @tablelist);
	$filecontent .= "\n#\n#\n#EndOfHeader\n\n";
	my $hashref	 = {
		tablelist 		=> \@tablelist,
		include			=> $include,
		dropifexists	=> $dropifexists,
		back			=> $back,
		comments		=> 1,
		lock			=> 0
	};
	$filecontent .= getdatanstructure($hashref);
	open (FH, "+> $file") || bail_out ("Can not open $file $!", $back);
	#binmode FH;
	flock(FH, 2) unless $WIN32;
	print FH $filecontent;
	flock(FH, 8) unless $WIN32;
	close FH;
	undef $filecontent;
	#chmod 0777, "$file";
	my ($outfile, $outfilename, $mimetype);
	my $i=0;
	if ($q->param('type') eq 'zip'){
		$outfile = $file.'.zip';
		$mimetype = 'application/zip';
		if (system ("$ZIP $outfile $file $ZIPLOG")){
			unlink $file if (-e $file);
			bail_out("$? zip $!", $back);
    	}
		
		$outfilename = $filename.'.zip';
    }
	elsif ($q->param('type') eq 'gzip'){
	my $i=0;
		if (system ("gzip -fq $file")){
			unlink "$file" if (-e $file);
			bail_out("$? $! gzip ");
		}
		$outfile = $file.'.gz';
		$outfilename = $filename.'.gz';
		$mimetype = 'application/x-gzip';
	}
	else {
		$mimetype = 'application/x-perl';
		$outfile = $file;
		$outfilename = $filename;
	}
#	chmod 0777, "$outfile";
	unless ($q->param('type') eq 'text') {
		if (-e $file){unlink $file || bail_out("Cannot unlink $file $!", $back)}
	}	
	if ($q->param('keep') and $MAX_BACKUP_SIZE){
		my $size = dirsize($userdir);
        if ($size > ($MAX_BACKUP_SIZE*1024)) {
    		my $errmsg = "Total size of backup files is limited to $MAX_BACKUP_SIZE kb.\n";
    		$errmsg .= "New backup file can only be downloaded.\n";
    		$errmsg .= "Please delete some files if you need to keep new backup file on the server.\n";			
    		unlink $outfile || bail_out("Cannot unlink $outfilename $! \n$errmsg", $back);
    		print "SIZE: $size<BR>";
    		bail_out("$errmsg",$back);
    	}
	}#if keep

	if ($q->param('downloadBackup')){
		$| = 1; 
		$SIG{CHLD}  = 'IGNORE';	

		my $size = -s "$outfile" or bail_out("$! $outfile", $back);
    	open FHN, $outfile or bail_out("$! $outfile", $back);
		flock (FHN,2) unless $WIN32;
    	binmode FHN;
    	
    	print "Content-disposition: inline; filename=$outfilename\n";
    	print "Content-length: $size\n";
		print "Content-type: $mimetype; name=\"$outfilename\"\n\n";

		binmode STDOUT;
    	my $data;
    	while (read FHN, $data, 1024) {
    		print $data
    	}
		flock (FHN,8) unless $WIN32;
    	close FHN;
	
		unless ($q->param('keep')) {unlink $outfile || bail_out("Cannot unlink $outfile $!", $back)}
		$dbh->disconnect if defined $dbh;
		exit 0;
	} # if download
}


sub execFlush {
	my $back = $_[0];
	if ($q->param('flush')) {
		my $flush = $q->param('flush');
		my $version = get_version();
		my $errmsg;
		if (($flush eq 'DES_KEY_FILE') or ($flush eq 'QUERY CACHE')) {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW GLOBAL VARIABLES syntax."	unless check_version('4.0.1');
		}
		elsif ($flush eq 'USER_RESOURCES') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW GLOBAL VARIABLES syntax."	unless check_version('4.0.2');
		}
		elsif ($flush eq 'TABLES WITH READ LOCK') {
			$errmsg = 
			"Current version ($version) of MYSQL SERVER does not support SHOW GLOBAL VARIABLES syntax."	unless check_version('4.23.18');
		}
		bail_out($errmsg, $back) if $errmsg;
		my $query = "FLUSH $flush";
		unless ($dbh->do($query)){bail_out("Failed to Flush", $back)}
	}
#	else{bail_out("Can not Flush. Nothing was selected", $back)}
}

sub execCheckRepair {
	my $back = $_[0];
    my $func = $_[1];
	bail_out("Database is not selected.", $back) unless ($q->param('selectdbname_'));
	my @tablelist;
	if ($q->param('selectalltables')) {
		my $tablelistref = getTablelist($q->param('selectdbname_'), $back);
		@tablelist = @$tablelistref;
	}
	else {@tablelist = $q->param('tablelist')}
	bail_out("Table list is not selected.", $back) unless ($tablelist[0]);
	
	
	my $errmsg = 
	"Current version (".get_version().") of MYSQL SERVER does not support $func TABLES syntax.";    
	if ($func eq 'ANALYZE'){
 		bail_out($errmsg,$back)	unless check_version('3.23.22')
	}
	elsif ($func eq 'CHECK'){
 		bail_out($errmsg,$back)	unless check_version('3.23.13')
	}
	elsif ($func eq 'REPAIR'){
   		bail_out($errmsg,$back)	unless check_version('3.23.14');
	}
	elsif ($func eq 'OPTIMIZE'){
   		bail_out($errmsg,$back)	unless check_version('3.22.7');
		bail_out("Too many tables selected for current version Mysql (".get_version().")") 
					  if (!check_version('3.23.00') and (@tablelist > 1));
	}
	unless ($q->param('selectdbname_')){loadAdmin(); return}
	unless ($q->param('selectdbname_') eq $database){
		my $query = "USE ".$q->param('selectdbname_');
		$dbh->do($query) || bail_out ("Cannot use secected database.", $back);
	}
	unless (@tablelist) {loadAdmin(); return}
	my $query = "$func TABLE ";
	$query .= join (', ', @tablelist);
	my ($sth, $res) = prepare_execute($query, $back);
	print "<P>Executed query:\n$query <BR>";
	if (belongs(\@selectlike,$func)){
	   print &printresult(\$sth);
	   ErrMessage ("Print Result Error. $DBI::errstr") if $DBI::err;
	}
	print qq!<FORM ACTION="$full_url" METHOD=POST>\n!;
	print qq!<P><INPUT TYPE=SUBMIT VALUE="Back">\n!;
	foreach (keys %$back){print qq!<INPUT TYPE=HIDDEN NAME="$_" VALUE="$back->{$_}">\n!}
	print "</FORM>";
}
sub preview {
		my ($filename, $file, $back, $pageHead, $targethost, $selectdbname_) = @_;
		open (FH, "$filename") || bail_out("Can not open file$!", $back);
		flock (FH,2) unless $WIN32;
		$targethost = myhost($targethost) 			if $targethost;
		my $onhost	= "&nbsp;&nbsp;on&nbsp;$targethost" 	if ($targethost and $selectdbname_);
		my $ondb	= "&nbsp;&nbsp;&nbsp;Selected&nbsp;Database:&nbsp;<U><I>$selectdbname_</I></U>" 	if $selectdbname_;
		&$pageHead("$ondb $onhost");
		print "<BR><B>FILE HEADER PREVIEW (",quoteit($file),")</B><BR>\n";
		print qq!<TEXTAREA COLS=70 ROWS=15 TITLE="Header of selected file">\n!;
		
		my $i;
		while(<FH>){
			last unless ((/^#/) or ($i<12));
			$_ = quoteit($_);
			print;
			if ($i++ > 10000) {bail_out("OVERCYCLED!", $back)} 
		}
		print "</TEXTAREA><BR>\n";
		flock (FH,8) unless $WIN32;
		close FH;
}

sub runremote  {
	my ($filename) = shift;
	return ("Database is not selected") unless (my $selectdbname_ = $q->param('selectdbname_'));
	if ($WIN32) {
		$filename =~ s/\//\\/g;
	}
# Syntax:
# DBI:mysql:db_name:host_name:port,user,password
# DBI:mysql:db_name;host=host_name:port,user,password
# DBI:mysql:database=db_name;host_name:port,user,password
# DBI:mysql:database=db_name;host=host_name:port,user,password
# DBI:mysql:database=db_name;host=host_name;port=port,user,password
# DBI:mysql:database=db_name;param_name=param_value;host=host_name;port=port,user,password

# other parameters:
# mysql_compression=1
# mysql_read_default_file=file_name;
# mysql_read_default_group=group_name;
# mysql_socket=socket_name
# 
		
		my ($hostname, $portnum, $username, $ppassword, $options);
#-----port:
		my $back = {
			page => 'admin',
			func => 'restore'
		};
		$back->{selectdbname_}	= $q->param('selectdbname_') if $q->param('selectdbname_');
		$back->{dbname}			= $q->param('dbname')		 if $q->param('dbname');
		$back->{target}			= $q->param('target');
		if ($q->param('target')){
			my ($targetuser, $targetpassword, $targethost)	= $q->cookie('target_db');
			($hostname, $portnum)							= myhost($targethost);
			$username										= " -u $targetuser"		if $targetuser;
			$ppassword 										= " -p$targetpassword"	if $targetpassword;
		}
		else{
			($hostname, $portnum)							= myhost();
			$username										= " -u $user"		if $user;
			$ppassword 										= " -p$password"	if $password;
		}
		$hostname				= " -h $hostname"	if $hostname;
		$portnum				= " -P $portnum"	if $portnum;
		$options 				= $hostname 		if $hostname;
		$options 				.= $portnum 		if $portnum;
		$options 				.= $username 		if $username;
		$options 				.= $ppassword 		if $ppassword;
		$options 				.= " -S $SOCKET" 	if $SOCKET;
		$options 				.= " $OTHER_MYSQL" 	if $OTHER_MYSQL;
		my $command = "EXECUTED COMMAND:\n$MYSQL $options $selectdbname_ \< $filename";

#++++++++++++++++++++++++++++++++++++++
	CGI::Carp::carpout(\*STDOUT);
	if (system("$MYSQL $options $selectdbname_ \< $filename")){return ("ERROR: $DBI::errstr\n$command\n")}
	
	return undef;

}

#++++++++++++++++++++++++++++++++++++++

sub loadexecscript  {

# attempt to create directory if not exist

	my $script			= $q->param('script');
	if ($script eq 'print'){execExecuteQuery(); return}
	my $userhost		= myhost();
	my $userdir 		= "$USER_DIR$delim$user.$userhost";
	my $errmsg			= "";
    unless ((-e $userdir) and (-d $userdir)) {mkdir $userdir, 0777 || {$errmsg = $!}}
	unless ($errmsg ){
		unless ((-e $userdir) and (-d $userdir)){$errmsg = $!}
		unless ($errmsg ){
			$userdir .= $delim."sql";
			unless ((-e $userdir) and (-d $userdir)) {mkdir $userdir, 0777 || {$errmsg = $!}}
			unless (!$errmsg and (-e $userdir) and (-d $userdir)) {$errmsg = $!}
		}
	}
	my $selectscript;
	my $selectedscript = $q->param('selectedscript') unless $q->param('script') eq 'Close';
	my $back = {
			dbname				=> "$database",
			page				=> "tables",
			func				=> 'script',
			selectedscript		=> $selectedscript,
			SQL					=> $q->param('SQL')
	};
	my $readscript = sub {
		my $script;
		my $file 	= "$userdir$delim$_[0]";
		open (FH, "$file") || bail_out("Can not open file $_[0]\n$!", $back);
		flock (FH,2) unless $WIN32;
		my $i;
		while(<FH>){
			$script .= $_;
			if ($i++ > 10000) {bail_out("The script is too big", $back)} 
		}
		flock (FH,8) unless $WIN32;
		close FH;
		return $script;
	};
	my @files 				= $q->param('selectscript');
	my $SQL;
	
	if ($script		=~ /(Edit)|(Open)/i ){
		bail_out("Too many files", $back) if (@files > 1);
		bail_out("Please select a file", $back) if (@files == 0);
		bail_out("Script list is empty",$back) unless ($files[0]);
		$selectedscript				= $files[0];
		$SQL						= &$readscript($selectedscript);
	}
	else {
		$SQL = $q->param('SQL');
	}
	$SQL =~ s/^\s*(.*)$/$1/m;
	$SQL =~ s/^(.*?)\s*$/$1/s;
	my $SQL_ = quoteit($SQL);
	$back->{SQL} = $SQL;
#	if ($errmsg){bail_out("$errmsg iiiii", $back)}
	
	

	my $printSaveAs = sub {
		my $file = quoteit($_[0]);
		my $var = qq!\n<FORM METHOD=POST ACTION="$full_url">\n!;
		$var .= qq!<BR><P><INPUT TYPE=SUBMIT NAME="script" VALUE="SAVE AS">&nbsp;\n!;
		$var .= qq!<INPUT TYPE=TEXT NAME="saveasname" SIZE=40 VALUE="$file"><P>\n!;
		$var .= qq!<INPUT TYPE=SUBMIT NAME="script" VALUE=" CANCEL">\n!;
		$var .= qq!<INPUT TYPE=HIDDEN NAME="overwrite" VALUE="1">\n!	if ($_[1] eq '1');	
		$var .= qq!<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">\n!;
		$var .= qq!<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">\n!;
		$var .= qq!<INPUT TYPE=HIDDEN NAME="func" VALUE="script">\n!;
		if ($SQL){$var .= qq!<INPUT TYPE=HIDDEN NAME="SQL" VALUE="$SQL_">\n! ;}
		$var .= qq!<INPUT TYPE=HIDDEN NAME="selectedscript" VALUE="!.quoteit($selectedscript).qq!">\n! if $selectedscript;
		$var .= qq!</FORM>!;
	};
	if ($script eq 'Rename'){
		bail_out("Too many files", $back) if (@files > 1);
		bail_out("Please select a file", $back) if (@files == 0);
		bail_out("Script list is empty",$back) unless ($files[0]);
		my $newname = $q->param('rename');
		$newname =~ s/^\s*(.*)$/$1/m;
		$newname =~ s/^(.*?)\s*$/$1/s;
		unless ($newname){bail_out("Please enter a name", $back)}
		checkfilename($newname, $back);
		rename "$userdir$delim$files[0]", "$userdir$delim$newname" or bail_out("Cannot rename $files[0].\n$!", $back);
		if ($files[0] eq $selectedscript){$selectedscript = $newname}
	}
	if ($script eq 'Save'){
		unless ($selectedscript) {
			print &$printSaveAs();
			return;
		}
		my $size = dirsize($userdir);
		$size += length $SQL; 
		$size -= -s "$userdir$delim$selectedscript";
        if ($MAX_SCRIPT_SIZE and ($size > ($MAX_SCRIPT_SIZE*1024))) {
    		my $errmsg = "Total size of user scripts is limited to $MAX_SCRIPT_SIZE kb.\n";
    		$errmsg .= "Please delete some files or contact us ($CONTACT_EMAIL) if you need more disk space.\n";			
			bail_out("$errmsg",$back);
    	}
		open (FH, ">$userdir$delim$selectedscript") || bail_out ("Can not open file $selectedscript\n$!", $back);
        flock(FH, 2) unless $WIN32;
        print FH $SQL;
        flock(FH, 8) unless $WIN32;
        close FH;
	}
	elsif ($script	=~ /Save as/i ){
		my $size = dirsize($userdir);
		$size += length $SQL; 
        if ($MAX_SCRIPT_SIZE and ($size > ($MAX_SCRIPT_SIZE*1024))) {
    		my $errmsg = "Total size of user scripts is limited to $MAX_SCRIPT_SIZE kb.\n";
    		$errmsg .= "Please delete some files or contact us ($CONTACT_EMAIL) if you need more disk space.\n";			
			bail_out("$errmsg",$back);
    	}
		my $filename	= $q->param('saveasname');
		checkfilename($filename, $back);
		my $file 			= "$userdir$delim$filename";
		$filename		=~ s/^\s*(.*)/$1/;
		$filename		=~ s/^(.*)\s*$/$1/;
		unless ($filename) {
			print "<BR><B>PLEASE SELECT FILE NAME</B><P>";
			print &$printSaveAs();
			return;
		}
		elsif ((-e $file) and !$q->param('overwrite')){
			print "<BR><B>THIS FILE NAME ALREADY EXISTS</B><P>";
			print "<B>CLICK <U>'SAVE AS'</U> TO OVERWRITE</B><P>";
			print &$printSaveAs($filename,'1');
			return;
		}
		else{
    		open (FH, ">$file") || bail_out ("Can not open file $filename\n$!", $back);
        	flock(FH, 2) unless $WIN32;
        	print FH $SQL;
        	flock(FH, 8) unless $WIN32;
        	close FH;
		}
		$selectedscript		= quoteit($q->param('saveasname')) if (-e "$file");
	}
	elsif ($script	=~ /close/i ){$selectedscript = ''; $SQL = $SQL_ = ''}
	elsif ($script	=~ /Back/i ){loadSelectTables(); return}
	elsif ($script	=~ /delete/i){
		unless($q->param('cancel')){
			if ($q->param('confirm')){
				my @filedelete = $q->param('filedelete');
				my @couldnot;
				foreach (@filedelete){
					my $filedelete = $userdir.$delim.$_;
					unless (unlink $filedelete) {push @couldnot, $_}
				}
				if (belongs(\@filedelete, $selectedscript) and ! belongs(\@couldnot, $selectedscript)){
					$selectedscript		= '';
				}
				if (@couldnot) {my $files = join (@couldnot, "\n"); bail_out("Can not delete files: $files\n $!", $back)}
			}
			else {
			 	bail_out("Please select a file", $back) if (@files == 0);
				bail_out("Script list is empty",$back) unless ($files[0]);
				print qq!\n<FORM METHOD=POST ACTION="$full_url">\n!;
				print "<BR><P><B>THESE FILES WILL BE DELETED:</B><P>\n";
				foreach (@files){
					s/^(.*[\/|\\])*(.*)/$2/;
					$_ = quoteit($_);
					print "<INPUT TYPE=CHECKBOX NAME=\"filedelete\" VALUE=\"$_\" CHECKED> $_ <BR>\n";
				}
				print qq!<BR>!;
				print qq!<INPUT TYPE=SUBMIT NAME="confirm" VALUE="DELETE">&nbsp;\n!;
				print qq!<INPUT TYPE=SUBMIT NAME="cancel" VALUE="CANCEL">\n!;
				print qq!<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">\n!;
				print qq!<INPUT TYPE=HIDDEN NAME="script" VALUE="delete">\n!;
				print qq!<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">\n!;
				print qq!<INPUT TYPE=HIDDEN NAME="SQL" VALUE="$SQL_">\n!;
				print qq!<INPUT TYPE=HIDDEN NAME="func" VALUE="script">\n!;
				print qq!<INPUT TYPE=HIDDEN NAME="selectedscript" VALUE="!.quoteit($selectedscript).qq!">\n!;
				print qq!</FORM>!;
				return
			}
		}
	}

	if ($errmsg){$selectscript = qq!\t<OPTION VALUE="">CANNOT CREATE DIRECTORY\n\t<OPTION VALUE="">$errmsg\n!;}
	my ($tsize, @filelist);
	unless ($errmsg){
		opendir DIR, $userdir;
		my @filenames	= readdir (DIR) or print "Cannot read this directory: $userdir<br>";
		closedir DIR;
		foreach (@filenames){
			next if (($_ eq '.') or ($_ eq '..'));
			my $file  = "$userdir$delim$_";
			my @stat = stat $file;
			unless (-d _){
				my $size = $stat[7];
				$tsize += $size;
				s/^(.*\/)*(.*)$/$2/;
				$_ = quoteit($_);
#				$selectscript .= qq!\t<OPTION VALUE="$_">$_ \/$size\/ $date\n!;
				push @filelist, [$_, $size, $stat[9]];
			}
		}
	}

	my $sort_ = $q->param('sort');
	my @orderedfiles;
	if ($sort_ eq 'name'){ 	   		  	
		@orderedfiles	= sort {
				uc $a->[0] cmp uc $b->[0]	# sort by names
						||
				uc $a->[2] <=> uc $b->[2]	# then by date
			} @filelist;
	}
	elsif ($sort_ eq 'size') {      	  		 
		@orderedfiles	= sort {
				uc $a->[1] <=> uc $b->[1]	# sort by size
						||
				uc $a->[0] cmp uc $b->[0]	#then by name
			} @filelist;
	}
	elsif($sort_ eq 'date')
	 {
		@orderedfiles	= sort {
				$a->[2] <=> $b->[2] #sort by date
						||
				uc $a->[0] cmp uc $b->[0]	  # then by name
			} @filelist ;
	}
	else {@orderedfiles = @filelist}
#	if ($order){@orderedfiles = reverse @orderedfiles}

	foreach my $element (@orderedfiles){
		my $date = scalar localtime ($element->[2]);
		$date =~ s/^\s*\w\w\w\s*(.*)/$1/;

		$selectscript .= qq!\t<OPTION VALUE="$element->[0]">$element->[0] : $element->[1] : $date\n!;
	}
	my $ch_name = 'CHECKED' if $sort_ eq 'name';
	my $ch_size = 'CHECKED' if $sort_ eq 'size';
	my $ch_date = 'CHECKED' if $sort_ eq 'date';
	
	my $sortby = <<EOT
	<TR>
		<TD><INPUT TYPE=SUBMIT NAME="script" VALUE="Sort by" style="width: 70px;" TITLE="SORT FILES BY NAME, SIZE OR DATE"></TD>
		<TD><NOBR>&nbsp;Name<INPUT TYPE=RADIO NAME="sort" VALUE="name" $ch_name>&nbsp;Size<INPUT TYPE=RADIO NAME="sort" VALUE="size" $ch_size>&nbsp;Date<INPUT TYPE=RADIO NAME="sort" VALUE="date" $ch_date></NOBR></TD>
	</TR>
EOT
;

	unless ($selectscript){$selectscript = qq!\t<OPTION VALUE="">Script list is empty\n!}
	$selectscript = qq!<SELECT NAME="selectscript" MULTIPLE SIZE=12 TITLE="Select a script">\n!.$selectscript;
	$selectscript .= "</SELECT>\n";
	$tsize = int($tsize / 1024 * 100) / 100;
	
	my $selectedscriptname		= "LOADED&nbsp;SCRIPT:&nbsp;<B><U>". quoteit($selectedscript) ."</U></B>" if $selectedscript;
	my $closebutton				= qq!<INPUT TYPE=SUBMIT NAME="script" VALUE=" Close " style="width: 60px" TITLE="Close the script &quot;$selectedscript&quot;">! if $selectedscript;

	my $abort = $q->checkbox(	-name=>'abortsql', -label=>'',  -title=>"Check to abort execution if error occurs. (For multiple queries)");
	
	my ($textareasize, $saveassize) = $agent ?
		(50, 12) :
		(80, 34) ;
	my $buttonwidth 	= '123px';
	my $buttonwidth2	= $buttonwidth * 2;
	
	
	my $renamesize = $agent ? 19 : 29;
	print <<EOT
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=285>
<FORM METHOD=POST ACTION="$full_url">
<INPUT TYPE=HIDDEN NAME=page VALUE=tables>
<INPUT TYPE=HIDDEN NAME=func VALUE=scripts>
<INPUT TYPE=HIDDEN NAME=dbname VALUE=$database>
<INPUT TYPE=HIDDEN NAME="selectedscript" VALUE="$selectedscript">

	<TR>
		<TH ALIGN=LEFT COLSPAN=2 ><p>SQL SCRIPTS<p></TH>
	</TR>
	<TR>
		<TD VALIGN=TOP>
		<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=285>			
				<TR>
					<TD>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>			
	<TR>
		<TD><INPUT TYPE=SUBMIT NAME="script" VALUE="Rename" style="width: 70px" TITLE="RENAME SELECTED FILE"></TD><TD><INPUT TYPE=TEXT SIZE="$renamesize" NAME="rename" VALUE=""></td>
	</TR>
$sortby
</TABLE>
$selectscript
			 		</TD>
				</TR>
			</TABLE>
			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
				<TR>
					<TD VALIGN=BOTTOM><INPUT TYPE=SUBMIT NAME="script" VALUE=" Edit " style="width: 60px" TITLE="Load selected script to view and edit"></TD>
					<TD VALIGN=BOTTOM><INPUT TYPE=SUBMIT NAME="script" VALUE="  Open " style="width: 60px" TITLE="Execute selected script"></TD>
					<TD VALIGN=BOTTOM>$closebutton</TD>
					<TD VALIGN=BOTTOM><INPUT TYPE=SUBMIT NAME="script" VALUE=" Delete " style="width: 60px; color=#CC0000" TITLE="DELETE SELECTED SCRIPT"></TD>
				</TR>
				
			</TABLE><p>$selectedscriptname
		</TD>
		<TD VALIGN=TOP><p>
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%">	
	<TR>			
		<TD>
		<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
			<TR>
				<TD><TEXTAREA WRAP=PHYSICAL NAME="SQL" ROWS=15 COLS=$textareasize TITLE="SQL script editor">$SQL_</TEXTAREA></TD>
			</TR>
			<TR>
				<TD><P>
					<TABLE BORDER=0  CELLPADDING=0 CELLSPACING=0>
						<TR>
							<TD><P><INPUT TYPE=SUBMIT VALUE="     Back     " style="width: 100px" NAME=script TITLE="Go back to previous page"></TD>
							<TD><P><INPUT TYPE=RESET VALUE="   Reset   " style="width: 100px" TITLE="Reset form"></TD>
							<TD><P><INPUT TYPE=SUBMIT NAME="script" VALUE="Execute Query" style="width: 100px" TITLE="Execute SQL script"></TD>
							<TD TITLE="Check to abort execution if error occurs. (For multiple queries)"><P>$abort Abort on error</TD>
						</TR>
					</TABLE></TD>
			</TR>
		</TABLE></TD>
	</TR>				
	<TR>
		<TD HEIGHT=2></TD>
	</TR>
	<TR>			
		<TD><P>
			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
				<TR VALIGN=BOTTOM>
					<TD VALIGN=BOTTOM><INPUT TYPE=SUBMIT NAME="script" VALUE="Save" style="width: 100px" TITLE="Save SQL script &quot;$selectedscript&quot;"></TD>
					<TD VALIGN=BOTTOM><INPUT TYPE=SUBMIT NAME="script" VALUE="Save as" style="width: 100px" TITLE="Save SQL script as ..."></TD>
					<TD VALIGN=BOTTOM>&nbsp;<INPUT TYPE=TEXT NAME="saveasname" SIZE=30 TITLE="Type name to save as"></TD>
					<TD>&nbsp;</TD>
				</TR>
			</TABLE>
			</TD>
		</TR>
	</TABLE>
</TD></TR></form></TABLE>

EOT
;

	if ($q->param('script') =~ /(Open)|(execute)/i){
		print "\n<hr size=1>\n";
		execExecuteQuery($back)
	}
}

sub execSearch {
	my ($table)		= $q->param('tables');
	my $back =		   {
	   page =>			'tables',
	   dbname =>		"$database",
	   tables =>		"$table",
	   func =>			"search"	 
	};
#		$back->{func}	= "return";
#		$back->{page} 	= "searchresult";
#		$back->{order}	= "$order";
#		$back->{where}	= "$where";
#		$back->{fields}	= \@fields;
#		$back->{start}	= "$start";
#		$back->{rows}	= "$rows";
	my $query 		= "SELECT * FROM $table WHERE 1=0";
	my ($sth,$res)	= prepare_execute($query, {page => 'select_db', dbname => "$database"});
	my @names 		= @{$sth->{NAME}};
	my $null 		= $sth->{NULLABLE};
	$sth->finish;
	my @fields		= $q->param('fields');
	my @where;
	my @unquote		= $q->param('unquote');
	my $j 			= 0;
	sub regescape {
		$_ = shift;
		s{(.)}{
				if ($1 eq '\\')			{ '\\\\\\\\' }
				elsif ($1 eq '%')		{ '\%' }
				elsif ($1 eq "'")		{ "\\'" }
				elsif ($1 eq '^')		{ '\^' }
				elsif ($1 eq '$')		{ '\$' }
				elsif ($1 eq '.')		{ '\.' }
				elsif ($1 eq '[')		{ '\[' }
				elsif ($1 eq ']')		{ '\]' }
				elsif ($1 eq '*')		{ '\*' }
				elsif ($1 eq '+')		{ '\+' }
				elsif ($1 eq '?')		{ '\?' }
				elsif ($1 eq '|')		{ '\|' }
				elsif ($1 eq '{')		{ '\{' }
				elsif ($1 eq '}')		{ '\}' }
				elsif ($1 eq ')')		{ '\)' }
				elsif ($1 eq '(')		{ '\(' }
				else					{ $1   }
			}gsex;
		return $_;
	}
	for(my $i=0; $i<@names; $i++){
		my $data 	= $q->param("$names[$i]\_data");
		my $oper 	= $q->param("operator\_$names[$i]");
		next if (($data eq '') and !$oper);
		my $not 	= ' NOT' 	if $q->param("not\_$names[$i]");
		my $case 	= ' BINARY' if $q->param("case\_$names[$i]");
		my $unquote;
		my $likexpr = sub {
			if (belongsb(\@unquote,$names[$i])){
				$unquote = 1;
				return ['REGEXP', $case, '', $data, '', '']
			}
			else {
				$case = '' unless check_version('3.23.4');
				return ['LIKE', $case, "'%", regescape($data), "%'", "'"]
			}
		} ;#if (!$oper or ($oper eq 'AND') or ($oper eq 'OR'));
		if (!$oper) {
			my $expr	= &$likexpr;
			$where[$j]	= "$names[$i]$not $expr->[0]$expr->[1] $expr->[2]$expr->[3]$expr->[4]";
		}
		elsif ($oper eq 'start') {
			my $expr	= &$likexpr;
			my @data	= split ',', $expr->[3];
			my @where_;
			for(my $k=0; $k<@data; $k++){
				$data[$k] =~ s/^\s*(.*)\s*$/$1/;
				push @where_, "$names[$i]$not $expr->[0]$expr->[1] $expr->[5]$data[$k]$expr->[4]"; 
			}
			$where[$j]	= join " OR \n", @where_;
		}
		elsif ($oper eq 'end') {
			my $expr	= &$likexpr;
			my @data	= split ',', $expr->[3];
			my @where_;
			for(my $k=0; $k<@data; $k++){
				$data[$k] =~ s/^\s*(.*)\s*$/$1/;
				push @where_, "$names[$i]$not $expr->[0]$expr->[1] $expr->[2]$data[$k]$expr->[5]"; 
			}
			$where[$j]	= join " OR \n", @where_;
		}
		elsif (($oper eq 'AND') or ($oper eq 'OR')){
			my $expr	= &$likexpr;
			my @data	= split ',', $expr->[3];
			my @where_;
			for(my $k=0; $k<@data; $k++){
				$data[$k] =~ s/^\s*(.*)\s*$/$1/;
				push @where_, "$names[$i]$not $expr->[0]$expr->[1] $expr->[2]$data[$k]$expr->[4]"; 
			}
			$where[$j]	= join " $oper \n", @where_;
		}
		elsif ($oper eq '>'){
			$oper 		= '<=' if $not;
			$data		= "'". regescape($data) ."'" unless (DBI::looks_like_number($data) or $unquote);
			$where[$j]	= "$case $names[$i] $oper $data ";
			
		}
		elsif ($oper eq '>='){
			$oper 		= '<' if $not;
			if (($data eq '') and $null->[$i] and !$not) {$where[$j] = " OR $names[$i] IS NULL"}
			$data		= "'". regescape($data) ."'" unless (DBI::looks_like_number($data) or $unquote);
			$where[$j]	= "$case $names[$i] $oper $data $where[$j] ";
		}
		elsif ($oper eq '<'){
			$oper		= '>=' if $not;
			if (($data eq '') and $null->[$i] and $not) {$where[$j] = " OR $names[$i] IS NULL"}
			$data		= "'". regescape($data) ."'" unless (DBI::looks_like_number($data) or $unquote);
			$where[$j]	= "$case $names[$i] $oper $data $where[$j] ";
		}
		elsif ($oper eq '<='){
			$oper		= '>' if $not;
			$data		= "'". regescape($data) ."'" unless (DBI::looks_like_number($data) or $unquote);
			$where[$j]	= "$case $names[$i] $oper $data ";
		}
		elsif ($oper eq '='){
			$oper		= '<>' if $not;
			if (($data eq '') and $null->[$i] and !$not) {$where[$j] = " OR $names[$i] IS NULL"}
			$data		= "'". regescape($data) ."'" unless (DBI::looks_like_number($data) or $unquote);
			$where[$j]	= "$case $names[$i] $oper $data $where[$j] ";
		}
		elsif ($oper eq 'BETWEEN'){
			my @data	= split ',', $data;
			bail_out("\"BETWEEN\" option requires TWO arguments to be comma separated.",$back) 
				if ((@data > 2) or (@data < 2));
			for(my $k=0; $k<2; $k++){
				$data[$k]	=~ s/^\s*(\S*)\s*$/$1/g;
				$data[$k]	= "'". regescape($data[$k]) ."'" unless (DBI::looks_like_number($data[$k]) or $unquote);
			}
			$where[$j] = "$case $names[$i]$not BETWEEN $data[0] AND $data[1]";
		}
		elsif ($oper eq 'IN'){
			my $expr 	= &$likexpr;
			my @data	= split ',', $expr->[3];
			
			for(my $k=0; $k<@data; $k++){
				$data[$k]	=~ s/^\s*(\S*)\s*$/$1/g;
				$data[$k]	= "$expr->[5]$data[$k]$expr->[5]";
			}
			$where[$j]		= join ' ,',@data;
			$where[$j]		= "$case $names[$i]$not IN ($where[$j])";
 		
		}
		elsif ($oper eq 'REGEXP'){
			my $expr		= &$likexpr;
			$where[$j]		= "$case $names[$i]$not REGEXP $expr->[5]$expr->[3]$expr->[5]";
		}
		elsif ($oper eq 'LIKE') {
			my $expr 		= &$likexpr;
			$where[$j] 		= "$names[$i]$not $oper$expr->[1] $expr->[5]$expr->[3]$expr->[5]";
		}
		elsif ($oper eq 'NULL'){
			$where[$j] 		= "$names[$i] IS $not NULL";
		}
		elsif ($oper eq 'FUNCTION'){
			$where[$j] 		= "$names[$i] $data";
		}
		$where[$j]	= "($where[$j])";
		$j++;
	} 
	my $andor			= $q->param('andor');
	my $where 			= join " $andor ", @where;
	$where 				= "WHERE $where" if $where;
	my $sort 			= $q->param('sort');
	my $sortorder 		= $q->param('sortorder');
	my $order 			= "ORDER BY $sort $sortorder" if $sort;
	searchresult($where, $order);

return;
}

sub searchresult {
#input:
# $_[0] - where
# $_[1] - order

	my $where 		= defined $_[0] ? $_[0] : $q->param('where');
	my $order 		= defined $_[1] ? $_[1] : $q->param('order');
	my ($table)		= $q->param('tables');
	my $start 		= $q->param('start');
	my $rows 		= $q->param('rows');
	my $func 		= $q->param('func');
	my @fields		= $q->param('fields');
	my $selectfrom	= "SELECT ". join (', ', @fields). " FROM $table";
	my $query_ 		= "$selectfrom $where $order";
	my $deletepreview = '1' if (($func =~ /delete/i) and !$q->param('back') and !$q->param('confirm'));
	my $hidden		= $q->hidden(-name=>'fields', -value=>\@fields, -override=>1);
	my $back = 	{
		tables 		=> "$table",
		dbname 		=> "$database"
	};

	if ($page eq 'search'){
		$back->{func}	= "search";
		$back->{page} 	= "tables";
	}
	else {
		$back->{func}	= "return";
		$back->{page} 	= "searchresult";
		$back->{order}	= "$order";
		$back->{where}	= "$where";
		$back->{fields}	= \@fields;
		$back->{start}	= "$start";
		$back->{rows}	= "$rows";
	}
	unless ($start =~ /^\s*\d*\s*$/){bail_out("Please check the 'Start' row number",$back)}
	unless ($rows =~ /^\s*\d*\s*$/){bail_out("Please check the number of 'hits' to be displayed",$back)}
	if	($q->param('confirm') and ($func =~ /delete/i)){
		my $query = $q->param('deletequery');
		bail_out("Cannot delete records", $back) unless $dbh->do($query);
	}

	my $count		= count_rows("$table $where", $back);
	if (($func 		=~ /next/i) and (($start + $rows)<$count)) {$start = ($start + $rows)}
	elsif (($func 	=~ /prev/i) and ($start > $rows)) {$start = ($start - $rows)}
	elsif (($func	=~ /prev/i) and ($start <= $rows)) {$start = '0'}
	my $deletequery;
	my $limit;
	my ($controlbar, $title, $confirmation, $conftitle, $printpage, $pr_res_up, $pr_res_down);
	if ($deletepreview) {
		bail_out("Please select rows to delete!", $back) unless defined $q->param('SelectRow');
		my $query 		= "SELECT *  FROM $table $where $order";

		my $calldelete = {
			count => "$count", table => "$table", start => "$start", rows => "$rows", query => "$query", back => $back
		};
		$deletequery 		= "DELETE ".$q->param('delete_option1')." FROM  $table ";
		my $deletewhere 	= getwhere($calldelete);
		if ($where and !$deletewhere){bail_out("Selected records where not found", $back)}
		$deletewhere 		= "WHERE $deletewhere" if $deletewhere;
		$deletequery 		.= $deletewhere;
		$query_		 		= "$selectfrom $deletewhere $order";
		$deletequery 		= quoteit($deletequery);
		$hidden .= qq!\n<INPUT TYPE=HIDDEN NAME="func" VALUE="DELETE">\n!;
		$hidden .= qq!\n<INPUT TYPE=HIDDEN NAME="deletequery" VALUE="$deletequery">\n!;
		$title = 'DELETE RECORDS';
		$confirmation = "Selected records will be deleted:";
		$controlbar = <<EOT
			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
				<TR>
					<TD><INPUT TYPE=SUBMIT NAME="confirm" VALUE=" CONFIRM " style="color=#CC0000" TITLE="Confirm deletion"></TD>
					<TD><INPUT TYPE=SUBMIT NAME="back" VALUE="  BACK  " TITLE="Cancel and return back"></TD>
				</TR>
				<TR>
					<TD COLSPAN=2 HEIGHT=6></TD>
				</TR>
			</TABLE>		
EOT
;

		
	}
	elsif ($q->param('printpage') ne 'full'){
		if ($start and ($rows ne ''))	{$limit = "LIMIT $start, $rows"}
		elsif ($start and ($rows eq '')){$rows = $count - $start; $limit = "LIMIT $start, $rows"}
		elsif (!$start and $rows ne '') {$limit	= "LIMIT $rows"}
		else {$rows = $count - $start}
		$query_ 			.= " $limit";	
	}
	$query 					= quoteit($query_);
	my ($sth,$res) 			= 	prepare_execute($query_, $back);
	if ($print) {print &printresult(\$sth, 0, 1);return}
	my ($sth_, $res_)  		= prepare_execute("SELECT * FROM $table WHERE 1=0", $back);
	my $pri_   				= get_mysql_pri($sth_);
	my $offset 				= ($start + 0);
	my $i 					= 0;
	my $array;
	$array->[0][0] 			= qq!<TD BGCOLOR="#CCCCCC">No</TH>!;
	$array->[0][1]			= qq!<TD BGCOLOR="#CCCCCC">Select</TD>! unless ($deletepreview);
	my $pri 				= get_mysql_pri($sth);
	unless (defined $pri){$pri = []}
	my $bgcolorH			= $print ? '#FFFFFF' : '#EEEEEE';
	my $bgcolor				= $print ? '#FFFFFF' : '#EEEEEE';
	my $pricolor 			= $print ? '#000000' : '#ff0000';
	foreach (my $i = 0; $i < $sth->{NUM_OF_FIELDS}; $i++) {
		my $color = '#000000';
		if ($pri->[$i]){
			$array->[0][$i+2] = qq!<TH BGCOLOR="$bgcolorH"><FONT COLOR="$pricolor">$sth->{NAME}->[$i]</TH>!;
		}
		else {
			$array->[0][$i+2] = qq!<TH BGCOLOR="$bgcolor"><FONT COLOR="#000000">$sth->{NAME}->[$i]</TH>!;
		}
	}
	my $j=1;
	my @offset = $deletepreview ? $q->param('SelectRow') : ($start..($start+$rows));
	while (@ary = $sth->fetchrow_array)	{
		@ary 	= quoteit(@ary);
		$offset = $offset[$j-1];
		unless ($print) {
			$array->[$j][0] = qq!<TD BGCOLOR="#CCCCCC">$offset</TD>!;
			$array->[$j][1] = qq!<TD BGCOLOR="#CCCCCC"><INPUT TYPE=CHECKBOX NAME="SelectRow" VALUE="$offset" TITLE="Select record"></TD>! unless
					($deletepreview);
		}
		for (my $i = 0; $i < @ary; $i++){
			$ary[$i] =~ s/(\r\n)|\n/<BR>/mg;
			$ary[$i] = '&nbsp;' if ($ary[$i] eq '' or !defined $ary[$i]);
			$array->[$j][$i+2]= qq!<TD BGCOLOR="$bgcolor">$ary[$i]</TD>!;
		}
		$j++;
		$offset++;
	}
	$where = quoteit($where);

	unless ($deletepreview){
		my $prev 	= qq!<INPUT TYPE=SUBMIT NAME="func" VALUE="<<Prev" TITLE="Show previous hits">! if ($start > 0);
		my $next 	= qq!<INPUT TYPE=SUBMIT NAME="func" VALUE="Next>>" TITLE="Show next hits">! if ((($start + $rows) < $count) and $rows);
		if ($prev or $next){
			$printpage = qq!Full&nbsp;result&nbsp;<INPUT TYPE=RADIO NAME="printpage" VALUE="full" TITLE="Print all found hits">&nbsp;Current&nbsp;Page&nbsp;<INPUT TYPE=RADIO NAME="printpage" VALUE="this" CHECKED TITLE="Print only shown hits">!;
		}
		$title = 'SEARCH&nbsp;RESULT';
		$confirmation = "Records&nbsp;found:&nbsp;$count";
		$conftitle	=  qq!TITLE="Totally $count hits were found with given search criteria"!;
		$controlbar = <<EndOfControlbar
			<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=650>
				<TR>
					<TD WIDTH=120>
					<TABLE CELLPADDING=0 CELLSPACING=0 WIDTH=120 BORDER=0>
						<TR>
							<TD>
								<TABLE CELLPADDING=0 CELLSPACING=0 WIDTH=60 BORDER=0>
									<TR>
										<TD WIDTH=60>$prev</TD>
									</TR>
								</TABLE>
							</TD>
							<TD WIDTH=60>
								<TABLE CELLPADDING=0 CELLSPACING=0 WIDTH=60 BORDER=0>
									<TR>
										<TD WIDTH=60>$next</TD>
									</TR>
								</TABLE>
							</TD>
						</TR>
					</TABLE>
					</TD>
					<TD WIDTH=20>&nbsp;</TD>
					<TD>
						<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0>
							<TR>
								<TD WIDTH=68><INPUT TYPE=SUBMIT NAME="func" VALUE="  BACK  " TITLE="Go back to select search criteria"></TD>
								<TD WIDTH=120 ALIGN=LEFT><INPUT TYPE=SUBMIT NAME="func" VALUE="EDIT RECORD " TITLE="Edit selected records"></TD>
								<TD WIDTH=120 ALIGN=LEFT><INPUT TYPE=SUBMIT NAME="func" VALUE=" NEW RECORD " TITLE="Insert new records"></TD>
								<TD WIDTH=118 ALIGN=LEFT><INPUT TYPE=SUBMIT NAME="func" VALUE="DELETE RECORD" TITLE="Delete selected records"></TD>
							</TR>
						</TABLE>
					</TD>
				</TR>
				<TR>
					<TD COLSPAN=3 HEIGHT=6></TD>
				</TR>
			</TABLE>		

EndOfControlbar
;
	my $titlesize = $agent ? 15 : 20;
	$pr_res_up = <<EOPR
<INPUT TYPE=SUBMIT NAME="print" VALUE="Print result" TITLE="Generate printer friendly report"></TD>
		<TD><nobr>$printpage</nobr></TD>
		<TD>&nbsp;</TD>
		<TD>Title:&nbsp;<INPUT TYPE=TEXT SIZE=$titlesize NAME="title" TITLE="Type page title to place on printout">
EOPR
;
$pr_res_down = <<EOT
Height:</TD>
		<TD><nobr>Rows:&nbsp;<SELECT NAME="rowheight" TITLE="Select height of table rows for printout">
		<OPTION VALUE="" SELECTED>min
		<OPTION VALUE="HEIGHT=20">20
		<OPTION VALUE="HEIGHT=30">30
</SELECT>&nbsp;Header:&nbsp;<SELECT NAME="headerheight" TITLE="Select height of table header for printout">
		<OPTION VALUE="">min
		<OPTION VALUE="HEIGHT=20">20
		<OPTION VALUE="HEIGHT=30" SELECTED>30
</SELECT></nobr></TD>
		<TD>&nbsp;</TD>
		<TD><nobr>Align:&nbsp;<SELECT NAME="align" TITLE="Select alignment of page title">
<OPTION VALUE="LEFT" SELECTED>left
<OPTION VALUE="CENTER">center
<OPTION VALUE="RIGHT">right
</SELECT>&nbsp;<B>B</B>&nbsp;<INPUT TYPE=CHECKBOX NAME="style" 
VALUE="B" TITLE="Style of page title - Bold">&nbsp;<B><I>I</I></B><INPUT TYPE=CHECKBOX NAME="style" 
VALUE="I" TITLE="Style of page title - Italic">&nbsp;<B><U>U</U></B><INPUT TYPE=CHECKBOX NAME="style" VALUE="U" TITLE="Style of page title - Underline"></nobr>

EOT
;
}

	my $export = <<EOT
	<TABLE BORDER=0>
	<FORM ACTION=$full_url METHOD=POST>
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="page" 			VALUE="tables">
<INPUT TYPE=HIDDEN NAME="count" 		VALUE="$count">
<INPUT TYPE=HIDDEN NAME="tables" 		VALUE="$table">
<INPUT TYPE=HIDDEN NAME="start" 		VALUE="$start">
<INPUT TYPE=HIDDEN NAME="rows" 			VALUE="$rows">
<INPUT TYPE=HIDDEN NAME="where" 		VALUE="$where">
<INPUT TYPE=HIDDEN NAME="order" 		VALUE="$order">
<INPUT TYPE=HIDDEN NAME="searchresult" 	VALUE="1">
$hidden
<INPUT TYPE=HIDDEN NAME="query" 		VALUE="$query">
	<TR>
		<TD><P><INPUT TYPE=SUBMIT NAME="func" VALUE="Export Result" style="width: 110"></TD>
		<TD>&nbsp;</TD>
		<TD>CSV&nbsp;File<INPUT TYPE=RADIO NAME="mode" VALUE="simple" CHECKED></TD>
		<TD>&nbsp;</TD>
		<TD>Advanced<INPUT TYPE=RADIO NAME="mode" VALUE="advanced"></TD>
		<TD>&nbsp;</TD>
	</TR>
</FORM>
    </TABLE>
EOT
unless $deletepreview;

	print <<EOT
<!-- Header Table -->
<TABLE BORDER=0>
	<TR>
		<TD VALIGN=TOP><P>
	<TABLE BORDER=0>
		<TR>
			<TH ALIGN=LEFT>$title</TH>
			<TD>&nbsp;</TD>
			<TD $conftitle>&nbsp;<CODE>$confirmation</CODE>&nbsp;</TD>
		</TR>
		<TR>
			<TD COLSPAN=3><CODE>TABLE&nbsp;"$table"&nbsp;</CODE></TD>
		</TR>
		<TR>
			<TD COLSPAN=3>&nbsp;</TD>
		</TR>
    </TABLE>
		</TD>
		<TD VALIGN=TOP><P>
	<TABLE BORDER=0>
	<FORM METHOD=POST ACTION="$full_url" TARGET=_blank>
		<TR>
			<TD>$pr_res_up</TD>
		</TR>
		<TR>
			<TD ALIGN=CENTER>$pr_res_down</TD>
		</TR>
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="page" VALUE="searchresult">
<INPUT TYPE=HIDDEN NAME="count" VALUE="$count">
<INPUT TYPE=HIDDEN NAME="tables" VALUE="$table">
<INPUT TYPE=HIDDEN NAME="start" VALUE="$start">
<INPUT TYPE=HIDDEN NAME="rows" VALUE="$rows">
<INPUT TYPE=HIDDEN NAME="where" VALUE="$where">
<INPUT TYPE=HIDDEN NAME="order" VALUE="$order">
$hidden
</FORM>
    </TABLE>
$export
		</TD>
	</TR>
</TABLE>
<!-- End of Header Table -->
EOT
unless $print;

	my $bordercolor = '#AAAAAA';
	print <<EOT
		  <!-- Search Result -->
<FORM METHOD=POST ACTION="$full_url">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%">
	<TR>
		<TD WIDTH="100%">
<!-- Control Bar starts here -->
$controlbar
<!-- Control Bar ends here -->
		</TD>
	</TR>
	<TR>
		<TD WIDTH="100%">
			<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0>
				<TR>
					<TD BGCOLOR="$bordercolor">
						<TABLE BORDER=0 CELLSPACING=1 CELLPADDING=2>
EOT
;

	#my $firstrow  ;
	my $rowheight = $q->param('rowheight');
	my $headerheight = $q->param('headerheight');
	print qq!\t<TR $headerheight>!, @{shift (@$array)}, qq!</TR>\n!;
	foreach (@$array){print qq!\t<TR $rowheight>@{$_}</TR>\n!}
	print <<EOT
						</TABLE>
					</TD>
				</TR>
			</TABLE>
		</TD>
	</TR>
</TABLE>
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="page" VALUE="searchresult">
<INPUT TYPE=HIDDEN NAME="count" VALUE="$count">
<INPUT TYPE=HIDDEN NAME="tables" VALUE="$table">
<INPUT TYPE=HIDDEN NAME="start" VALUE="$start">
<INPUT TYPE=HIDDEN NAME="rows" VALUE="$rows">
<INPUT TYPE=HIDDEN NAME="where" VALUE="$where">
<INPUT TYPE=HIDDEN NAME="order" VALUE="$order">
$hidden
</FORM>
		 <!-- end of printresult subroutine -->
EOT
;


}
sub execSearchupdate {
	my ($back, $updatewhere) = @_;
	my $table 		= $q->param('tables');
	my $err_msg;
	$updatewhere 	= "WHERE $updatewhere" if $updatewhere;
	my $query 		= "SELECT * FROM $table $updatewhere";
	my ($sth,$res)	= prepare_execute($query,$back);
	if ($res > 1){bail_out("Too many results. Check the code", $back)}
	my @names		= @{$sth->{NAME}};
	my @ary 		= $sth->fetchrow_array();#||bail_out("",$back);
	my @unquote		= $q->param('unquote');
	my @upload		= $q->param('upload');
	my $num			= $sth->{NUM_OF_FIELDS};
	$sth->finish;
	my @setarray;
	for (my $i = 0; $i<$num; $i++) {
		my $data;
		if (belongs(\@upload, $names[$i])){
			$data = $q->param("$names[$i]\_data_upload")||bail_out("No file entered ('$names[$i]' column).",$back);
			my $buf;
			$err_msg .= "File not found or is empty. $! - column '$names[$i]'\n" unless (-s $data);
#			binmode $data if -B $data;
			binmode $data;
			my $line = '';

			while (read $data, $buf, 1024) {$line .= $buf; bail_out("$!", $back) if $! }
			close $data;
			bail_out("$!", $back) if $!;
			$data = $line;	
		}
		else {$data = $q->param("$names[$i]\_data").''}

#++++++++++++++++++++++++++++++++++++++

		if (belongs(\@unquote, $names[$i])){
			my $data_ = $data;
			my $sth 	= $dbh->prepare("SELECT $data");
			my $res 	= $sth->execute() || bail_out("CHECK YOUR INPUT. WRONG UNQUOTED PARAMETERS IN COLUMN: '$names[$i]'\n\n$data\n\n", $back);
			($data_)	= $sth->fetchrow_array();
			if (($data_ ne $ary[$i]) or (!defined $data_) or (!defined $ary[$i])){
				push @setarray, "$names[$i]=$data"; 
			}
		}
		else {
			unless ($data eq $ary[$i]){
				$data = $dbh->quote($data);
				push @setarray, "$names[$i]=$data";
			}
		}
	}#for
	bail_out($err_msg, $back) if $err_msg;
	unless (@setarray == 0) {
		bail_out($demomsg, $back);
	}#end update
}#execSearchupdate


sub printHeaderTable {
	my $headtab = $_[0];
# $_[0]->{name} - the name of proc.
# $_[0]->{title1} - table name
# $_[0]->{title2} - count rows
# $_[0]->{rows} - No of rows
# $_[0]->{table} - Table name

	my $total = qq!<CODE>$headtab->{rows}</CODE>! if (defined $headtab->{rows});
	my $table = qq!<CODE>$headtab->{table}</CODE>! if $headtab->{table};
	print <<EOT
<TABLE BORDER=0><!-- Header Table -->
	<TR><TH COLSPAN=5 ALIGN=LEFT>$headtab->{name}</TH><TR>
	<TR>
		<TD TITLE="$headtab->{title1}">$table</TD>
		<TD>&nbsp;&nbsp;&nbsp;</TD>
		<TD TITLE="$headtab->{title2}">&nbsp; $total &nbsp;</TD>
		<TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD>
		<TD>$headtab->{msg}</TD>
	</TR>
</TABLE><!-- End of Header Table -->
EOT
;
}
sub backtoselect {
		my $tables	= quoteit ($q->param('tables'));
		my @cols 	= $q->param("fields_$tables");
		return {
			select				=> "".$q->param('select'),
			tables				=> "".$tables,
			where				=> "".$q->param('where'),
			groupby				=> "".$q->param('groupby'),
			orderby				=> "".$q->param('orderby'),
			limit				=> "".$q->param('limit'),
			"fields_$tables"	=> \@cols
		}
}

sub printform {
	my $input = shift;
	my $hidden = qq!<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">\n!;
	$hidden .= qq!<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">\n!;
	my $query	= $input->{query};
	if ($q->param('func') =~ /^select/i){
		my $param = backtoselect();
		foreach (keys %$param){
			$hidden .= $q->hidden(-name=>$_, -value=>$param->{$_}, -override=>1)."\n";
		}
		$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="query" VALUE="$query">\n!;
	}
	else {
		my $sql				.= quoteit ($input->{'SQL'});
		my $selectedscript	.= quoteit ($input->{'selectedscript'});
 		$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="SQL" VALUE="$sql">!;
		$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="selectedscript" VALUE="$selectedscript">! if $selectedscript;
		$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="query" VALUE="$query">\n!;
		$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="script" VALUE="execute">\n!;
#		$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="func" VALUE="script">!;
	}
	print <<EOT
	<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<TR><TD><P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1>
<FORM ACTION=$full_url METHOD=POST TARGET=_blank>
<INPUT TYPE=HIDDEN NAME="SQL" VALUE="$input->{query}">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="page" VALUE="tables">
<INPUT TYPE=HIDDEN NAME="script" VALUE="print">
<INPUT TYPE=HIDDEN NAME="func" VALUE="script">
	<TR>
		<TD><INPUT TYPE=SUBMIT NAME="print" VALUE="Print Result" TITLE="Generate printer friendly report"  style="width: 110">&nbsp;</TD>
		<TD>&nbsp;Heights:</TD>
		<TD>Rows&nbsp;<SELECT NAME="rowheight" TITLE="Select height of table rows for printout">
<OPTION VALUE="" SELECTED>min
<OPTION VALUE="HEIGHT=20">20
<OPTION VALUE="HEIGHT=30">30
</SELECT></TD>
		<TD>Header&nbsp;<SELECT NAME="headerheight" TITLE="Select height of table header for printout">
<OPTION VALUE="">min
<OPTION VALUE="HEIGHT=20">20
<OPTION VALUE="HEIGHT=30" SELECTED>30
</SELECT></TD>
		<TD>Title:&nbsp;<INPUT TYPE=TEXT SIZE=20 NAME="title" TITLE="Type page title to place on printout"></TD>
		<TD><NOBR>Align:&nbsp;<SELECT NAME="align" TITLE="Select alignment of page title">
<OPTION VALUE="LEFT" SELECTED>left
<OPTION VALUE="CENTER">center
<OPTION VALUE="RIGHT">right
</SELECT>&nbsp;<B>B</B>&nbsp;<INPUT TYPE=CHECKBOX NAME="style" 
VALUE="B" TITLE="Style of page title - Bold">&nbsp;<B><I>I</I></B><INPUT TYPE=CHECKBOX NAME="style" 
VALUE="I" TITLE="Style of page title - Italic">&nbsp;<B><U>U</U></B><INPUT TYPE=CHECKBOX NAME="style" VALUE="U" TITLE="Style of page title - Underline"></NOBR></TD>

	</TR>
</FORM>	
</TABLE>

</TD></TR>
<TR><TD><P>

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=1>
	<FORM ACTION=$full_url METHOD=POST><TR>
$hidden
		<TD><P><INPUT TYPE=SUBMIT NAME="func" VALUE="Export Result" style="width: 110"></TD>
		<TD>&nbsp;</TD>
		<TD>CSV&nbsp;File<INPUT TYPE=RADIO NAME="mode" VALUE="simple" CHECKED></TD>
		<TD>&nbsp;</TD>
		<TD>Advanced<INPUT TYPE=RADIO NAME="mode" VALUE="advanced"></TD>
		<TD>&nbsp;</TD>
	</TR>
</FORM>
</TABLE>

</TD></TR></TABLE>
EOT
;

}
sub removeUser {
	my $back = {page => 'admin', func =>'access', dbname => "$database"};
	bail_out("Access denied to database 'mysql'", $back) if defined $q->param('add');
	my @userlist = $q->param('userlist');
	unless (@userlist and ($userlist[0] =~/@/)){bail_out "Please select from user list", $back}
	if ($q->param('confirm')){
		my @tables = ('mysql.user', 'mysql.columns_priv', 'mysql.db', 'mysql.tables_priv');
		foreach (@tables) {
			my $query = "DELETE FROM $_ WHERE ";
			my @where = ();
			foreach (@userlist){
				/^\s*('\S*.*')\@('.*\S*')\s*$/;
				push @where, "((User = $1) AND (Host = $2))";
			}
			$query .= join (' OR ', @where);
			$dbh->do($query) || bail_out("Can not do query:/n$query",$back);
		}
		$dbh->do("FLUSH PRIVILEGES") || bail_out("Can not flush privileges",$back);
		return
	}
	else {
		my $accounts;
		foreach (@userlist){
			$accounts .= qq!<INPUT TYPE=CHECKBOX NAME="userlist" VALUE="$_" CHECKED> $_ <BR>\n!;
		}
		my $message;
		my $buttons;
		unless (@userlist){
			$message = "Please select from user list";
			$buttons = qq!<INPUT TYPE=SUBMIT NAME="" VALUE="Back">\n!;
		}
		else {
			$message = 'You are going to remove the folowing accounts';
			$buttons = qq!<INPUT TYPE=SUBMIT NAME="action" VALUE="REMOVE" style="color=#CC0000">!;
			$buttons .= qq!&nbsp;<INPUT TYPE=SUBMIT NAME="" VALUE="Cancel">\n!;
		}
		print <<EOT
<FORM ACTION="$full_url" METHOD=POST>
<B>$message</B><BR>
$accounts<P>
$buttons
<INPUT TYPE=HIDDEN NAME="page" VALUE="admin">
<INPUT TYPE=HIDDEN NAME="func" VALUE="access">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="confirm" VALUE="1">
</FORM>
EOT
;
	}

}
sub showGrants {
	my $back = {page => 'admin', func =>'access', dbname => "$database"};
	unless (check_version('3.23.4')){
		my $version = get_version();
		bail_out("Current version of mysql server ($version) does not allow this operation.\nYou need to upgrade mysql installation.", $back);
	}
	my @userlist = get_user_host();
	if (@userlist == 0){bail_out ("Please select from user list", $back)}
	foreach (@userlist){

		print "SHOW GRANTS FOR $_ <BR>";
		my ($sth, $res) = prepare_execute("SHOW GRANTS FOR $_", $back);
		print &printresult(\$sth), "<BR>";
		ErrMessage ("<BR>Print Result Error. $DBI::errstr") if $DBI::err;
	}
	bail_out('',$back);
}
sub getAnotherUser {
	my $user_  = $q->param('user1');
	my $host_  = $q->param('host1');
	my $add	   = ($host_ ne '') ? '@' : $q->param('add');
	$host_	   = $dbh->quote($host_) if $add;
	$user_	   = $dbh->quote($user_);
	return ($user_.$add.$host_)
}
sub get_user_host {
	my @userlist;
	if (defined $q->param('add')){
		$userlist[0] = getAnotherUser();
	}
	else {
		@userlist = $q->param('userlist');
	}
	return @userlist;
}
sub changePassword {
	my $back = {page => 'admin', func =>'access', dbname => "$database"};
#++++++++++++++++++++++++++++++++++++++

	my $new_password; 
	my $password_	 = $q->param('new_password');
	if ($password_ =~/\S/){
		$password_ = $dbh->quote($password_);
		$new_password = "PASSWORD($password_)"
	}
	else {$new_password = "''"}
	my $for;
	my $message;
	unless ($q->param('for') eq 'self'){
		my @userlist = get_user_host;
		bail_out ("Please select only one user name", $back) if (@userlist > 1);
		bail_out ("Please select from user list", $back) if (@userlist == 0);
		$for = "FOR $userlist[0]";
		$message = quoteit("New password was set for $userlist[0]")
	}
	else {$message = "My password was changed"}
	my $query = "SET PASSWORD $for = $new_password";
	$dbh->do($query) || bail_out("Can not set password.\n$query",$back);
	print $query;
#++++++++++++++++++++++++++++++++++++++
	bail_out ($message, $back);

}
sub loadAccessControl {

#++++++++++++++++++++++++++++++++++++++



	my $action				= $q->param('action');
	my $back				= $_[0];
	if ($action =~ /SHOW/i){showGrants();return}
	elsif ($action =~ /REMOVE/i){removeUser();return unless $q->param('confirm')}
	elsif ($action =~ /(GRANT)|(REVOKE)|(NEXT)|(CREATE)/i){loadGrantTables(); return}
	elsif ($action =~ /CHANGE/i){changePassword();return unless $q->param('confirm')}
	my $show_grants_button = qq!<INPUT TYPE=SUBMIT NAME="action" VALUE="SHOW GRANTS" style="Width: 150px" TITLE="Show grants for selected users">!;
	my $selectdbname_ 		= $q->param('selectdbname_');
	my ($userlist, $labels) = getuserlist();
#	unshift @$userlist, ''; 
	my $num_of_acc; my $myuser;
	if ($userlist->[0] =~/@/){$num_of_acc  = "<B>".(scalar @$userlist)." accounts found</B>"}
	else {
		if ($userlist->[0] == 1){
			$myuser = <<EOT
<TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<TR>
		<TD ALIGN=CENTER>user</TD><TD>&nbsp;</TD><TD ALIGN=CENTER>host</TD>
	</TR>
	<TR>
		<TD><INPUT TYPE=TEXT NAME="user1" SIZE=10 TITLE="User name"></TD>
		<TD><SELECT NAME="add">
					<OPTION VALUE="">
					<OPTION VALUE="\@" SELECTED>@
			</SELECT></TD>
		<TD><INPUT TYPE=TEXT NAME="host1" SIZE=10 TITLE="Host name"></TD>
	</TR>
</TABLE>
EOT
;
		}
		$num_of_acc = ''}
	
	my $SelectUser	= $q->scrolling_list(
		   		  	 			   		-name		=> 'userlist',
										-value		=> $userlist,
										-labels		=> $labels,
										-multiple	=> 1,
										-size		=> 8
								);
	my ($other_users, $alt_hostname, $reload);
	my $apply		= 'NEXT>>';
	my $new_num		= $q->param('new_num');
	my $uh 			= $q->param('alt_hostname');
	$new_num =~ s/^\s*(.+)\s*$/$1/;
	if (($new_num =~ /\d+/) and ($new_num > 0)){
		$other_users = <<EOT
		<TABLE BORDER=0>
			<TR>
				<TD>&nbsp;</TD><TD>USER</TD><TD>PASSWORD</TD><TD>HOST</TD><TD>&nbsp;</TD>
			</TR>
EOT
;
		$reload			= qq!<INPUT TYPE=SUBMIT VALUE="Reload"><INPUT TYPE=RESET>!;
		my @un 			= $q->param('user_name');
		my @up 			= $q->param('user_password');
		my @uh;
		my $uh			= quoteit($uh);
		$apply			= 'Apply';
		if ($q->param('apply_alt_host')){for(1..$new_num){push @uh, $uh}}
		else {@uh = $q->param('user_host');@uh = quoteit @uh}
		@un 	= quoteit @un;
		@up 	= quoteit @up;
		for(0..$new_num-1){
			my $create_button = $_ ? "&nbsp;" : qq!<INPUT TYPE=SUBMIT NAME="action" VALUE="NEXT>>" TITLE="Show privileges">! ;
			my $n = $_ + 1;
			$other_users .= <<EOT
			<TR>
				<TD>$n</TD><TD><INPUT TYPE=TEXT SIZE=20 NAME="user_name" VALUE="$un[$_]" TITLE="User name"></TD>
				<TD><INPUT TYPE=TEXT SIZE=20 NAME="user_password" VALUE="$up[$_]" TITLE="Password"></TD>
				<TD><INPUT TYPE=TEXT SIZE=20 NAME="user_host" VALUE="$uh[$_]" TITLE="Host name or IP"></TD>
				<TD>$create_button</TD>
			</TR>
EOT
;

		}
		$other_users .=	"\n\t\t</TABLE>\n";	

	}
	elsif($new_num =~ /\S/){
		$other_users .= qq!<FONT COLOR="#FF0000">"Number of accounts" field must contain a number &gt; 0</FONT>!;
		$new_num = '';
	}
	else {$other_users = "&nbsp;"; $new_num = '';}
	unless (defined $new_num){$new_num = 1}
	my $textsize = $agent ? 15 : 20 ;
	$alt_hostname =<<EOT
&nbsp;&nbsp;&nbsp;
			<I>Use this host name for all accounts</I>&nbsp;
			<INPUT TYPE=TEXT NAME="alt_hostname" VALUE="$uh" SIZE=20 TITLE="Type host name and click '$apply'">&nbsp;
			<INPUT TYPE=SUBMIT NAME="apply_alt_host" VALUE="$apply" TITLE="Click here to apply this host name to all accounts">
$reload
EOT
;

	print <<EOT

<!-- MAIN TABLE1 STARTS -->
<TABLE  BORDER=0>
	<TR><TH ALIGN=LEFT>ADMINISTRATION -> ACCESS CONTROL</TH></TR>
	<TR>
		<TD><FORM ACTION="$full_url" METHOD=POST>
	<TABLE WIDTH="100%" BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR><!-- Grant, Revoke, Show -->
			<TD VALIGN=TOP ALIGN=RIGHT WIDTH="50%"><P>
		<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%" >
			<TR>
				<TD width="100%"><!-- BORDER START -->
    		<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=0 ALIGN=LEFT BGCOLOR="#CCCCCC" WIDTH="100%" >
				   <TR><TD><P><BR><INPUT TYPE=SUBMIT NAME="action" VALUE="      GRANT     " style="Width: 150px" TITLE="Grant privileges to selected users"></TD><!-- BUTTONS -->
					<TD ROWSPAN=5 TITLE="Select user"><!-- SELECT USER -->
$num_of_acc <BR>
$SelectUser
<BR>
$myuser
		   			</TD>
					</TR>
					<TR><TD><P><INPUT TYPE=SUBMIT NAME="action" VALUE="     REVOKE     " style="Width: 150px" TITLE="Revoke privileges from selected users"></TD></TR>
					<TR><TD><P><INPUT TYPE=SUBMIT NAME="action" VALUE="    REMOVE     " style="Width: 150px; color=#CC0000" TITLE="Remove selected users"></TD></TR>
					<TR><TD><P>$show_grants_button</TD></TR>
					<TR HEIGHT=25><TD HEIGHT=25 ><P>&nbsp;</TD></TR>
    		</TABLE>
		</TD></TR></TABLE>
			</TD><!-- End of Grant, Revoke, Show --><TD>&nbsp;&nbsp;</TD>
			<TD VALIGN=TOP WIDTH="50%"><!-- Change Password -->
    		
			
			<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%" >
			<TR>
				<TD width="100%"><!-- BORDER START -->
			<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%">
				<TR>
					<TD VALIGN=BOTTOM >
					<INPUT TYPE=SUBMIT NAME="action" VALUE="CHANGE PASSWORD" style="width: 180px" TITLE="Change password"></TD>
					<TD VALIGN=BOTTOM>&nbsp;&nbsp;&nbsp;New&nbsp;Password</B><BR>
					<INPUT TYPE=TEXT NAME="new_password" SIZE=$textsize TITLE="Type new password"></TD>
				</TR>
				<TR>
					<TD COLSPAN=2>
					<INPUT TYPE=RADIO NAME="for" CHECKED TITLE="Change password for selected user">For selected user
					<INPUT TYPE=RADIO NAME="for" VALUE="self" TITLE="Change my password">For myself
					</TD>
				</TR>
    		</TABLE>
			</TD></TR></TABLE><BR>
			
		<!--	<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" WIDTH="100%">
			<TR>
				<TD width="100%">
			<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%">
				<TR>
					<TD VALIGN=BOTTOM >
					<INPUT TYPE=SUBMIT NAME="host_priv" VALUE="  HOST PRIVILEGES " style="width: 180px" TITLE="Assign host privilege"></TD>
				</TR>
    		</TABLE>
			</TD></TR></TABLE> -->
    		
    		
			</TD>
		</TR><!-- End of Change Password -->
		
	</TABLE>
	
<INPUT TYPE=HIDDEN NAME="page" VALUE="admin">
<INPUT TYPE=HIDDEN NAME="func" VALUE="access">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="selectdbname_" VALUE="$selectdbname_">

</FORM>
		</TD>
	</TR>
	<TR>
		<TD><HR SIZE=1></TD>
	</TR>
	<TR>
		<TD><FORM ACTION="$full_url" METHOD=POST><P><B>
CREATE</B>&nbsp;<INPUT TYPE=TEXT SIZE=3 MAXLENGTH=3 NAME="new_num" VALUE="$new_num" TITLE="Type number of new accounts to be created"><B>&nbsp;ACCOUNTS</B>$alt_hostname<BR>


$other_users
<INPUT TYPE=HIDDEN NAME="page" VALUE="admin">
<INPUT TYPE=HIDDEN NAME="func" VALUE="access">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
<INPUT TYPE=HIDDEN NAME="selectdbname_" VALUE="$selectdbname_">

</FORM>
		</TD>
	</TR>
</TABLE>
<!-- MAIN TABLE ENDS -->



EOT
;
return


}
sub loadGrantTables {
# $_[0] contains $back
	my $back = {page => 'admin', func =>'access', dbname => "$database"};
	my @userlist = get_user_host();
	my $action = $q->param('action');
	my $num;
	my ($hidden_userlist, $hidden_password, $hidden_glob, $hidden_db, $hidden_table, $hidden_column);
	my @global = $q->param('global');
	my %global_lables = (
	'SELECT'					=>'Select_priv',
	'INSERT'					=>'Insert_priv',
	'UPDATE'					=>'Update_priv',
	'DELETE'					=>'Delete_priv',
	'CREATE'					=>'Create_priv',
	'DROP'						=>'Drop_priv',
	'RELOAD'					=>'Reload_priv',
	'SHUTDOWN'					=>'Shutdown_priv',
	'PROCESS'					=>'Process_priv',
	'FILE'						=>'File_priv',
	'GRANT'						=>'Grant_priv',
	'REFERENCES'				=>'References_priv',
	'INDEX'						=>'Index_priv',
	'ALTER'						=>'Alter_priv',
	'CREATE TEMPORARY TABLES'	=>'Create_tmp_table_priv',
	'EXECUTE'					=>'Execute_priv' ,
	'LOCK TABLES'				=>'Lock_tables_priv' ,
	'REPLICATION CLIENT'		=>'Repl_client_priv',
	'REPLICATION SLAVE'			=>'Repl_slave_priv',
	'SHOW DATABASES'			=>'Show_db_priv',
	'SUPER'						=>'Super_priv'
	);
	my @database_values = (
	'SELECT', 'INSERT','UPDATE','DELETE','CREATE', 'DROP', 'REFERENCES', 'INDEX', 'ALTER'
	);
	
	my $table_values = [
	'SELECT', 'INSERT','UPDATE','DELETE','CREATE', 'DROP', 'REFERENCES', 'INDEX', 'ALTER', 'GRANT', ''
	];
	my $column_values = ['SELECT', 'INSERT','UPDATE','REFERENCES'];
	my ($textsize, $textareasize) = $agent ? (12, 70) : (19, 100) ;
	my @password = $q->param('user_password') if ($action =~ /next/i or $action =~ /create/i);
	if($action =~ /next/i){
		$action = 'create';
		my $userlist_ 	= getuserlist();
		@userlist			= ();
		my @username		= $q->param('user_name');
		my @host;
		@host = $q->param('user_host');
		$num 				= scalar @username;
		my @username_		= @username;
		my @password_		= @password;
		my @host_			= @host;
		$back->{new_num}	= $q->param('new_num');
		$back->{user_name} = \@username_;
		$back->{user_host} = \@host_;
		$back->{user_password} = \@password_;
		# do revike
		#return
		for (my $i = 0; $i<$num; $i++){
			$password[$i] 	=~ s/^\s*(\S*.*\S)\s*$/$1/;
			$password[$i] 	= $dbh->quote($password[$i]) if ($password[$i] ne '');
			$host[$i] 		=~ s/^\s*(\S*.*\S)\s*$/$1/;
			bail_out("Illegal host name '$host[$i]'", $back) if $host[$i] =~ /\s/;
			$host[$i]		= $dbh->quote($host[$i]);
			$username[$i] 	=~ s/^\s*(\S*.*\S)\s*$/$1/;
			bail_out("Illegal user name '$username[$i]'", $back) if $username[$i] =~ /\s/;
			$username[$i]	= $dbh->quote($username[$i]);
			if (belongs \@userlist, "$username[$i]\@$host[$i]") {
				bail_out("The entry $username[$i]\@$host[$i] is duplicated.\nCheck user/host names.", $back);
			}
			if (belongs $userlist_, "$username[$i]\@$host[$i]") {
				bail_out("The entry $username[$i]\@$host[$i] already exists.\nCheck user/host names.", $back);
			}
			push @userlist,"$username[$i]\@$host[$i]";
		}
	}
	elsif ($action =~/(grant)|(create)|(revoke)/i){
		$num = scalar @userlist
	}

	my $back_; my @query; 
	my @x = $q->param();
	foreach (@x){
		my @y	 	= $q->param($_);
		$back_->{$_} = [@y];
	}
	undef  $back_->{'create'};
	$action					= uc $action;
	my $s 					= 'S' if $num > 1;
	my $num_				= $num;
	$num_ 					= '' if $num == 1;
	my $actionDescr 		= ($action eq "CREATE") ? "CREATE $num_ NEW ACCOUNT$s" : "$action PRIVILEGES" ;
	my $count = 0;
	
	if ($q->param('create') and !$q->param('after_preview')){
		my $v4opt;
		{
			$v4opt = sub {
				return {} if $count;
				my $with = shift || "\n";
				my $errmessage;
				my $grant_opt;
				my $queriesph = deletespace($q->param('queriesph'));
				if ($queriesph ne ''){
					if (($queriesph =~ /^\d+$/) or ($queriesph =~ /^\d*\.?\d+e?\d+$/i) or ($queriesph =~ /^\d+\.?\d*e?\d+$/i)){
						$grant_opt	.= "$with  MAX_QUERIES_PER_HOUR $queriesph ";
						$with		= '';
					}
					else{
						$errmessage .= "Value MAX_QUIRIES_PER_HOUR must be Numeric\n"
					}
				}
				my $updatesph		= deletespace($q->param('updatesph'));
				if($updatesph ne ''){
					if (($updatesph =~ /^\d+$/) or ($updatesph =~ /^\d*\.?\d+e?\d+$/i) or ($updatesph =~ /^\d+\.?\d*e?\d+$/i)){
						$grant_opt	.= "$with MAX_UPDATES_PER_HOUR $updatesph ";
						$with		= '';
					}
					elsif(!$errmessage){
						$errmessage .= "Value MAX_UPDATES_PER_HOUR must be Numeric\n"
					}
				}
				my $connectionsph	= deletespace($q->param('connectionsph'));
				if ($connectionsph ne ''){
					if (($connectionsph =~ /^\d+$/) or ($connectionsph =~ /^\d*\.?\d+e?\d+$/i) or ($connectionsph =~ /^\d+\.?\d*e?\d+$/i)){
						$grant_opt	.= "$with MAX_CONNECTIONS_PER_HOUR $connectionsph ";
					}
					elsif(!$errmessage){
						$errmessage .= "Value MAX_CONNECTIONS_PER_HOUR must be Numeric\n"
					}
				}
				if ($errmessage){bail_out($errmessage, $back_)}
				my $v4output;
				$v4output->{max} = "$grant_opt";
				
		
				my $require;
				if ($q->param('require')){
					if ($q->param('require_opt') eq 'none'){$require = "\nREQUIRE NONE"}
					if ($q->param('require_opt') eq 'ssl'){$require = "\nREQUIRE SSL"}
					if ($q->param('require_opt') eq 'x509'){$require = "\nREQUIRE X509"}
					if ($q->param('require_opt') eq 'other'){
						my $req = "\nREQUIRE";
						if (my $cipher	= deletespace($q->param('cipher'))){$require .= qq!$req CIPHER "$cipher"!; $req = "\n\t"}
						if (my $issuer	= deletespace($q->param('issuer'))){$require .= qq!$req ISSUER "$issuer"!; $req = "\n\t"}
						if (my $subject	= deletespace($q->param('subject'))){$require .= qq!$req SUBJECT "$subject"!}
					}
				}
				$v4output->{req} = "$require";
				return $v4output;
			};
		}
		my $ident;
		my $with = "\nWITH";
		my $global_priv	= $q->param('global_priv');
		my $db_priv		= $q->param('db_priv');
		my $table_priv	= $q->param('table_priv');
		my $column_priv	= $q->param('column_priv');
		if ($global_priv and ($global[0]  or !($db_priv or $table_priv or $column_priv))){
			my $priv_type;
			my $grant_opt;
			my @privileges		= @global;
			my @to				= @userlist;
			$ident				= 1;
			shift @privileges 		if ($privileges[0]	eq '');
			my $t;
			until($privileges[-1]){pop @privileges; last unless @privileges}
			my $max = check_version('4.0.2') ? 20 : 13;
			if ($action =~ /revoke/i){
				if  ($privileges[-1] eq 'GRANT'){
					$privileges[-1] = 'GRANT OPTION';
					$priv_type = join (', ', @privileges)
				}
				elsif (scalar @privileges == $max){$priv_type = ' ALL'}
				elsif (scalar @privileges == 0) {$priv_type = ' USAGE'}
				else {$priv_type = join (', ', @privileges)}
				my $to = join ', ', @to;
				push @query, "REVOKE $priv_type ON *.* FROM \n$to$grant_opt\n";
			}
			else {
				if ($privileges[-1] eq 'GRANT'){
					$grant_opt = "$with GRANT OPTION";
					pop @privileges;
					$with = '';
				}
				my $v4output = &$v4opt($with);
				$count = 1;
				$grant_opt .= $v4output->{max};
				my $require = $v4output->{req};
				if (scalar @privileges == $max){$priv_type = ' ALL'}
				elsif (scalar @privileges == 0) {
					$priv_type = ' USAGE'
				}
				else {$priv_type = join (', ', @privileges)}
				for(my $i=0; $i < $num; $i++){
					$to[$i]	.= " IDENTIFIED BY $password[$i]" if $password[$i];
				}
				my $to = join ', ', @to;
				push @query, "GRANT $priv_type \nON *.* TO $to $require$grant_opt\n";
			}
		}
		if ($db_priv){
			my @query3 				= (); #
			my $priv_type;
			my $grant_opt;
			my @db					= $q->param('d_db');
			shift @db unless $db[0];
			my @other_db			= split ',', $q->param('d1_db');
			my @db3;
			my $i;
			foreach(@other_db){
				my $db = $_;
				$db = deletespace($db);
				next if ($db eq '');
				next if belongsb (\@db, $db);
				my $chars;
				while($db =~ /(?=(\W)(.?))/g){
					if ($1 eq "\\"){
						$chars .= $1 unless ($2 eq '_')
					}
					elsif(($1 ne '?') and ($1 ne '%')){
						if ($1 eq ' '){$chars .= 'SPACE '}	
						elsif ($1 eq "\t"){$chars .= 'TAB '}
						else {$chars .= $1}
					}
				}
						bail_out("Illegal characters $chars in database name '$db'.\n", $back_) if $chars;
				
				my $db_temp = $db;
				$db_temp =~ s/\?//ig;
				if ($db =~ /^[a-zA-Z0-9_\$]*$/){push @db, $db}			# legal db names
				elsif ($db !~ /\?/){push @db, "`$db`"} 					# db names with non-alphanumeric chars but the `?'
				elsif ($db_temp =~ /^[a-zA-Z0-9_\$]*$/){push @db3,$db}  # legal db names with `?' variable
				else {push @db3, "`$db`"} 								# names with non-alphanumeric chars and `?'
			}
			bail_out("Database privileges failed.\nNo database was selected.\n\n", $back_) unless (@db or @db3);
			my @privileges			= $q->param('database');
			shift @privileges 		if ($privileges[0]	eq '');		
			until($privileges[-1]){pop @privileges; last unless @privileges}
			my ($priv_cols, @priv_cols);
			foreach (@privileges){
				$priv_cols .= ", $global_lables{$_}";
				push @priv_cols, $global_lables{$_};
			}
					
    		my (@query2, $j, @values1, @set, $set);
			my $max = check_version("4.0.4") ? 11 : 9;
			if ($action =~ /revoke/i){
				my @privileges_ = @privileges;
				if  ($privileges[-1] eq 'GRANT'){
					$privileges[-1] = 'GRANT OPTION';
					$priv_type = join (', ', @privileges)
				}
    			elsif (scalar @privileges == $max){$priv_type = ' ALL'}
    			elsif (scalar @privileges == 0) {$priv_type = ' USAGE'}
    			else {$priv_type = join (', ', @privileges)}
    			my @query1; my @where_delete; my @where_update;
    			my @to 		= @userlist;
    			my @to1		= @to;
				for(my $i=0; $i < $num; $i++){
    				
					if (@db3) {
    					$userlist[$i]		=~ /^'(.*)'\@'(.*)'/;
						my $username 		= $1;
	    				my $hostname		= $2;
						foreach (@db3){
							my $db3 = $_;
							$db3	=~ s/\?/$username/gi;
							unless (belongs(\@db, $db3)){
    							push @query3, "REVOKE $priv_type \n ON $db3\.* \n FROM '$username'\@'$hostname'\n";
							}
						}
				
    				}#if (@db2)
				}#for(my $i=0; $i < $num; $i++)
    			my $to = join ', ',@to;
    			my $to1 = join ', ',@to1;
    			if ($db[0]){
    				push @query, "REVOKE $priv_type \n ON $db[0]\.* \n FROM $to\n";
    				shift @db;
    			}
    			foreach (@db){
    				push @query, "REVOKE $priv_type \n ON $_\.*  \n FROM $to1\n";

    			}
			}
			else{#create, grant
				if  ($privileges[-1] eq 'GRANT'){
					$grant_opt		= " \nWITH GRANT OPTION";
					pop @privileges;
					$with = '';
				}
    			if (scalar @privileges == $max){$priv_type = ' ALL'}
    			elsif (scalar @privileges == 0) {$priv_type = ' USAGE'}
    			else {$priv_type = join (', ', @privileges)}
    			my @query1;
    			my @to 		= @userlist;
    			my @to1		= @to;
				my @where_update;
    			for(my $i=0; $i < $num; $i++){
    				if (@db){
    					$to[$i]	.= " IDENTIFIED BY $password[$i]" if (($password[$i] ne '') and !$ident);
    				}
    				if (@db3) {
    					$userlist[$i]		=~ /^'(.*)'\@'(.*)'/;
    					my $username 		= $1;
    					my $hostname		= $2;
						my $count_			= $count;
    					if ($action =~ /create/i){
							my $ident_ = $ident;
							foreach (@db3){
								my $grant;
								unless(@db or $count_){
									my $v4output = &$v4opt($with);
									my $max = $v4output->{max};
									$count_ = 1;
									my $require = $v4output->{req};
									$grant = "$require$grant_opt$max";
								}
								my $db3 = $_;
								$db3	=~ s/\?/$username/ig;
								unless (belongs(\@db, $db3)){
									my $pw = "IDENTIFIED BY $password[$i]" unless ($ident_ or @db);
    								push @query3, "GRANT $priv_type \nON $db3.* \nTO '$username'\@'$hostname' $pw $grant\n";
								}
								$ident_ = 1;
							}
    					}
    					else { #GRANT
							foreach (@db3){
								my $grant;
								unless(@db or $count_){
									my $v4output = &$v4opt($with);
									my $max = $v4output->{max};
									$count_ = 1;
									my $require = $v4output->{req};
									$grant = "$require$grant_opt$max";
								}
								my $v4output = &$v4opt($with);
								my $max = $v4output->{max};
								my $require = $v4output->{req};
								my $db3 = $_;
								$db3	=~ s/\?/$username/gi;
								unless (belongs(\@db, $db3)){
    								push @query3, "GRANT $priv_type \nON $db3.* \nTO '$username'\@'$hostname' $grant\n";
								}
							}
    					}#else
    				}#if (@db3)
    			}#for(my $i=0; $i < $num; $i++)
    			my $to = join ', ',@to;
    			my $to1 = join ', ',@to1;

    			for (my $i=0; $i<@db; $i++){
					my $v4output = &$v4opt($with) unless $count;
					$count = 1;
					my $max = $v4output->{max};
					my $require = $v4output->{req};
    				unless ($i) {push @query,	"GRANT $priv_type \nON $db[0]\.* \nTO $to $require$grant_opt$max\n"}
    				else {push @query, 			"GRANT $priv_type \nON $db[$i]\.* \nTO $to1 $require$grant_opt$max\n"}
    			}
			}# create, grant

			push @query, @query3;
			
			$ident = 1;
		}

		if ($table_priv){
			my ($db, @tb);
			$db 			  = $q->param('t_db');
			@tb				  = $q->param('t_table');
			shift @tb unless $tb[0];
			$db = deletespace($db);
			bail_out("Table privileges failed.\nDatabase was not selected.\n\n", $back_) if ($db eq '');
			
			my @privileges		= $q->param('table_t');
			my $grant_opt		= '';
			my $priv_type		= '';
			shift @privileges 		if ($privileges[0]	eq '');
			until($privileges[-1]){pop @privileges; last unless @privileges}
   			my $ok = 0;
			if ($action =~ /revoke/i){
				if  ($privileges[-1] eq 'GRANT'){
					$privileges[-1] = 'GRANT OPTION';
					$priv_type = join (', ', @privileges)
				}
    			elsif (scalar @privileges == 9){$priv_type = ' ALL'}
    			elsif (scalar @privileges == 0) {$priv_type = ' USAGE'}
    			else {$priv_type = join (', ', @privileges)}

    			my @to = @userlist;
    			my @to1 = @to;
    			my $to = join ', ',@to;
    			my $to1 = join ', ',@to1;
    			if ($tb[0]){
    				$tb[0] =~ s/^\s*(.*)\s*$/$1/; 
    				$ok =1;
    				push @query, "REVOKE $priv_type \nON $db.$tb[0] FROM $to\n";
    				shift @tb
    			}
    			foreach (@tb){
    				s/^\s*(.*)\s*$/$1/;
    				next unless $_;
    				$ok =1;
    				push @query, "REVOKE $priv_type \nON $db.$_ FROM $to1\n "
    			}
			}
			else{
    			if ($privileges[-1] eq 'GRANT') {
    				$grant_opt = " \nWITH GRANT OPTION";
    				pop @privileges;
					$with = '';
				}
    			if (scalar @privileges == 9){$priv_type = ' ALL'}
    			elsif (scalar @privileges == 0) {$priv_type = ' USAGE'}
    			else {$priv_type = join (', ', @privileges)}
				
    			my @to = @userlist;
    			my @to1 = @to;
    			for (my $i=0; $i<$num; $i++){
					
    				if ($password[$i] and !$ident){$to[$i] .= " IDENTIFIED BY $password[$i]"} 
    			}
    			my $to = join ', ',@to;
    			my $to1 = join ', ',@to1;
				
    			if ($tb[0]){
    				$tb[0] =~ s/^\s*(.*)\s*$/$1/; 
    				$ok =1;
					my $v4output = &$v4opt($with) unless $count;
					$count = 1;
					my $max = $v4output->{max};
					my $require = $v4output->{req};
    				push @query, "GRANT $priv_type \nON $db.$tb[0] \nTO $to $require$grant_opt$max\n";
    				shift @tb
    			}
    			foreach (@tb){
    				s/^\s*(.*)\s*$/$1/;
    				next unless $_;
    				$ok =1;
    				push @query, "GRANT $priv_type \nON $db.$_ \nTO $to1 $grant_opt\n "
    			}
			}			
			bail_out("Table privileges failed.\nTable was not selected.\n\n", $back_) unless $ok;
			$ident = 1;
		}
		if ($column_priv){
			my ($db, $tb, @col, $col);
			$db 			= $q->param('c_db');
			$tb				= $q->param('c_table');
			@col			= $q->param('c_column');
			$db =~ s/^\s*(.*)\s*$/$1/;
			bail_out("Column privileges failed.\nDatabase was not selected.\n\n", $back_) if ($db eq '');
			$tb =~ s/^\s*(.*)\s*$/$1/;
			bail_out("Column privileges failed.\nTable was not selected.\n\n", $back_) if ($tb eq '');
			my @privileges		= $q->param('column');
			my $priv_type		= '';
			shift @privileges 		if ($privileges[0]	eq '');
			until($privileges[-1]){pop @privileges; last unless @privileges}
			if (scalar @privileges == 0) {bail_out("Error. Column privileges are not selected", $back_)}
			else {$priv_type = join (', ', @privileges)}
			my @to = @userlist;
			for (my $i=0; $i<$num; $i++){
				$to[$i] .= " IDENTIFIED BY $password[$i]" if ($password[$i] and !$ident)
			}
			my $to = join ', ',@to;
			my @col_ = ();
			foreach (@col){
				s/^\s*(.*)\s*$/$1/;
				next unless $_;
				push @col_,$_
			}
			bail_out("Column privileges failed.\nColumn was not selected.\n\n", $back_) unless @col_;
			$col = join ', ',@col_;
			if ($action =~ /revoke/i){push @query, "REVOKE $priv_type ($col) \nON $db.$tb FROM $to\n "}
			else {

				my $v4output = &$v4opt($with) unless $count;
				$count = 1;
				my $max = $v4output->{max};
				my $require = $v4output->{req};
				push @query, "GRANT $priv_type ($col) ON $db.$tb \nTO $to $require$max\n "
			}
			$ident = 1;
		}
	}
	print <<EOT
<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=0 WIDTH=650>
		<TR><FORM ACTION="$full_url" METHOD=POST>
			<TH ALIGN=LEFT WIDTH=550>
			ADMINISTRATION -> ACCESS CONTROL -> $actionDescr </TH>
			<TH WIDTH=100 ALIGN=RIGHT VALIGN=CENTER>
			<INPUT TYPE=SUBMIT VALUE="Cancel">
			<INPUT TYPE=HIDDEN NAME="page" VALUE="admin">
			<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
			<INPUT TYPE=HIDDEN NAME="func" VALUE="access">
			</TH></FORM>
		</TR>
</TABLE>
EOT
;
	if ($q->param('create')){
	
        if ($q->param('preview')){
        	undef $back_->{'preview'};
			$back_->{'after_preview'} = '1';
			print qq!\n<FORM ACTION="$full_url" METHOD=POST>!;
			print qq!<P><TABLE><TR><TD></TD><TD>The following queries were generated:!;
			print qq!\n<B><INPUT TYPE=SUBMIT NAME="create" VALUE="Confirm" style="font-weight: bold" TITLE="Proceed with selected options"></B>\n!;
			print qq!\n<INPUT TYPE=SUBMIT VALUE="Back" TITLE="Back to edit privileges"></TD></TR>\n!;
			
			@query = quoteit(@query);
			my $i = 1;
			foreach (@query){
				$_ = deletespace($_);
				next unless ($_);
				my $count;
				while(/\n/g){$count++; last if $count > 8}
				my $rows = $count+1;
				if ($rows < 2){$rows = 2}
				print qq!\t<TR><TD>$i</TD><TD><TEXTAREA NAME="query" COLS=$textareasize ROWS=$rows  WRAP=OFF>$_</TEXTAREA></TD></TR>\n!;
				$i++;
			}
			print "</TABLE>\n";
			foreach (keys %$back_){
            		print $q->hidden(-name=>$_, -value=>$back_->{$_}, -override=>1),"\n";
			}

			print qq!\n</FORM>!;
			return

        }
		else {
			if ($q->param('after_preview')){@query = $q->param('query')}
			my $i=0;
			
			print "<P>";
			my $message;
			#$dbh->{AutoCommit} = 0;
			foreach(@query){
				next unless $_;
				$i++;
				my $query = quoteit $_;
				$query =~ s/$/<BR>/mg;
				print"$i) $query<BR>";
				next if  /^\/\*\s*error/i;
				my $message_ = '';
				my $res = $dbh->do($_);
				if ($dbh->err()){
					$message_		= quoteit($DBI::errstr);
					$message_		=~ s/^/<BR>/mg;
					$message_		= "Error  $DBI::err (<B>$message_ </B>)\n\n" ;
				}
				elsif (/^\s*((INSERT)|(DELETE)|(UPDATE))\s/i and ($res == 0)){
					$message_ = "<B>The result of this query is zero. Probably the privileges have been set/revoked before.</B>\n\n";
				}
				print "<P>$message_<BR>\n" if $message_;
				print "_" x 30, "<P>\n";
				$message .= $message_
			}
			#$dbh->commit() or bail_out("", $back_);
			#$dbh->{AutoCommit} = 1;
			print "<B>Result: OK</B>\n\n" unless $message;
			print qq!\n<FORM ACTION="$full_url" METHOD=POST>!;
			print qq!\n<INPUT TYPE=SUBMIT VALUE="Back" TITLE="Back to privileges"></TD></TR>\n!;
			foreach (keys %$back_){
            		print $q->hidden(-name=>$_, -value=>$back_->{$_}, -override=>1),"\n";
			}

			print qq!\n</FORM>!;
			return
        }
	}
		

	@password = quoteit(@password);
	foreach (@password){
		$hidden_password .= "\t<INPUT TYPE=HIDDEN NAME=\"user_password\" VALUE=\"$_\">\n";
	}
	bail_out("User(s) not defined", $back) unless (@userlist);

	@userlist = quoteit(@userlist);
	foreach (@userlist){
		$hidden_userlist .= "\t<INPUT TYPE=HIDDEN NAME=\"userlist\" VALUE=\"$_\">\n";
	}
	my $globs	= 1 if (($q->param('global_priv') or $q->param('global_priv_on')) and !$q->param('global_priv_off'));
	my $dbs	  	= 1 if (($q->param('db_priv') or $q->param('db_priv_on')) and !$q->param('db_priv_off'));
	my $tables	= 1 if (($q->param('table_priv') or $q->param('table_priv_on')) and !$q->param('table_priv_off'));
	my $columns	= 1 if (($q->param('column_priv') or $q->param('column_priv_on')) and !$q->param('column_priv_off'));
	if ($globs) {$hidden_glob = qq!<INPUT TYPE=HIDDEN NAME="global_priv" VALUE="on">!}
	if ($dbs) {$hidden_db = qq!<INPUT TYPE=HIDDEN NAME="db_priv" VALUE="on">!}
	if ($tables) {$hidden_table = qq!<INPUT TYPE=HIDDEN NAME="table_priv" VALUE="on">!}
	if ($columns) {$hidden_column = qq!<INPUT TYPE=HIDDEN NAME="column_priv" VALUE="on">!}

	my $d_db			= $q->param('d_db');
	my $t_db			= $q->param('t_db');
	my $c_db			= $q->param('c_db');
	my $dblistref 		= getdblist($dbh);
	my @dblist;
	my ($d_dblist, $t_dblist, $c_dblist);
	if ($DBI::err and !$database) {
		$d_dblist	= $q->scrolling_list(
										-name		=> 'd_db',
										-values		=> [''],
										-labels		=> {'' => 'ACCESS DENIED'},
										-size		=> 4,
										-multiple	=>1										
					);
		$t_dblist	= $q->scrolling_list(
										-name		=> 't_db',
										-values		=> [''],
										-labels		=> {'' => 'ACCESS DENIED'},
										-size		=> 1,
					);
		$c_dblist	= $q->scrolling_list(
										-name		=> 'c_db',
										-values		=> [''],
										-labels		=> {'' => 'ACCESS DENIED'},
										-size		=> 1,
					);	
	}
	else {
		@dblist		= @$dblistref;
		unshift		@dblist, '';
		$d_dblist	= $q->scrolling_list(
										-name		=> 'd_db',
										-values		=> \@dblist,
										-size		=> 6,
										-multiple	=>1										
					);
		$t_dblist	= $q->scrolling_list(
										-name		=> 't_db',
										-values		=> \@dblist,
										-size		=> 1,
										-default	=> '',
										-onChange	=> 'this.form.submit()'
					);
		$c_dblist	= $q->scrolling_list(
										-name		=> 'c_db',
										-values		=> \@dblist,
										-size		=> 1,
										-default	=> '',
										-onChange	=> 'this.form.submit()'
					);
		}
	my $t_table		= $q->param('t_table');
	my $c_table		= $q->param('c_table');
	my $t_tablelist;
	my $c_tablelist;
	my $T_Table;
	my $database_checkbox;
	my $d1_db;
	my ($C_Other_Db, $C_Other_Table, $C_Other_Column);
	if ($t_db){
		$back_->{t_db} = '';
		my @t_tablelist;
		my $sth = $dbh->prepare("SHOW TABLES FROM $t_db") || bail_out("Cannot prepare query\nSHOW TABLES FROM $t_db");
		my $res = $sth->execute();
		if ($DBI::err){
			if ($DBI::errstr =~ /(access)|(denied)/i){
				$t_tablelist = <<EOT
<SELECT NAME="t_table">
<OPTION VALUE="">ACCESS DENIED
</SELECT>
EOT
;
			}
			else {bail_out("Cannot execute query:\nSHOW TABLES FROM $t_db", $back_)}
		}
		else{
			my $i = 0;
			while(my ($tab) = $sth->fetchrow_array){
				push @t_tablelist, $tab;
				if ($i++ > 100){bail_out("", $$back_)}
			}
			$back_->{t_db} = $t_db;
			my $size		= scalar @t_tablelist;
			unshift 		@t_tablelist, '';
			if ($size == 0){
				$t_tablelist = $q->scrolling_list(
		   		  	 			   		-name		=> 't_table',
										-value		=> '',
										-labels		=> {'' => "Table list is empty\n"},
										-size		=> 1
							) ;
			}
			else {
				if ($size > 7) {$size	= 8} else {$size = $size + 1} ;
				$t_tablelist = $q->scrolling_list(
										-name		=> 't_table',
										-values		=> \@t_tablelist,
										-size		=> $size,
										-multiple	=> 1
							);
			}
		}
		$T_Table	=<<EOT
				<TR>
					<TD TITLE="Select one or more tables"><B>Table</B></TD>
					<TD TITLE="Select one or more tables" ALIGN=RIGHT>$t_tablelist</TD>
				</TR>
EOT
;
	}
	else {
		$t_tablelist = $q->scrolling_list(
									-name   => 't_table',
									-value  => '',
									-labels  => {'' => "DB is not selected\n"},
									-size	=> 1
					);
		$T_Table	=<<EOT
				<TR>
					<TD TITLE="Select a database in the scrolling list above"><B>Table</B></TD>
					<TD TITLE="Select a database in the scrolling list above" ALIGN=RIGHT>$t_tablelist</TD>
				</TR>
EOT
;
	}
	my @c_tablelist; 
	my $C_Table;
	my $columnlist;
	my $column		= $q->param('column');
	unless ($q->param('column_priv_off')){
		if ($c_db){
			$back_->{c_db} = '';
			@c_tablelist = @{getTablelist($c_db, $back_)};
			$back_->{c_db} = $c_db;
			unshift 		@c_tablelist, '';
			if (@c_tablelist == 1){
				$c_tablelist = $q->scrolling_list(
		   		  	 			   		-name		=> 'c_table',
										-value		=> '',
										-labels		=> {'' => "Table list is empty\n"},
										-size		=> 1
							);
			}
			else {
				$c_tablelist = $q->scrolling_list(
										-name		=> 'c_table',
										-values		=> \@c_tablelist,
										-size		=> 1,
										-onChange	=> 'this.form.submit()'
							);
			}
			$C_Table = <<EOT
				<TR>
					<TD TITLE="Select table"><B>Table</B></TD>
					<TD ALIGN=RIGHT TITLE="Select table">$c_tablelist</TD>
				</TR>
EOT
;
		}
		else{
			$c_tablelist = $q->scrolling_list(
									-name		=> 'c_table',
									-value		=> '',
									-labels		=> {'' => "DB is not selected\n"},
									-size		=> 1
					);
			$C_Table = <<EOT
				<TR>
					<TD TITLE="Select a database in the scrolling list above"><B>Table</B></TD>
					<TD ALIGN=RIGHT TITLE="Select a database in the scrolling list above">$c_tablelist</TD>
				</TR>
EOT
;

		}	
	
			my $title;
			if ($c_table and belongs(\@c_tablelist, $c_table)) {
				my @columnlist = ();
				my $size;
				my $multiple = 0;
				#$back_->{column_priv_off} = 1;
				$back_->{c_table} = '';
				my $sth		= $dbh->prepare("DESCRIBE $c_db.$c_table") || bail_out ("Cannot prepare query:\n$query", $back_);
				my $res		= $sth->execute();
				if ($DBI::err){
					if ($DBI::errstr =~ /(denied)|(access)/i){
						@columnlist = ('ACCESS DENIED');
						$size = 1;
						$multiple = 0;
					}
					else {bail_out("Cannot execute query:\n$query", $back_)}
				}
				else {
					while (my @row = $sth->fetchrow_array){
						push @columnlist, $row[0];
					}
					unshift @columnlist,'';
					$size = scalar @columnlist;
					if ($size > 7) {$size	= 8};
					$multiple = 1
				}
				$sth->finish;
				$columnlist = $q->scrolling_list(
									-name		=> 'c_column',
									-values		=> \@columnlist,
									-size		=> $size,
									-multiple	=> $multiple
							);
				$title = "Select one or more columns."
			}
			else {
				$columnlist = $q->scrolling_list(
									-name		=> 'c_column',
									-value		=> '',
									-labels		=> {'' => "Table is not selected\n"},
									-size		=> 1
						);
				$title = 'Select a table in the scrolling list above';
			}
			$columnlist = <<EOT
				<TR>
					<TD TITLE="$title"><B>Column</B></TD>
					<TD ALIGN=RIGHT TITLE="$title">$columnlist</TD>
				</TR>
EOT
;
		
	}
	my $global_priv 	= $globs	? 'global_priv_off' : 'global_priv_on';
	my $db_priv			= $dbs		? 'db_priv_off'	 	: 'db_priv_on';
	my $table_priv		= $tables	? 'table_priv_off'	: 'table_priv_on';
	my $column_priv		= $columns	? 'column_priv_off'	: 'column_priv_on';

	my $v402 = sub {
		return '' if $action =~ /REVOKE/i;
		my $color			= "#000000";
		my $color_max		= "#000000";
		my $disabled		= '';
		my $disabled_max 	= '';
		my $title_req;
		my $title1;
		my $title_maxq;
		my $title_maxu;
		my $title_maxc;
		my $queriesph;
		my $updatesph;
		my $connectionsph;
		my $cipher;
		my $issuer;
		my $subject;
		my $requirecheck;
		my @require_opt_check;
		if (check_version("4.0.2")){
			$title_maxq 	= qq!TITLE="Parameter MAX_QUERIES_PER_HOUR. Numeric value"!;
			$title_maxu 	= qq!TITLE="Parameter MAX_UPDATES_PER_HOUR. Numeric value"!;
			$title_maxc 	= qq!TITLE="Parameter MAX_CONNECTIONS_PER_HOUR. Numeric value "!;
			$queriesph		= quoteit($q->param('queriesph'));
			$updatesph		= quoteit($q->param('updatesph'));
			$connectionsph	= quoteit($q->param('connectionsph'));
		}
		else{
			$color_max		= "#999999";
			$queriesph		= $updatesph = $connectionsph = "N/A";
			$disabled_max	= 'DISABLED';
			$title_maxq = $title_maxu = $title_maxc = qq!TITLE="These options require MySQL server version 4.0.2 or higher"!;
		}
		if(check_version("4.0.4")){
			$title_req				= qq!TITLE="Check this to use the options below"!;
			$cipher					= quoteit($q->param('cipher'));
			$issuer					= quoteit($q->param('issuer'));
			$subject				= quoteit($q->param('subject'));
			$requirecheck			= "CHECKED" if $q->param('require');
			$require_opt_check[0] 	= "CHECKED" if ($q->param('require_opt') eq 'none');
			$require_opt_check[1] 	= "CHECKED" if ($q->param('require_opt') eq 'ssl');
			$require_opt_check[2] 	= "CHECKED" if ($q->param('require_opt') eq 'x509');
			$require_opt_check[3] 	= "CHECKED" if ($q->param('require_opt') eq 'other');
		}
		else{
			$title_req		= $title1 = qq!TITLE="These options require MySQL server version 4.0.4 or higher"!;
			$color			= "#999999";
			$requirecheck	= $disabled = 'DISABLED';
			$cipher 		= $issuer = $subject = "N/A";
			for(my $i = 0; $i < 4; $i++){$require_opt_check[$i] = 'DISABLED'}
		}
		my $h1	= $agent ? 140	: 105;
		my $r1	= $agent ? 1	: 2;
		my $c1	= $agent ? 10	: 16;
		my $s1	= $agent ? 3	: 4;
		
			return qq!
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=2 WIDTH="100" style="color: $color; font-weight: bold">
	<TR>
		<TD COLSPAN=4 HEIGHT=5></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#AAAAAA">
	<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20>
<INPUT TYPE=CHECKBOX NAME="require" $requirecheck $title_req>
	</TD></TR></TABLE>
		</TD>
		<TD COLSPAN=3 BGCOLOR="#AAAAAA" $title_req>
	<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 BGCOLOR="#CCCCCC" WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20><P style="color: $color; font-weight: bold" >REQUIRE:</p></TD></TR></TABLE>
	</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#AAAAAA">
		
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20>		
		<INPUT NAME="require_opt" TYPE=RADIO VALUE="none" $require_opt_check[0] $title1>
</TD></TR></TABLE>
		
		</TD><TD COLSPAN=3 BGCOLOR="#AAAAAA">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20 $title1><P style="color: $color">
		NONE
</TD></TR></TABLE>
		</TD>
	</TR>
	<TR>
		<TD WIDTH="10%" BGCOLOR="#AAAAAA">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20>		
		<INPUT NAME="require_opt" TYPE=RADIO VALUE="ssl" $require_opt_check[1] $title1>
</TD></TR></TABLE>
		</TD>
		<TD WIDTH="40%" BGCOLOR="#AAAAAA">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20 $title1><P style="color: $color">
		SSL
</TD></TR></TABLE>
		</TD>
		<TD WIDTH="10%" BGCOLOR="#AAAAAA">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20>		
		<INPUT NAME="require_opt" TYPE=RADIO VALUE="x509" $require_opt_check[2] $title1>
</TD></TR></TABLE>
		</TD>
		<TD WIDTH="40%" BGCOLOR="#AAAAAA">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=20 $title1><P style="color: $color">
		X509
</TD></TR></TABLE>
		</TD>
	</TR>
	<TR>
		<TD VALIGN=TOP BGCOLOR="#AAAAAA">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%"><TR><TD BGCOLOR="#CCCCCC" HEIGHT=$h1>
		<INPUT NAME="require_opt" TYPE=RADIO VALUE="other" $require_opt_check[3] $title1>
</TD></TR></TABLE>
		</TD><TD COLSPAN=3 BGCOLOR="#AAAAAA">
		
		<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%" BGCOLOR="#CCCCCC" HEIGHT=$h1>	
		<TR><TD $title1><P style="color: $color">cipher</TD><TD><TEXTAREA COLS=$c1 ROWS=$r1 NAME="cipher" SCROLLING=OFF $title1 $disabled>$cipher</TEXTAREA></TD></TR>
		<TR><TD $title1><P style="color: $color">issuer</TD><TD><TEXTAREA COLS=$c1 ROWS=$r1 NAME="issuer" SCROLLING=OFF $title1 $disabled>$issuer</TEXTAREA></TD></TR>
		<TR><TD $title1><P style="color: $color">subject</TD><TD><TEXTAREA COLS=$c1 ROWS=$r1 NAME="subject" SCROLLING=OFF $title1 $disabled>$subject</TEXTAREA></TD></TR>
		</TABLE>
		
		</TD>
	</TR>
	<TR>
		<TD COLSPAN=4 HEIGHT=5></TD>
	</TR>
	<TR>
		<TD COLSPAN=4 BGCOLOR="#AAAAAA">
<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH="100%" BGCOLOR="#CCCCCC" >	
<TR><TD><P style="color: $color_max">max&nbsp;queries/hour</TD><TD><INPUT TYPE=TEXT NAME="queriesph" VALUE="$queriesph" $disabled_max SIZE=$s1 $title_maxq ></TD></TR>
<TR><TD><P style="color: $color_max">max&nbsp;updates/hour</TD><TD><INPUT TYPE=TEXT NAME="updatesph" VALUE="$updatesph" $disabled_max SIZE=$s1 $title_maxu ></TD></TR>
<TR><TD><P style="color: $color_max">max&nbsp;connections/hour</TD><TD><INPUT TYPE=TEXT NAME="connectionsph" VALUE="$connectionsph" $disabled_max SIZE=$s1 $title_maxc ></TD></TR>
</TABLE>
		</TD>
	</TR>
</TABLE>

!;
		
	};
	my $objectpriv;
	my $global_checkbox;
	if ($globs){
		$objectpriv = 1;
		my $size = 22;
		my @global_values = (
		'SELECT', 'INSERT','UPDATE','DELETE','CREATE', 'DROP', 'RELOAD', 
		'SHUTDOWN', 'PROCESS', 'FILE', 'REFERENCES', 'INDEX', 'ALTER'
		);
		my @global_values_ext = (
		'SHOW DATABASES', 'SUPER', 'CREATE TEMPORARY TABLES', 'LOCK TABLES',
		'EXECUTE', 'REPLICATION CLIENT', 'REPLICATION SLAVE'
		);
		
		
		if (check_version("4.0.2")){
			foreach (@global_values, @global_values_ext, "GRANT"){
				my $selected		= "SELECTED" if belongs(\@global, $_);
				$global_checkbox	.= qq!<OPTION VALUE="$_" $selected>$_\n!; 
			}
		}
		else {
			foreach (@global_values, 'GRANT'){
				my $selected		= "SELECTED" if belongs(\@global, $_);
				$global_checkbox	.= qq!<OPTION VALUE="$_" $selected>$_\n!; 
			}

			my $style = qq!STYLE="color: #bbbbbb;"!;
			foreach (@global_values_ext){
				my $element = (lc $_);
				$global_checkbox	.= qq!<OPTION VALUE="" $style>(N/A) $element\n!;
			}
		}
		
		
		$global_checkbox	.= qq!<OPTION VALUE="">\n!;
		$global_checkbox	.= qq!</SELECT><br>!;
		$global_checkbox	.= &$v402;
		$global_checkbox = qq!<SELECT NAME="global" MULTIPLE SIZE=$size>\n! . $global_checkbox;
		
	}
							
	if ($dbs) {
		my $size = 13;
		my @database = $q->param('database');
		my @database_values_ext = ('LOCK TABLES', 'CREATE TEMPORARY TABLES');
		if (check_version("4.0.4")){
			foreach (@database_values, @database_values_ext, 'GRANT'){
				my $selected		= "SELECTED" if belongs(\@database, $_);
				$database_checkbox	.= qq!<OPTION VALUE="$_" $selected>$_\n!;
			}
		}
		else{
			foreach (@database_values, 'GRANT'){
				my $selected		= "SELECTED" if belongs(\@database, $_);
				$database_checkbox	.= qq!<OPTION VALUE=$_ $selected>$_\n!;
			}
			my $style = qq!STYLE="color: #bbbbbb;"!;

			foreach (@database_values_ext){
				$_ = lc $_;
				$database_checkbox .= qq!<OPTION VALUE="" $style>(N/A) $_\n!;
			}
		}
		$database_checkbox = qq!<SELECT NAME="database" MULTIPLE SIZE=$size>\n$database_checkbox<OPTION VALUE="">\n</SELECT><br>!;
		$database_checkbox = <<EOT
					<TR>
						<TD TITLE="Choose Database Privileges" COLSPAN=2>$database_checkbox</TD>
					</TR>
EOT
;
		
		unless ($objectpriv){
			$database_checkbox .= qq!
					<TR>
						<TD TITLE="Choose Database Privileges" COLSPAN=2 ALIGN=RIGHT>! . &$v402 . qq!</TD>
					</TR>
			
!
;
		}
		$objectpriv			= 1;
		$d_dblist 		=	<<EOT	
					<TR>
						<TD ALIGN=RIGHT VALIGN=MIDDLE TITLE="Select one or more databases"><B>Db</B></TD>
						<TD ALIGN=RIGHT TITLE="Select one or more databases">$d_dblist</TD>
					</TR>
EOT
;
		my $d1db = $q->textfield(-name=>'d1_db', -size=>$textsize, -title=>"Type database names (comma separated).\nPlaceholder `?' will be substituted\nwith user name for each user." );
		$d1_db			= 	<<EOT
					<TR>
						<TD COLSPAN=2 ALIGN=RIGHT TITLE="Type database names (comma separated).\nPlaceholder `?' will be substituted\nwith user name for each user."><I>Other&nbsp;Db&nbsp;</I>$d1db</TD>
					</TR>
EOT
;
	} else {$d_dblist = ''; }
	my $table_checkbox_t;
	if ($tables){
		$table_checkbox_t = $q->scrolling_list(
		  					-name		=> 'table_t',
							-values		=> $table_values,
							-size		=>11,
							-multiple	=>1
							);
		my $ext = qq!
				<TR>
					<TD COLSPAN=2 ALIGN=RIGHT>! . &$v402 . qq!</TD>
				</TR>
! unless ($objectpriv);
		$objectpriv			= 1;
		$t_dblist = <<EOT
			<TABLE BORDER=0 WIDTH="100%">
				<TR>
					<TD TITLE="Select database"><INPUT TYPE=SUBMIT VALUE=">" TITLE="Reload page to apply changes">&nbsp;<B>Db</B></TD>
					<TD TITLE="Select database" ALIGN=RIGHT>$t_dblist</TD>
				</TR>
				$T_Table
				<TR HEIGHT=6>
					<TD HEIGHT=6></TD>
					<TD HEIGHT=6></TD>
				</TR>
				<TR>
					
					<TD TITLE="Choose table privileges" COLSPAN=2 ALIGN=RIGHT>$table_checkbox_t</TD>
				</TR>
$ext
			</TABLE>
EOT
;

	}
	else {$t_dblist = ''}
	my $column_checkbox;
	if ($columns){
		$column_checkbox = $q->scrolling_list(
		  					-name		=> 'column',
							-values		=> $column_values,
							-size		=> 4,
							-multiple	=> 1
							) ;
		my $ext = qq!
				<TR>
					<TD COLSPAN=2 ALIGN=RIGHT>! . &$v402 . qq!</TD>
				</TR>
! unless ($objectpriv);

		$c_dblist = <<EOT
				<TABLE BORDER=0 WIDTH="100%">
				<TR>
					<TD TITLE="Select database"><INPUT TYPE=SUBMIT VALUE=">" TITLE="Reload page to apply changes">&nbsp;<B>Db</B></TD>
					<TD ALIGN=RIGHT TITLE="Select database">$c_dblist</TD>
				</TR>
				$C_Other_Db
				$C_Table
				$C_Other_Table
				$columnlist
				$C_Other_Column
				<TR HEIGHT=6>
					<TD HEIGHT=6></TD>
					<TD HEIGHT=6></TD>
				</TR>
				<TR>
					<TD TITLE="Choose column privileges">&nbsp;</TD>
					<TD ALIGN=RIGHT TITLE="Choose column privileges">$column_checkbox</TD>
				</TR>
$ext
				</TABLE>
EOT
;
	
	}
	else {$c_dblist = ''}
	my $action_bar	= <<EOT
	<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
		<TR>
			<TD ALIGN=LEFT>
			<INPUT TYPE=RESET TITLE="Reset" style="width: 65">&nbsp;&nbsp;
			<INPUT TYPE=SUBMIT VALUE="Reload" TITLE="Reload this page" style="width: 65">&nbsp;&nbsp;<B>
			<INPUT TYPE=SUBMIT NAME="create" VALUE="$action" style="font-weight: bold" TITLE="Proceed with selected options"></B>
			&nbsp;&nbsp;&nbsp;&nbsp;<I>Preview queries</I>&nbsp;<INPUT NAME="preview" TYPE=CHECKBOX CHECKED></TD>
		</TR>
		<TR HEIGHT=4><TD HEIGHT=4></TD</TR>
	</TABLE>
EOT
	if ($globs or $dbs or ($tables and $t_db) or ($columns and ($c_db and $c_table)) or $C_Other_Db);

print <<EOT
<!-- USER ACCOUNTS PROCEDURE STARTS HERE -->

<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>
	<TR HEIGHT=10><TD ALIGN=LEFT HEIGHT=10></TD></TR>
	<TR>
		<TD>
	<FORM ACTION="$full_url" METHOD=POST>

$action_bar	
	<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 BGCOLOR="#AAAAAA"><!-- PRIVILEGES -->

		<TR><TD BGCOLOR="#AAAAAA"><!-- SET OF GLOBAL PRIVILEGES -->
			<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=1 BGCOLOR="#AAAAAA">
				<TR><TD BGCOLOR="#CCCCCC"><P TITLE="Check to assign Global Privileges">&nbsp;<B><INPUT TYPE=SUBMIT		VALUE="Global privileges" 	NAME="$global_priv"	style="font-weight: bold; width=150px" TITLE="Click to show/hide privileges">&nbsp;</B></TD>
					<TD BGCOLOR="#CCCCCC"><P TITLE="Check to assign Database Privileges">&nbsp;<B><INPUT TYPE=SUBMIT	VALUE="Database privileges"	NAME="$db_priv" 	style="font-weight: bold; width=150px" TITLE="Click to show/hide privileges">&nbsp;</B></TD>
					<TD BGCOLOR="#CCCCCC"><P TITLE="Check to assign Table Privileges">&nbsp;<B><INPUT TYPE=SUBMIT		VALUE="Table privileges"	NAME="$table_priv"	style="font-weight: bold; width=150px" TITLE="Click to show/hide privileges">&nbsp;</B></TD>
					<TD BGCOLOR="#CCCCCC"><P TITLE="Check to assign Column Privileges">&nbsp;<B><INPUT TYPE=SUBMIT		VALUE="Column privileges"	NAME="$column_priv"	style="font-weight: bold; width=150px" TITLE="Click to show/hide privileges">&nbsp;</B></TD>
				</TR>
				<TR BGCOLOR="#AAAAAA">
					<TD VALIGN=TOP BGCOLOR="#CCCCCC" ALIGN=LEFT><P>&nbsp;<BR><!-- GLOBAL PRIVILEGES -->
$global_checkbox
				</TD>
				<TD VALIGN=TOP BGCOLOR="#CCCCCC"><!-- DATABASE PRIVILEGES -->
				<TABLE BORDER=0>
					$d_dblist
					$d1_db
					<TR HEIGHT=6>
						<TD HEIGHT=6 COLSPAN=2></TD>
					</TR>
					<TR>
						<TD TITLE="Choose Database Privileges" COLSPAN=2>$database_checkbox</TD>
					</TR>
				</TABLE></TD>
				<TD VALIGN=TOP BGCOLOR="#CCCCCC"><P><!-- TABLE PRIVILEGES -->
				$t_dblist
				</TD>
				<TD VALIGN=TOP BGCOLOR="#CCCCCC"><P><!-- COLUMN PRIVILEGES -->
				$c_dblist
				</TD>
			</TR>	
			</TABLE>
		</TR></TD>
	</TABLE>

	<INPUT TYPE=HIDDEN NAME="page" VALUE="admin">
	<INPUT TYPE=HIDDEN NAME="func" VALUE="access">
	<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
	<INPUT TYPE=HIDDEN NAME="action" VALUE="$action">
	$hidden_glob
	$hidden_db
	$hidden_table
	$hidden_column
	$hidden_userlist
	$hidden_password
</FORM>
	</TD></TR>
	</TABLE><BR>

<!-- USER access PROCEDURE STARTS HERE -->
EOT
;
	print "\n\n<TABLE><TR><TD><B>USER LIST:</B></TD></TR>\n";
	foreach (@userlist){print "\t<TR><TD><B>$_</B></TD></TR>\n"}
	print "</TABLE>\n";
  	return
}
sub setup {
	if ($q->param('cancel')){
		$page= '';
		logout();
		return
	}
	if ($q->param('save')){
		sub exitonerror{
			print 	$q->header();
			&startpage();
			print qq!<FORM ACTION="$full_url" METHOD=POST>\n!;
			print <<EOT
<FONT COLOR="#FF0000">$_[0]</FONT><BR>
		<P><INPUT TYPE=SUBMIT VALUE="BACK">
		<INPUT TYPE=HIDDEN NAME="page" VALUE="setup" >
		</FORM>
</TD></TR></TABLE>
</BODY>
</HTML>
EOT
;
exit 0
		}
		if ($q->param('charset') !~ /iso-8859-1/i){
			local $SIG{__DIE__} = sub{
				my $message = <<EOT
Perl module CGI.pm is outdated on this system.<br>
Please pass this message to your system administrator.<br>
You can not use Character Set other than ISO-8859-1 before the module CGI.pm is updated.
EOT
;
&exitonerror($message);
			};
			$q->charset($CHARSET)
		}
		my @config;
		my ($userName, $Password, $type) = $q->cookie('mdm_setup');
		unless (open FH, "$configFile") {exitonerror ("$configFile, $!") }
		flock (FH,2) unless $WIN32;
		while(<FH>){
			push @config, $_;
		}
		flock (FH,8) unless $WIN32;
		close FH;
		my $i=0;
		unless ($q->param('new_admin')){
			my $config = readconfig(\@config);
			if (($config->{userName} ne $userName) or ($config->{Password} ne $Password)){
				exitonerror("Login incorrect!")
			}
			
		}
		my $err_message;
		if($q->param('setPW')){
			unless ($q->param('userName') =~ /^\w+$/){
				$err_message = "User name can not be blank and must consist of alphanumeric characters only.<BR>\n";
			}
			unless ($q->param('Password') =~ /^\w+$/){
				$err_message .= "Password can not be blank and must consist of alphanumeric characters only.<BR>\n";
			}
			unless ($q->param('Password') eq $q->param('Password_')){
				$err_message .= "Password was incorrect.<BR>\n"
			}
		}
		foreach(@config){
			if (/^\s*#/ or /^\s*$/){$i++; next}
			s/^\s*(\S+.*\S*)\s*$/$1/;
    		if (/^userName\b/){
				if ($q->param('setPW') and !$err_message){
					$config[$i] = 'userName = '.$q->param('userName')."\n" ;
				}
				else {$config[$i] .= "\n" }
			}
			elsif(/^Password\b/){
				if ($q->param('setPW') and !$err_message){
						my $pw =  crypt $q->param('Password'), $q->param('userName');
						$config[$i] = "Password=$pw\n";
				}
				else {$config[$i] .= "\n";}
			}
			elsif(/^(\w*\b)/){
				$config[$i] = "$1 = ".$q->param($1)."\n";
			}
			$i++;
		}
		unless (open FH, ">$configFile") {exitonerror ("$configFile, $!") }
		else {
			flock (FH,2) unless $WIN32;
			foreach (@config) {print FH }
			flock (FH,8) unless $WIN32;
			close FH;
		}
		if ($err_message){
			$err_message = "User name and password were not changed.<P>\n$err_message<BR>\n";
			exitonerror($err_message)
		}
		
		$page= '';
		logout();
		return
	}
	#print 	$q->header();
	if ($q->param('login')){
		my $pw = crypt $q->param('Password'),$q->param('userName');
		my $cookies = $q->cookie(	
							-name=>'mdm_setup',
    						-value=>[$q->param('userName'), $pw, 'glob'],
    						-secure=>0
    						);
		print 	$q->header(-cookie=>$cookies, -expires=>0);
	}
	else {print 	$q->header()}
	&startpage();
	print qq!<FORM ACTION="$full_url" METHOD=POST>\n!;
	printHeaderTable({name=>'SETUP'});
	my @config;
	my ($user_password,$config, $zip_CHECKED, $gzip_CHECKED);
	if (-e $configFile){
	my @params = qw(
userName 
Password
homeURL
helpURL
defaultSocket
defaultHost
defaultPort
mysql
otherMysql
userDirectory
backupMax
SQLMax
asciiMax
adminEmail
compressCommand
allowZIP
allowGZIP
zipSyntax
zipLog
printPopUp
bgcolor1
bgcolor2
statusfontcolor
logo
slogan
slogancolor
logolink
logotarget
charset
);
	
		open FH, $configFile or die $!;
		flock (FH,2) unless $WIN32;
		while(<FH>){
			push @config, $_;
		}
		flock (FH,8) unless $WIN32;
		close FH;
		$config 		= readconfig(\@config);
		my @param_missing;
		foreach (@params){
			unless (exists $config->{$_}){push @param_missing, "$_ = \n"}
		}
		if (@param_missing){
			open FH, ">>$configFile" or exitonerror ("$configFile, $!");
			flock (FH,2) unless $WIN32;
			foreach (@param_missing) {print FH }
			flock (FH,8) unless $WIN32;
			close FH;
		}
	}
	else {
		@config = @{config()};
		unless (open FH, ">$configFile") {print qq?<FONT COLOR="#FF0000">$configFile, $!</FONT><BR>? }
		else {
			flock (FH,2) unless $WIN32;
			foreach (@config) {print FH "$_\n"}
			flock (FH,8) unless $WIN32;
			close FH;
			$config 		= readconfig(\@config);
		}
	}
	my $new_admin;
	my $printPopUp_CHECKED 	= 'CHECKED' if ($config->{printPopUp} > 0);
	my $allowZIP_CHECKED	= 'CHECKED' if ($config->{allowZIP} > 0);
	my $allowGZIP_CHECKED	= 'CHECKED' if ($config->{allowGZIP} > 0);
	if ($config->{compressCommand} eq 'zip'){$zip_CHECKED = 'CHECKED'}
	elsif ($config->{compressCommand} eq 'gzip'){$gzip_CHECKED = 'CHECKED'}
	
	if ($config->{userName}){
		unless ($q->param('login')){
			print <<EOT
<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0>
	<TR>
		<TD WIDTH=100 HEIGNT=30><P>&nbsp;</TD>
		<TD><P>Admin Name&nbsp;</TD>
		<TD><P><INPUT TYPE=TEXT NAME="userName" SIZE=25>&nbsp;</TD>
	</TR>	
	<TR>
		<TD WIDTH=100 HEIGNT=10><P>&nbsp;</TD>
		<TD HEIGNT=10><P>&nbsp;</TD>
		<TD HEIGNT=10><P>&nbsp;</TD>
	</TR>	
	<TR>
		<TD WIDTH=100 HEIGNT=30><P>&nbsp;</TD>
		<TD><P>Password&nbsp;</TD>
		<TD><P><INPUT TYPE=PASSWORD NAME="Password" SIZE=25>&nbsp;</TD>
	</TR>
	<TR>
		<TD WIDTH=100 HEIGNT=10><P>&nbsp;</TD>
		<TD HEIGNT=10><P>&nbsp;</TD>
		<TD HEIGNT=10><P>&nbsp;</TD>
	</TR>	
	<TR>
		<TD WIDTH=100 HEIGNT=30><P>&nbsp;</TD>
		<TD><P>&nbsp;</TD>
		<TD><P><INPUT TYPE=SUBMIT NAME="login" VALUE="SUBMIT" SIZE=30>&nbsp;</TD>
	</TR>
</TABLE>
<INPUT TYPE=HIDDEN NAME="page" VALUE="setup">
</FORM>
</TD></TR></TABLE>
</BODY>
</HTML>
EOT
;
			return
		}
		my $pw = crypt $q->param('Password'), $q->param('userName');
		if (($config->{userName} ne $q->param('userName')) or ($pw ne $config->{Password})){
			
			print <<EOT
		<FONT COLOR="#FF0000"><B>INCORRECT USER NAME OR PASSWORD</B></FONT><P>
		<P><INPUT TYPE=SUBMIT VALUE="BACK">
		<INPUT TYPE=HIDDEN NAME="page" VALUE="setup">
		</FORM>
</TD></TR></TABLE>
</BODY>
</HTML>


EOT
;
	return
		}

		$user_password 	= "CHANGE&nbsp;USER&nbsp;NAME&nbsp;AND&nbsp;PASSWORD&nbsp;";
		$new_admin		= '';
	}

	else {
		$user_password 	= "CREATE&nbsp;ADMIN&nbsp;USER&nbsp;";
		$new_admin		= '1';
	}
	foreach (keys %{$config}){$config->{$_} = quoteit $config->{$_}}	
	print <<EOT
                    
                    <TABLE BORDER=0 BGCOLOR="#CCCCCC" CELLPADDING=1 CELLSPACING=2 WIDTH=650>
						<TR>
							<TD ALIGN=RIGHT><P>
<TABLE BORDER=0 BGCOLOR="#AAAAAA" CELLPADDING=1 CELLSPACING=0><TR><TD>		
					<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=2 BGCOLOR="#CCCCCC">
						<TR><TD COLSPAN=2><P><INPUT TYPE=CHECKBOX NAME="setPW" TITLE="Check to submit user name and password">&nbsp;<B>$user_password</B></TD>
						</TR>
						<TR>
							<TD><P>User Name:</TD>
							<TD>
								<P><INPUT TYPE=TEXT NAME="userName" VALUE="" SIZE=20 
								TITLE="Admin user name.\nOnly alphanumeric characters are allowed">&nbsp;
							</TD>
						</TR>
						<TR>
							<TD><P>Password:</TD>
							<TD>
								<P><INPUT TYPE=PASSWORD NAME="Password" VALUE="" SIZE=20 
								TITLE="Password.\nOnly alphanumeric characters are allowed">&nbsp;
							</TD>
						</TR>
						<TR>
							<TD><P>Confirm Password:</TD>
							<TD>
								<P><INPUT TYPE=PASSWORD NAME="Password_" VALUE="" SIZE=20 
								TITLE="Confirm Password.\nOnly alphanumeric characters are allowed">&nbsp;
							</TD>
						</TR>
					</TABLE></TD></TR></TABLE>
							</TD>
						</TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%"><P><B>PARAMETERS</B></TD>
                                        <TD WIDTH="51%"><P><B>DESCRIPTION</B></TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA"><P>
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%"><P>Home page URL:<BR>
                                        <INPUT TYPE=TEXT NAME="homeURL" VALUE="$config->{homeURL}" SIZE=32 
										TITLE="URL of your Home Page. For example,\n http://www.edatanew.com/index.html\nor ../index.html">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Your home page URL. </TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Help directory URL:<BR>
                                        <INPUT TYPE=TEXT NAME="helpURL" VALUE="$config->{helpURL}" SIZE=32 
										TITLE="URL of 'help' directory. For example,\nhttp://www.edatanew.com/help\nor  ../help">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>URL of directory where 'help' files are installed</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>MYSQL CONNECTION PARAMETERS<BR><BR>Default socket<BR>
										<INPUT TYPE=TEXT NAME="defaultSocket" VALUE="$config->{defaultSocket}" SIZE=32 
										TITLE="These are connection parameters of the most frequently used Mysql server. If defined as default, it will be not necessarily to type them at login page.">
                                        <BR>Default host<BR>
                                        <INPUT TYPE=TEXT NAME="defaultHost" VALUE="$config->{defaultHost}" SIZE=32 
										TITLE="These are connection parameters of the most frequently used Mysql server. If defined as default, it will be not necessarily to type them at login page.">
                                        <BR>Default port number<BR>
                                        <INPUT TYPE=TEXT NAME="defaultPort" VALUE="$config->{defaultPort}" SIZE=16 
										TITLE="These are connection parameters of the most frequently used Mysql server. If defined as default, it will be not necessarily to type them at login page.">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Default socket, Default host and Default port are used when the field 'HOST:PORT' is blank (login page).<BR>&nbsp;</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="100%" COLSPAN=2><P><I>mysql</I> CLIENT PARAMETERS (Restore databases)</TD>
                                   </TR>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Path to binary <i>mysql</i> client<BR>
										<INPUT TYPE=TEXT NAME="mysql" VALUE="$config->{mysql}" SIZE=32 MAXLENGTH=200
										TITLE="Path to binary mysql client.\nFor example,\n for Windows: c:\\mysql\\bin\\mysql.exe\n for Unix/Linux: /usr/local/mysql/bin/mysql">
										<TD WIDTH="51%"><P>Path to binary <i>mysql</i> client</TD>
									</TR>
									<TR>
                                        <TD WIDTH="48%" ><P>Other parameters<BR>
                                        <INPUT TYPE=TEXT NAME="otherMysql" VALUE="$config->{otherMysql}" SIZE=32 MAXLENGTH=200
										TITLE="You can use some additional parameters in mysql client call syntax">
                                        <TD WIDTH="51%"><P>Additional parameters used to call <i>mysql</i><br>
										For example 'SILENT' AND 'COMPRESS': -s -C</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Path to user directory:<BR>
                                        <INPUT TYPE=TEXT NAME="userDirectory" VALUE="$config->{userDirectory}" SIZE=32 MAXLENGTH=200
										TITLE="Path to user directory.\nFor example,\nfor Windows: C:\\MYDOCU~1\\DATA\\USR\nfor Unix/Linux: /home/mydirname/usr">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Path to directory where user subdirectories are stored.</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Max. total size of backup files (per user): <BR>
                                        <INPUT TYPE=TEXT NAME="backupMax" VALUE="$config->{backupMax}" SIZE=10 MAXLENGTH=10
										TITLE="Maximum total size of backup files per user [kilobytes].\nZero value or blank field means 'Unlimited'">&nbsp;[kbyte] </TD>
                                        <TD WIDTH="51%"><P>Maximum allowed total size of bacup files for each user (in kilobytes)</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Max. total size of SQL scripts (per user):<BR>
                                        <INPUT TYPE=TEXT NAME="SQLMax" VALUE="$config->{SQLMax}" SIZE=10 MAXLENGTH=10
										TITLE="Maximum total size of SQL scripts per user [kilobytes].\nZero value or blank field means 'Unlimited'">&nbsp;[kbyte]</TD>
                                        <TD WIDTH="51%"><P>Maximum allowed total size of SQL scripts for each user (in kilobytes)</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Max. total size of ASCII delimited files (per user):<BR>
                                        <INPUT TYPE=TEXT NAME="asciiMax" VALUE="$config->{asciiMax}" SIZE=10 MAXLENGTH=10
										TITLE="Maximum total size of ASCII delimited files per user [kilobytes].\nZero value or blank field means 'Unlimited'">&nbsp;[kbyte]</TD>
                                        <TD WIDTH="51%"><P>Maximum allowed total size of ASCII delimited files for each user (in kilobytes)</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Administrator email:<BR>
                                        <INPUT TYPE=TEXT NAME="adminEmail" VALUE="$config->{adminEmail}" SIZE=32 MAXLENGTH=200
										TITLE="Put your administrator email address here">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Email address used in error messages</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Compressing method:<BR>
                                        <INPUT TYPE=RADIO $zip_CHECKED NAME="compressCommand" VALUE="zip"
										TITLE="It defines, which method 'ZIP' or 'GZIP' will be used in 'Compress File' command">&nbsp;zip&nbsp;
                                        <INPUT TYPE=RADIO $gzip_CHECKED NAME="compressCommand" VALUE="gzip"
										TITLE="It defines, which method 'ZIP' or 'GZIP' will be used in 'Compress File' command"> gzip</TD>
                                        <TD WIDTH="51%"><P>Compressing method used by "Compress" command</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>
                                        <INPUT TYPE=CHECKBOX NAME="allowZIP" VALUE="1" $allowZIP_CHECKED
										TITLE="Check to allow ZIP method to compress backup files">&nbsp;Allow ZIP </TD>
                                        <TD WIDTH="51%"><P>Uncheck if zip utility is not installed</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>
                                        <INPUT TYPE=CHECKBOX NAME="allowGZIP" VALUE="1" $allowGZIP_CHECKED
										TITLE="Check to allow GZIP method to compress backup files">&nbsp;Allow GZIP </TD>
                                        <TD WIDTH="51%"><P>Uncheck if gzip utility is not installed</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>ZIP call syntax:<BR>
                                        <INPUT TYPE=TEXT NAME="zipSyntax" VALUE="$config->{zipSyntax}" SIZE=16 
										TITLE="For Windows command line utility 'Wzzip' syntax is: 'Wzzip -Pr' \nFor Unix/Linux zip utility: 'zip -qj'">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Syntax used to call ZIP utility.</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Syntax to suppress the output from ZIP utility<BR>
                                        <INPUT TYPE=TEXT NAME="zipLog" VALUE="$config->{zipLog}" SIZE=16 
										TITLE="In the case of Windows command line ZIP utility 'Wzzip' this syntax looks like: 1>NUL">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Some command lline ZIP programs print output information that must be 
										suppressed using this syntax.</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>
                                        <INPUT TYPE=CHECKBOX NAME="printPopUp" VALUE="1" $printPopUp_CHECKED 
										TITLE="Check to enable print pop up window">&nbsp;Print Pop Up </TD>
                                        <TD WIDTH="51%"><P>Unchech if your browser does not support JavaScript function window.print(), or you do not want print pop up window to appear </TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Specify the character set<BR>
                                        <INPUT TYPE=TEXT NAME="charset" VALUE="$CHARSET" SIZE=16
										TITLE="Specify the character set to be used in the documents"></TD>
                                        <TD WIDTH="51%"><P>Specify the character set to be used in the documents and forms. The default value is ISO-8859-1. Leave it blank if you are not sure.</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
						
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>SETTING UP OF LOOK AND FEEL</TD>
                                        <TD WIDTH="51%"><P>&nbsp;</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
						
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>The color of the upper part of the banner<BR>
                                        <INPUT TYPE=TEXT NAME="bgcolor1" VALUE="$config->{bgcolor1}" SIZE=16 
										TITLE="Color of the upper part of the banner">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Hexadecimal value. 336699 by default.</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>The color of the status bar<BR>
                                        <INPUT TYPE=TEXT NAME="bgcolor2" VALUE="$config->{bgcolor2}" SIZE=16 
										TITLE="Color of the status bar">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Hexadecimal value. 003366 by default.</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Font color in the status bar<BR>
                                        <INPUT TYPE=TEXT NAME="statusfontcolor" VALUE="$config->{statusfontcolor}" SIZE=16 
										TITLE="Font color in the status bar">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Hexadecimal value. 336699 by default.</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>URL of logo image<BR>
                                        <INPUT TYPE=TEXT NAME="logo" VALUE="$config->{logo}" SIZE=16 
										TITLE="URL of logo image">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Location of Logo Image. For example:<BR> http://www.mydomain.com/images/logo.jpg</TD>
                                    </TR>
                                </TABLE>
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Logo is linked to URL:<BR>
                                        <INPUT TYPE=TEXT NAME="logolink" VALUE="$config->{logolink}" SIZE=16 
										TITLE="Type web address the logo is linked to">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Web address the logo is linket to. For example:<BR> http://www.mywebsite.com</TD>
                                    </TR>
                                </TABLE>
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Target window of Logo link<BR>
                                        <INPUT TYPE=TEXT NAME="logotarget" VALUE="$config->{logotarget}" SIZE=16 
										TITLE="Target window of Logo Link. Leave blank to open the link in the same window">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Name of the target window (or frame) of the above link. For example:<BR>_blank - new window; _self - the same window</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Your company slogan<BR>
                                        <INPUT TYPE=TEXT NAME="slogan" VALUE="$config->{slogan}" SIZE=16 
										TITLE="Your company slogan">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Text. For example: MYSQL DATA MANAGER (default value)</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
                        <TR>
                            <TD BGCOLOR="#AAAAAA">
                                <TABLE BORDER=0 WIDTH="100%" BGCOLOR="#CCCCCC" CELLPADDING=2 CELLSPACING=0>
                                    <TR>
                                        <TD WIDTH="48%" HEIGHT=16><P>Slogan font color<BR>
                                        <INPUT TYPE=TEXT NAME="slogancolor" VALUE="$config->{slogancolor}" SIZE=16 
										TITLE="Slogan font color">&nbsp;</TD>
                                        <TD WIDTH="51%"><P>Hexadecimal value. ffffff - by default</TD>
                                    </TR>
                                </TABLE>
                            </TD>
                        </TR>
						
						<TR>
							<TD ALIGN=RIGHT>
							<INPUT TYPE=SUBMIT NAME="save" VALUE="SAVE AND EXIT">
							<INPUT TYPE=SUBMIT NAME="cancel" VALUE="CANCEL">
							<INPUT TYPE=RESET>
							</TD>
						</TR>
                    </TABLE>
					<INPUT TYPE=HIDDEN NAME="page" VALUE="setup">
					<INPUT TYPE=HIDDEN NAME="new_admin" VALUE="$new_admin">

</FORM>
</TD></TR></TABLE>
</BODY>
</HTML>

EOT
;
	
}

sub getdatanstructure {
	my $hashref			= shift;
	my @tablelist 		= @{$hashref->{tablelist}} if defined $hashref->{tablelist};
	my @newtablelist	= @{$hashref->{newtablelist}} if defined $hashref->{newtablelist};
	my $include			= $hashref->{include};
	my $dropifexists	= $hashref->{dropifexists};
	my $back			= $hashref->{back};
	my $comments		= $hashref->{comments};
	my @locks;
	my $filecontent		= '';
	if ($hashref->{lock}){
		my $query = "LOCK TABLES";
		foreach (@tablelist){
			push @locks, " $_ READ";
		}
		$query .= join(',',@locks);
		$dbh->do($query) or bail_out("Cannon lock!",$back);
	}
	my $j	= 0;
	my @filecontent;
	my $fk;
	foreach my $table (@tablelist) {
#		my $tbname		= "\n#\tTABLE $table \n" if $comments;
		my $text		= getCreateTableSQL({
			tabsref 		=> [$table],
			dropifexists 	=> "$dropifexists",
			newtabs 		=> $hashref->{newtablelist},
			back			=> $back
			}) unless ($include eq 'data');
		if ($text =~ /FOREIGN KEY/si){$fk = 1}
		$text = "\n#\tTABLE $table \n$text" if $comments;
		unless ($include eq 'structure') {
    		$text .= "\n#\tDUMPING DATA\n\n" if $comments;	
    
    		my $query 		= "SELECT * FROM $table";
    		my ($sth, $res) = prepare_execute($query,$back);
			$table			= $newtablelist[$j] if $newtablelist[$j];
    		while (my @row = $sth->fetchrow_array){
    			$text .= "INSERT INTO $table VALUES ( ";
    			my @rowdata;
    			for (my $i = 0; $i < @row; $i++) {
    				push @rowdata, $dbh->quote($row[$i]);
    			}
    			$text .= join (', ', @rowdata);
    			$text .= ");\n";

    		}
    		$sth->finish;
		}
		$text .= "\n#--------------------------------------------------------\n" if $comments;
		if ($fk){push @filecontent, $text} else {unshift @filecontent, $text}
		$j++;
		$fk = 0;
	}
	$filecontent = join '', @filecontent;
	$filecontent .= "#\tEND OF FILE\n" if ($filecontent and $comments);
	if ($hashref->{lock}){
		$dbh->do("UNLOCK TABLES") or bail_out("Cannot unlock!", $back);
	}
	return $filecontent
}
sub config {
	my $config = <<EOT
#######################################################################################
# 				MYSQL DATA MANAGER CONFIGURATION FILE
#######################################################################################
userName = 
Password = 
homeURL = 
helpURL = ../help
defaultSocket = 
defaultHost = localhost
defaultPort = 3306
mysql = /usr/local/mysql/bin/mysql
otherMysql = 
userDirectory = SET VALID VALUE!
backupMax = 200
SQLMax = 50
adminEmail = 
compressCommand = gzip
allowZIP = 1
allowGZIP = 1
zipSyntax = zip -qj
zipLog = 
printPopUp = 1
bgcolor1 = 336699
bgcolor2 = 003366
statusfontcolor = 336699
logo = 
slogan = Mysql Data Manager
slogancolor = ffffff
logolink = 
logotarget = _blank


EOT
;
	my @config = split "\n", $config;
	return (\@config);
}
sub readconfig {
	my $config;
	my @config = @{$_[0]};
	foreach(@config){
		next if (/^\s*#/ or /^\s*$/);
		s/^\s*(\S+.*\S*)\s*$/$1/;
		if (/^\w*/){
			/^(\w*)\s*=\s*(\S*.*\S*)\s*$/;
			$config->{$1}=$2;
		}
	}
	return $config
}

sub checkuserdir {
		my $dirname					= shift;
		my $userhost				= myhost();
		unless ((-e $USER_DIR) and (-d $USER_DIR)) {return "Cannot create user directory." unless mkdir $USER_DIR, 0777}
		my $userdir					= "$USER_DIR$delim$user.$userhost";
		unless ((-e $userdir) and (-d $userdir)) {return "Cannot create directory $user.$userhost" unless mkdir $userdir, 0777 }
		$userdir 					= "$USER_DIR$delim$user.$userhost$delim$dirname";
		unless ((-e $userdir) and (-d $userdir)) {return "Cannot create directory $dirname." unless mkdir $userdir, 0777}
		return 0;
		
# see: 	LoadRestore
#		suggest
#		create backup
#		loadImport
}
sub download {
	my $path_	= $_[0]; # Path to directory or -1 to download from variable $content
	my $file 	= $_[1]; # File name to be downloaded. Must be defined
	my $content	= $_[2]; # If Path = -1, this shoud be array reference, containing downloadable information
	my $size = 0;
	my $EOL	= $WIN32 ? "\r\n" : "\n" ;
	if ($path_ == -1){
		foreach (@$content){
			$size += length ;
		}
		print "Content-disposition: application; filename=$file$EOL";
		print "Content-Type: application/download$EOL$EOL";
		binmode STDOUT;
		foreach (@$content){print}
	}
	else {
		my @stat = stat $path_.$delim.$file;
		$size = $stat[7];
		open FH, $path_.$delim.$file or return("Could not open file $path_$delim$file. $!");
		flock(FH, 2) unless $WIN32;
		binmode FH;
#		print "Content-type: application/download$EOL";
#		print  "Content-Length: $size$EOL";
#		print  "Content-Disposition: attachment; filename=$file$EOL";
#		print  "Content-Transfer-Encoding: binary$EOL$EOL";
		print "Content-disposition: application; filename=$file$EOL";
		print "Content-Type: application/download$EOL$EOL";
		binmode STDOUT;
		my $data;
		while (read FH, $data, 1024) {print $data}
		flock(FH, 8) unless $WIN32 ;
		close FH;
	}
	return undef;
}
sub backslash {
	my $input	= shift;
	$input		=~ s/\\a/\a/g;
	$input		=~ s/\\b/\b/g;
	$input		=~ s/\\e/\e/g;
	$input		=~ s/\\f/\f/g;
	$input		=~ s/\\n/\n/g;
	$input		=~ s/\\r/\r/g;
	$input		=~ s/\\t/\t/g;
	$input		=~ s{\&\#(\w+)\;}{
				chr($1)
		}gsex;
	return $input
}
sub charesc {
	my $seq = ["+","?",".","*","^","\$","(",")","[","{","|","\\"];
	my @char = @_;
	foreach (@char){if (belongsb($seq, $_)){$_ = "\\".$_}}
	return @char if wantarray;
	return $char[0];	
}

sub import_ {
	my $input		= shift;
	my $back		= $input->{back};
	my @file 		= $q->param('selectfilelist');
	if (@file > 1)		{return "Too many files selected"}
	unless ($file[0])	{return "Please select a file"}

	my $userhost	= myhost();
	my $userdir		= "$USER_DIR$delim$user.$userhost$delim" . "ascii";
	my $fterm 		= $q->param('fterm1')	? $q->param('fterm2')	: $q->param('fterm');
	my $fencl 		= $q->param('fencl1')	? $q->param('fencl2')	: $q->param('fencl');
	my $fesc 		= $q->param('fesc1')	? $q->param('fesc2')	: $q->param('fesc');
	my $lterm 		= $q->param('lterm1')	? $q->param('lterm2')	: $q->param('lterm');
	my $ignore		= $q->param('ignore');
	{
		my $long = "The `FIELDS [OPTIONALLY] ENCLOSED BY' and `FIELDS ESCAPED BY' values must be a single character or empty.\nThey can be specified as backslash followed by a letter: \\x,\nor as a Numeric Entity: &#xxx; (where xxx is character's three-digit numerical value)";
		if (length $fencl > 1 and ($fencl !~ /^(\\[a-zA-Z]|&#\d\d\d;)$/)) {
			return $long
		}
		if (length $fesc > 1 and ($fesc !~ /^(\\[a-zA-Z]|&#\d\d\d;)$/)) {
			return $long
		}
	}
	$ignore =~ s/^\s*(\S*)/$1/;
	$ignore =~ s/^(\S*)\s*/$1/;
	unless ($ignore =~ /^\d*$/){return "Parameter IGNORE ... LINES must consist of digits only"}
	$fterm			= backslash($fterm);
	$fencl			= backslash($fencl);
	$fesc			= backslash($fesc);
	$lterm			= backslash($lterm);
	my $content;
	open FH, "$userdir$delim$file[0]" or return (qq?$! "$file[0]"?);
	flock (FH,2) unless $WIN32;
	while (read FH, my $data, 1024) {$content .= $data}
	flock (FH,8) unless $WIN32;
	close FH;
	my $insert	= [[]];
	my $jj = 0;
	my $i = 0;
	my @esc = ();
		my %test;

	if ($q->param('mode') =~ /simple/i){
		$_ = $content;
		while (
			m/
				(?:
					(?<!$fesc)$fencl
					([^$fencl]*?(?:$fesc$fesc)+[^$fencl]*?)		#1
					(?<!$fesc)$fencl
					|
					(?<!$fesc)$fencl
					(.*?)										#2
					$fesc(?!$fencl)
					|
					([^\n\r$fterm$fesc]*?)						#3
				)?
				($fterm|\n|\r\n)
			/gxs
		)
		{
			my $cell			= $1.$2.$3;
			my $eoc				= $4;
			$cell				=~ s/$fesc$fencl/$fencl/g;
			$insert->[$jj]->[$i] = $cell;
			bail_out("Too big", $back) if ($i++ > 100000);
			if ($eoc ne $fterm){
				if ($ignore){$ignore--;$insert->[0]=[]}
				else {$jj++}
				$i=0
			}
		}
	}# end of simple mode
	else {
		my $ii;
		foreach($fterm,$fencl,$fesc,$lterm){if ($_ ne ''){$esc[$ii] = "\\" unless m/[a-zA-Z0-9]/} ; $ii++} #m/[\+\?\.\*\^\$\(\)\[\{\|\\]/
		$_ = $content;
		my $lterm1;
		if ($lterm eq "\n"){$lterm1 = "\r"; $esc[4]="\\"}
		elsif ($lterm eq "\r"){$lterm1 = "\n"; $esc[4]="\\"}
		my $null = $fesc ? "$esc[2]$fesc"."N" : 'NULL';
		my $cut;
		my @lines = split /(?<!$esc[2]$fesc)(?:esc[3]$lterm$esc[4]$lterm1$|$esc[3]$lterm)/s, $_;
		foreach (@lines){
			while (
				m/
					(?:
						($null)										#1
						|
						(?<!$esc[2]$fesc)$esc[1]$fencl?
						(.*?)										#2
						(?<!$esc[2]$fesc)$esc[1]$fencl?
					)?
					((?<!$esc[2]$fesc)(?:$esc[0]$fterm)|\z)	#3
				/gxs
			)
			{
#			 print "1-'$1'; 2-'$2', 3-'$3', 4-'$4'<BR>";
				my $cell			= "$1$2";
				my $eoc				= $3;
				my $zero			= 0;
				$cell				=~ s/$esc[2]$fesc$zero/chr(0)/gsxe;
				$test{"$i-$4"} = $1 ;
				if ($cell eq "$fesc"."N"){$cell = undef}
				else {$cell			=~ s/$esc[2]$fesc([$esc[0]$fterm$esc[1]$fencl$esc[2]$fesc$esc[3]$lterm])/$1/g}
				$insert->[$jj]->[$i] = $cell;
				$i++;
				
			}
			pop @{$insert->[$jj]};
			if ($ignore){$ignore--;$insert->[0]=[]}
			else {$jj++}
			$i=0;
		}
	}


	my $table = $q->param('tables');
	my ($sth,$res) = prepare_execute("SELECT * FROM $table WHERE 1=0");
	my $Type	= $sth->{TYPE};
	my $bool = $sth->{mysql_is_num};
	$sth->finish();
	for (my $i=0; $i<@$insert; $i++){
		for (my $j=0; $j<@{$insert->[$i]}; $j++){
			$insert->[$i]->[$j] = $dbh->quote($insert->[$i]->[$j]);
#			$insert->[$i]->[$j] = $dbh->quote($insert->[$i]->[$j], $Type->[$j]);
		}
	}
	my $insertopt;
	if ($q->param('replacekey') eq 'ignore'){
		$insertopt = 'INSERT IGNORE';
	}
	elsif ($q->param('replacekey') eq 'replace'){$insertopt = 'REPLACE'}
	elsif ($q->param('replacekey') eq 'error'){$insertopt = 'INSERT'}
	my @value = ();
	foreach (@$insert){
		my $value = join ',',@{$_};
		push @value, "(".$value.")"; 
	}
	if (check_version("3.22.5")){
		my $value =  join ",\n",@value;
		my $query = "$insertopt INTO $table VALUES\n$value";
		$dbh->do($query) || return "Cannot insert.\n$query";
		return "Selected file was imported successfully\n";
	}
	else{
		foreach (@value){
			my $query = "$insertopt INTO $table VALUES\n$_";
			$dbh->do($query) || return "Cannot insert.\n$query\n";
		}
	}

	
}
sub export_ {
	my $input		= shift;
	my $query		= $input->{query};
	my $back		= $input->{back};
	my @file 		= ($q->param('exportintofile') eq 'new') ? $q->param('newfilename') : $q->param('selectfilelist');
	if (@file > 1)	{return "Too many files selected"}
	$file[0]		= deletespace($file[0]);
	if ($file[0]		=~ /[\/\\:\*\?\"<>]/){return qq!A filename cannot contain any of the following character:\n \\/:*?"<>|!}
	if (!$file[0] or ($file[0] eq 'NEW FILE NAME')){return "Please select a file or create a new one"}
	my ($sth, $res) = prepare_execute($query, $back);
	my $userhost	= myhost();
	my $userdir		= "$USER_DIR$delim$user.$userhost$delim" . "ascii";
	
	if ($q->param('exportintofile') eq 'new'){
		if (-e "$userdir$delim$file[0]"){return "File $file[0] already exists"}	
	}
	my $fterm 		= $q->param('fterm1')	? $q->param('fterm2')	: $q->param('fterm');
	my $fencl 		= $q->param('fencl1')	? $q->param('fencl2')	: $q->param('fencl');
	my $fesc 		= $q->param('fesc1')	? $q->param('fesc2')	: $q->param('fesc');
	my $lterm 		= $q->param('lterm1')	? $q->param('lterm2')	: $q->param('lterm');
	{
		my $long = "The `FIELDS [OPTIONALLY] ENCLOSED BY' and `FIELDS ESCAPED BY' values must be a single character or empty.\nThey can be specified as backslash followed by a letter: \\x,\nor as a Numeric Entity: &#xxx; (where xxx is character's three-digit numerical value)";
		if (length $fencl > 1 and ($fencl !~ /^(\\[a-zA-Z]|&#\d\d\d;)$/)) {
			return $long
		}
		if (length $fesc > 1 and ($fesc !~ /^(\\[a-zA-Z]|&#\d\d\d;)$/)) {
			return $long
		}
	}
	open FH, ">$userdir$delim$file[0]" or return (qq?$! "$file[0]"?);
	flock (FH,2) unless $WIN32;
	my $length 			= $sth->{mysql_length};
	my $maxlength 		= $sth->{mysql_max_length};
	my $Type 			= $sth->{TYPE};
	my $mysql_type_name	= $sth->{mysql_type_name};
	my $Nullable 		= $sth->{NULLABLE};
	my $Nameref			= $sth->{NAME};
	#($fterm,$fencl,$fesc,$lterm) = charesc($fterm,$fencl,$fesc,$lterm);
	$fterm			= backslash($fterm);
	$fencl			= backslash($fencl);
	$fesc			= backslash($fesc);
	$lterm			= backslash($lterm);
	my $zero		= chr(0);
	if ($q->param('mode') =~ /simple/i){
		if ($q->param('colnames')){
			my $result = join $fterm, @$Nameref;
			print FH $result, "\n";
		}
		while(my @result = $sth->fetchrow_array()){
			my $i = 0;
			foreach (@result){
# escape ENCLOSE and ESCAPE characters
				s{$fencl}{$fesc.$fencl}gse;
# convert ASCII 0 into ASCII 48 and escape it
				s{$zero}{$fesc."0"}gse;
				#s/\x0D\x0D/\x0D/gm;
# enclose when appropriate
				$_ = "$fencl$_$fencl" if /[$fterm"\n]/;
			}
			my $result = join $fterm,@result;						# add FIELDS TERMINATED BY characters
#			print FH $result,$lterm;								# add LINES TERMINATED BY characters
			print FH $result,"\n";								# add LINES TERMINATED BY characters
		}	
		$sth->finish();
		flock (FH,8) unless $WIN32;
		close FH;
		return 0;
	}
	
	if (($lterm eq '') and $fterm){$lterm = $fterm}
# ........
# If the FIELDS TERMINATED BY and FIELDS ENCLOSED BY values are both empty (''), 
# a fixed-row (non-delimited) format is used. With fixed-row format, no delimiters are used between fields. 
# Instead, column values are written and read using the ``display'' widths of the columns. 
# For example, if a column is declared as INT(7), values for the column are written using 7-character fields. 
# On input, values for the column are obtained by reading 7 characters. 
# Fixed-row format also affects handling of NULL values; see below. 
# Note that fixed-size format will not work if you are using a multi-byte character set.
# NULLs are treated as empty strings
#.........
#												MySQL Manual
#
	my $fixed			= 0;
	if ($fencl eq '' and $fterm eq ''){
		unless (belongsb($Type, -1)){$fixed = 1}
	}
	
	my ($fencl_,$fesc_,$fterm_,$lterm_) = ($fencl,$fesc,$fterm,$lterm);

	while(my @result = $sth->fetchrow_array()){
		my $i = 0;
		foreach (@result){
			($fencl,$fesc,$fterm,$lterm) = ($fencl_,$fesc_,$fterm_,$lterm_);
			if ($fixed){
				my $len	= $length->[$i];
				my $kk = (substr $_, 0, $len).(" " x($len - length $_));
				$_ = $kk;
			}
			else {
				my $esc = "\\";
# escape FIELDS ESCAPED BY characters
				if ($fesc ne ''){
					$fesc =~ /^(.)/s;
					my $fc = $1;
					if ($fesc =~ /[\+\?\.\*\^\$\(\)\[\{\|\\]/){
						s{$esc$fc}{$fesc.$fc}gsex
					}
					else{s{$fc}{$fesc.$fc}gse}
				}
# escape FIELDS ENCLOSED BY characters
				$fencl =~ /^(.)/s;
				if (($fesc ne $1) and ($fencl ne '')){
					my $fc = $1;
					if ($fencl =~ /[\+\?\.\*\^\$\(\)\[\{\|\\]/){s{$esc$fc}{$fesc.$fc}gse}
					else{s{$fc}{$fesc.$fc}gse}
				}
# escape The first character in FIELDS TERMINATED BY
				$fterm =~ /^(.)/s;
				if (($fesc ne $1) and ($fterm ne $fencl) and ($fterm ne '') and ($fencl eq '')){
					my $fc = $1;
					if ($fterm =~ /[\+\?\.\*\^\$\(\)\[\{\|\\]/){s{$esc$fc}{$fesc.$fc}gse}	
					else {s{$fc}{$fesc.$fc}gse}		
				}
# escape LINES TERMINATED BY characters
				$lterm =~ /^(.)/s;
				if (($fesc ne $1) and ($lterm ne $fencl) and ($lterm ne $fterm) and ($lterm ne '')){
					my $fc = $1;
					if ($lterm =~ /[\+\?\.\*\^\$\(\)\[\{\|\\]/){s{$esc$fc}{$fesc.$fc}gse}	
					else {s{$fc}{$fesc.$fc}gse}		
				}
# convert ASCII 0 into ASCII 48 and escape it
				s{$zero}{$fesc."0"}gse unless ($lterm eq "");
# escape NULLs
				unless (defined $_){$_ = ($fesc eq '') ? "NULL" : $fesc."N"} 
# enclose the correct data types
				else {$_ = "$fencl$_$fencl"  if  (					
						!$q->param('optionally') or 
		((abs $Type->[$i] <= 1) or (( $Type->[$i] >= 9 ) and (($Type->[$i]!=11) or $Nullable->[$i])))
							)
				}
			}
			#$_ = "<$_ LENGTH=$length->[$i], MAX_LENGTH=$maxlength->[$i], mTYPE=$Type->[$i], mTYPE_NAME=$mysql_type_name->[$i]>";  
			$i++;
		}
		my $result = join $fterm,@result;						# add FIELDS TERMINATED BY characters
		print FH $result,$lterm;								# add LINES TERMINATED BY characters
	}
	$sth->finish();
	flock (FH,8) unless $WIN32;
	close FH;
	return 0;
}
sub loadImportExportFile {
	my $border			= 0;
	my $input			= shift;
	my $func			= $q->param('func');
	my $action			= $q->param('action');
	my $userhost 		= myhost();
	my $chkusrdir		=  checkuserdir('ascii');
    my $userdir			= "$USER_DIR$delim$user.$userhost$delim" . "ascii";
	my $mode			= $q->param('setmode') || $q->param('mode') || "simple";
	my $sql				= $q->param('query');
	my $back 			= {	page => 'select_db', dbname => "$database"};
	my $table;			
	{
		my @table		= $q->param('tables'); 
		bail_out ("Too many tables selected", $back) if  @table > 1;
    	$table			= $table[0];
	}
	$back->{page} 				= 'tables';
	$back->{func} 				= $func;
	$back->{tables} 			= $table if $table;
	$back->{query}				= $sql if $sql;
	$back->{mode} 				= $mode;
	$back->{replacekey} 		= $q->param('replacekey'); 
	$back->{fterm} 				= $q->param('fterm'); 
	$back->{fterm1} 			= $q->param('fterm1'); 
	$back->{fterm2} 			= $q->param('fterm2'); 
	$back->{fencl} 				= $q->param('fencl'); 
	$back->{fencl1} 			= $q->param('fencl1'); 
	$back->{fencl2} 			= $q->param('fencl2'); 
	$back->{fesc} 				= $q->param('fesc'); 
	$back->{fesc1} 				= $q->param('fesc1'); 
	$back->{fesc2} 				= $q->param('fesc2'); 
	$back->{lterm} 				= $q->param('lterm'); 
	$back->{lterm1} 			= $q->param('lterm1'); 
	$back->{lterm2} 			= $q->param('lterm2');
	$back->{exportintofile} 	= $q->param('exportintofile');
	$back->{optionally} 		= $q->param('optionally');
	$back->{colnames} 			= $q->param('colnames');
	if ($func =~ /export/i){
		if (defined $q->param('SQL')){
			$back->{SQL} 				= $q->param('SQL');
			$back->{selectedscript} 	= $q->param('selectedscript');
		}
		elsif (defined $q->param('select')){
			my $tables					= $q->param('tables');
			my @cols 					= $q->param("fields_$tables");
			$back->{"select"}			= $q->param('select');
			$back->{where}				= $q->param('where');
			$back->{groupby}			= $q->param('groupby');
			$back->{orderby}			= $q->param('orderby');
			$back->{limit}				= $q->param('limit');
			$back->{"fields_$tables"}	= \@cols;
		}
		elsif (defined $q->param('searchresult')){
			my @fields					= $q->param('fields');
			$back->{rows}				= $q->param('rows');
			$back->{order}				= $q->param('order');
			$back->{where}				= $q->param('where');
			$back->{start}				= $q->param('start');
			$back->{count}				= $q->param('count');
			$back->{searchresult}		= $q->param('searchresult');
			$back->{fields}				= \@fields;
		}
	}
	if ($action =~ /export/i){
		my $sql_		= $sql || "SELECT * FROM $table";
		if(my $errmsg = export_({query => $sql_, back => $back})){bail_out($errmsg, $back)}
	}
	elsif ($action =~ /import/i){
		if(my $errmsg = import_({back => $back})){bail_out($errmsg, $back)}
	}
	elsif ($action =~ /(alter)|(create)/i){
		&loadAlterTable({back => $back});
		return
	}
	elsif ($action =~ /download/i){
		my @file = $q->param('selectfilelist');
		bail_out("Too many files selected", $back) if (@file > 1);
		bail_out("Please select a file", $back) if (@file == 0);
		if (my $errmsg = download($userdir, $file[0])){bail_out($errmsg, $back)} 
		exit
	}
	elsif ($action =~ /upload/i){
		if (my $sourse = $q->param('localfile')) {
			my $dest = $sourse;
			$dest =~ s/^(.*[\/|\\])*(.*)/$2/;
			my $dest_ = $dest;
			my $filexist = sub {
				if ($q->param('overwrite')){
					unlink $_[0]
				}
				else {
					close $sourse or bail_out("$!");
					bail_out("File $dest_ already exists",$back)
				}	
			};
			my $size_ = 0;
			if (-e "$userdir$delim$dest_") 
			{&$filexist("$userdir$delim$dest_"); $size_ = -s "$userdir$delim$dest_"}
    		if ($MAX_ASCII_SIZE){
        		my $size = dirsize($userdir);
    			$size += (-s $sourse) - $size_;
            	if ($size > ($MAX_ASCII_SIZE*1024)) {
        			my $errmsg = "Total size of this directory is limited to $MAX_ASCII_SIZE kb.";
        			$errmsg .= "\nPlease delete some files before uploading.";			
        			bail_out("$errmsg",$back);
        		}
    		}
			$dest = "$userdir$delim$dest";
			open (DEST, ">$dest") || bail_out ("$! $dest_", $back);
			flock (DEST,2) unless $WIN32;
			binmode $sourse;
			binmode DEST;
			my $data;
			while (read $sourse,$data,1024) {
				print DEST $data;
	    	}
			flock (DEST,8) unless $WIN32;
			close DEST;
			close $sourse or bail_out($!);
		}
		else {bail_out("Please select file to upload", $back)}
	}
	elsif ($action =~ /edit/i){
		my @file = $q->param('selectfilelist');
		bail_out("Too many files selected", $back) if (@file > 1);
		bail_out("Please select a file", $back) if (@file == 0);
		my $errmsg = editfile({path => $userdir, back => $back});
		bail_out($errmsg, $back) if $errmsg;
		return 0 unless defined $errmsg
	}
	elsif ($action =~ /delete/i){
		my @file = $q->param('selectfilelist');
		bail_out("Please select a file", $back) if (@file == 0);
		my $errmsg = deletefiles({path => $userdir, back => $back});
		bail_out($errmsg, $back) if $errmsg;
		return 0 unless defined $errmsg;
	}
	my $multiform = $q->start_multipart_form(-action=>$full_url, -method=>"post");
	my $selectfilelist = qq!\n<SELECT NAME="selectfilelist" SIZE=8 MULTIPLE  TITLE="Select file">\n!;
	my $tsize		= 0;
	my @files 		= ();
	my @lables		= ();
	unless ($chkusrdir){

		opendir DIR, $userdir; 
		my @filenames	= readdir (DIR) or print "Cannot read this directory: $userdir<br>";
		closedir DIR;

        foreach (@filenames){
			next if (($_ eq '.') or ($_ eq '..'));
			my $file  = "$userdir$delim$_";
			unless (-d $file){
				my @stat = stat $file;
				my $size = $stat[7];
				$tsize += $size;
				my $date = scalar localtime ($stat[9]);
				$date =~ s/^\s*\w\w\w\s*(.*)/$1/;
				s/^(.*[\/\\])*(.*)$/$2/;
				push @files, $_;
				push @lables, "$_ /$size/ $date";
			}
		}
		$tsize = int($tsize / 1024 * 100) / 100;
		if (@files == 0){$selectfilelist .=  "\t<OPTION VALUE=\"\">FILE LIST IS EMPTY"}
		else{
			@files 		= quoteit(@files);
			@lables		= quoteit(@lables);
			for (my $j=0; $j<@files; $j++) {
				$selectfilelist .= "\t<OPTION VALUE=\"$files[$j]\">$lables[$j]\n"
			}
		}
	}
	else {
		$selectfilelist .= qq!<OPTION VALUE="">$chkusrdir\n!;
		$selectfilelist .= qq?<OPTION VALUE="">$!\n?;
	}
	my $exportfile		= '';
	my $hidden = <<EOT
<INPUT TYPE=HIDDEN NAME="page" 		VALUE="tables">
<INPUT TYPE=HIDDEN NAME="dbname" 	VALUE="$database">
<INPUT TYPE=HIDDEN NAME="func" 		VALUE="$func">
<INPUT TYPE=HIDDEN NAME="mode" 		VALUE="$mode">
EOT
;
	my $nameheader = uc $func;
	if ($func =~ /export/i){
		if (defined $sql){ # Export query result
			bail_out ("Query is empty", {dbname => $database, page => 'select_db'}) unless $sql;
			$sql 				= quoteit($sql);
			$hidden .= qq!<INPUT TYPE=HIDDEN NAME="query" 			VALUE="$sql">\n!;
			my $backhidden = qq!<INPUT TYPE=HIDDEN NAME="dbname" 			VALUE="$database">\n!;
			if (defined $q->param('SQL')){
				my $value			= quoteit ($q->param('SQL'));
				my $selectedscript	= quoteit ($q->param('selectedscript'));
				$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="SQL" 			VALUE="$value">\n!;
				$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="selectedscript" 	VALUE="$selectedscript">\n!;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="SQL" 			VALUE="$value">\n!;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="selectedscript" 	VALUE="$selectedscript">\n!;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="script" 			VALUE="execute">\n!;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="page" 			VALUE="tables">\n!;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="func" 			VALUE="script">\n!;
			}
			elsif(defined $q->param('select')){
				my $param			= backtoselect();
				my $concatenate;
				foreach (keys %$param){
					$concatenate .= $q->hidden(-name=>$_, -value=>$param->{$_}, -override=>1)."\n";
				}
				$backhidden 		.= $concatenate;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="func" 			VALUE="select">\n!;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="page" 			VALUE="tables">\n!;

				$hidden 			.= $concatenate;
			}
			elsif (defined $q->param('searchresult')){
				my @fields					= $q->param('fields');
				my $concatenate;
				foreach ('rows','tables','order','where','start','count'){
					$concatenate .= $q->hidden(-name=>$_, -value=>$q->param($_), -override=>1)."\n";
				}
				$concatenate .= $q->hidden(-name=>"fields", -value=>\@fields, -override=>1)."\n";
				$backhidden 		.= $concatenate;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="func" 			VALUE="return">\n!;
				$backhidden 		.= qq!<INPUT TYPE=HIDDEN NAME="page" 			VALUE="searchresult">\n!;
				$hidden 			.= $concatenate;
				$hidden 			.= qq!<INPUT TYPE=HIDDEN NAME="searchresult" 	VALUE="1">\n!;
			}
			
			print <<EOT
<TABLE BORDER=0><!-- Header Table -->
<FORM ACTION=$full_url METHOD=POST>
	<TR><TH COLSPAN=5 ALIGN=LEFT>$nameheader</TH><TR>
	<TR>
		<TD><INPUT TYPE=SUBMIT NAME="" VALUE="BACK" TITLE="Return to previous page"></TD>
	</TR>
$backhidden
</FORM>
</TABLE><!-- End of Header Table -->
EOT
;

		}
		else { # Export the entire table
			bail_out ("Table is not selected", {dbname => $database, page => 'select_db'}) unless $table;
			$hidden .= qq!<INPUT TYPE=HIDDEN NAME="tables" 	VALUE="$table">\n!;
			printHeaderTable( {name =>(uc $func), table => "TABLE: $table"} );
		}
		my $newformsize		= $agent ? 16 : 27;
		my $exportintofile1			= $q->radio_group(-name => "exportintofile", -values => ["new"], 		labels => {new => ''},		default=>"new", title=>"Check to create new file");
		my $exportintofile2			= $q->radio_group(-name => "exportintofile", -values => ["existing"],	labels => {existing => ''},	default=>"-", title=>"Check to overwrite an existing file");
		$exportfile =<<EOT
$exportintofile1&nbsp;Create&nbsp;New&nbsp;File&nbsp;<INPUT TYPE=TEXT NAME="newfilename" SIZE=$newformsize TITLE="Type the Name of a new file" 
onFocus="if(this.value=='NEW FILE NAME')this.value='';" onBlur="if(this.value=='')this.value='NEW FILE NAME';" VALUE="NEW FILE NAME"><BR>		
$exportintofile2&nbsp;Overwrite existing file<BR>		
EOT
;		
	}
	else { # IMPORT
		bail_out ("Table is not selected", {dbname => $database, page => 'select_db'}) unless $table;
		$hidden .= qq!<INPUT TYPE=HIDDEN NAME="tables" 	VALUE="$table">\n!;
		printHeaderTable( {name =>(uc $func), table => "TABLE: $table"} );
	}
	
	$selectfilelist 	.= "</SELECT> \n";
	my $narrowstyle 	= qq!style="width: 100;"!;
	my $buttonstyle1 	= qq!style="width: 150;"!;
	my $buttonstyle2 	= qq!style="width: 360;"!;
	my $finput			= $agent ? 25 : 36;
	my $advanced;
	my $setmode;
	my $colnames		= $q->checkbox(-name => "colnames", -label => '', title=>"Check to include column names into first row");
	my $ignorekey		= $q->radio_group(-name => "replacekey", -values => ["ignore"], 	-label => {ignore => ''},	default=>"-", title=>"Check to ignore input on duplicate Unique Key Values" );
	my $replacekey		= $q->radio_group(-name => "replacekey", -values => ["replace"], 	-label => {replace => ''},	default=>"-", title=>"Check to replace existing row on duplicate Unique Key Values");
	my $errorkey		= $q->radio_group(-name => "replacekey", -values => ["error"], 		-label => {error => ''},	default=>"error", title=>"Check to abort input on duplicate Unique Key Values and get Error message");
if ($mode =~ /advanced/i){
		my $ignore = <<EOT
	<TR>
		<TD COLSPAN=5 ALIGN=CENTER><P><B>Other Options:</B></TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT COLSPAN=4><P>Ignore:</TD>
		<TD><INPUT TYPE=TEXT NAME="ignore" VALUE="" SIZE=4 TITLE="Type number of lines to ignore"> lines</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT COLSPAN=4><P>Ignore input on duplicate Unique Key Values:</TD>
		<TD>$ignorekey</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT COLSPAN=4><P>Replace&nbsp;existing&nbsp;row&nbsp;on&nbsp;duplicate&nbsp;Unique&nbsp;Key&nbsp;Values:</TD>
		<TD>$replacekey</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT COLSPAN=4><P>Get&nbsp;error&nbsp;on&nbsp;duplicate&nbsp;Unique&nbsp;Key&nbsp;Values:</TD>
		<TD>$errorkey</TD>
	</TR>
EOT
		if ($func =~ /import/i);
		my $fterm	 = $q->scrolling_list(
		   		  	 			   		-name		=> 'fterm',
										-value		=> ["\&#009;", ",", ";", "|", " ", ""],
										-labels		=> {"\&#009;"	=> 'tab (\\t)',
														","		=> 'comma',
														";"		=> 'semicolon',
														"|"		=> 'pipe',
														" "		=> 'space',
														""		=> ''},
										-size		=> 1,
										-default	=> "\t",
										-title		=> 'Select delimiter'
								);
		my $fencl	 = $q->scrolling_list(
		   		  	 			   		-name		=> 'fencl',
										-value		=> ["", "'", '"'],
										-size		=> 1,
										-default	=> "",
										-title		=> 'Select Enclosed By character'
								);
		my $fesc	 = $q->scrolling_list(
		   		  	 			   		-name		=> 'fesc',
										-value		=> ["\\"],
										-size		=> 1,
										-default	=> "\\",
										-title		=> 'Select Escaped By character'
								);
		my $lterm	 = $q->scrolling_list(
		   		  	 			   		-name		=> 'lterm',
										-value		=> ["\n"],
										-labels		=> {"\n"	=> 'New Line'},
										-size		=> 1,
										-title		=> 'Select Lines Terminated By character'
								);
		my $checktitle1 = 'Check to use another character';
		my $checktitle2 = 'Type a single character or its numeric entity: &#xxx;.';
		my $checktitle3 = 'Type other characters or their numeric entity: &#xxx;.';
		my $charlength = $agent ? 4 : 6;
		my $fterm1					= $q->checkbox(-name => 'fterm1', -label => '', title => $checktitle1);
		my $fterm2					= $q->textfield(-name => 'fterm2', -size => $charlength, title => $checktitle2);
		my $fencl1					= $q->checkbox(-name => 'fencl1', -label => '', title => $checktitle1);
		my $fencl2					= $q->textfield(-name => 'fencl2', -size => $charlength, title => $checktitle2);
		my $fesc1					= $q->checkbox(-name => 'fesc1', -label => '', title => $checktitle1);
		my $fesc2					= $q->textfield(-name => 'fesc2', -size => $charlength, title => $checktitle2);
		my $lterm1					= $q->checkbox(-name => 'lterm1', -label => '', title => $checktitle1);
		my $lterm2					= $q->textfield(-name => 'lterm2', -size => $charlength, title => $checktitle3);
		my $optionally				= $q->checkbox(-name => 'optionally', -label => '', title => "If checked, only strings will be enclosed");
		$advanced = <<EOT
	<TABLE BORDER=$border>
		<TR>
			<TD COLSPAN=5><P><INPUT TYPE=SUBMIT NAME="action" VALUE="$func" $buttonstyle2></TD>
		</TR>
		<TR>
			<TD COLSPAN=5 ALIGN=CENTER><P><B>File Format:</B></TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT TITLE="Select a delimiter"><P>Fields terminated by:</TD>
			<TD TITLE="Select a delimiter"><P>

$fterm</TD>
			<TD><P>Other $fterm1</TD>
			<TD><P>$fterm2</TD>
			<TD><P>&nbsp;</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT TITLE="Select Enclosed By character"><P>Fields enclosed by:</TD>
			<TD TITLE="Select Enclosed By character"><P>
$fencl</TD>
			<TD><P>Other $fencl1</TD>
			<TD><P>$fencl2</TD>
			<TD><P>$optionally&nbsp;Optionally</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT TITLE="Select Escaped By character"><P>Fields escaped by:</TD>
			<TD TITLE="Select Escaped By character"><P>
$fesc</TD>
			<TD><P>Other $fesc1</TD>
			<TD><P>$fesc2</TD>
			<TD><P>&nbsp;</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT TITLE="Select Lines Terminated By character"><P>Lines terminated by:</TD>
			<TD TITLE="Select Lines Terminated By character"><P>
$lterm</TD>
			<TD><P>Other $lterm1</TD>
			<TD><P>$lterm2</TD>
			<TD><P>&nbsp;</TD>
		</TR>

$ignore

	</TABLE>

EOT
;
	$setmode = <<EOT

	<TR>
		<TD ALIGN=RIGHT><P>
<INPUT TYPE=SUBMIT NAME="" VALUE="Reload Default Values" TITLE="Click to reset all values">
		</TD>
		<TD ALIGN=RIGHT><P>
<INPUT TYPE=SUBMIT NAME="setmode" VALUE="<< Simple (CSV)" style="width: 150;" TITLE="Click to switch to CSV mode">
		</TD><TD WIDTH=80><P>&nbsp;</TD>
	</TR>
EOT
;
	}
	else {
		my $ignore = ($func =~ /import/i) ? <<EOT
	<TR>
		<TD ALIGN=RIGHT><P>Ignore:</TD>
		<TD><INPUT TYPE=TEXT NAME="ignore" VALUE="" SIZE=4 TITLE="Type number of lines to ignore"> lines</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT><P>Ignore input on duplicate Unique Key Values:</TD>
		<TD>$ignorekey</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT><P>Replace&nbsp;existing&nbsp;row&nbsp;on&nbsp;duplicate&nbsp;Unique&nbsp;Key&nbsp;Values:</TD>
		<TD>$replacekey</TD>
	</TR>
	<TR>
		<TD ALIGN=RIGHT><P>Get&nbsp;error&nbsp;on&nbsp;duplicate&nbsp;Unique&nbsp;Key&nbsp;Values:</TD>
		<TD>$errorkey</TD>
	</TR>

EOT
:
		<<EOT
		<TR>
			<TD ALIGN=RIGHT>Include column names:</TD>
			<TD>&nbsp;$colnames</TD>
		</TR>
EOT
;
	my @fterm = (
		$q->radio_group(-name=>"fterm", -values=>[','], -labels=>{','=>''}, -default=>",", title=>"Check to use comma separated values"),
		$q->radio_group(-name=>"fterm", -values=>[';'], -labels=>{';'=>''}, -default=>"-", title=>"Check to use semicolon separated values")
		);
	
	$advanced = <<EOT
<INPUT TYPE=SUBMIT NAME="action" VALUE="$func" $buttonstyle2 TITLE="Click to $func text file">
	<TABLE BORDER=$border>
		<TR>
			<TD COLSPAN=2 ALIGN=CENTER><B>File Format (CSV):</B></TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT>Comma-separated values:</TD>
			<TD>&nbsp;$fterm[0]</TD>
		</TR>
		<TR>
			<TD ALIGN=RIGHT>Semicolon-separated values:</TD>
			<TD>&nbsp;$fterm[1]</TD>
		</TR>
		<TR>
			<TD COLSPAN=2 ALIGN=CENTER><B>Other Options:</B></TD>
		</TR>
$ignore
	</TABLE>
<INPUT TYPE=HIDDEN NAME="fencl" VALUE="&quot;">
<INPUT TYPE=HIDDEN NAME="fesc" VALUE="&quot;">
<INPUT TYPE=HIDDEN NAME="lterm" VALUE="
">

EOT
;
	$setmode = <<EOT
	<TR>
		<TD ALIGN=RIGHT><P>
<INPUT TYPE=SUBMIT NAME="setmode" VALUE="Advanced >>" $buttonstyle1 TITLE="Click to switch to Advanced mode (Mysql compatible text files)">
		</TD>
		<TD WIDTH=30></TD>
	</TR>
EOT
;
		
	}
	print <<EOT

		<TABLE BORDER=$border>
			<TR>
				<TD>
<TABLE BORDER=$border>
$multiform
		<TR>
		<TD VALIGN=TOP><P>
$exportfile
$selectfilelist
<BR>
		<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=$border>
			<TR>
				<TD><P>
				<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=$border>
					<TR>
						<TD><P><INPUT TYPE=SUBMIT NAME="action" VALUE="View/Edit" $narrowstyle TITLE="Click to view/edit selected file"></TD>
						<TD><P><INPUT TYPE=SUBMIT NAME="action" VALUE="Delete" $narrowstyle TITLE="Click to delete selected files"></TD>
						<TD><P><INPUT TYPE=SUBMIT NAME="action" VALUE="Download" $narrowstyle TITLE="Click to download selected files"></TD>
					</TR>
				</TABLE></TD>
				<TD><P>&nbsp;</TD>
			</TR>
		<!--	<TR>
				<TD><INPUT TYPE=SUBMIT NAME="action" VALUE="Download" TITLE="Click to download selected files"></TD>
				<TD ALIGN=RIGHT><INPUT TYPE=SUBMIT NAME="action" VALUE="Compress" $buttonstyle1 TITLE="Click to compress selected files"></TD>
				</TD>
			</TR> -->
			<TR>
				<TD COLSPAN=2 HEIGHT=6></TD>
			</TR>
			<TR>
				<TD COLSPAN=2><P><INPUT TYPE=FILE NAME="localfile" SIZE=$finput title="Select file to upload"></TD>
			</TR>
			<TR>
				<TD><P>
				<TABLE CELLPADDING=0 CELLSPACING=0 BORDER=$border WIDTH="100%">
					<TR>
						<TD><P><INPUT TYPE=CHECKBOX NAME="overwrite" TITLE="Check to overwrite existing file">&nbsp;Overwrite&nbsp;if&nbsp;exists</TD>
						<TD ALIGN=RIGHT><P><INPUT TYPE=SUBMIT NAME="action" VALUE="Upload" $buttonstyle1 TITLE="Click to upload selected file"></TD>
					</TR>
				</TABLE></TD>
				<TD ALIGN=RIGHT><P>&nbsp;</TD>
			</TR>
		</TABLE>
		</TD>
		<TD>&nbsp;</TD>
			<TD VALIGN=TOP><P>
<!-- selecttable -->
$advanced
		</TD>
	</TR>
$hidden
</FORM>	
</TABLE>

	</TD>
		</TR>
		<TR>
	<TD ALIGN=RIGHT>

<TABLE BORDER=$border CELLPADDING=0 CELLSPACING=0>
<FORM METHOD=POST ACTION="$full_url">
$setmode
$hidden
</FORM>
	
</TABLE>
			</TD>
		</TR>
	</TABLE>
EOT
;
	
}

sub editfile {
	my $input = shift;
	my $path	= $input->{path};
	my $back	= $input->{back};
	my $errmsg = '';
	my @files = $q->param('selectfilelist');
	if ($q->param('save')){
		open FH, ">$path$delim$files[0]" or $errmsg = qq?<font color="#ff0000">Could not open file $files[0]. $!</font>?;
		flock (FH,2) unless $WIN32;
		print FH $q->param('filebody');
		flock (FH,8) unless $WIN32;
		close FH;
	}
	elsif($q->param('saveas')){
		my $filename = $q->param('filename');
		if (!$q->param('overwrite') and -e "$path$delim$filename"){
			$errmsg = qq!<font color="#ff0000">File <b>$filename</b> already exists</font>!;
		}
		else {
			open FH, ">$path$delim$filename" or $errmsg = qq?<font color="#ff0000">Could not open File $filename. $!</font>?;
			flock (FH,2) unless $WIN32;
			print FH $q->param('filebody');
			flock (FH,8) unless $WIN32;
			close FH;
		}
		$files[0] = $filename;
	}
	elsif ($q->param('back')){
		return 0;
	}
	else{
		unless ($input->{new}){
			if(!-f $path.$delim.$files[0]){
				return "Selected file does not seem to be editable";
			}
		}
	}
	my $file;
	if ($q->param('action') =~ /view\/edit/i or $q->param('reload')){
		$file = "";
		open FH, "$path$delim$files[0]" or return("Cannot open $files[0]");
		flock (FH,2) unless $WIN32;
		while (<FH>){
			$file .= $_
		}
		flock (FH,8) unless $WIN32;
		close FH;
	}
	else {$file = $q->param('filebody')}
	$file = quoteit($file);
	my ($wrap, $checked_on, $checked_off);
	if ($q->param('wrap') eq 'on'){
		$wrap = "wrap=virtual";
		$checked_on = "checked";
		$checked_off = "";
	}
	else {
		$wrap = "wrap=off";
		$checked_on = "";
		$checked_off = "checked";
	}
	my ($cols, $rows);
	if ($q->param('resize')){
		($cols, $rows) = ($q->param('cols_'),$q->param('rows_'));
	}
	else {
		unless (($cols, $rows) = ($q->param('cols_h'),$q->param('rows_h'))){
			($cols, $rows) = $agent ? (80, 25) : (150, 25)
		}
	}
	my $func = $q->param('func');
	my $hiddenback;
	foreach (keys %$back){
		$hiddenback .= $q->hidden(-name=>$_, -value=>$back->{$_}, -override=>1)."\n";
	}
	print <<EOT
<form action="$full_url" method=post>
<table border=0 cellpadding=0 cellspacing=0>
	<tr height=6>
		<td colspan=7><p>
		<table  border=0 cellpadding=0 cellspacing=0>
			<tr>
				<td><input type=submit name="save" value="Save" title="Click to save changes" style="width: 100px"></td>
				<td><p><input type=submit name="saveas" value="Save as" title="Click to save as another file" style="width: 100px"></td>
				<td><p>&nbsp;</td>
				<td><p><input type=text name="filename" title="Type a file name to save as"></td>
				<td><p><input type=checkbox name="overwrite" title="Check to overwrite if file name already exists"></td>
				<td><p>Overwrite if exists</td>
			</tr>
		</table>
		</td>
		<td colspan=3 align=right><p><input type=submit name="back" value="Close" title="Click to return back. All changes will be lost" style="width: 100"></td>
	</tr>
	<tr height=6>
		<td colspan=10 ><p>
			<table  border=0 cellpadding=2 cellspacing=2>
				<tr>
					<td height=14><p>$errmsg</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr valign=center>
		<td><p>
		<table  border=0 cellpadding=0 cellspacing=0>
			<tr>
				<td><p><input type=submit name="reload" value="Reload File" title="Click to reload file. All changes will be lost" style="width: 100"></td>
				<td><p><input type=reset style="width: 100"></td>
			</tr>
		</table>
		</td>
		<td width=60>&nbsp;</td>
		<td>Wrap text</td>
		<td><input type=radio name="wrap" value="on" onClick="this.form.submit()" $checked_on title="Check to wrap text"><nobr>&nbsp;on&nbsp;</nobr></td>
		<td><input type=radio name="wrap" value="off" onClick="this.form.submit()" $checked_off title="Check to unwrap text"><nobr>&nbsp;off</nobr></td>
		<td width=10>&nbsp;</td>
		<td>Cols&nbsp;<input type=text name="cols_" value="$cols" size=3 title="Define area width"></td>
		<td width=2>&nbsp;</td>
		<td>Rows&nbsp;<input type=text name="rows_" value="$rows" size=3 title="Define area height"></td>
		<td><input type=submit name="resize" value="Resize" title="Click to apply new area dimensions" style="width: 100"></td>
	</tr>
</table>
<br>
<textarea name="filebody" cols=$cols rows=$rows $wrap title="Edit file">$file</textarea><p>
FILE NAME: <b>$files[0]</b><br>
<input type=hidden name="path" value="$path">
<input type=hidden name="edit" value="continue">
<input type=hidden name="selectfilelist" value="$files[0]">
<input type=hidden name="cols_h" value="$cols">
<input type=hidden name="rows_h" value="$rows">
<input type=hidden name="action" value="edit">
$hiddenback
</form>
EOT
;
	return undef;
}
sub deletefiles {	
	my $input 	= shift;
	my $path 	= $input->{path};
	my $back	= $input->{back};
	my @filestodelete = $q->param('selectfilelist');
	return 0 if $q->param('cancel');
	unless ($q->param('deleteconfirm')) {
		my $func = $q->param('func');
		print qq!<FORM ACTION="$full_url" METHOD=POST>!;
		print qq!<BR><P TITLE="List of files to be deleted"><B>THESE FILES WILL BE DELETED:</B></P>\n!;
		foreach (@filestodelete){
			$_ = quoteit($_);
			print qq!<INPUT TYPE=CHECKBOX NAME="selectfilelist" VALUE="$_" CHECKED TITLE="Uncheck to keep this file"> $_ <BR>\n!;
		}
		my $hiddenback;
		foreach (keys %$back){
			$hiddenback .= $q->hidden(-name=>$_, -value=>$back->{$_}, -override=>1)."\n";
		}
		print <<EOT
<BR><INPUT TYPE=SUBMIT NAME="deleteconfirm" VALUE="DELETE" TITLE="Delete selected files">&nbsp;
<INPUT TYPE=SUBMIT NAME="cancel" VALUE="CANCEL" TITLE="Go back to previous page without deletion">
<INPUT TYPE=HIDDEN NAME="delete" VALUE="1">
<INPUT TYPE=HIDDEN NAME="action" VALUE="delete">
$hiddenback
</FORM>
EOT
;

		return undef;			
	}
	else {
		my $errmsg = '';
		foreach (@filestodelete){
			my $file = "$path$delim$_";
			$errmsg .= "Could not unlink $_ : $!\n" unless unlink ($file);
		}
		return $errmsg 
	}
}
sub loadBackup{
	if ($q->param('back')){loadSelectTables(); return}
	elsif($q->param('backup')){&execBackup()}
	elsif($q->param('restore')){&loadRestore(); return}

	my @databases;
	my $selectdbname_   = $q->param('selectdbname_');
	$selectdbname_  = $database unless $selectdbname_;
	my $databasesref = getdblist($dbh);
	my $selectDBlist;
	if ($DBI::err and !$database){
		$selectDBlist = $q->scrolling_list(
                		-name   =>'selectdbname_',
 						-labels	=>{'' => 'ACCESS DENIED'},
               			-values =>[''],
                		-size   =>1,
					);
	}
	else {
		@databases = @$databasesref;
		push @databases,'' unless $selectdbname_;					
		$selectDBlist = $q->scrolling_list(
                		-default=>[$database],
                		-name=>'selectdbname_',
                		-values=>[@databases],
                		-size=>1,
						-onChange=>'this.form.submit()'
					);
	}
	my $downloadcheck 	= 'CHECKED' if $q->param('downloadBackup');
	my $keepcheck 		= 'CHECKED' if ($q->param('keep') or (!$q->param('downloadBackup') and !$q->param('keep')));
	my $dropcheck 		= 'CHECKED' if $q->param('dropifexists');
	my ($bothcheck, $structurecheck, $datacheck);
	if ($q->param('include') eq 'structure'){$structurecheck = 'CHECKED'}
	elsif ($q->param('include') eq 'data'){$datacheck  = 'CHECKED'}
	else {$bothcheck = 'CHECKED'}
	my  $buttonwidth 	= '110px';
	my  $buttonwidth2 	=  ($buttonwidth * 2) + 15;
	my $filenamestyle	= "style= 'width: $buttonwidth2"."px'";
	my $remotefile;
	if ($q->param('suggest')) {
		my $back					= {page => "$page"};
		$back->{dbname}				= "$database" if $database;
		$back->{selectdbname_}		= "$selectdbname_" if $selectdbname_;
		my $userhost				= myhost();
		if (my $errmsg = checkuserdir('backup')){bail_out("$errmsg\n$!", $back)}
		my $userdir 				= "$USER_DIR$delim$user.$userhost$delim" . "backup";
	
	
		bail_out("Select a database first") unless ($selectdbname_);
		my @files = ();
		opendir DIR, $userdir; 
		my @filenames	= readdir (DIR) or print "Cannot read this directory: $userdir<br>";
		closedir DIR;
		my $n = 0;
		for (@filenames){
			next if (($_ eq '.') or ($_ eq '..'));
			s/^(.*\/)*(.*)$/$2/;
			if (/^(.+)(\.[a-zA-Z]*)$/){push @files, $1}
			else {push @files, $_}
		}
		$remotefile = "$user.$userhost.$selectdbname_.0";		
		for (0..$#files){
			if (belongs(\@files, $remotefile)){
				$n++;
				$remotefile = "$user.$userhost.$selectdbname_.$n";
			}
		}
	}
	my $tablelist = qq!\n<SELECT NAME="tablelist" SIZE=13 MULTIPLE>\n!;
	my $tablelistref;
	if ($selectdbname_) {
		$tablelistref = $dbh->selectcol_arrayref("SHOW TABLES FROM $selectdbname_");
		if (! defined $tablelistref ) {
			if ($DBI::err){
				if ($DBI::errstr =~ /access/i){
					$tablelist .= qq!<OPTION VALUE="">ACCESS DENIED\n!;
				}
				else{
					$tablelist .= qq!<OPTION VALUE="">CANNOT SHOW TABLES\n!;
					$tablelist .= qq!<OPTION VALUE="">Check database name\n!;
				}
			}
			else {$tablelist .= qq!<OPTION VALUE="">CANNOT SHOW TABLES\n!}
		}
		elsif (@$tablelistref == 0){
			$tablelist .= qq!<OPTION VALUE="">Table list is empty\n!;
		}
		else{
			my @tblist = $q->param('tablelist');
			foreach (@$tablelistref){
				my $selected = 'SELECTED' if belongs(\@tblist, $_);
				$tablelist .= qq!<OPTION VALUE="$_" $selected>$_!
			}
		}
	}
	else {
		$tablelist .= qq!<OPTION VALUE="">SELECT DATABASE\n!;
	}
	$tablelist .= "</SELECT>\n";
	my $textsize 		= $agent ? 21 : 36 ;
	my $gzipchecked 	= 'CHECKED' if (($q->param('type') eq 'gzip') or  !$q->param('type'));
	my $zipchecked 		= 'CHECKED' if ($q->param('type') eq 'zip');
	
	my $zipselect 		= qq!<INPUT TYPE=RADIO NAME="type" VALUE="zip" $zipchecked TITLE="Select to create compressed backup file (ZIP format)"><I>zip</I>! if $ALLOW_ZIP;
	my $targzselect 	= qq!<INPUT TYPE=RADIO NAME="type" VALUE="gzip" $gzipchecked TITLE="Select to create compressed backup file (GZIP format)"><I>gzip</I>! if $ALLOW_GZIP;
	my $textchecked 	= 'CHECKED' if ((!$ALLOW_GZIP and !$q->param('type')) or ($q->param('type') eq 'text'));
	my $selectallcheck 	= 'CHECKED' if $q->param('selectalltables');

	print <<EOT
<FORM METHOD=POST ACTION="$full_url">
<TABLE BORDER=0>
	<TR><TH ALIGN=LEFT COLSPAN=3>CREATE BACKUP</TH></TR>
	<TR><TD VALIGN=TOP>
<!-- BACKUP CONTROL PANEL -->
<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA"   WIDTH=240><!-- BORDER START -->
			<TR>
				<TD width="100%">
<TABLE WIDTH="100%" BORDER=0 CELLPADDING=3 CELLSPACING=0 BGCOLOR="#AAAAAA" >
	<TR><TD BGCOLOR="#CCCCCC"><INPUT TYPE=CHECKBOX NAME="downloadBackup" $downloadcheck TITLE="Download created backup file">&nbsp;Download&nbsp;
			<INPUT TYPE=CHECKBOX NAME="keep" $keepcheck TITLE="Save created backup file on the server">&nbsp;Save</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC"><INPUT TYPE=CHECKBOX NAME="dropifexists" $dropcheck TITLE="Include SQL query 'DROP TABLE IF EXISTS tablename' for each table into backup ">&nbsp;Add&nbsp;'DROP&nbsp;TABLE'</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC">Include:&nbsp<INPUT TYPE=RADIO NAME="include" VALUE="structure" $structurecheck TITLE="Include only 'CREATE TABLE...' SQL query into backup"
		><I>Structure</I><INPUT TYPE=RADIO NAME="include" VALUE="data" $datacheck TITLE="Include only 'INSERT INTO TABLE...' SQL query into backup"
		><I>Data</I><INPUT TYPE=RADIO NAME="include" VALUE="both" $bothcheck TITLE="Include both 'CREATE TABLE...' and 'INSERT INTO TABLE ... ' SQL queries into backup"><I>Both</I></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC"><P><INPUT TYPE=SUBMIT NAME="suggest" VALUE="Suggest output file name"   style="width: $buttonwidth2" TITLE="Ask the program to propose an appropriate name for backup file"><BR>
		<INPUT TYPE=TEXT NAME="remotefile" VALUE="$remotefile" SIZE=$textsize TITLE="Type name of backup file" $filenamestyle></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC">Type:&nbsp;$zipselect&nbsp;$targzselect&nbsp;<INPUT TYPE=RADIO NAME="type" VALUE="text" $textchecked TITLE="Select to create plain text backup file"><I>text</I>&nbsp;</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC" ><INPUT TYPE=SUBMIT NAME="backup" VALUE="CREATE BACKUP FILE"  style="width: $buttonwidth2" TITLE="Create backup file"></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC"><INPUT TYPE=SUBMIT NAME="restore" VALUE="        SELECT FILE       "  style="width: $buttonwidth2" TITLE="Backup file manager"></TD>
	</TR>
</TABLE>
				</TD></TR><!-- BORDER END -->
</TABLE>

<!-- END BACKUP CONTROL PANEL -->
</TD>
<TD>&nbsp;</TD>
<TD VALIGN=TOP>

<!-- SELECT DATABASE AND TABLE  -->

<TABLE BORDER=0 CELLPADDING=1 CELLSPACING=0 BGCOLOR="#AAAAAA" >
			<TR>
				<TD width="100%"><!-- BORDER START -->

<TABLE WIDTH=200 BORDER=0 CELLPADDING=4 CELLSPACING=0 BGCOLOR="#AAAAAA">
	<TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Databases available on this server">SELECT DATABASE:
<BR><nobr>$selectDBlist&nbsp;<INPUT TYPE=SUBMIT VALUE="<-" TITLE="Show tables in selected database"></nobr></TD>
		
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Select tables to backup">SELECT TABLE:<BR>
$tablelist
		</TD>
	</TR>
	<TR>
		<TD BGCOLOR="#CCCCCC" TITLE="Select all tables"><INPUT TYPE=CHECKBOX NAME="selectalltables" $selectallcheck TITLE="Select all tables"> SELECT ALL TABLES</TD>
	</TR>
</TABLE>
				
				</TD><!-- BORDER END -->
			</TR>
</TABLE>

<!-- END SELECT DATABASE AND TABLE -->

</TD></TR></TABLE>
<INPUT TYPE=HIDDEN NAME="page" VALUE="$page">
<INPUT TYPE=HIDDEN NAME="func" VALUE="backup">
<INPUT TYPE=HIDDEN NAME="dbname" VALUE="$database">
</FORM>

EOT
;


}
sub dirsize {
	my $dir = shift;
	my $size = 0;
	opendir DIR, $dir; 
	my @filenames	= readdir (DIR); # or print "Cannot read this directory: $dir<br>";
	closedir DIR;
 	foreach (@filenames){
		next if (($_ eq '.') or ($_ eq '..'));
		my $file  = "$dir$delim$_";
		unless (-d $file){
			$size += -s _;
		}
	}#foreach
	return $size
}
sub get_mysql_pri {
	my $sth = shift @_;
	my $pri;
	if (eval {local $SIG{__DIE__};  $pri = $sth->{mysql_is_pri_key}}) {
		return $pri
	}
	else {return $sth->{is_pri_key}}
}
sub get_mysql_length {
	my $sth = shift @_;
	my $len;
	if (eval {local $SIG{__DIE__};  $len = $sth->{mysql_is_pri_key}}) {
		return $len
	}
	else {return $sth->{is_pri_key}}
}
sub get_mysql_max_lendth {
	my $sth = shift @_;
	my $len;
	if (eval {local $SIG{__DIE__};  $len = $sth->{mysql_max_length}}) {
		return $len
	}
	else {return $sth->{max_length}}
}
sub checkfilename {
	my $filename	= $_[0];
	my $back		= $_[1];
	if ($filename =~ /[\/\\:\*\?"<>\|]/){bail_out("A filename cannot contain any of the following characters",$back)}
	if ($filename =~ /(\.\.)/){bail_out("File name is incorrect", $back)}
	return
}
sub deletespace {
	my $var = shift;
	$var =~ s/^\s*(.*)$/$1/m;
	$var =~ s/^(.*?)\s*$/$1/s;
	return $var;
}
print "<H1>There is no data<H1>";
exit 0;

#++++++++++++++++++++++++++++++++++++++
